#include <config.h>

#include "../config.h"

#if defined(HAVE_FORTRAN)


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "grace_np.h"

#define GRACEFORTRANWRAPPER_FC FC_FUNC(gracefortranwrapper,GRACEFORTRANWRAPPER)
#define GRACEREGISTERERRORFUNCTIONF_FC FC_FUNC(graceregistererrorfunctionf,GRACEREGISTERERRORFUNCTIONF)
#define GRACEOPENF_FC FC_FUNC(graceopenf,GRACEOPENF)
#define GRACEISOPENF_FC FC_FUNC(graceisopenf,GRACEISOPENF)
#define GRACECLOSEF_FC FC_FUNC(graceclosef,GRACECLOSEF)
#define GRACECLOSEPIPEF_FC FC_FUNC(graceclosepipef,GRACECLOSEPIPEF)
#define GRACEFLUSHF_FC FC_FUNC(graceflushf,GRACEFLUSHF)
#define GRACECOMMANDF_FC FC_FUNC(gracecommandf,GRACECOMMANDF)

typedef void (*GraceFortranFunctionType) (const char *str, int len);
static GraceFortranFunctionType fortran_error = (GraceFortranFunctionType) 0;

static void GRACEFORTRANWRAPPER_FC(const char *str)
{
    if (fortran_error == (GraceFortranFunctionType) 0) {
        fprintf(stderr, "%s\n", str);
    } else {
        fortran_error(str, strlen(str));
    }
}

void GRACEREGISTERERRORFUNCTIONF_FC (GraceFortranFunctionType f)
{
    fortran_error = f;
    GraceRegisterErrorFunction(GRACEFORTRANWRAPPER_FC);
}

int GRACEOPENF_FC (const int *arg)
{
    return (GraceOpen (*arg));
}

int GRACEISOPENF_FC (void)
{
    return (GraceIsOpen ());
}

int GRACECLOSEF_FC (void)
{
    return (GraceClose ());
}

int GRACECLOSEPIPEF_FC (void)
{
    return (GraceClosePipe());
}

int GRACEFLUSHF_FC (void)
{
    return (GraceFlush ());
}


int GRACECOMMANDF_FC (const char* arg, int length)
{
    char* str;
    int res;

    str = (char*) malloc ((size_t) (length + 1));
    if (str == NULL) {
        fprintf (stderr, "GraceCommandf: Not enough memory\n");
        return (-1);
    }
    strncpy (str, arg, length);
    str[length] = 0;
    res = GraceCommand (str);
    free (str);
    return (res);
}

#else /* don't include Fortran wrapper */

/* To make ANSI C happy about non-empty file */

#define GRACEF_NP_C_DUMMY_FUNC_FC FC_FUNC(_gracef_np_c_dummy_func,_GRACEF_NP_C_DUMMY_FUNC)
void  GRACEF_NP_C_DUMMY_FUNC_FC(void) 
{
}

#endif /* FC */
