/** Filz gg_gtkdrv.h : driver for Grace-GTK 
 * Protos pour gg_gtkdrv.c
 */

#ifndef __GG_GTKDRV_H_
#define __GG_GTKDRV_H_


#include "defines.h"
#include "t1fonts.h"


#define CMAP_INSTALL_NEVER      0
#define CMAP_INSTALL_ALWAYS     1
#define CMAP_INSTALL_AUTO       2

/* functions for the standard interface */
int  gg_initgraphics  (void);
void gg_drawarc       (VPoint vp1, VPoint vp2, int a1, int a2);
void gg_drawpixel     (VPoint vp);
void gg_drawpolyline  (VPoint *vps, int n, int mode);
void gg_fillarc       (VPoint vp1, VPoint vp2, int a1, int a2, int mode);
void gg_fillpolygon   (VPoint *vps, int nc);
void gg_leavegraphics (void);
void gg_putpixbuf     (void *data ,VPoint *vp1 ,VPoint *vp2 ,int scaling_type ,double *scale_x ,double *scale_y);
void gg_putpixmap     (VPoint vp, int width, int height, char *databits, int pixmap_bpp, int bitmap_pad, int pixmap_type);
void gg_puttext       (VPoint vp, char *s, int len, int font, TextMatrix *tm, int underline, int overline, int kerning);
void gg_setfrgbcolor  (double red ,double green ,double blue);
void gg_updatecmap    (void);

/* functions for this particular driver */
int  gg_init		 (void);
void gg_initcmap 	 (void);
void gg_sync_canvas_size (gint *w ,gint *h  ,CanvasType canvas_type);
void gg_redraw 	 	 (GtkWidget *window ,gint x ,gint y ,gint width ,gint height);
void gg_writestring 	 (VPoint vp ,int rot ,int just ,char *theString);

VPoint gg_gtk2VPoint (int x ,int y);
VPoint gg_pixbuf_place_2nd_corner (void *data ,VPoint vp1 ,VPoint vp2 ,int scaling_type);
void   gg_pixbuf_scale 		  (int i);
/* gg_gtkdrv.c */
int  	 gg_xconvglib 	    (double x);
int  	 gg_yconvglib 	    (double y);
void 	 gg_VPoint2dev	    (VPoint vp ,int *x ,int *y);
GdkPoint gg_VPoint2GdkPoint (VPoint vp);

/* gg_gutil.c */
extern void gg_draw_focus(int gno);
//27 extern GdkPixmap *gg_resize_bufpixmap ( int w , int h);


#endif /* __GG_GTKDRV_H_ */
