/** File gg_timewin.c
 * A tool to compute julian date/time from FORMAT_YYMMDDHMS
 */

#include <gtk/gtk.h>

#include "gw_list.h"

#include "globals.h"
#include "gg_gtkinc.h"
#include "gg_protos.h"
#include "utils.h"
#include "noxprotos.h"

extern GdkColor  bleuciel ,wheat;

static GtkWidget *time_win = NULL;
static GtkWidget *vb;
static GtkWidget *entry;
static GtkWidget *rc ,*w_year ,*w_month ,*w_day ,*w_hour ,*w_minute ,*w_second ,*w_fracsec;
static int two_digits_years_flag_saved;

static void gg_timewin_AC_CB   (GtkWidget *w ,gint reponse);

GtkWidget *gg_timewin_create (GtkWidget *w ,gpointer p)
{
  double val ,fracsec;
  int year ,month ,day ,hour ,minute ,second;
  if (time_win == NULL) {
    time_win   = gg_CreateAACDialog   ("Time tool" ,gg_timewin_AC_CB ,0 ,0 ,&vb);
    vb 	      = GTK_DIALOG (time_win)->vbox;
    rc = gg_frame (vb ,"" ,&wheat ,3 ,3);
    w_year    = gg_spin_new (rc ,"Year:"    ,-5000.0 ,9000.0 ,1.0);
    w_month   = gg_spin_new (rc ,"Month"    ,1.0     ,12.0   ,1.0);
    w_day     = gg_spin_new (rc ,"Day"      ,1.0     ,31.0   ,1.0);
    w_hour    = gg_spin_new (rc ,"Hours"    ,0.0     ,24.0   ,1.0);
    w_minute  = gg_spin_new (rc ,"Minutes"  ,0.0     ,60.0   ,1.0);
    w_second  = gg_spin_new (rc ,"Sec."     ,0.0     ,60.0   ,1.0);
    w_fracsec = gg_spin_new (rc ,"FracSec." ,0.0     ,1.0    ,0.001);
  }
  entry = (GtkWidget *)p;
  if (gg_evalexpr (entry ,&val) == RETURN_FAILURE) {
    errmsg ("Entry is not valid");
    gtk_widget_hide_all (time_win);
    return time_win;
  }
  gtk_widget_show_all (time_win);
  two_digits_years_flag_saved = two_digits_years_allowed ();
  allow_two_digits_years (FALSE);
  jul_to_cal_and_time (val  ,NO_ROUND 
		       ,&year ,&month ,&day
		       ,&hour ,&minute ,&second
		       ,&fracsec);
  gg_set_int  (w_year   ,year);
  gg_set_int  (w_month  ,month);
  gg_set_int  (w_day    ,day);
  gg_set_int  (w_hour   ,hour);
  gg_set_int  (w_minute ,minute);
  gg_set_int  (w_second ,second);
  gg_set_dble (w_fracsec ,fracsec);
  return time_win;
}

static void  gg_timewin_AC_CB	(GtkWidget *w ,gint reponse)
{
  double val ,fracsec ,sec;
  int year ,month ,day ,hour ,minute ,second;
  char buf[32];
  if (reponse == GTK_RESPONSE_ACCEPT || reponse == GTK_RESPONSE_APPLY) {
    
  year    = gg_get_int  (w_year);
  month   = gg_get_int  (w_month );
  day 	  = gg_get_int  (w_day);
  hour 	  = gg_get_int  (w_hour);
  minute  = gg_get_int  (w_minute);
  second  = gg_get_int  (w_second);
  fracsec = gg_get_dble (w_fracsec);
  sec = second + fracsec;
  val = cal_and_time_to_jul (year ,month ,day ,hour ,minute ,sec);
  gg_setstr_d (entry ,"%10f" ,val ,buf);
  allow_two_digits_years (two_digits_years_flag_saved);
  }
  if (reponse == GTK_RESPONSE_ACCEPT || reponse == GTK_RESPONSE_CLOSE) {
    gtk_widget_hide (time_win);
  }
}
