/** File wavelet.h
 */


#ifndef __WAVELET_H_
#define __WAVELET_H_

#include <gsl/gsl_wavelet.h>

void gg_wavelet_update (void);

typedef enum {
  WAVELET_DAUBECHIES
  ,WAVELET_DAUBECHIES_CENTERED
  ,WAVELET_HARR
  ,WAVELET_HARR_CENTERED
  ,WAVELET_BSPLINE
  ,WAVELET_BSPLINE_CENTERED
} WAVELET_type;

#ifdef __WAVELET_WIN_
/* To be used in the follow_me_on mode */
static char *waveletype[] = {"Daubechies"                /* WAVELET_DAUBECHIES          */
			   ,"Daubechies_centered"        /* WAVELET_DAUBECHIES_CENTERED */
			   ,"Haar"                       /* WAVELET_HARR             	  */
			   ,"Haar_centered"              /* WAVELET_HARR_CENTERED    	  */
			   ,"Bspline"                    /* WAVELET_BSPLINE          	  */
			   ,"Bspline_centered"           /* WAVELET_BSPLINE_CENTERED 	  */
};

#endif /* __WAVELET_WIN_ */

typedef struct _WAVParams WAVParams;

struct _WAVParams {
  WAVELET_type typ;        /* see above */
  int          invflag;    /* 0:forward 1:backward */
  int          stride;     /* on the input data */
  int          pk;         /* pointer to the k nb in the Bspline family */
  int          k;          /* the k number in the family */
};

void wavelet_set_defaults (void);
int  wavelet_params_get   (WAVParams *p);
int  wavelet_params_set   (WAVParams *p);

int  do_wavelet 	  (int gno1 ,int setno1 ,int gno2 ,int setno2);
void do_wavelet_command   (int gno1 ,int setno1 ,WAVELET_type typ ,int stride ,int k ,int invflag);
void do_wavelet_command_1 (int gno1 ,int setno1 ,WAVELET_type typ ,int stride ,int k ,int invflag
			   ,int gno2 ,int setno2);


#endif /* __WAVELET_H_ */
