
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 2 "pars.yacc"

/*
 * Grace - GRaphing, Advanced Computation and Exploration of data
 *
 * Home page: http://plasma-gate.weizmann.ac.il/Grace/
 *
 * Copyright (c) 1991-1995 Paul J Turner, Portland, OR
 * Copyright (c) 1996-2003 Grace Development Team
 * and after 2010 P. Vincent
 *
 *
 *
 *                           All Rights Reserved
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *
 * evaluate expressions, commands, parameter files
 *
 */

#include <config.h>
#include <cmath.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#if defined(HAVE_SYS_PARAM_H)
#  include <sys/param.h>
#endif

/* bison not always handles it well itself */
#if defined(HAVE_ALLOCA_H)
#  include <alloca.h>
#endif

#include "defines.h"
#include "globals.h"
#include "cephes/cephes.h"
#include "device.h"
#include "utils.h"
#include "files.h"
#include "graphs.h"
#include "graphutils.h"
#include "plotone.h"
#include "dlmodule.h"
#include "t1fonts.h"
#include "ssdata.h"
#include "parser.h"
#ifndef HAVE_DRAND48
  extern double drand48(void);
#endif
#include "mathstuff.h"
#  include "noxprotos.h"
#  include <gtk/gtk.h>
#  include "gg_protos.h"
#  include "ng_objects.h"
#  include "nn_tree.h"
#  include "zc.h"

#include "fourier.h"
#include "wavelet.h"
#include "nonlfit.h"

#include "gg_gtkdrv.h"

#define MAX_PARS_STRING_LENGTH  4096
#define MAX_GRARR_TMP 100

/* Tick sign type */
#define SIGN_NORMAL     0
#define SIGN_ABSOLUTE   1
#define SIGN_NEGATE     2

#define CAST_DBL_TO_BOOL(x) (fabs(x) < 0.5 ? 0:1)

typedef double (*ParserFnc)();

extern graph *g;
extern NONLparams      nonl_parms[MAXPARM];
extern NONLopts        nonl_opts;
extern NONL_load_prefs nonl_prefs;

static int file_project_version = 0;
static int curid;
static int curobjtyp;
static int curpmask = MA_NONE;

#include "pars_tree.h"
extern ParsTreeNode *ptree;

static double  s_result;    /* return value if a scalar expression is scanned*/
static grarr  *v_result;    /* return value if a vector or matrix expression is scanned*/

static int expr_parsed, vexpr_parsed;

static int interr;

static grarr freelist[MAX_GRARR_TMP]; /* temporary vectors */
static int fcnt = 0;		      /* number of the temporary vectors allocated */

static grarr mattmp[MAX_GRARR_TMP];   /* temporary matrices */
static int   matcnt = 0;              /* number of the temporary matrices allocated */

static target trgt_pool[100]; 	/* pool of temporary targets */
static int tgtn = 0;		/* number of the temporary targets used */

int naxis = 0;	/* current axis */
//static int curstring;
/* these guys attempt to avoid reentrancy problems */
static int gotparams = FALSE, gotread = FALSE;
int readxformat;
static double *nlfit_warray = NULL;

char batchfile[GR_MAXPATHLEN] = "",
     paramfile[GR_MAXPATHLEN] = "",
     readfile[GR_MAXPATHLEN] = "";

static FILE *fplog = NULL;  /* Log file to record commands */

static char f_string[MAX_PARS_STRING_LENGTH]; /* buffer for string to parse */
static int pos;

/* the graph, set, and its length of the parser's current state */
 static int gn;  		     /* whichgraph in grace-5   */
 static int sn;  		     /* whichset   in grace-5   */
 static int jo;  		     /* synonym for cur_obj_num */

/* the graph and set of the left part of a vector assignment */
static int vasgn_gno;
static int vasgn_setno;

/* to assign  matrix columns */
static int masgn_row1;
static int masgn_row2;
static int masgn_col1;
static int masgn_col2;

static int alias_force = FALSE; /* controls whether aliases can override
                                                       existing keywords */

extern char print_file[];
extern char *close_input;

static int filltype_obs;

 static int string_font    = 0;    //24
 static double string_size = 1.0;  //24

static int index_shift = 0;     /* 0 for C, 1 for F77 index notation */

static void free_grarr (grarr *gar);
static void copy_grarr     (grarr *dest, grarr *src);
static int find_set_bydata (double *data, target *tgt);

static int getcharstr(void);
static void ungetchstr(void);
static int follow(int expect, int ifyes, int ifno);

static int yylex(void);
static int yyparse(void);
static void yyerror(char *s);

static int findf(symtab_entry *keytable, char *s);

/* Total (intrinsic + user-defined) list of functions and keywords */
symtab_entry *key;
static void undefine_all_users_var (void);

/* Functions to shorten C part of a lot of rules */
static int bad_gno  (void);
static int bad_axis (void);
static int div_null (double div);
static grarr *tmp_vec (grarr *src);
static grarr *tmp_mat (grarr *src);



/* Line 189 of yacc.c  */
#line 268 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     KEY_VAR = 258,
     KEY_VEC = 259,
     KEY_MAT = 260,
     KEY_CONST = 261,
     KEY_UNIT = 262,
     KEY_FUNC_I = 263,
     KEY_FUNC_D = 264,
     KEY_FUNC_NN = 265,
     KEY_FUNC_ND = 266,
     KEY_FUNC_DD = 267,
     KEY_FUNC_NND = 268,
     KEY_FUNC_PPD = 269,
     KEY_FUNC_PPPD = 270,
     KEY_FUNC_PPPPD = 271,
     KEY_FUNC_PPPPPD = 272,
     INDEX = 273,
     DATE = 274,
     VAR_D = 275,
     VEC_D = 276,
     MAT_D = 277,
     CONSTANT = 278,
     UCONSTANT = 279,
     FUNC_I = 280,
     FUNC_D = 281,
     FUNC_NN = 282,
     FUNC_ND = 283,
     FUNC_DD = 284,
     FUNC_NND = 285,
     FUNC_PPD = 286,
     FUNC_PPPD = 287,
     FUNC_PPPPD = 288,
     FUNC_PPPPPD = 289,
     ABOVE = 290,
     ABSOLUTE = 291,
     ALIAS = 292,
     ALLVARS = 293,
     ALT = 294,
     ALTXAXIS = 295,
     ALTYAXIS = 296,
     ANCHOR = 297,
     ANGLE = 298,
     ANGLES = 299,
     ANTIALIASING = 300,
     APPEND = 301,
     ARC = 302,
     ARRANGE = 303,
     ARROW = 304,
     ASCENDING = 305,
     ASPLINE = 306,
     AUTO = 307,
     AUTOSCALE = 308,
     AUTOTICKS = 309,
     AVALUE = 310,
     AVG = 311,
     BACKGROUND = 312,
     BACKWARD = 313,
     BAR = 314,
     BARDY = 315,
     BARDYDY = 316,
     BASELINE = 317,
     BATCH = 318,
     BEGIN = 319,
     BELOW = 320,
     BETWEEN = 321,
     BLACKMAN = 322,
     BLOCK = 323,
     BOTH = 324,
     BOTTOM = 325,
     BOX = 326,
     BREAK = 327,
     BSPLINE = 328,
     BSPLINE_CENTERED = 329,
     CD = 330,
     CENTER = 331,
     CHAR = 332,
     CHART = 333,
     CHRSTR = 334,
     CLEAR = 335,
     CLICK = 336,
     CLIP = 337,
     CLOSE = 338,
     CMAP = 339,
     COEFFICIENTS = 340,
     COLOR = 341,
     COLORBAR = 342,
     COMMENT = 343,
     COMPLEX = 344,
     COMPOUND = 345,
     COMPUTING = 346,
     CONSTRAINTS = 347,
     CONTOUR = 348,
     COPY = 349,
     CYCLE = 350,
     DAUBECHIES = 351,
     DAUBECHIES_CENTERED = 352,
     DAYMONTH = 353,
     DAYOFWEEKL = 354,
     DAYOFWEEKS = 355,
     DAYOFYEAR = 356,
     DDMMYY = 357,
     DECIMAL = 358,
     DECIMATE = 359,
     DEF = 360,
     DEFAULT = 361,
     DEFINE = 362,
     DEGREES = 363,
     DEGREESLAT = 364,
     DEGREESLON = 365,
     DEGREESMMLAT = 366,
     DEGREESMMLON = 367,
     DEGREESMMSSLAT = 368,
     DEGREESMMSSLON = 369,
     DESCENDING = 370,
     DESCRIPTION = 371,
     DEVICE = 372,
     DFT = 373,
     DIFFERENCE = 374,
     DISK = 375,
     DOWN = 376,
     DPI = 377,
     DROP = 378,
     DROPLINE = 379,
     ECHO = 380,
     ELLIPSE = 381,
     ENGINEERING = 382,
     ERRORBAR = 383,
     EXIT = 384,
     EXPONENTIAL = 385,
     FFT = 386,
     FILEP = 387,
     FILL = 388,
     FIT = 389,
     FIXED = 390,
     FIXEDPOINT = 391,
     FLUSH = 392,
     FOCUS = 393,
     FOLLOWS = 394,
     FONTP = 395,
     FORCE = 396,
     FORMAT = 397,
     FORMULA = 398,
     FORWARD = 399,
     FRAMEP = 400,
     FREE = 401,
     FREQUENCY = 402,
     FROM = 403,
     GAUSSIAN = 404,
     GENERAL = 405,
     GEOTRANSFORM = 406,
     GETP = 407,
     GRAPH = 408,
     GRAPHNO = 409,
     GRID = 410,
     HAAR = 411,
     HAAR_CENTERED = 412,
     HALF = 413,
     HAMMING = 414,
     HANNING = 415,
     HARDCOPY = 416,
     HBAR = 417,
     HELP = 418,
     HGAP = 419,
     HIDDEN = 420,
     HISTOGRAM = 421,
     HMS = 422,
     HORIZI = 423,
     HORIZONTAL = 424,
     HORIZO = 425,
     ID = 426,
     IF = 427,
     IFILTER = 428,
     IMAGE = 429,
     IMAX = 430,
     IMIN = 431,
     IN = 432,
     INCREMENT = 433,
     INOUT = 434,
     INSEGX = 435,
     INT = 436,
     INTEGRATE = 437,
     INTERPOLATE = 438,
     INVDFT = 439,
     INVERT = 440,
     INVFFT = 441,
     JUST = 442,
     KILL = 443,
     LABEL = 444,
     LANDSCAPE = 445,
     LAYER = 446,
     LAYOUT = 447,
     LEFT = 448,
     LEGEND = 449,
     LENGTH = 450,
     LINCONV = 451,
     LINE = 452,
     LINEAR = 453,
     LINESTYLE = 454,
     LINEWIDTH = 455,
     LINK = 456,
     LOAD = 457,
     LOCTYPE = 458,
     LOESS = 459,
     LOG = 460,
     LOGARITHMIC = 461,
     LOGIT = 462,
     LOGX = 463,
     LOGXY = 464,
     LOGY = 465,
     MAGIC = 466,
     MAGNITUDE = 467,
     MAJOR = 468,
     MAP = 469,
     MAXP = 470,
     MESH = 471,
     MESH2D = 472,
     MINP = 473,
     MINMAXP = 474,
     MINOR = 475,
     MMDD = 476,
     MMDDHMS = 477,
     MMDDYY = 478,
     MMDDYYHMS = 479,
     MMSSLAT = 480,
     MMSSLON = 481,
     MMYY = 482,
     MONTHDAY = 483,
     MONTHL = 484,
     MONTHS = 485,
     MONTHSY = 486,
     MOVE = 487,
     NEGATE = 488,
     NEW = 489,
     NONE = 490,
     NONLFIT = 491,
     NORMAL = 492,
     NTICKS = 493,
     NXY = 494,
     OBJ = 495,
     OFF = 496,
     OFFSET = 497,
     OFFSETX = 498,
     OFFSETY = 499,
     OFILTER = 500,
     ON = 501,
     ONREAD = 502,
     OP = 503,
     OPEN = 504,
     OPPOSITE = 505,
     OUT = 506,
     PAGE = 507,
     PARA = 508,
     PARAMETERS = 509,
     PARZEN = 510,
     PATTERN = 511,
     PERIOD = 512,
     PERP = 513,
     PHASE = 514,
     PIE = 515,
     PIPE = 516,
     PLACE = 517,
     POINT = 518,
     POLAR = 519,
     POLYI = 520,
     POLYLINE = 521,
     POLYO = 522,
     POP = 523,
     PORTRAIT = 524,
     POSITIVE = 525,
     POWER = 526,
     PREC = 527,
     PREPEND = 528,
     PRINT = 529,
     PS = 530,
     PUSH = 531,
     PUTP = 532,
     RAND = 533,
     READ = 534,
     REAL = 535,
     RECIPROCAL = 536,
     REDRAW = 537,
     REFERENCE = 538,
     REGNUM = 539,
     REGRESS = 540,
     RESIDUALS = 541,
     RESIZE = 542,
     RESTRICT = 543,
     RESULTS = 544,
     REVERSE = 545,
     RIGHT = 546,
     RISER = 547,
     ROT = 548,
     ROUNDED = 549,
     RSUM = 550,
     RULE = 551,
     RUNAVG = 552,
     RUNMAX = 553,
     RUNMED = 554,
     RUNMIN = 555,
     RUNSTD = 556,
     SAMPLE = 557,
     SAVEALL = 558,
     SCALE = 559,
     SCIENTIFIC = 560,
     SELXY = 561,
     SCROLL = 562,
     SD = 563,
     SET = 564,
     SETNUM = 565,
     SFORMAT = 566,
     SIGN = 567,
     SIZE = 568,
     SKIP = 569,
     SLEEP = 570,
     SMITH = 571,
     SORT = 572,
     SOURCE = 573,
     SPEC = 574,
     SPLINE = 575,
     SPLIT = 576,
     STACK = 577,
     STACKED = 578,
     STACKEDBAR = 579,
     STACKEDHBAR = 580,
     STAGGER = 581,
     START = 582,
     STEPS = 583,
     STOP = 584,
     STRING = 585,
     SUM = 586,
     SUBTITLE = 587,
     SWAP = 588,
     SYMBOL = 589,
     SYMMETRIC = 590,
     TARGET = 591,
     TICKLABEL = 592,
     TICKP = 593,
     TICKSP = 594,
     TIMER = 595,
     TIMESTAMP = 596,
     TITLE = 597,
     TO = 598,
     TOP = 599,
     TRACE = 600,
     TRIANGULAR = 601,
     TYPE = 602,
     UP = 603,
     UPDATEALL = 604,
     USE = 605,
     VALUES = 606,
     VERSION = 607,
     VERTI = 608,
     VERTICAL = 609,
     VERTO = 610,
     VGAP = 611,
     VIEW = 612,
     VMAP = 613,
     VX1 = 614,
     VX2 = 615,
     VXMAX = 616,
     VY1 = 617,
     VY2 = 618,
     VYMAX = 619,
     WAVELET = 620,
     WEIGHT = 621,
     WELCH = 622,
     WITH = 623,
     WORLD = 624,
     WRAP = 625,
     WRITE = 626,
     WX1 = 627,
     WX2 = 628,
     WY1 = 629,
     WY2 = 630,
     X_TOK = 631,
     X0 = 632,
     X1 = 633,
     XAXES = 634,
     XAXIS = 635,
     XCOR = 636,
     XMAX = 637,
     XMIN = 638,
     XSPLINE = 639,
     XY = 640,
     XYAXES = 641,
     XYBOXPLOT = 642,
     XYCOLOR = 643,
     XYCOLPAT = 644,
     XYDX = 645,
     XYDXDX = 646,
     XYDXDXDYDY = 647,
     XYDXDY = 648,
     XYDY = 649,
     XYDYDY = 650,
     XYHILO = 651,
     XYR = 652,
     XYSIZE = 653,
     XYSPLINE = 654,
     XYSTRING = 655,
     XYCMAP = 656,
     XYVMAP = 657,
     XYZ = 658,
     Y_TOK = 659,
     Y0 = 660,
     Y1 = 661,
     Y2 = 662,
     Y3 = 663,
     Y4 = 664,
     YAXES = 665,
     YAXIS = 666,
     YEAR = 667,
     YMAX = 668,
     YMIN = 669,
     YYMMDD = 670,
     YYMMDDHMS = 671,
     ZERO = 672,
     ZNORM = 673,
     ZSCALE = 674,
     FITPARM = 675,
     FITPMAX = 676,
     FITPMIN = 677,
     NUMBER = 678,
     NEW_TOKEN = 679,
     OR = 680,
     AND = 681,
     NE = 682,
     EQ = 683,
     GE = 684,
     LE = 685,
     LT = 686,
     GT = 687,
     NOT = 688,
     UMINUS = 689
   };
#endif
/* Tokens.  */
#define KEY_VAR 258
#define KEY_VEC 259
#define KEY_MAT 260
#define KEY_CONST 261
#define KEY_UNIT 262
#define KEY_FUNC_I 263
#define KEY_FUNC_D 264
#define KEY_FUNC_NN 265
#define KEY_FUNC_ND 266
#define KEY_FUNC_DD 267
#define KEY_FUNC_NND 268
#define KEY_FUNC_PPD 269
#define KEY_FUNC_PPPD 270
#define KEY_FUNC_PPPPD 271
#define KEY_FUNC_PPPPPD 272
#define INDEX 273
#define DATE 274
#define VAR_D 275
#define VEC_D 276
#define MAT_D 277
#define CONSTANT 278
#define UCONSTANT 279
#define FUNC_I 280
#define FUNC_D 281
#define FUNC_NN 282
#define FUNC_ND 283
#define FUNC_DD 284
#define FUNC_NND 285
#define FUNC_PPD 286
#define FUNC_PPPD 287
#define FUNC_PPPPD 288
#define FUNC_PPPPPD 289
#define ABOVE 290
#define ABSOLUTE 291
#define ALIAS 292
#define ALLVARS 293
#define ALT 294
#define ALTXAXIS 295
#define ALTYAXIS 296
#define ANCHOR 297
#define ANGLE 298
#define ANGLES 299
#define ANTIALIASING 300
#define APPEND 301
#define ARC 302
#define ARRANGE 303
#define ARROW 304
#define ASCENDING 305
#define ASPLINE 306
#define AUTO 307
#define AUTOSCALE 308
#define AUTOTICKS 309
#define AVALUE 310
#define AVG 311
#define BACKGROUND 312
#define BACKWARD 313
#define BAR 314
#define BARDY 315
#define BARDYDY 316
#define BASELINE 317
#define BATCH 318
#define BEGIN 319
#define BELOW 320
#define BETWEEN 321
#define BLACKMAN 322
#define BLOCK 323
#define BOTH 324
#define BOTTOM 325
#define BOX 326
#define BREAK 327
#define BSPLINE 328
#define BSPLINE_CENTERED 329
#define CD 330
#define CENTER 331
#define CHAR 332
#define CHART 333
#define CHRSTR 334
#define CLEAR 335
#define CLICK 336
#define CLIP 337
#define CLOSE 338
#define CMAP 339
#define COEFFICIENTS 340
#define COLOR 341
#define COLORBAR 342
#define COMMENT 343
#define COMPLEX 344
#define COMPOUND 345
#define COMPUTING 346
#define CONSTRAINTS 347
#define CONTOUR 348
#define COPY 349
#define CYCLE 350
#define DAUBECHIES 351
#define DAUBECHIES_CENTERED 352
#define DAYMONTH 353
#define DAYOFWEEKL 354
#define DAYOFWEEKS 355
#define DAYOFYEAR 356
#define DDMMYY 357
#define DECIMAL 358
#define DECIMATE 359
#define DEF 360
#define DEFAULT 361
#define DEFINE 362
#define DEGREES 363
#define DEGREESLAT 364
#define DEGREESLON 365
#define DEGREESMMLAT 366
#define DEGREESMMLON 367
#define DEGREESMMSSLAT 368
#define DEGREESMMSSLON 369
#define DESCENDING 370
#define DESCRIPTION 371
#define DEVICE 372
#define DFT 373
#define DIFFERENCE 374
#define DISK 375
#define DOWN 376
#define DPI 377
#define DROP 378
#define DROPLINE 379
#define ECHO 380
#define ELLIPSE 381
#define ENGINEERING 382
#define ERRORBAR 383
#define EXIT 384
#define EXPONENTIAL 385
#define FFT 386
#define FILEP 387
#define FILL 388
#define FIT 389
#define FIXED 390
#define FIXEDPOINT 391
#define FLUSH 392
#define FOCUS 393
#define FOLLOWS 394
#define FONTP 395
#define FORCE 396
#define FORMAT 397
#define FORMULA 398
#define FORWARD 399
#define FRAMEP 400
#define FREE 401
#define FREQUENCY 402
#define FROM 403
#define GAUSSIAN 404
#define GENERAL 405
#define GEOTRANSFORM 406
#define GETP 407
#define GRAPH 408
#define GRAPHNO 409
#define GRID 410
#define HAAR 411
#define HAAR_CENTERED 412
#define HALF 413
#define HAMMING 414
#define HANNING 415
#define HARDCOPY 416
#define HBAR 417
#define HELP 418
#define HGAP 419
#define HIDDEN 420
#define HISTOGRAM 421
#define HMS 422
#define HORIZI 423
#define HORIZONTAL 424
#define HORIZO 425
#define ID 426
#define IF 427
#define IFILTER 428
#define IMAGE 429
#define IMAX 430
#define IMIN 431
#define IN 432
#define INCREMENT 433
#define INOUT 434
#define INSEGX 435
#define INT 436
#define INTEGRATE 437
#define INTERPOLATE 438
#define INVDFT 439
#define INVERT 440
#define INVFFT 441
#define JUST 442
#define KILL 443
#define LABEL 444
#define LANDSCAPE 445
#define LAYER 446
#define LAYOUT 447
#define LEFT 448
#define LEGEND 449
#define LENGTH 450
#define LINCONV 451
#define LINE 452
#define LINEAR 453
#define LINESTYLE 454
#define LINEWIDTH 455
#define LINK 456
#define LOAD 457
#define LOCTYPE 458
#define LOESS 459
#define LOG 460
#define LOGARITHMIC 461
#define LOGIT 462
#define LOGX 463
#define LOGXY 464
#define LOGY 465
#define MAGIC 466
#define MAGNITUDE 467
#define MAJOR 468
#define MAP 469
#define MAXP 470
#define MESH 471
#define MESH2D 472
#define MINP 473
#define MINMAXP 474
#define MINOR 475
#define MMDD 476
#define MMDDHMS 477
#define MMDDYY 478
#define MMDDYYHMS 479
#define MMSSLAT 480
#define MMSSLON 481
#define MMYY 482
#define MONTHDAY 483
#define MONTHL 484
#define MONTHS 485
#define MONTHSY 486
#define MOVE 487
#define NEGATE 488
#define NEW 489
#define NONE 490
#define NONLFIT 491
#define NORMAL 492
#define NTICKS 493
#define NXY 494
#define OBJ 495
#define OFF 496
#define OFFSET 497
#define OFFSETX 498
#define OFFSETY 499
#define OFILTER 500
#define ON 501
#define ONREAD 502
#define OP 503
#define OPEN 504
#define OPPOSITE 505
#define OUT 506
#define PAGE 507
#define PARA 508
#define PARAMETERS 509
#define PARZEN 510
#define PATTERN 511
#define PERIOD 512
#define PERP 513
#define PHASE 514
#define PIE 515
#define PIPE 516
#define PLACE 517
#define POINT 518
#define POLAR 519
#define POLYI 520
#define POLYLINE 521
#define POLYO 522
#define POP 523
#define PORTRAIT 524
#define POSITIVE 525
#define POWER 526
#define PREC 527
#define PREPEND 528
#define PRINT 529
#define PS 530
#define PUSH 531
#define PUTP 532
#define RAND 533
#define READ 534
#define REAL 535
#define RECIPROCAL 536
#define REDRAW 537
#define REFERENCE 538
#define REGNUM 539
#define REGRESS 540
#define RESIDUALS 541
#define RESIZE 542
#define RESTRICT 543
#define RESULTS 544
#define REVERSE 545
#define RIGHT 546
#define RISER 547
#define ROT 548
#define ROUNDED 549
#define RSUM 550
#define RULE 551
#define RUNAVG 552
#define RUNMAX 553
#define RUNMED 554
#define RUNMIN 555
#define RUNSTD 556
#define SAMPLE 557
#define SAVEALL 558
#define SCALE 559
#define SCIENTIFIC 560
#define SELXY 561
#define SCROLL 562
#define SD 563
#define SET 564
#define SETNUM 565
#define SFORMAT 566
#define SIGN 567
#define SIZE 568
#define SKIP 569
#define SLEEP 570
#define SMITH 571
#define SORT 572
#define SOURCE 573
#define SPEC 574
#define SPLINE 575
#define SPLIT 576
#define STACK 577
#define STACKED 578
#define STACKEDBAR 579
#define STACKEDHBAR 580
#define STAGGER 581
#define START 582
#define STEPS 583
#define STOP 584
#define STRING 585
#define SUM 586
#define SUBTITLE 587
#define SWAP 588
#define SYMBOL 589
#define SYMMETRIC 590
#define TARGET 591
#define TICKLABEL 592
#define TICKP 593
#define TICKSP 594
#define TIMER 595
#define TIMESTAMP 596
#define TITLE 597
#define TO 598
#define TOP 599
#define TRACE 600
#define TRIANGULAR 601
#define TYPE 602
#define UP 603
#define UPDATEALL 604
#define USE 605
#define VALUES 606
#define VERSION 607
#define VERTI 608
#define VERTICAL 609
#define VERTO 610
#define VGAP 611
#define VIEW 612
#define VMAP 613
#define VX1 614
#define VX2 615
#define VXMAX 616
#define VY1 617
#define VY2 618
#define VYMAX 619
#define WAVELET 620
#define WEIGHT 621
#define WELCH 622
#define WITH 623
#define WORLD 624
#define WRAP 625
#define WRITE 626
#define WX1 627
#define WX2 628
#define WY1 629
#define WY2 630
#define X_TOK 631
#define X0 632
#define X1 633
#define XAXES 634
#define XAXIS 635
#define XCOR 636
#define XMAX 637
#define XMIN 638
#define XSPLINE 639
#define XY 640
#define XYAXES 641
#define XYBOXPLOT 642
#define XYCOLOR 643
#define XYCOLPAT 644
#define XYDX 645
#define XYDXDX 646
#define XYDXDXDYDY 647
#define XYDXDY 648
#define XYDY 649
#define XYDYDY 650
#define XYHILO 651
#define XYR 652
#define XYSIZE 653
#define XYSPLINE 654
#define XYSTRING 655
#define XYCMAP 656
#define XYVMAP 657
#define XYZ 658
#define Y_TOK 659
#define Y0 660
#define Y1 661
#define Y2 662
#define Y3 663
#define Y4 664
#define YAXES 665
#define YAXIS 666
#define YEAR 667
#define YMAX 668
#define YMIN 669
#define YYMMDD 670
#define YYMMDDHMS 671
#define ZERO 672
#define ZNORM 673
#define ZSCALE 674
#define FITPARM 675
#define FITPMAX 676
#define FITPMIN 677
#define NUMBER 678
#define NEW_TOKEN 679
#define OR 680
#define AND 681
#define NE 682
#define EQ 683
#define GE 684
#define LE 685
#define LT 686
#define GT 687
#define NOT 688
#define UMINUS 689




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 199 "pars.yacc"

    int     ival;
    double  dval;
    char   *sval;
    double *dptr;
    target *trgt;
    grarr  *vrbl;
    grarr  *matp;
  QDobject *qobj;



/* Line 214 of yacc.c  */
#line 1185 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1197 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  547
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   14537

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  453
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  98
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1004
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2169

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   689

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   439,     2,     2,
     445,   446,   437,   435,   447,   436,   443,   438,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   426,   444,
       2,   450,     2,   425,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   448,     2,   449,   442,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   451,     2,   452,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     427,   428,   429,   430,   431,   432,   433,   434,   440,   441
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    15,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    46,    48,    50,    52,    54,    56,    59,
      64,    71,    75,    79,    83,    87,    89,    92,    94,    99,
     104,   111,   118,   125,   134,   143,   154,   167,   182,   186,
     190,   194,   198,   202,   206,   210,   214,   219,   228,   243,
     245,   247,   249,   251,   253,   255,   257,   259,   261,   263,
     267,   271,   275,   278,   281,   285,   289,   293,   297,   303,
     307,   311,   315,   319,   323,   327,   331,   335,   338,   340,
     344,   348,   350,   352,   356,   358,   360,   362,   364,   366,
     368,   372,   374,   381,   386,   395,   400,   405,   410,   415,
     420,   427,   434,   441,   448,   457,   466,   477,   490,   505,
     509,   513,   517,   521,   525,   529,   533,   537,   541,   545,
     549,   553,   557,   561,   565,   569,   573,   577,   580,   586,
     592,   598,   604,   608,   612,   616,   620,   624,   628,   632,
     636,   640,   644,   648,   652,   656,   660,   664,   668,   672,
     676,   680,   684,   688,   692,   696,   700,   703,   707,   710,
     712,   714,   718,   720,   727,   734,   743,   752,   756,   760,
     764,   768,   772,   776,   780,   785,   787,   791,   795,   799,
     805,   807,   810,   815,   821,   830,   833,   836,   839,   842,
     845,   848,   851,   855,   859,   866,   875,   878,   882,   885,
     888,   891,   901,   907,   912,   915,   921,   927,   932,   937,
     945,   950,   956,   961,   966,   970,   974,   978,   983,   986,
     991,   996,  1001,  1005,  1015,  1018,  1021,  1025,  1028,  1031,
    1036,  1040,  1043,  1047,  1051,  1055,  1059,  1063,  1067,  1072,
    1077,  1081,  1085,  1089,  1093,  1098,  1103,  1106,  1109,  1113,
    1119,  1122,  1126,  1129,  1133,  1138,  1142,  1145,  1148,  1152,
    1156,  1161,  1165,  1168,  1171,  1174,  1177,  1182,  1185,  1190,
    1194,  1202,  1216,  1225,  1228,  1237,  1240,  1244,  1247,  1251,
    1254,  1258,  1264,  1267,  1271,  1274,  1278,  1281,  1285,  1291,
    1295,  1299,  1303,  1307,  1311,  1315,  1319,  1323,  1326,  1329,
    1332,  1336,  1340,  1344,  1348,  1352,  1356,  1361,  1366,  1370,
    1374,  1378,  1382,  1387,  1392,  1395,  1398,  1401,  1405,  1409,
    1412,  1415,  1418,  1421,  1425,  1429,  1432,  1436,  1440,  1444,
    1449,  1453,  1458,  1464,  1471,  1478,  1481,  1487,  1490,  1493,
    1496,  1499,  1503,  1507,  1509,  1511,  1513,  1515,  1517,  1519,
    1521,  1524,  1526,  1528,  1531,  1534,  1538,  1540,  1543,  1546,
    1550,  1554,  1559,  1562,  1566,  1575,  1580,  1590,  1596,  1599,
    1603,  1607,  1611,  1614,  1617,  1620,  1624,  1628,  1632,  1637,
    1642,  1649,  1654,  1658,  1664,  1668,  1671,  1675,  1680,  1683,
    1691,  1695,  1698,  1701,  1706,  1711,  1718,  1722,  1727,  1732,
    1738,  1742,  1746,  1750,  1753,  1763,  1767,  1778,  1791,  1793,
    1795,  1798,  1801,  1804,  1806,  1809,  1813,  1817,  1819,  1824,
    1829,  1834,  1836,  1840,  1844,  1847,  1850,  1852,  1855,  1858,
    1862,  1866,  1870,  1876,  1884,  1890,  1895,  1900,  1905,  1908,
    1912,  1917,  1922,  1925,  1929,  1932,  1935,  1937,  1950,  1969,
    1990,  2009,  2028,  2035,  2044,  2057,  2064,  2075,  2084,  2095,
    2102,  2109,  2122,  2129,  2142,  2159,  2186,  2213,  2226,  2241,
    2252,  2265,  2276,  2287,  2300,  2313,  2320,  2331,  2344,  2349,
    2356,  2367,  2380,  2387,  2396,  2419,  2426,  2435,  2446,  2455,
    2464,  2466,  2469,  2472,  2475,  2477,  2480,  2483,  2487,  2491,
    2496,  2500,  2503,  2506,  2510,  2515,  2519,  2524,  2527,  2532,
    2537,  2544,  2547,  2550,  2552,  2556,  2558,  2560,  2562,  2565,
    2568,  2571,  2575,  2579,  2582,  2585,  2588,  2591,  2593,  2595,
    2598,  2602,  2609,  2613,  2617,  2621,  2625,  2629,  2633,  2638,
    2643,  2648,  2653,  2658,  2663,  2668,  2677,  2688,  2701,  2705,
    2709,  2713,  2717,  2722,  2727,  2731,  2735,  2739,  2744,  2748,
    2752,  2757,  2763,  2767,  2771,  2776,  2781,  2786,  2793,  2798,
    2803,  2808,  2815,  2819,  2823,  2827,  2831,  2836,  2840,  2844,
    2849,  2854,  2860,  2867,  2870,  2873,  2876,  2881,  2886,  2893,
    2900,  2905,  2915,  2926,  2929,  2933,  2937,  2940,  2943,  2946,
    2950,  2953,  2958,  2962,  2966,  2971,  2975,  2979,  2988,  2992,
    2996,  3000,  3002,  3005,  3009,  3012,  3015,  3018,  3021,  3024,
    3027,  3030,  3035,  3037,  3040,  3044,  3048,  3051,  3054,  3057,
    3059,  3063,  3067,  3069,  3072,  3075,  3077,  3080,  3083,  3086,
    3089,  3093,  3097,  3099,  3103,  3106,  3111,  3116,  3118,  3121,
    3124,  3127,  3130,  3133,  3136,  3139,  3142,  3144,  3147,  3150,
    3153,  3157,  3161,  3165,  3169,  3173,  3175,  3177,  3181,  3184,
    3187,  3192,  3194,  3197,  3200,  3203,  3206,  3211,  3214,  3218,
    3220,  3222,  3224,  3226,  3228,  3230,  3232,  3235,  3238,  3242,
    3245,  3249,  3252,  3256,  3258,  3260,  3262,  3264,  3266,  3268,
    3271,  3275,  3280,  3282,  3285,  3288,  3292,  3294,  3296,  3298,
    3300,  3302,  3304,  3306,  3308,  3310,  3312,  3314,  3316,  3318,
    3320,  3322,  3324,  3326,  3328,  3330,  3332,  3334,  3336,  3338,
    3340,  3342,  3344,  3346,  3348,  3350,  3352,  3354,  3356,  3358,
    3360,  3362,  3364,  3366,  3368,  3370,  3372,  3374,  3376,  3378,
    3380,  3382,  3384,  3386,  3388,  3390,  3392,  3394,  3396,  3398,
    3400,  3402,  3404,  3406,  3408,  3410,  3412,  3414,  3416,  3418,
    3420,  3422,  3424,  3426,  3428,  3430,  3432,  3434,  3436,  3438,
    3440,  3442,  3444,  3446,  3448,  3450,  3452,  3454,  3456,  3458,
    3460,  3462,  3464,  3466,  3468,  3470,  3472,  3474,  3476,  3478,
    3480,  3482,  3484,  3486,  3488,  3490,  3492,  3494,  3496,  3498,
    3500,  3502,  3504,  3506,  3508,  3510,  3512,  3514,  3516,  3518,
    3520,  3522,  3524,  3526,  3528,  3530,  3532,  3534,  3536,  3538,
    3540,  3542,  3544,  3546,  3548,  3550,  3552,  3554,  3556,  3558,
    3560,  3562,  3564,  3566,  3568,  3570,  3572,  3574,  3576,  3578,
    3580,  3582,  3584,  3586,  3588,  3590,  3592,  3594,  3596,  3598,
    3600,  3602,  3604,  3606,  3608,  3610,  3612,  3614,  3616,  3618,
    3620,  3622,  3624,  3626,  3628,  3630,  3632,  3634,  3636,  3638,
    3640,  3642,  3644,  3646,  3648,  3650,  3652,  3654,  3656,  3658,
    3660,  3662,  3664,  3666,  3668,  3670,  3673,  3676,  3679,  3682,
    3685,  3688,  3697,  3700,  3703,  3705,  3707,  3709,  3713,  3718,
    3721,  3725,  3730,  3748,  3751,  3754,  3757,  3761,  3765,  3769,
    3774,  3779,  3785,  3788,  3791,  3795,  3799,  3803,  3807,  3811,
    3815,  3819,  3823,  3827,  3831,  3835,  3839,  3843,  3847,  3851,
    3855,  3859,  3863,  3868,  3873,  3877,  3882,  3887,  3890,  3892,
    3894,  3899,  3903,  3907,  3912,  3917,  3920,  3923,  3926,  3931,
    3937,  3942,  3947,  3950,  3953,  3956,  3959,  3962,  3965,  3968,
    3971,  3974,  3977,  3981,  3983,  3985,  3988,  3991,  3994,  3997,
    4000,  4004,  4008,  4010,  4013,  4015,  4017,  4019,  4022,  4024,
    4026,  4028,  4030,  4032,  4035
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     454,     0,    -1,   455,    -1,   457,    -1,   465,    -1,   456,
      -1,   455,   444,   456,    -1,    -1,   476,    -1,   541,    -1,
     481,    -1,   483,    -1,   475,    -1,   498,    -1,   486,    -1,
     484,    -1,   485,    -1,   470,    -1,   472,    -1,   469,    -1,
     473,    -1,   474,    -1,     1,    -1,   423,    -1,    20,    -1,
     420,    -1,   421,    -1,   422,    -1,   464,   461,    -1,   532,
     445,   465,   446,    -1,   181,   445,   465,   447,   465,   446,
      -1,   464,   443,   195,    -1,   497,   443,   195,    -1,   497,
     443,   171,    -1,   496,   443,   171,    -1,    23,    -1,   457,
      24,    -1,   278,    -1,    25,   445,   459,   446,    -1,    26,
     445,   457,   446,    -1,    28,   445,   459,   447,   457,   446,
      -1,    27,   445,   459,   447,   459,   446,    -1,    29,   445,
     457,   447,   457,   446,    -1,    30,   445,   459,   447,   459,
     447,   457,   446,    -1,    31,   445,   457,   447,   457,   447,
     457,   446,    -1,    32,   445,   457,   447,   457,   447,   457,
     447,   457,   446,    -1,    33,   445,   457,   447,   457,   447,
     457,   447,   457,   447,   457,   446,    -1,    34,   445,   457,
     447,   457,   447,   457,   447,   457,   447,   457,   447,   457,
     446,    -1,   496,   443,   359,    -1,   496,   443,   360,    -1,
     496,   443,   362,    -1,   496,   443,   363,    -1,   496,   443,
     372,    -1,   496,   443,   373,    -1,   496,   443,   374,    -1,
     496,   443,   375,    -1,    19,   445,   462,   446,    -1,    19,
     445,   459,   447,   460,   447,   460,   446,    -1,    19,   445,
     459,   447,   460,   447,   460,   447,   460,   447,   460,   447,
     457,   446,    -1,   359,    -1,   360,    -1,   362,    -1,   363,
      -1,   372,    -1,   373,    -1,   374,    -1,   375,    -1,   361,
      -1,   364,    -1,   445,   457,   446,    -1,   457,   435,   457,
      -1,   457,   436,   457,    -1,   436,   457,    -1,   435,   457,
      -1,   457,   437,   457,    -1,   457,   438,   457,    -1,   457,
     439,   457,    -1,   457,   442,   457,    -1,   457,   425,   457,
     426,   457,    -1,   457,   434,   457,    -1,   457,   433,   457,
      -1,   457,   432,   457,    -1,   457,   431,   457,    -1,   457,
     430,   457,    -1,   457,   429,   457,    -1,   457,   428,   457,
      -1,   457,   427,   457,    -1,   440,   457,    -1,    79,    -1,
     458,   443,   458,    -1,   458,   443,   457,    -1,   457,    -1,
     459,    -1,   448,   459,   449,    -1,   457,    -1,   458,    -1,
     457,    -1,   458,    -1,    21,    -1,   519,    -1,   497,   443,
     519,    -1,   464,    -1,   464,   448,   459,   426,   459,   449,
      -1,   216,   445,   460,   446,    -1,   216,   445,   457,   447,
     457,   447,   460,   446,    -1,   278,   445,   460,   446,    -1,
     284,   445,   497,   446,    -1,   295,   445,   465,   446,    -1,
      25,   445,   465,   446,    -1,    26,   445,   465,   446,    -1,
      29,   445,   465,   447,   465,   446,    -1,    29,   445,   457,
     447,   465,   446,    -1,    29,   445,   465,   447,   457,   446,
      -1,    28,   445,   459,   447,   465,   446,    -1,    30,   445,
     459,   447,   459,   447,   465,   446,    -1,    31,   445,   457,
     447,   457,   447,   465,   446,    -1,    32,   445,   457,   447,
     457,   447,   457,   447,   465,   446,    -1,    33,   445,   457,
     447,   457,   447,   457,   447,   457,   447,   465,   446,    -1,
      34,   445,   457,   447,   457,   447,   457,   447,   457,   447,
     457,   447,   465,   446,    -1,   465,   435,   465,    -1,   465,
     435,   457,    -1,   457,   435,   465,    -1,   465,   436,   465,
      -1,   465,   436,   457,    -1,   457,   436,   465,    -1,   465,
     437,   465,    -1,   465,   437,   457,    -1,   457,   437,   465,
      -1,   465,   438,   465,    -1,   465,   438,   457,    -1,   457,
     438,   465,    -1,   465,   439,   465,    -1,   465,   439,   457,
      -1,   457,   439,   465,    -1,   465,   442,   465,    -1,   465,
     442,   457,    -1,   457,   442,   465,    -1,   465,    24,    -1,
     465,   425,   457,   426,   457,    -1,   465,   425,   457,   426,
     465,    -1,   465,   425,   465,   426,   457,    -1,   465,   425,
     465,   426,   465,    -1,   465,   427,   465,    -1,   465,   427,
     457,    -1,   457,   427,   465,    -1,   465,   428,   465,    -1,
     465,   428,   457,    -1,   457,   428,   465,    -1,   465,   434,
     465,    -1,   465,   434,   457,    -1,   457,   434,   465,    -1,
     465,   433,   465,    -1,   465,   433,   457,    -1,   457,   433,
     465,    -1,   465,   431,   465,    -1,   465,   431,   457,    -1,
     457,   431,   465,    -1,   465,   432,   465,    -1,   465,   432,
     457,    -1,   457,   432,   465,    -1,   465,   430,   465,    -1,
     465,   430,   457,    -1,   457,   430,   465,    -1,   465,   429,
     465,    -1,   465,   429,   457,    -1,   457,   429,   465,    -1,
     440,   465,    -1,   445,   465,   446,    -1,   436,   465,    -1,
      22,    -1,   466,    -1,   467,   435,   467,    -1,   466,    -1,
     466,   448,   449,   448,   460,   449,    -1,   466,   448,   460,
     449,   448,   449,    -1,   466,   448,   460,   426,   460,   449,
     448,   449,    -1,   466,   448,   449,   448,   460,   426,   460,
     449,    -1,   468,   450,   467,    -1,   468,   450,   457,    -1,
     468,   450,   465,    -1,    20,   450,   457,    -1,   420,   450,
     457,    -1,   421,   450,   457,    -1,   422,   450,   457,    -1,
     464,   461,   450,   457,    -1,   464,    -1,   471,   450,   465,
      -1,   471,   450,   457,    -1,   471,   450,   467,    -1,   172,
     445,   510,   446,   451,    -1,   452,    -1,   107,   424,    -1,
     107,   424,   448,   449,    -1,   107,   424,   448,   460,   449,
      -1,   107,   424,   448,   460,   449,   448,   460,   449,    -1,
     107,    20,    -1,   107,    21,    -1,   107,    22,    -1,    80,
      20,    -1,    80,    21,    -1,    80,    22,    -1,    80,    38,
      -1,    37,   458,   458,    -1,    37,   141,   510,    -1,   350,
     458,   347,   500,   148,   458,    -1,   350,   458,   347,   500,
     148,   458,    37,   458,    -1,   284,   510,    -1,   284,   347,
     508,    -1,   284,   537,    -1,   284,   535,    -1,   284,   538,
      -1,   284,   197,   457,   447,   457,   447,   457,   447,   457,
      -1,   284,   385,   457,   447,   457,    -1,   201,   284,   343,
     496,    -1,   352,   460,    -1,   252,   287,   460,   447,   460,
      -1,   252,   313,   460,   447,   460,    -1,   252,   313,   458,
     507,    -1,   252,   287,   458,   507,    -1,   117,   458,   252,
     313,   460,   447,   460,    -1,   117,   458,   122,   457,    -1,
     117,   458,   140,    45,   510,    -1,   117,   458,   140,   510,
      -1,   117,   458,   248,   458,    -1,   161,   117,   458,    -1,
     283,    19,   463,    -1,    19,   370,   510,    -1,    19,   370,
     412,   459,    -1,    57,   537,    -1,   252,    57,   133,   510,
      -1,   252,   307,   457,   439,    -1,   252,   179,   457,   439,
      -1,   201,   252,   510,    -1,   322,   369,   457,   447,   457,
     447,   457,   447,   457,    -1,   340,   460,    -1,   336,   497,
      -1,   336,   266,   460,    -1,   368,   496,    -1,   368,   497,
      -1,   497,   201,   512,   458,    -1,   497,   201,   510,    -1,
     480,   510,    -1,   480,   191,   460,    -1,   480,   203,   518,
      -1,   480,   356,   460,    -1,   480,   164,   460,    -1,   480,
     195,   460,    -1,   480,   185,   510,    -1,   480,    71,   133,
     537,    -1,   480,    71,   133,   536,    -1,   480,    71,   537,
      -1,   480,    71,   536,    -1,   480,    71,   535,    -1,   480,
      71,   538,    -1,   480,   457,   447,   457,    -1,   480,    77,
     313,   457,    -1,   480,   534,    -1,   480,   537,    -1,   341,
     165,   510,    -1,   341,    42,   457,   447,   457,    -1,   341,
     510,    -1,   341,   191,   460,    -1,   341,   534,    -1,   341,
     187,   460,    -1,   341,    77,   313,   457,    -1,   341,   293,
     460,    -1,   341,   537,    -1,   341,   535,    -1,   341,   133,
     536,    -1,   341,   133,   537,    -1,   341,   457,   447,   457,
      -1,   341,   105,   458,    -1,   106,   535,    -1,   106,   538,
      -1,   106,   537,    -1,   106,   536,    -1,   106,    77,   313,
     457,    -1,   106,   534,    -1,   106,   334,   313,   457,    -1,
     106,   311,   458,    -1,   214,   140,   460,   343,   458,   447,
     458,    -1,   214,    86,   460,   343,   445,   460,   447,   460,
     447,   460,   446,   447,   458,    -1,   369,   457,   447,   457,
     447,   457,   447,   457,    -1,   418,   457,    -1,   357,   457,
     447,   457,   447,   457,   447,   457,    -1,   342,   458,    -1,
     342,   191,   460,    -1,   342,   534,    -1,   342,   313,   457,
      -1,   342,   537,    -1,   342,   187,   460,    -1,   342,   242,
     457,   447,   457,    -1,   332,   458,    -1,   332,   191,   460,
      -1,   332,   534,    -1,   332,   313,   457,    -1,   332,   537,
      -1,   332,   187,   460,    -1,   332,   242,   457,   447,   457,
      -1,   379,   304,   509,    -1,   410,   304,   509,    -1,   379,
     185,   510,    -1,   410,   185,   510,    -1,    53,   247,   235,
      -1,    53,   247,   379,    -1,    53,   247,   410,    -1,    53,
     247,   386,    -1,   116,   458,    -1,    80,   116,    -1,   194,
     510,    -1,   194,   191,   460,    -1,   194,   203,   518,    -1,
     194,   356,   460,    -1,   194,   164,   460,    -1,   194,   195,
     460,    -1,   194,   185,   510,    -1,   194,    71,   133,   537,
      -1,   194,    71,   133,   536,    -1,   194,    71,   537,    -1,
     194,    71,   536,    -1,   194,    71,   535,    -1,   194,    71,
     538,    -1,   194,   457,   447,   457,    -1,   194,    77,   313,
     457,    -1,   194,   534,    -1,   194,   537,    -1,   145,   510,
      -1,   145,   191,   460,    -1,   145,   347,   460,    -1,   145,
     535,    -1,   145,   538,    -1,   145,   537,    -1,   145,   536,
      -1,   145,    57,   537,    -1,   145,    57,   536,    -1,   496,
     510,    -1,   496,   165,   510,    -1,   496,   347,   505,    -1,
     496,   323,   510,    -1,   496,    59,   164,   457,    -1,   496,
     136,   510,    -1,   496,   136,   347,   460,    -1,   496,   136,
     142,   515,   515,    -1,   496,   136,   272,   457,   447,   457,
      -1,   496,   136,   385,   457,   447,   457,    -1,   347,   504,
      -1,   107,   502,   458,   503,   458,    -1,    80,   502,    -1,
     318,   512,    -1,   142,   515,    -1,   134,   493,    -1,   134,
     202,   495,    -1,   420,    92,   510,    -1,   197,    -1,    71,
      -1,   126,    -1,    47,    -1,   330,    -1,   266,    -1,   174,
      -1,    90,   460,    -1,   482,    -1,   478,    -1,   194,   496,
      -1,   368,   477,    -1,   368,   477,   460,    -1,   477,    -1,
     477,   460,    -1,   477,   105,    -1,   477,   460,   105,    -1,
     477,   105,   458,    -1,   477,   460,   105,   458,    -1,   477,
     496,    -1,   477,   460,   496,    -1,   477,   457,   447,   457,
     447,   457,   447,   457,    -1,   477,   457,   447,   457,    -1,
     482,   426,   457,   447,   457,   447,   457,   447,   457,    -1,
     482,    42,   457,   447,   457,    -1,   482,   510,    -1,   482,
     191,   460,    -1,   482,   165,   510,    -1,   482,   203,   518,
      -1,   482,   535,    -1,   482,   538,    -1,   482,   537,    -1,
     482,   133,   537,    -1,   482,   133,   536,    -1,   482,    49,
     460,    -1,   482,    49,   195,   457,    -1,   482,    49,   347,
     460,    -1,   482,    49,   192,   457,   447,   457,    -1,   482,
      49,   313,   457,    -1,   482,   347,   460,    -1,   482,    44,
     460,   447,   460,    -1,   482,   293,   460,    -1,   482,   534,
      -1,   482,   187,   460,    -1,   482,    77,   313,   457,    -1,
     482,   458,    -1,   482,   320,   445,   457,   447,   457,   446,
      -1,   482,   320,   235,    -1,   482,    83,    -1,   482,   249,
      -1,   482,   189,   347,   460,    -1,   482,   189,   142,   458,
      -1,   482,   189,   242,   457,   447,   457,    -1,   234,    90,
     479,    -1,   234,    90,   458,   479,    -1,   234,    90,   460,
     479,    -1,   234,    90,   460,   458,   479,    -1,    90,   460,
     479,    -1,   478,   165,   510,    -1,   478,   203,   518,    -1,
     478,   496,    -1,   478,   426,   457,   447,   457,   447,   457,
     447,   457,    -1,    90,   460,    72,    -1,   202,   174,   132,
     458,   447,   457,   447,   457,   447,   457,    -1,   202,   174,
     132,   458,   447,   457,   447,   457,   447,   457,   447,   457,
      -1,   282,    -1,   349,    -1,    75,   458,    -1,   125,   458,
      -1,   125,   457,    -1,    83,    -1,    83,   458,    -1,    83,
     205,   132,    -1,    83,   289,   132,    -1,   129,    -1,   129,
     445,   459,   446,    -1,   249,   205,   132,   458,    -1,   249,
     289,   132,   458,    -1,   274,    -1,   274,   343,   117,    -1,
     274,   343,   458,    -1,   252,   517,    -1,   315,   457,    -1,
     163,    -1,   152,   458,    -1,   277,   458,    -1,   497,   165,
     510,    -1,   497,   195,   460,    -1,    21,   195,   460,    -1,
     497,   263,   457,   447,   457,    -1,   497,   263,   457,   447,
     457,   447,   460,    -1,   497,   123,   460,   447,   460,    -1,
     317,   497,   521,   520,    -1,    94,   497,   343,   497,    -1,
      46,   497,   343,   497,    -1,   290,   497,    -1,   321,   497,
     460,    -1,   232,   497,   343,   497,    -1,   333,   497,   428,
     497,    -1,   188,   497,    -1,   188,   497,   303,    -1,   188,
     496,    -1,   188,   284,    -1,   137,    -1,    48,   445,   460,
     447,   460,   447,   457,   447,   457,   447,   457,   446,    -1,
      48,   445,   460,   447,   460,   447,   457,   447,   457,   447,
     457,   447,   510,   447,   510,   447,   510,   446,    -1,    48,
     445,   460,   447,   460,   447,   457,   447,   457,   447,   457,
     447,   510,   447,   510,   447,   510,   447,   510,   446,    -1,
     104,   445,   497,   447,   497,   447,   460,   447,   518,   447,
     457,   447,   457,   447,   460,   447,   460,   446,    -1,   204,
     445,   497,   447,   494,   447,   460,   447,   457,   447,   510,
     447,   457,   447,   460,   447,   497,   446,    -1,   236,   445,
     497,   447,   460,   446,    -1,   236,   445,   497,   447,   465,
     447,   460,   446,    -1,   236,   445,   497,   447,   465,   447,
     460,   447,   458,   447,   510,   446,    -1,   236,   445,   497,
     447,   497,   446,    -1,   236,   445,   497,   447,   497,   447,
     284,   447,   510,   446,    -1,   236,   445,   497,   447,   497,
     447,   460,   446,    -1,   236,   445,   497,   447,   497,   447,
     284,   447,   460,   446,    -1,   285,   445,   497,   447,   460,
     446,    -1,   511,   445,   497,   447,   460,   446,    -1,   511,
     445,   497,   447,   460,   447,   497,   447,   459,   447,   460,
     446,    -1,   522,   445,   497,   447,   460,   446,    -1,   522,
     445,   497,   447,   523,   447,   530,   447,   524,   447,   525,
     446,    -1,   522,   445,   497,   447,   523,   447,   530,   447,
     524,   447,   525,   447,   526,   447,   527,   446,    -1,   522,
     445,   497,   447,   497,   447,   525,   447,   528,   447,   526,
     447,   523,   447,   510,   447,   530,   447,   457,   447,   510,
     447,   524,   447,   527,   446,    -1,   522,   445,   497,   447,
     497,   447,   525,   447,   528,   447,   526,   447,   497,   447,
     510,   447,   530,   447,   457,   447,   510,   447,   524,   447,
     527,   446,    -1,   365,   445,   497,   447,   529,   447,   460,
     447,   460,   447,   460,   446,    -1,   365,   445,   497,   447,
     529,   447,   460,   447,   460,   447,   460,   447,   497,   446,
      -1,   183,   445,   497,   447,   465,   447,   531,   447,   510,
     446,    -1,   183,   445,   497,   447,   497,   447,   465,   447,
     531,   447,   510,   446,    -1,   399,   445,   497,   447,   497,
     447,   457,   447,   457,   446,    -1,   166,   445,   497,   447,
     465,   447,   510,   447,   510,   446,    -1,   166,   445,   497,
     447,   465,   447,   510,   447,   510,   447,   497,   446,    -1,
     166,   445,   497,   447,   497,   447,   510,   447,   510,   447,
     497,   446,    -1,   119,   445,   497,   447,   460,   446,    -1,
     119,   445,   497,   447,   460,   447,   460,   447,   460,   446,
      -1,   119,   445,   497,   447,   497,   447,   460,   447,   460,
     447,   460,   446,    -1,   182,   445,   497,   446,    -1,   182,
     445,   497,   447,   497,   446,    -1,   381,   445,   497,   447,
     497,   447,   460,   447,   510,   446,    -1,   381,   445,   497,
     447,   497,   447,   460,   447,   510,   447,   497,   446,    -1,
     196,   445,   497,   447,   497,   446,    -1,   196,   445,   497,
     447,   497,   447,   497,   446,    -1,   151,   445,   497,   447,
     497,   447,   458,   447,   457,   447,   457,   447,   457,   447,
     457,   447,   457,   447,   457,   447,   457,   446,    -1,   288,
     445,   497,   447,   465,   446,    -1,   288,   445,   497,   447,
     284,   447,   510,   446,    -1,   302,   445,   497,   447,   497,
     447,   460,   447,   460,   446,    -1,   302,   445,   497,   447,
     497,   447,   458,   446,    -1,   302,   445,   497,   447,   497,
     447,   533,   446,    -1,    53,    -1,    53,   379,    -1,    53,
     410,    -1,    53,   497,    -1,    54,    -1,   138,   496,    -1,
     279,   458,    -1,   279,    63,   458,    -1,   279,    68,   458,
      -1,   279,    68,   512,   458,    -1,    68,   504,   458,    -1,
     188,    68,    -1,   306,   458,    -1,   279,   504,   458,    -1,
     279,   504,   512,   458,    -1,   279,   239,   458,    -1,   279,
     239,   512,   458,    -1,   371,   497,    -1,   371,   497,   142,
     458,    -1,   371,   497,   132,   458,    -1,   371,   497,   132,
     458,   142,   458,    -1,   303,   458,    -1,   202,   458,    -1,
     234,    -1,   234,   148,   458,    -1,   276,    -1,   268,    -1,
      95,    -1,   322,   460,    -1,    80,   322,    -1,    80,   477,
      -1,   252,   192,   506,    -1,    52,   282,   510,    -1,   138,
     510,    -1,   138,   309,    -1,   138,   139,    -1,   138,    81,
      -1,   487,    -1,   543,    -1,   497,   510,    -1,   497,   347,
     504,    -1,   497,   347,   401,   460,   447,   460,    -1,   497,
     191,   460,    -1,   497,   334,   460,    -1,   497,   334,   537,
      -1,   497,   334,   536,    -1,   497,   334,   538,    -1,   497,
     334,   535,    -1,   497,   334,   133,   537,    -1,   497,   334,
     133,   536,    -1,   497,   334,   313,   457,    -1,   497,   334,
      77,   460,    -1,   497,   334,    77,   534,    -1,   497,   334,
     314,   460,    -1,   497,   197,   347,   460,    -1,   497,   197,
     347,   460,   447,   460,   447,   460,    -1,   497,   197,   347,
     460,   447,   460,   447,   460,   447,   457,    -1,   497,   197,
     347,   460,   447,   460,   447,   460,   447,   457,   447,   457,
      -1,   497,   197,   535,    -1,   497,   197,   538,    -1,   497,
     197,   537,    -1,   497,   197,   536,    -1,   497,   133,   347,
     460,    -1,   497,   133,   296,   460,    -1,   497,   133,   537,
      -1,   497,   133,   536,    -1,   497,    62,   510,    -1,   497,
      62,   347,   460,    -1,   497,   124,   510,    -1,   497,    55,
     510,    -1,   497,    55,   347,   460,    -1,   497,    55,    77,
     313,   457,    -1,   497,    55,   534,    -1,   497,    55,   537,
      -1,   497,    55,   293,   460,    -1,   497,    55,   142,   515,
      -1,   497,    55,   272,   460,    -1,   497,    55,   242,   457,
     447,   457,    -1,   497,    55,   273,   458,    -1,   497,    55,
      46,   458,    -1,   497,    55,   314,   460,    -1,   497,    55,
     314,   460,   447,   460,    -1,   497,   128,   510,    -1,   497,
     128,   539,    -1,   497,   128,   537,    -1,   497,   128,   536,
      -1,   497,   128,   313,   457,    -1,   497,   128,   538,    -1,
     497,   128,   535,    -1,   497,   128,   292,   538,    -1,   497,
     128,   292,   535,    -1,   497,   128,   292,    82,   510,    -1,
     497,   128,   292,    82,   195,   457,    -1,   549,   537,    -1,
     549,   538,    -1,   549,   535,    -1,   549,    49,   347,   460,
      -1,   549,    49,   195,   457,    -1,   549,    49,   192,   457,
     447,   457,    -1,   497,    87,   419,   457,   447,   457,    -1,
     497,    87,   238,   460,    -1,   550,   426,   457,   447,   457,
     447,   457,   447,   457,    -1,    87,   460,   426,   457,   447,
     457,   447,   457,   447,   457,    -1,   550,    53,    -1,   550,
     191,   460,    -1,   550,   165,   510,    -1,   550,   535,    -1,
     550,   538,    -1,   550,   537,    -1,   550,   187,   460,    -1,
     550,   534,    -1,   550,    77,   313,   457,    -1,   497,    84,
     460,    -1,   497,    84,   458,    -1,   497,    93,   165,   510,
      -1,   497,    93,   537,    -1,   497,    93,   538,    -1,   497,
      93,   189,   457,   447,   457,   447,   457,    -1,   497,    88,
     458,    -1,   497,   194,   458,    -1,   497,   194,   510,    -1,
     510,    -1,   191,   460,    -1,   347,   417,   510,    -1,   338,
     489,    -1,   338,   544,    -1,   337,   490,    -1,   337,   545,
      -1,   189,   491,    -1,   189,   542,    -1,    59,   492,    -1,
     242,   457,   447,   457,    -1,   510,    -1,   213,   457,    -1,
     220,   339,   460,    -1,   262,   294,   510,    -1,   243,   457,
      -1,   244,   457,    -1,   106,   460,    -1,   514,    -1,   213,
     313,   457,    -1,   220,   313,   457,    -1,   537,    -1,   213,
     537,    -1,   220,   537,    -1,   538,    -1,   213,   538,    -1,
     220,   538,    -1,   213,   535,    -1,   220,   535,    -1,   213,
     155,   510,    -1,   220,   155,   510,    -1,   539,    -1,   319,
     347,   501,    -1,   319,   460,    -1,   213,   460,   447,   457,
      -1,   220,   460,   447,   457,    -1,   510,    -1,   272,   460,
      -1,   142,   515,    -1,   142,   457,    -1,    46,   458,    -1,
     273,   458,    -1,    43,   460,    -1,   314,   460,    -1,   326,
     460,    -1,   539,    -1,   143,   458,    -1,   327,   457,    -1,
     329,   457,    -1,   327,   347,   319,    -1,   327,   347,    52,
      -1,   329,   347,   319,    -1,   329,   347,    52,    -1,    77,
     313,   457,    -1,   534,    -1,   537,    -1,   460,   447,   458,
      -1,   242,    52,    -1,   242,   319,    -1,   242,   457,   447,
     457,    -1,   458,    -1,   192,   258,    -1,   192,   253,    -1,
     262,    52,    -1,   262,   319,    -1,   262,   457,   447,   457,
      -1,   187,   513,    -1,    77,   313,   457,    -1,   534,    -1,
     537,    -1,   539,    -1,   510,    -1,   537,    -1,   535,    -1,
     538,    -1,   342,   458,    -1,   143,   458,    -1,   368,   460,
     254,    -1,   272,   457,    -1,   215,   328,   460,    -1,   345,
     510,    -1,   366,   143,   458,    -1,   149,    -1,   335,    -1,
     351,    -1,   286,    -1,   143,    -1,   154,    -1,   153,   461,
      -1,   496,   443,   310,    -1,   496,   443,   309,   461,    -1,
     310,    -1,   309,   461,    -1,   499,   488,    -1,   496,   499,
     488,    -1,   380,    -1,   411,    -1,    40,    -1,    41,    -1,
       6,    -1,     7,    -1,     8,    -1,     9,    -1,    11,    -1,
      10,    -1,    12,    -1,    13,    -1,    14,    -1,    15,    -1,
      16,    -1,    17,    -1,   235,    -1,   339,    -1,    69,    -1,
     173,    -1,   245,    -1,   211,    -1,   256,    -1,   385,    -1,
     306,    -1,    59,    -1,    60,    -1,    61,    -1,   403,    -1,
     390,    -1,   394,    -1,   391,    -1,   395,    -1,   393,    -1,
     392,    -1,   396,    -1,   397,    -1,   398,    -1,   388,    -1,
     389,    -1,   401,    -1,   402,    -1,   387,    -1,   400,    -1,
     385,    -1,    78,    -1,   264,    -1,   316,    -1,   135,    -1,
     260,    -1,   146,    -1,   135,    -1,   190,    -1,   269,    -1,
      35,    -1,    65,    -1,   193,    -1,   291,    -1,   265,    -1,
     267,    -1,   168,    -1,   353,    -1,   170,    -1,   355,    -1,
     237,    -1,   206,    -1,   281,    -1,   207,    -1,   108,    -1,
     246,    -1,   241,    -1,   297,    -1,   301,    -1,   299,    -1,
     298,    -1,   300,    -1,   120,    -1,   261,    -1,   291,    -1,
     193,    -1,    76,    -1,   177,    -1,   251,    -1,    69,    -1,
     103,    -1,   130,    -1,   150,    -1,   305,    -1,   127,    -1,
      91,    -1,   271,    -1,   102,    -1,   223,    -1,   415,    -1,
     227,    -1,   221,    -1,   228,    -1,    98,    -1,   230,    -1,
     231,    -1,   229,    -1,   100,    -1,    99,    -1,   101,    -1,
     167,    -1,   222,    -1,   224,    -1,   416,    -1,   110,    -1,
     112,    -1,   114,    -1,   226,    -1,   109,    -1,   111,    -1,
     113,    -1,   225,    -1,   237,    -1,    36,    -1,   233,    -1,
     348,    -1,   121,    -1,   291,    -1,   193,    -1,   177,    -1,
     251,    -1,   369,    -1,   357,    -1,   376,    -1,   404,    -1,
     377,    -1,   405,    -1,   406,    -1,   407,    -1,   408,    -1,
     409,    -1,    50,    -1,   115,    -1,   376,    -1,   404,    -1,
     118,    -1,   131,    -1,   184,    -1,   186,    -1,   280,    -1,
      89,    -1,    18,    -1,   147,    -1,   257,    -1,   212,    -1,
     259,    -1,    85,    -1,    89,    -1,    18,    -1,   180,    -1,
     270,    -1,   158,    -1,    76,    -1,   235,    -1,   335,    -1,
     144,    -1,    58,    -1,    96,    -1,    97,    -1,   156,    -1,
     157,    -1,    73,    -1,    74,    -1,   235,    -1,   346,    -1,
     255,    -1,   367,    -1,   160,    -1,   159,    -1,    67,    -1,
     198,    -1,   320,    -1,    51,    -1,   384,    -1,   399,    -1,
     218,    -1,   215,    -1,    56,    -1,   308,    -1,   331,    -1,
     176,    -1,   175,    -1,   218,    -1,   215,    -1,   219,    -1,
     140,   460,    -1,   140,   458,    -1,   199,   460,    -1,   256,
     460,    -1,    86,   460,    -1,    86,   458,    -1,    86,   445,
     460,   447,   460,   447,   460,   446,    -1,   200,   457,    -1,
     262,   540,    -1,   237,    -1,   250,    -1,    69,    -1,   252,
     192,   507,    -1,   252,   313,   423,   423,    -1,   252,   460,
      -1,   252,   179,   460,    -1,   106,   140,   318,   457,    -1,
     322,   369,   457,   447,   457,   447,   457,   447,   457,   338,
     457,   447,   457,   447,   457,   447,   457,    -1,   341,   538,
      -1,   342,   538,    -1,   332,   538,    -1,   194,    71,   510,
      -1,   194,   378,   457,    -1,   194,   406,   457,    -1,   194,
     330,   460,   458,    -1,   194,    71,   133,   510,    -1,   194,
      71,   133,   368,   546,    -1,   194,   535,    -1,   194,   538,
      -1,   496,   189,   510,    -1,   496,   347,   208,    -1,   496,
     347,   210,    -1,   496,   347,   209,    -1,   496,   347,    59,
      -1,   496,   347,   162,    -1,   496,   347,   324,    -1,   496,
     347,   325,    -1,   369,   383,   457,    -1,   369,   382,   457,
      -1,   369,   414,   457,    -1,   369,   413,   457,    -1,   357,
     383,   457,    -1,   357,   382,   457,    -1,   357,   414,   457,
      -1,   357,   413,   457,    -1,   194,   192,   457,    -1,   145,
     133,   510,    -1,   496,    53,   347,    52,    -1,   496,    53,
     347,   319,    -1,   161,   117,   457,    -1,   275,   200,    64,
     457,    -1,   275,   200,   178,   457,    -1,   275,   538,    -1,
     538,    -1,   547,    -1,   497,   334,   133,   460,    -1,   497,
     314,   460,    -1,   497,   133,   460,    -1,   497,   128,   347,
     548,    -1,   497,   334,    76,   510,    -1,   497,   535,    -1,
     497,   538,    -1,   497,   537,    -1,   497,   133,   368,   546,
      -1,   497,   403,   457,   447,   457,    -1,   497,   128,   195,
     457,    -1,   497,   128,   292,   510,    -1,   213,   510,    -1,
     220,   510,    -1,    39,   510,    -1,   218,   423,    -1,   215,
     423,    -1,   205,   510,    -1,   347,    52,    -1,   347,   319,
      -1,   220,   457,    -1,   313,   457,    -1,   460,   447,   457,
      -1,   547,    -1,   538,    -1,   347,    52,    -1,   347,   319,
      -1,   192,   319,    -1,   192,   169,    -1,   192,   354,    -1,
     262,   246,   339,    -1,   262,    66,   339,    -1,   547,    -1,
     312,   516,    -1,   235,    -1,    86,    -1,   256,    -1,   248,
     548,    -1,   344,    -1,    70,    -1,   193,    -1,   291,    -1,
      69,    -1,   497,   358,    -1,   497,    87,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   753,   753,   754,   758,   765,   766,   769,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   792,   793,   794,   795,   796,   797,   804,
     821,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   841,   845,   849,   853,   857,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   873,   877,
     878,   879,   880,   881,   882,   883,   884,   885,   890,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   926,   929,
     933,   942,   952,   961,   971,   974,   989,   992,  1007,  1008,
    1021,  1037,  1041,  1063,  1081,  1099,  1116,  1145,  1152,  1159,
    1167,  1178,  1185,  1192,  1199,  1206,  1213,  1220,  1227,  1234,
    1245,  1252,  1259,  1270,  1277,  1284,  1295,  1302,  1313,  1325,
    1333,  1341,  1353,  1361,  1369,  1388,  1403,  1418,  1425,  1434,
    1447,  1460,  1473,  1484,  1491,  1498,  1511,  1518,  1525,  1536,
    1543,  1550,  1561,  1568,  1575,  1586,  1593,  1600,  1611,  1618,
    1625,  1636,  1643,  1650,  1661,  1668,  1675,  1682,  1689,  1705,
    1708,  1709,  1723,  1740,  1757,  1774,  1791,  1810,  1821,  1829,
    1870,  1871,  1872,  1873,  1874,  1883,  1909,  1920,  1927,  1944,
    1948,  1953,  1969,  1977,  1988,  1996,  1997,  1998,  1999,  2000,
    2005,  2015,  2016,  2034,  2037,  2044,  2055,  2056,  2057,  2058,
    2059,  2060,  2067,  2075,  2079,  2090,  2091,  2092,  2093,  2094,
    2109,  2123,  2137,  2151,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2178,  2183,  2187,  2188,  2191,
    2195,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,
    2208,  2209,  2210,  2211,  2212,  2215,  2216,  2217,  2222,  2223,
    2225,  2226,  2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,
    2235,  2237,  2240,  2241,  2242,  2243,  2244,  2245,  2246,  2247,
    2248,  2256,  2269,  2276,  2279,  2287,  2288,  2289,  2290,  2291,
    2292,  2293,  2296,  2297,  2298,  2299,  2300,  2301,  2302,  2305,
    2306,  2307,  2308,  2309,  2310,  2311,  2312,  2313,  2322,  2324,
    2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,
    2335,  2336,  2337,  2339,  2340,  2341,  2343,  2344,  2345,  2346,
    2347,  2348,  2349,  2350,  2351,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2365,  2368,  2372,  2375,  2382,  2383,  2384,
    2385,  2386,  2387,  2394,  2395,  2396,  2397,  2398,  2399,  2400,
    2404,  2418,  2419,  2423,  2432,  2433,  2450,  2451,  2464,  2465,
    2471,  2485,  2494,  2496,  2504,  2511,  2515,  2521,  2524,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,
    2542,  2544,  2545,  2551,  2552,  2553,  2554,  2555,  2556,  2558,
    2566,  2567,  2568,  2569,  2570,  2571,  2575,  2579,  2587,  2591,
    2598,  2599,  2600,  2601,  2602,  2608,  2610,  2634,  2660,  2661,
    2664,  2665,  2666,  2673,  2674,  2675,  2676,  2677,  2678,  2679,
    2685,  2687,  2694,  2695,  2699,  2709,  2711,  2718,  2719,  2733,
    2734,  2735,  2736,  2737,  2754,  2757,  2761,  2762,  2772,  2773,
    2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,  2784,  2790,
    2796,  2799,  2814,  2818,  2829,  2839,  2844,  2852,  2865,  2881,
    2884,  2887,  2891,  2894,  2901,  2910,  2931,  2952,  2955,  2959,
    2964,  2969,  2972,  2976,  2980,  2985,  2988,  2991,  2994,  2997,
    3000,  3003,  3006,  3009,  3012,  3024,  3041,  3057,  3061,  3066,
    3069,  3074,  3079,  3084,  3085,  3086,  3094,  3095,  3096,  3097,
    3098,  3111,  3114,  3115,  3125,  3132,  3136,  3140,  3147,  3155,
    3163,  3172,  3180,  3181,  3182,  3183,  3184,  3185,  3186,  3187,
    3188,  3194,  3199,  3200,  3201,  3202,  3203,  3208,  3209,  3213,
    3214,  3216,  3220,  3222,  3223,  3224,  3225,  3226,  3227,  3228,
    3229,  3230,  3231,  3232,  3238,  3239,  3244,  3253,  3265,  3266,
    3267,  3268,  3270,  3271,  3272,  3289,  3309,  3310,  3312,  3313,
    3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,  3323,  3324,
    3325,  3327,  3329,  3330,  3331,  3333,  3334,  3335,  3337,  3339,
    3340,  3341,  3342,  3344,  3345,  3346,  3347,  3348,  3349,  3352,
    3357,  3358,  3364,  3373,  3374,  3375,  3376,  3377,  3378,  3379,
    3380,  3381,  3383,  3384,  3391,  3392,  3393,  3394,  3397,  3398,
    3399,  3403,  3404,  3406,  3407,  3408,  3409,  3410,  3411,  3412,
    3413,  3414,  3421,  3422,  3423,  3424,  3425,  3426,  3427,  3428,
    3429,  3430,  3431,  3432,  3433,  3434,  3435,  3436,  3437,  3438,
    3439,  3440,  3441,  3442,  3443,  3444,  3448,  3455,  3456,  3457,
    3458,  3459,  3460,  3461,  3462,  3463,  3464,  3465,  3469,  3470,
    3471,  3472,  3473,  3474,  3475,  3476,  3477,  3478,  3488,  3489,
    3490,  3495,  3496,  3497,  3498,  3499,  3500,  3502,  3503,  3504,
    3505,  3506,  3508,  3509,  3510,  3511,  3514,  3515,  3516,  3517,
    3518,  3519,  3520,  3523,  3524,  3527,  3528,  3529,  3531,  3532,
    3536,  3549,  3562,  3575,  3591,  3592,  3596,  3597,  3598,  3599,
    3603,  3604,  3605,  3606,  3607,  3608,  3609,  3610,  3611,  3612,
    3613,  3614,  3618,  3619,  3620,  3624,  3625,  3629,  3630,  3633,
    3634,  3635,  3636,  3637,  3638,  3639,  3640,  3641,  3642,  3643,
    3644,  3645,  3646,  3647,  3648,  3649,  3650,  3651,  3652,  3653,
    3657,  3658,  3659,  3660,  3661,  3662,  3666,  3667,  3671,  3672,
    3676,  3677,  3678,  3679,  3680,  3681,  3682,  3683,  3684,  3685,
    3688,  3689,  3690,  3691,  3692,  3695,  3696,  3699,  3700,  3701,
    3702,  3703,  3707,  3708,  3718,  3719,  3720,  3723,  3724,  3725,
    3728,  3729,  3730,  3731,  3732,  3733,  3734,  3735,  3736,  3737,
    3738,  3739,  3740,  3741,  3742,  3743,  3744,  3745,  3746,  3747,
    3748,  3749,  3750,  3751,  3752,  3753,  3754,  3755,  3756,  3757,
    3758,  3759,  3762,  3763,  3764,  3767,  3768,  3769,  3770,  3771,
    3772,  3775,  3776,  3779,  3780,  3781,  3782,  3783,  3784,  3785,
    3786,  3789,  3790,  3793,  3794,  3798,  3799,  3800,  3801,  3806,
    3807,  3811,  3812,  3813,  3817,  3818,  3819,  3820,  3824,  3825,
    3829,  3830,  3831,  3835,  3836,  3837,  3838,  3842,  3843,  3844,
    3845,  3846,  3847,  3851,  3852,  3853,  3854,  3855,  3856,  3857,
    3860,  3861,  3862,  3863,  3864,  3867,  3868,  3869,  3870,  3871,
    3872,  3873,  3876,  3877,  3878,  3882,  3886,  3894,  3907,  3920,
    3930,  3940,  3959,  3974,  3980,  3981,  3982,  3987,  3998,  3999,
    4000,  4002,  4004,  4007,  4009,  4010,  4011,  4016,  4017,  4018,
    4025,  4026,  4027,  4028,  4030,  4031,  4032,  4033,  4034,  4035,
    4036,  4037,  4039,  4040,  4041,  4042,  4043,  4044,  4045,  4046,
    4048,  4050,  4051,  4052,  4053,  4054,  4055,  4056,  4061,  4062,
    4072,  4086,  4087,  4109,  4110,  4111,  4112,  4113,  4114,  4115,
    4116,  4117,  4127,  4128,  4129,  4130,  4131,  4132,  4133,  4134,
    4141,  4149,  4150,  4153,  4157,  4158,  4163,  4164,  4165,  4166,
    4167,  4168,  4169,  4170,  4188,  4189,  4190,  4193,  4196,  4197,
    4198,  4199,  4200,  4203,  4206
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KEY_VAR", "KEY_VEC", "KEY_MAT",
  "KEY_CONST", "KEY_UNIT", "KEY_FUNC_I", "KEY_FUNC_D", "KEY_FUNC_NN",
  "KEY_FUNC_ND", "KEY_FUNC_DD", "KEY_FUNC_NND", "KEY_FUNC_PPD",
  "KEY_FUNC_PPPD", "KEY_FUNC_PPPPD", "KEY_FUNC_PPPPPD", "INDEX", "DATE",
  "VAR_D", "VEC_D", "MAT_D", "CONSTANT", "UCONSTANT", "FUNC_I", "FUNC_D",
  "FUNC_NN", "FUNC_ND", "FUNC_DD", "FUNC_NND", "FUNC_PPD", "FUNC_PPPD",
  "FUNC_PPPPD", "FUNC_PPPPPD", "ABOVE", "ABSOLUTE", "ALIAS", "ALLVARS",
  "ALT", "ALTXAXIS", "ALTYAXIS", "ANCHOR", "ANGLE", "ANGLES",
  "ANTIALIASING", "APPEND", "ARC", "ARRANGE", "ARROW", "ASCENDING",
  "ASPLINE", "AUTO", "AUTOSCALE", "AUTOTICKS", "AVALUE", "AVG",
  "BACKGROUND", "BACKWARD", "BAR", "BARDY", "BARDYDY", "BASELINE", "BATCH",
  "BEGIN", "BELOW", "BETWEEN", "BLACKMAN", "BLOCK", "BOTH", "BOTTOM",
  "BOX", "BREAK", "BSPLINE", "BSPLINE_CENTERED", "CD", "CENTER", "CHAR",
  "CHART", "CHRSTR", "CLEAR", "CLICK", "CLIP", "CLOSE", "CMAP",
  "COEFFICIENTS", "COLOR", "COLORBAR", "COMMENT", "COMPLEX", "COMPOUND",
  "COMPUTING", "CONSTRAINTS", "CONTOUR", "COPY", "CYCLE", "DAUBECHIES",
  "DAUBECHIES_CENTERED", "DAYMONTH", "DAYOFWEEKL", "DAYOFWEEKS",
  "DAYOFYEAR", "DDMMYY", "DECIMAL", "DECIMATE", "DEF", "DEFAULT", "DEFINE",
  "DEGREES", "DEGREESLAT", "DEGREESLON", "DEGREESMMLAT", "DEGREESMMLON",
  "DEGREESMMSSLAT", "DEGREESMMSSLON", "DESCENDING", "DESCRIPTION",
  "DEVICE", "DFT", "DIFFERENCE", "DISK", "DOWN", "DPI", "DROP", "DROPLINE",
  "ECHO", "ELLIPSE", "ENGINEERING", "ERRORBAR", "EXIT", "EXPONENTIAL",
  "FFT", "FILEP", "FILL", "FIT", "FIXED", "FIXEDPOINT", "FLUSH", "FOCUS",
  "FOLLOWS", "FONTP", "FORCE", "FORMAT", "FORMULA", "FORWARD", "FRAMEP",
  "FREE", "FREQUENCY", "FROM", "GAUSSIAN", "GENERAL", "GEOTRANSFORM",
  "GETP", "GRAPH", "GRAPHNO", "GRID", "HAAR", "HAAR_CENTERED", "HALF",
  "HAMMING", "HANNING", "HARDCOPY", "HBAR", "HELP", "HGAP", "HIDDEN",
  "HISTOGRAM", "HMS", "HORIZI", "HORIZONTAL", "HORIZO", "ID", "IF",
  "IFILTER", "IMAGE", "IMAX", "IMIN", "IN", "INCREMENT", "INOUT", "INSEGX",
  "INT", "INTEGRATE", "INTERPOLATE", "INVDFT", "INVERT", "INVFFT", "JUST",
  "KILL", "LABEL", "LANDSCAPE", "LAYER", "LAYOUT", "LEFT", "LEGEND",
  "LENGTH", "LINCONV", "LINE", "LINEAR", "LINESTYLE", "LINEWIDTH", "LINK",
  "LOAD", "LOCTYPE", "LOESS", "LOG", "LOGARITHMIC", "LOGIT", "LOGX",
  "LOGXY", "LOGY", "MAGIC", "MAGNITUDE", "MAJOR", "MAP", "MAXP", "MESH",
  "MESH2D", "MINP", "MINMAXP", "MINOR", "MMDD", "MMDDHMS", "MMDDYY",
  "MMDDYYHMS", "MMSSLAT", "MMSSLON", "MMYY", "MONTHDAY", "MONTHL",
  "MONTHS", "MONTHSY", "MOVE", "NEGATE", "NEW", "NONE", "NONLFIT",
  "NORMAL", "NTICKS", "NXY", "OBJ", "OFF", "OFFSET", "OFFSETX", "OFFSETY",
  "OFILTER", "ON", "ONREAD", "OP", "OPEN", "OPPOSITE", "OUT", "PAGE",
  "PARA", "PARAMETERS", "PARZEN", "PATTERN", "PERIOD", "PERP", "PHASE",
  "PIE", "PIPE", "PLACE", "POINT", "POLAR", "POLYI", "POLYLINE", "POLYO",
  "POP", "PORTRAIT", "POSITIVE", "POWER", "PREC", "PREPEND", "PRINT", "PS",
  "PUSH", "PUTP", "RAND", "READ", "REAL", "RECIPROCAL", "REDRAW",
  "REFERENCE", "REGNUM", "REGRESS", "RESIDUALS", "RESIZE", "RESTRICT",
  "RESULTS", "REVERSE", "RIGHT", "RISER", "ROT", "ROUNDED", "RSUM", "RULE",
  "RUNAVG", "RUNMAX", "RUNMED", "RUNMIN", "RUNSTD", "SAMPLE", "SAVEALL",
  "SCALE", "SCIENTIFIC", "SELXY", "SCROLL", "SD", "SET", "SETNUM",
  "SFORMAT", "SIGN", "SIZE", "SKIP", "SLEEP", "SMITH", "SORT", "SOURCE",
  "SPEC", "SPLINE", "SPLIT", "STACK", "STACKED", "STACKEDBAR",
  "STACKEDHBAR", "STAGGER", "START", "STEPS", "STOP", "STRING", "SUM",
  "SUBTITLE", "SWAP", "SYMBOL", "SYMMETRIC", "TARGET", "TICKLABEL",
  "TICKP", "TICKSP", "TIMER", "TIMESTAMP", "TITLE", "TO", "TOP", "TRACE",
  "TRIANGULAR", "TYPE", "UP", "UPDATEALL", "USE", "VALUES", "VERSION",
  "VERTI", "VERTICAL", "VERTO", "VGAP", "VIEW", "VMAP", "VX1", "VX2",
  "VXMAX", "VY1", "VY2", "VYMAX", "WAVELET", "WEIGHT", "WELCH", "WITH",
  "WORLD", "WRAP", "WRITE", "WX1", "WX2", "WY1", "WY2", "X_TOK", "X0",
  "X1", "XAXES", "XAXIS", "XCOR", "XMAX", "XMIN", "XSPLINE", "XY",
  "XYAXES", "XYBOXPLOT", "XYCOLOR", "XYCOLPAT", "XYDX", "XYDXDX",
  "XYDXDXDYDY", "XYDXDY", "XYDY", "XYDYDY", "XYHILO", "XYR", "XYSIZE",
  "XYSPLINE", "XYSTRING", "XYCMAP", "XYVMAP", "XYZ", "Y_TOK", "Y0", "Y1",
  "Y2", "Y3", "Y4", "YAXES", "YAXIS", "YEAR", "YMAX", "YMIN", "YYMMDD",
  "YYMMDDHMS", "ZERO", "ZNORM", "ZSCALE", "FITPARM", "FITPMAX", "FITPMIN",
  "NUMBER", "NEW_TOKEN", "'?'", "':'", "OR", "AND", "NE", "EQ", "GE", "LE",
  "LT", "GT", "'+'", "'-'", "'*'", "'/'", "'%'", "NOT", "UMINUS", "'^'",
  "'.'", "';'", "'('", "')'", "','", "'['", "']'", "'='", "'{'", "'}'",
  "$accept", "full_list", "multi_list", "list", "expr", "sexpr", "iexpr",
  "nexpr", "indx", "jdate", "jrawdate", "array", "vexpr", "matrix",
  "mexpr", "lside_matrix", "masgn", "asgn", "lside_array", "vasgn",
  "flowcontrol", "defines", "regionset", "parmset", "objtyp",
  "thiscompound", "incompound", "thislegend", "setpobj", "selobj",
  "objects", "actions", "options", "set_setprop", "setprop", "axisfeature",
  "tickattr", "ticklabelattr", "axislabeldesc", "axisbardesc",
  "nonlfitopts", "nonlfamily", "nonlloadtype", "selectgraph", "selectset",
  "setaxis", "axis", "proctype", "tickspectype", "filtertype",
  "filtermethod", "xytype", "graphtype", "pagelayout", "pageorient",
  "regiontype", "scaletype", "onoff", "runtype", "sourcetype",
  "justchoice", "inoutchoice", "formatchoice", "signchoice", "direction",
  "worldview", "datacolumn", "sortdir", "sorton", "ffttype", "fourierdata",
  "fourierloadx", "fourierloady", "fourierinseg", "fourieroutsg",
  "fouriernorm", "waveletype", "windowtype", "interpmethod", "stattype",
  "minmaxp", "font_select", "lines_select", "pattern_select",
  "color_select", "linew_select", "opchoice_sel", "opchoice",
  "parmset_obs", "axislabeldesc_obs", "setprop_obs", "tickattr_obs",
  "ticklabelattr_obs", "colpat_obs", "opchoice_sel_obs", "opchoice_obs",
  "vectormap", "colorbar", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,    63,    58,   680,   681,   682,
     683,   684,   685,   686,   687,    43,    45,    42,    47,    37,
     688,   689,    94,    46,    59,    40,    41,    44,    91,    93,
      61,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   453,   454,   454,   454,   455,   455,   456,   456,   456,
     456,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   456,   456,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   458,   458,
     458,   459,   460,   461,   462,   462,   463,   463,   464,   464,
     464,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   466,
     467,   467,   468,   468,   468,   468,   468,   469,   469,   469,
     470,   470,   470,   470,   470,   471,   472,   472,   472,   473,
     473,   474,   474,   474,   474,   474,   474,   474,   474,   474,
     474,   474,   474,   474,   474,   474,   475,   475,   475,   475,
     475,   475,   475,   475,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   477,   477,   477,   477,   477,   477,   477,
     478,   479,   479,   480,   481,   481,   482,   482,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   485,   485,   485,   485,   485,   485,   486,   486,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   488,   488,   488,   488,   488,   488,   488,   488,   488,
     488,   488,   489,   489,   489,   489,   489,   489,   489,   489,
     489,   489,   489,   489,   489,   489,   489,   489,   489,   489,
     489,   489,   489,   489,   489,   489,   489,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     491,   491,   492,   492,   492,   492,   493,   493,   493,   493,
     493,   493,   493,   494,   494,   495,   495,   495,   496,   496,
     497,   497,   497,   497,   498,   498,   499,   499,   499,   499,
     500,   500,   500,   500,   500,   500,   500,   500,   500,   500,
     500,   500,   501,   501,   501,   502,   502,   503,   503,   504,
     504,   504,   504,   504,   504,   504,   504,   504,   504,   504,
     504,   504,   504,   504,   504,   504,   504,   504,   504,   504,
     505,   505,   505,   505,   505,   505,   506,   506,   507,   507,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     509,   509,   509,   509,   509,   510,   510,   511,   511,   511,
     511,   511,   512,   512,   513,   513,   513,   514,   514,   514,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   516,   516,   516,   517,   517,   517,   517,   517,
     517,   518,   518,   519,   519,   519,   519,   519,   519,   519,
     519,   520,   520,   521,   521,   522,   522,   522,   522,   523,
     523,   524,   524,   524,   525,   525,   525,   525,   526,   526,
     527,   527,   527,   528,   528,   528,   528,   529,   529,   529,
     529,   529,   529,   530,   530,   530,   530,   530,   530,   530,
     531,   531,   531,   531,   531,   532,   532,   532,   532,   532,
     532,   532,   533,   533,   533,   534,   534,   535,   536,   537,
     537,   537,   538,   539,   540,   540,   540,   541,   541,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   542,   542,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   546,   546,   546,   547,   548,   548,
     548,   548,   548,   549,   550
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       6,     3,     3,     3,     3,     1,     2,     1,     4,     4,
       6,     6,     6,     8,     8,    10,    12,    14,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     8,    14,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     2,     2,     3,     3,     3,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     1,     3,
       3,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       3,     1,     6,     4,     8,     4,     4,     4,     4,     4,
       6,     6,     6,     6,     8,     8,    10,    12,    14,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     5,     5,
       5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     1,
       1,     3,     1,     6,     6,     8,     8,     3,     3,     3,
       3,     3,     3,     3,     4,     1,     3,     3,     3,     5,
       1,     2,     4,     5,     8,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     6,     8,     2,     3,     2,     2,
       2,     9,     5,     4,     2,     5,     5,     4,     4,     7,
       4,     5,     4,     4,     3,     3,     3,     4,     2,     4,
       4,     4,     3,     9,     2,     2,     3,     2,     2,     4,
       3,     2,     3,     3,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     3,     4,     4,     2,     2,     3,     5,
       2,     3,     2,     3,     4,     3,     2,     2,     3,     3,
       4,     3,     2,     2,     2,     2,     4,     2,     4,     3,
       7,    13,     8,     2,     8,     2,     3,     2,     3,     2,
       3,     5,     2,     3,     2,     3,     2,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     3,     4,     4,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     3,     3,     2,     3,     3,     3,     4,
       3,     4,     5,     6,     6,     2,     5,     2,     2,     2,
       2,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     2,     3,     1,     2,     2,     3,
       3,     4,     2,     3,     8,     4,     9,     5,     2,     3,
       3,     3,     2,     2,     2,     3,     3,     3,     4,     4,
       6,     4,     3,     5,     3,     2,     3,     4,     2,     7,
       3,     2,     2,     4,     4,     6,     3,     4,     4,     5,
       3,     3,     3,     2,     9,     3,    10,    12,     1,     1,
       2,     2,     2,     1,     2,     3,     3,     1,     4,     4,
       4,     1,     3,     3,     2,     2,     1,     2,     2,     3,
       3,     3,     5,     7,     5,     4,     4,     4,     2,     3,
       4,     4,     2,     3,     2,     2,     1,    12,    18,    20,
      18,    18,     6,     8,    12,     6,    10,     8,    10,     6,
       6,    12,     6,    12,    16,    26,    26,    12,    14,    10,
      12,    10,    10,    12,    12,     6,    10,    12,     4,     6,
      10,    12,     6,     8,    22,     6,     8,    10,     8,     8,
       1,     2,     2,     2,     1,     2,     2,     3,     3,     4,
       3,     2,     2,     3,     4,     3,     4,     2,     4,     4,
       6,     2,     2,     1,     3,     1,     1,     1,     2,     2,
       2,     3,     3,     2,     2,     2,     2,     1,     1,     2,
       3,     6,     3,     3,     3,     3,     3,     3,     4,     4,
       4,     4,     4,     4,     4,     8,    10,    12,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     4,     3,     3,
       4,     5,     3,     3,     4,     4,     4,     6,     4,     4,
       4,     6,     3,     3,     3,     3,     4,     3,     3,     4,
       4,     5,     6,     2,     2,     2,     4,     4,     6,     6,
       4,     9,    10,     2,     3,     3,     2,     2,     2,     3,
       2,     4,     3,     3,     4,     3,     3,     8,     3,     3,
       3,     1,     2,     3,     2,     2,     2,     2,     2,     2,
       2,     4,     1,     2,     3,     3,     2,     2,     2,     1,
       3,     3,     1,     2,     2,     1,     2,     2,     2,     2,
       3,     3,     1,     3,     2,     4,     4,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       3,     3,     3,     3,     3,     1,     1,     3,     2,     2,
       4,     1,     2,     2,     2,     2,     4,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     3,     2,
       3,     2,     3,     1,     1,     1,     1,     1,     1,     2,
       3,     4,     1,     2,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     8,     2,     2,     1,     1,     1,     3,     4,     2,
       3,     4,    17,     2,     2,     2,     3,     3,     3,     4,
       4,     5,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     4,     3,     4,     4,     2,     1,     1,
       4,     3,     3,     4,     4,     2,     2,     2,     4,     5,
       4,     4,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     1,     1,     2,     2,     2,     2,     2,
       3,     3,     1,     2,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,    22,     0,    24,    98,   169,    35,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   718,   719,
       0,   356,     0,     0,   500,   504,   897,     0,     0,   354,
       0,     0,   423,     0,     0,     0,   527,     0,     0,     0,
       0,     0,   855,     0,     0,   355,   427,   856,     0,   456,
       0,     0,     0,     0,     0,     0,   708,     0,   436,     0,
       0,   359,   901,   900,     0,     0,     0,   857,   858,     0,
       0,     0,   353,     0,     0,     0,     0,   896,     0,   895,
       0,   523,     0,     0,     0,   358,   526,   431,     0,   525,
       0,    37,     0,   418,     0,     0,     0,     0,     0,     0,
     787,   790,   789,   791,   788,     0,     0,     0,   898,     0,
     712,     0,     0,     0,     0,     0,   357,   899,     0,     0,
       0,     0,     0,     0,     0,   419,     0,     0,     0,    59,
      60,    67,    61,    62,    68,     0,     0,     0,     0,    63,
      64,    65,    66,   843,   845,     0,   716,     0,     0,   844,
     846,   847,   848,   849,   850,     0,   717,     0,    25,    26,
      27,    23,     0,     0,     0,     0,   190,     0,     2,     5,
       3,   101,     4,   172,     0,    19,    17,     0,    18,    20,
      21,    12,     8,   366,     0,     0,    10,     0,    11,    15,
      16,    14,   537,     0,     0,    13,     0,     0,    99,     0,
       0,     9,   538,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    88,
       0,     0,     0,     0,     0,     0,     0,   501,   502,   503,
       0,   228,   741,   742,   743,   740,   739,   758,   754,   755,
     745,   747,   750,   749,   746,   748,   751,   752,   753,   759,
     756,   757,   744,     0,   420,   198,   199,   200,   201,   308,
     735,   736,   529,   530,   347,     0,     0,   424,     0,    24,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      37,    25,    26,    27,     0,     0,     0,    91,    92,     0,
       0,     0,     0,   360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   277,   272,   275,   274,   273,   195,   196,
     197,   191,     0,   307,     0,     0,   422,   421,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   350,   536,   535,
     786,   785,   534,   505,   533,   805,   813,   818,   817,   819,
     807,   800,   828,   824,   829,   825,   830,   826,   804,   801,
     802,   820,   811,   821,   808,   822,   831,   827,   810,   812,
     816,   814,   815,   806,   803,   809,   823,   349,     0,     0,
       0,     0,   326,   329,   332,   331,   330,     0,   437,     0,
     709,     0,     0,     0,     0,     0,     0,   511,   455,   454,
     452,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   847,     0,   363,   309,   324,   932,   325,
     933,     0,     0,     0,     0,   522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   836,   839,     0,
       0,   838,   840,     0,   837,     0,     0,   835,   919,   434,
       0,     0,   957,   438,     0,     0,     0,     0,   506,     0,
       0,     0,     0,     0,     0,   206,   209,   208,   210,     0,
       0,   448,     0,     0,   521,   512,   713,   435,     0,   792,
     793,   348,     0,     0,   528,     0,     0,     0,     0,   292,
     294,   296,   925,     0,     0,   235,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   260,   262,   267,   266,
     923,     0,     0,     0,     0,   285,   287,   289,   924,   345,
       0,   214,     0,     0,     0,     0,     0,     0,   364,   237,
     238,     0,     0,     0,     0,     0,   517,     0,     0,     0,
       0,     0,     0,   283,     0,     0,     0,     0,    73,     0,
      72,   101,   168,    87,   166,     0,     0,     1,     0,    36,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,   137,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   368,    91,   367,
     372,     0,     0,     0,   413,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   241,   256,   257,     0,     0,     0,
       0,   401,     0,     0,     0,     0,     0,     0,   402,     0,
       0,     0,     0,   398,   378,   395,   382,   384,   383,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,  1004,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1003,
       0,     0,   539,   965,   967,   966,     0,     0,     0,     0,
       0,     0,     0,   714,   621,     0,     0,     0,     0,   595,
     593,   594,   603,     0,     0,     0,     0,     0,   610,   606,
     608,   607,     0,   226,    91,    95,     0,     0,   180,   441,
      91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,     0,   202,     0,     0,     0,
     532,   303,   304,   306,   305,     0,   910,   909,   510,   425,
     426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,   415,
       0,   366,   362,   410,   361,     0,     0,     0,     0,   906,
     905,   907,   912,   908,   279,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   697,   707,   706,   705,   351,     0,
     699,   696,   701,     0,     0,   334,   333,   951,   327,   328,
       0,     0,   954,   224,     0,     0,     0,     0,     0,     0,
     453,     0,   926,   320,   319,   318,   321,     0,   313,   315,
     310,   950,   314,   842,   841,   311,     0,   312,   927,   928,
       0,     0,   232,     0,     0,     0,     0,     0,    91,     0,
       0,     0,     0,   406,   524,     0,     0,     0,     0,    91,
     920,   767,   766,   768,   769,   531,   917,     0,     0,     0,
      23,     0,     0,   432,   433,     0,     0,     0,   507,   508,
       0,   515,     0,   513,     0,    96,    97,   225,     0,   770,
     771,   776,   778,   772,   774,   775,   773,   777,   779,   207,
       0,     0,     0,     0,     0,     0,   853,   854,     0,   449,
       0,   297,   293,     0,   295,     0,   236,     0,     0,   271,
     268,   269,   258,   263,   261,   265,     0,   290,   286,     0,
     288,     0,   947,   946,   949,   948,     0,     0,   365,   943,
     942,   945,   944,     0,     0,     0,   301,   784,   781,   783,
     780,   782,   299,     0,     0,   302,   300,   352,   181,   182,
     183,    69,   167,     0,     0,     0,     0,     0,     0,     6,
     185,     0,     0,     0,    86,   144,    85,   147,    84,   165,
      83,   162,    82,   156,    81,   159,    80,   153,    79,   150,
      70,   121,    71,   124,    74,   127,    75,   130,    76,   133,
      77,   136,    31,     0,     0,     0,     0,   143,   142,   146,
     145,   164,   163,   161,   160,   155,   154,   158,   157,   152,
     151,   149,   148,   120,   119,   123,   122,   126,   125,   129,
     128,   132,   131,   135,   134,     0,     0,   178,   179,   170,
     177,   187,   186,   188,   370,     0,   369,   373,   411,   412,
       0,     0,   252,   251,   250,   253,     0,   245,   247,   242,
     246,   243,   244,     0,     0,     0,     0,     0,     0,     0,
     387,     0,   386,   385,   380,   396,     0,     0,     0,   379,
     381,   394,   400,     0,   392,     0,     0,     0,     0,     0,
       0,     0,   340,   336,   934,   338,   938,   761,   764,   939,
     935,   937,   936,   765,   762,   763,   940,   941,   760,   337,
      34,     0,   710,    48,    49,    50,    51,    52,    53,    54,
      55,   715,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   569,   572,   573,     0,   566,   613,   612,     0,     0,
     618,     0,     0,   615,   616,     0,   568,     0,     0,     0,
       0,     0,   582,   588,   585,   584,   587,   583,     0,     0,
       0,   962,   565,   564,   439,   542,   619,   620,   440,     0,
     558,   561,   560,   559,   240,     0,     0,   961,     0,     0,
       0,     0,     0,   543,   547,   545,   544,   546,   756,   540,
       0,    33,    32,   100,   630,   692,   694,   693,   695,     0,
       0,     0,     0,     0,   681,   628,   689,   690,   958,   691,
     629,   959,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   626,   657,   675,   676,   984,   666,   627,   992,     0,
     799,     0,   797,     0,     0,   896,   895,     0,     0,     0,
     798,     0,     0,     0,     0,     0,   624,   632,   639,   642,
     645,   652,   625,   983,     0,     0,     0,     0,     0,     0,
       0,     0,   605,   609,   604,     0,   227,     0,    56,    38,
     108,    39,   109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    90,    89,   447,     0,    91,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    85,    84,    83,
      82,    81,    80,    79,    70,    71,    74,    75,    76,    77,
       0,   360,   367,   446,     0,   276,   921,   278,   192,     0,
     737,   738,     0,   220,     0,   222,   223,     0,     0,   428,
     700,   702,   698,     0,    93,     0,     0,     0,   488,     0,
       0,     0,   930,   317,   316,   323,   929,   322,     0,   213,
       0,     0,     0,     0,     0,   103,   450,   407,     0,   408,
       0,   429,   430,   229,   231,   218,     0,   230,   918,   217,
       0,   955,   956,   105,   509,   516,   514,     0,     0,   106,
       0,     0,   107,     0,   851,   852,   445,     0,     0,   451,
       0,   264,   270,     0,   720,   721,   722,   723,   725,   724,
     726,   727,   728,   729,   730,   731,     0,     0,     0,     0,
     519,   518,     0,     0,     0,     0,     0,     0,   184,     0,
       0,     0,     0,     0,     0,   375,   371,     0,   249,   248,
     255,   254,     0,     0,     0,   388,   391,   389,   397,   404,
       0,   403,     0,     0,   952,   953,   339,     0,     0,   341,
       0,   711,   579,     0,   575,     0,   576,   578,   574,   580,
     570,   567,   600,     0,   614,     0,     0,   970,   916,   914,
     915,   913,     0,   971,   590,   589,   586,  1002,   999,  1000,
    1001,   998,   963,   563,   562,   995,   994,   996,   968,   554,
     239,     0,   964,   551,   552,   960,   549,   548,   550,   553,
       0,     0,     0,   796,   795,   794,   687,   683,   682,   997,
     684,   685,     0,     0,   663,   661,     0,   660,   659,   667,
     988,   987,   989,   678,   679,     0,     0,     0,   658,   662,
     833,   834,   832,   993,   664,   665,     0,   668,     0,   669,
     985,   986,     0,   974,   638,   977,     0,     0,   633,     0,
     972,   648,   643,   646,   976,   975,     0,     0,     0,   980,
       0,   973,   649,   644,   647,   636,   637,     0,   981,     0,
     654,   978,   979,     0,   623,     0,     0,    29,     0,   597,
     596,   611,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   193,   346,   221,
       0,     0,     0,     0,     0,     0,   189,     0,     0,     0,
       0,   931,     0,     0,   703,   704,     0,     0,     0,     0,
     409,     0,     0,     0,   215,   216,     0,   212,     0,     0,
       0,     0,     0,   298,   259,   291,     0,     0,   881,   882,
     877,   878,   879,   880,     0,     0,     0,     0,     0,    78,
       0,   138,   139,   140,   141,     0,     0,     0,   171,     0,
       0,   377,   393,     0,     0,     0,     0,   342,     0,     0,
     571,     0,     0,     0,     0,   444,     0,   591,     0,   442,
       0,   969,   688,     0,   631,   674,     0,   991,   990,   671,
     670,   673,   672,   677,   650,   640,     0,   651,   641,   634,
       0,   635,   734,   732,   733,   653,   982,     0,   860,   859,
       0,     0,     0,     0,     0,     0,    41,    40,   113,    42,
     111,   112,   110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   485,     0,     0,     0,     0,     0,    30,   489,     0,
       0,   492,     0,     0,     0,     0,     0,     0,   462,     0,
     465,     0,     0,   469,     0,   495,     0,     0,   204,     0,
       0,     0,   520,     0,     0,   102,     0,   173,     0,   174,
       0,     0,   390,   405,     0,     0,   343,   344,   577,   581,
     599,     0,   592,     0,     0,   541,   686,   680,   655,   656,
     470,     0,   472,     0,     0,   598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   219,     0,     0,     0,     0,
       0,   892,   890,   891,   893,   894,     0,     0,     0,     0,
       0,     0,   280,     0,     0,     0,     0,     0,     0,   896,
     895,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   399,     0,     0,     0,
     443,     0,   866,   867,   864,   865,     0,   889,   888,   887,
     883,   885,   884,   886,     0,     0,    57,     0,    43,   114,
      44,   115,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   194,     0,     0,     0,     0,     0,
       0,     0,   493,     0,     0,     0,   104,   463,     0,     0,
     467,     0,   496,   498,     0,   499,     0,   205,   284,     0,
     282,     0,     0,   176,   175,   374,     0,     0,   617,   555,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     911,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
       0,   233,     0,     0,     0,   414,   376,     0,     0,   876,
     875,   873,   874,     0,   861,   862,   863,     0,   601,     0,
      45,   116,     0,     0,     0,     0,     0,     0,   602,     0,
     486,     0,     0,   482,     0,     0,   479,     0,   416,     0,
       0,     0,   468,   466,   497,     0,     0,   490,     0,   481,
     556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   868,   869,     0,     0,
       0,    46,   117,     0,   457,     0,     0,     0,     0,   487,
       0,   483,   484,   480,   417,     0,     0,   464,     0,   477,
       0,   491,   557,   471,     0,   473,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   281,     0,     0,     0,     0,
       0,    58,    47,   118,     0,     0,     0,     0,     0,     0,
     478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   872,   871,   870,     0,     0,     0,     0,     0,     0,
       0,     0,   474,     0,     0,     0,     0,   922,     0,     0,
     458,     0,   460,     0,   461,     0,     0,     0,     0,     0,
       0,   459,     0,     0,     0,     0,     0,     0,   494,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   475
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   167,   168,   169,   287,   769,   288,   770,   758,   697,
     877,   290,   172,  1029,  1030,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   761,   762,   763,   185,   186,   764,
     188,   189,   190,   191,   192,   673,  1246,  1221,  1195,  1184,
     327,  1626,   788,   291,   292,   195,   196,  1406,  1715,   264,
    1322,   253,  1099,   855,   856,   889,   942,   455,   197,   471,
    1506,  1248,   367,  1533,   439,   825,   198,  1386,   898,   199,
    1722,  1997,  1886,  2058,  2124,  1993,  1654,  1894,  1846,   200,
    1864,   303,   456,   305,   457,   458,  1147,  1471,   201,  1200,
     202,  1252,  1227,  1488,  1201,  1482,   203,   204
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1449
static const yytype_int16 yypact[] =
{
    4293, -1449,  -325,  -393,   -90, -1449, -1449,  -331,  -318,  -243,
    -158,  -136,   -47,   -30,    -8,    27,    31,    13, -1449, -1449,
     305, -1449,    34,  -147,   238, -1449, -1449,   210,  3080, -1449,
     311,  6536,   -64, 12705, 12705,   305, -1449,    51,   463,     7,
     311,   311, -1449,    54, 11048, -1449,    60, -1449,   768, -1449,
     380, 14121,   411,    65,   311,   -93, -1449,   349, -1449,    97,
     182, -1449, -1449, -1449,   185,   187,   194, -1449, -1449,   199,
    6466,   197, -1449,  -112,    89,   202,    30, -1449,   209, -1449,
     305,    11,   211,   -75,  6963, -1449, -1449,   139,   458, -1449,
     311,   216, 13986, -1449,   465,   -11,   220,   228,   305,   231,
   -1449, -1449, -1449, -1449, -1449,   237,   311,   311, -1449,   -93,
   -1449, 12705,   305,   -24,   305, 11219, -1449, -1449,   459,   305,
     646, 12705,  6728,  1508,  3080, -1449,   311, 12705,  8573, -1449,
   -1449, -1449, -1449, -1449, -1449,   243,  1059,  8836,   305, -1449,
   -1449, -1449, -1449, -1449, -1449,  -108, -1449,   245,   249, -1449,
   -1449, -1449, -1449, -1449, -1449,   -85, -1449, 12705,   -71,   234,
     258, -1449, 12705,  9440,  9440,  9440, -1449,   714,   272, -1449,
    9997,   -10, 13396,   280,   270, -1449, -1449,   274, -1449, -1449,
   -1449, -1449, -1449, 11357,   -91,  7272, -1449, 13946, -1449, -1449,
   -1449, -1449, -1449,   -18, 13915, -1449,   859,   288, -1449,   290,
     320, -1449, -1449,   406,   113,  -139, 11048, 12705, 12705,  9440,
    9440, 12705, 12705,  9440, 12705, 12705, 12705, 12705, 12705, -1449,
     -86,   -66,   336,   430, 12705,   -86,  -122, -1449, -1449, -1449,
   11528, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449,   311,   339, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449,   664,   674,   339,   363, -1449,
   -1449,   365,   367,   371,   393,   396,   398,   400,   402,   424,
   -1449, -1449, -1449, -1449, 12705, 12705, 12705, 13424, -1449,   447,
    -310,   431,   432,    77,   534,   305,   571,  9874, 12705, 12705,
   12705,   311,   572, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449,   438,   311,   339,   -61,   305, 13424,   339, 12705,   311,
     -37,   562, 12705,   311,   -86,   761, 12705, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,    -2,   -86,
   12705, 12705, -1449, -1449, -1449, -1449, -1449,   305,   339, 12705,
   -1449, 11048,   305,   -86,  9440,   305,   305, -1449, -1449,   336,
     602,   989,   596, 11048, 12705,   -86, 12705, 12705, 12705,    57,
   12705, 12705, 12705, 12705,   421,   431, -1449, -1449, -1449, -1449,
   -1449,   305,   -86,   570,   782,   339,   305, 12705, 12705, 12705,
     574,  7390,   311,   305,   783,   790,   794, -1449, -1449, 12705,
     226, -1449, -1449, 11048, -1449, 12705, 11666, -1449, -1449, -1449,
     159, 10037, -1449,   339, 12705,   311,    -3,    -3,   339,    -3,
   11048, 12705,   276, 12705,   305, -1449, -1449, -1449, -1449,   305,
     305, -1449,  9440,   305,   339,   339, -1449, 13424,  -311, -1449,
   -1449, -1449, 12705, 12705, -1449, 12705, 12705, 12705, 12705,   339,
   -1449, -1449, -1449,   504, 12705, -1449, -1449, 12705,   622,   311,
      -2,   -86, 12705, 12705, 12705,   568, -1449, -1449, -1449, -1449,
   -1449, 12705, 12705, 12705, 12705,   339, -1449, -1449, -1449, -1449,
    -262, -1449, 12705, 12705, 12705, 12705,   594,   305, 12705,   336,
   -1449, 12705, 12705, 12705, 12705,   716,   227,   -86,   359,   305,
     305,   -86,   359, 13424,   -86, 12705, 12705, 12705,   496,   497,
     499,   -31,   501,   499,   501,   657,  1104, -1449,  4722, -1449,
   12705,  9440,  9440,  9440,  9440,  9440,  9440,  9440,  9440,  9440,
    9440,  9440,  9440,  9440,  9440,   751, 12705,   498, -1449,  9440,
    9440,  9440,  9440,  9440,  9440,  9440,  9440,  9440,  9440,  9440,
    9440,  9440,  9440,  9440,  5126,  9005,  9005,   311,   745,   246,
     431,   -86,    57, 12705, -1449,   680,   636, 12705,   -86, 12705,
   12705,    57, 12705,   867, -1449, -1449, -1449, 12705, 12705,  9145,
     637, -1449,    -2,   -86, 12705,   -45, 12705,    57, -1449, 12705,
    -162, 12705, 12705,   339, -1449, -1449, -1449, -1449, -1449,   604,
     788,   -17,   -86,   -86,   -86,  3727,  1076,   859, -1449,  5975,
    -155, 11048,  -149,   311,   263, 12705,   -86,   725,  8301,   -86,
   12705,    -1, 12705,   -56,   719, 12705, 12705,  7703,  3117, -1449,
   12705,   912, -1449, -1449, -1449, -1449,   518,  1511, 12705, 12705,
    5932,  6204,   542, -1449, -1449,   305,   305,  9440,   123, -1449,
   -1449, -1449, -1449,   648,   -86, 12705, 12705, 12705, -1449, -1449,
   -1449, -1449, 12705, -1449,  2887,   339,   515,   517, 13424, -1449,
    9997,   522,  6042, 10369, 12543,   525,   526,  1030,  1203,   527,
    1229,  1375,  1452,  1768, -1449, 11048,   339,  -115,   305,   528,
   -1449, -1449, -1449, -1449, -1449, 12705,   339, -1449,   339, -1449,
   -1449, 12705, 12705, 12705, 12705, 12705, 12705, 12705, 12705, 12705,
     496,   496, 12563, 12705, 12705, 12705, 12705, 12705, 12705, 12705,
   12705, 12705, 12705, 12705, 12705, 12705, 12705, 12705, -1449, -1449,
   12705, 12705, -1449, -1449, -1449,   305,   529, 12705, 12705,   339,
   -1449, -1449, 13424, -1449,   339, 12705,  5264,  -168, 12705,    87,
     311,   651,   531,   523,   339, -1449, -1449, -1449, -1449, 12705,
   13424,   339, -1449,   311,   730, -1449, -1449, -1449, -1449, -1449,
     538,   537, 13424,   339,   541,   543,  9997,  1851,  -178,   544,
   -1449,   -48, -1449, -1449, -1449, -1449, -1449, 12705, -1449, -1449,
   -1449, 13424, -1449, -1449, -1449, -1449,   311, -1449, 13424, 13424,
   12705,   545, -1449,   340,   311,   561,   666,   668,  1874,   566,
     305,   -22,   793, -1449,   339,   567,   311,   311,   -86, 13444,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449,  -124,   569, 13464,
     590,  -124,   587, -1449,   339, 12705, 12705,   593,   339,   339,
     311,   339,   311,   339,   311, 13424,   339, -1449,  2087, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
    2159,   597,   595,   600, 12592,   608, -1449, -1449,   317, -1449,
    2205, -1449, -1449,  2329, 13424,   305, -1449,  2366, 12705,   339,
   -1449, -1449, -1449, -1449, -1449, -1449, 12705, -1449, -1449,  2445,
   13424,  1969, 13424, 13424, 13424, 13424, 12705,   613, -1449, 13424,
   13424, 13424, 13424, 12705,   311,   311, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449,   615,   616, -1449, -1449, -1449, 13424, 13424,
   13424, -1449, -1449,   679,  -393,   635,   -71,   234,   258, -1449,
     -93,    -7, 13927,  4251,   464,   913,   389,  1177,  1332,  1404,
    1332,  1404,  1332,  1404,  1332,  1404,  1332,  1404,  1332,  1404,
     254,   260,   254,   260,   499,   501,   499,   501,   499,   501,
     499,   501, -1449,  -307, 12705,  7416,  8532,   464,   913,   389,
    1177,  1332,  1404,  1332,  1404,  1332,  1404,  1332,  1404,  1332,
    1404,  1332,  1404,   254,   260,   254,   260,   499,   501,   499,
     501,   499,   501,   499,   501,   617,   -55,  9997, 13396, -1449,
     609,  9997, 13396,   609,   339, 12705,   311, -1449, -1449, -1449,
    2471,    -2, -1449, -1449, -1449, -1449, 12705, -1449, -1449, -1449,
   -1449, -1449, -1449, 12705,  2513,   619, 12705, 12705, 12705, 12705,
   -1449, 12705, -1449, -1449, -1449, -1449,   311, 12705, 12705, -1449,
   -1449, -1449, -1449, 12705, -1449,  2540,   -21, 12705, 14121, 12705,
   12705, 12705, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449,   -93, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449,   311,   755, 14121, 12705, 12705,   311, 12705, 12705,
   12705, -1449, -1449, -1449, 12705, -1449,   339, -1449, 12705, 12705,
     339,   -86, 12705, -1449, -1449,   624, -1449, 12705,    29,   265,
   12705,    12, -1449, -1449, -1449, -1449, -1449, -1449, 12705, 12705,
      37, -1449, -1449, -1449, -1449, -1449,   339, -1449, -1449, 12705,
   -1449, -1449, -1449, -1449, -1449,   311,  2629, -1449,   -86, 11837,
   10308, 12705, 12705, -1449, -1449, -1449, -1449, -1449, 12705, -1449,
    2653, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,   756,
      55,   153,    12,  8409,   339, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449,  2674, 12705,   311,   763,  5623,   311,    64,
   10145,   388, 12705,   311,    28, 12705, 12705, 11975, 12150,   -12,
     631, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,   -86,
   -1449, 12705, -1449,   -86,  8138,   641,   675,  7843, 12705, 12705,
   -1449,    40, 12705, 12268,     2,   633, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449,   -86,   655,   661, 12612, 12705, 12705,
   12705, 12705, -1449, -1449, -1449,  2723, -1449, 12705, -1449, -1449,
   -1449, -1449, -1449, 12705,  9440,  9440,  9440, 12705, 12705, 12705,
   12705, 12705, 13424, -1449, -1449, 12705, 12563,   662, 12658,   665,
    2825,   667,  2911,  2971,  3118,  3142,  1133,  1423,  1559,  1559,
    1559,  1559,  1559,  1559,   268,   268,   496,   496,   496,   496,
    3180, -1449, -1449, -1449,   305, 13424, 13424, 13424, -1449,   670,
   -1449, -1449,   311, 13424,   -86, -1449,   339, 12705, 12705, -1449,
   -1449,   339, -1449,   305, -1449,  9440,   660,  9440, -1449,   305,
    9440,    37, -1449, -1449, -1449, 13424,   339, 13424,   305, -1449,
    -344,  -113,   671,   311, 12705, -1449, -1449, -1449,   -22, -1449,
    9440,   339,   339, -1449, 12705, -1449, 12705, 12705, -1449, -1449,
   12705, 13424, 13424, -1449,   339,   339,   339, 12705, 12705, -1449,
   12705,  9603, -1449,   305, -1449, -1449, -1449, 12705, 12705, -1449,
   12705, 13424, 13424, 12705, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449,   972,  3244,   292,  3268,
    -126,   339,   305,   305,   498,   996, 12705, 12705, 13424,  9440,
    9440, 12705, 12705,   673,  1103,  3467,   339, 12705, -1449, -1449,
   13424, 13424, 12705, 12705,  3538, 13424, 13424, -1449, 13424,   339,
    3582, -1449,  3705, 12705, -1449, -1449, 13424, 14121,  3798, -1449,
    3821, -1449,   339, 12705, -1449,  3849, -1449,   339, -1449,   684,
   -1449, -1449, -1449,  4510, -1449,  4756, 12705, 13424, -1449, -1449,
   -1449, -1449,   285, -1449, -1449, -1449, 13424, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449, -1449,   686,
     339, 12705, -1449, -1449, -1449, -1449, -1449, -1449, 13424, -1449,
     688, 12705, 12705, -1449, -1449, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449,  4780, 12705, -1449,   339, 12705, 13424, -1449,   339,
   -1449, -1449, -1449, -1449, -1449,  4801,   787,   799, -1449,   339,
   -1449, -1449, -1449, -1449, -1449, -1449,     4, 13424,     8, 13424,
   -1449, -1449,   311, -1449, -1449, -1449,   -86, 12705,  4822,   692,
   -1449, -1449, -1449, -1449, -1449, -1449,   -86, 12705, 12705,  4822,
     695, -1449, -1449, -1449, -1449, 13424, 13424,   -86, 13424,    21,
   -1449, -1449, -1449, 12705, -1449, 12705, 10601, -1449,  4896, 13424,
   -1449, 13424, 12705,   712,   681, 12724, 12744, 12764, 12784, 12815,
   12837,   713,  4926,  4949,  5033,  5081,   715, 12705, 12705, 12705,
   12705, 12705, 12705, 12705, 12705, 12705,   717,   720,   339, -1449,
     718,    71,  -274,   722,  5151,  -105, -1449, 12860,   721,  5172,
      73, -1449,   154, 12705, -1449, -1449,   743, 12705,    82,  5378,
   -1449,   752,  5430,   190, -1449, -1449,  5453, 13424,   753,   -69,
   12880,   757,  5480, 13424, 13424, 13424,   311, 12705, -1449, -1449,
   -1449, -1449, -1449, -1449,   758, 12705,   311,   762,   764, 13490,
     754, 13510, 13530, 13510, 13530,    49,   759,   766, -1449, 12705,
    5664, 13424, -1449, 12705, 12705, 12705,  5706, -1449, 12705, 12705,
   13424, 12705, 12705, 12705, 12705, -1449, 12705, -1449, 12705,  5730,
   12705, 13424, 13424, 12705, 13424, 13424, 12705, -1449, -1449, -1449,
   -1449, -1449, -1449,   339, -1449, 13424, 12705, -1449, 13424, -1449,
   12705, -1449, -1449, -1449, -1449, -1449, 13424,   233, -1449, -1449,
     770,   166,   772, 12705,  5754, 12705, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449,  9440,  9440, 12705, 12705, 12705, 12705,   774,
   12913, 12936,   775,  6002,  6258,  6288,  6520,  6614, 12705, 12705,
   12705, -1449, 12705, 12705,   311,   -86,   -86, -1449, -1449,   -14,
    9440, -1449,   305,  6635, 12705,   776,   311, 12705, -1449, 12705,
   -1449, 12443, 12705, -1449,   -86, -1449, 10739, 12705,   -23,  6755,
   12705,  6788,   339, 12705, 12705, -1449, 12705, -1449,   780, -1449,
    7070, 12705, 13424, 13424, 12960, 12705, 13424, 13424, 13424, -1449,
   13424,  7094, 13424,   777, 12705, -1449, 13424, 13424, 13424, 13424,
   -1449,   305, -1449,   142,    -9, 13424, 12705,   239, 12980, 13008,
   13028, 13048,  7182,  7458,  7510,  7533, 12705, 12705, 12705, 12705,
   12705, 12705, 12705,   784,   791, -1449,   789,   796,   177,   797,
     801, -1449, -1449, -1449, -1449, -1449,   803,  7798,   795, 12705,
     805, 12705,   339,   800,   284,   808,   811,  7961,   814,   816,
     818, -1449,   -16,   819,   821,  8093,   311, 12705,   823, 12705,
     824,  8480,   828,   833, 12705,  8642, -1449,  8665, 12705, 12705,
   -1449,   826, -1449, -1449, -1449, -1449,   836, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449,   837,  8688, -1449, 12705, -1449, -1449,
   -1449, -1449,  9440, 12705, 12705, 12705,   839, 13074, 13094,  8914,
    8959,  9170,  9215,    57, -1449, 12705, 12705, 12705,   -86,   -86,
     -86,   -14, -1449,  9236, 12705,   840, -1449, -1449,   311, 10910,
   -1449, 12705, -1449, -1449, 12705, -1449, 12705,   339, 13424, 12705,
   13424,   -86, 12705, -1449, -1449, 13424, 12705, 12705, 13424,   844,
   12705,   -34,    14, 12705,   860, 13114, 13140,  9260,  9395,  9489,
   -1449, 12705, 12705, 12705, 12705,   861,   864,   865,  9510,   316,
     866,   869,   876, 12705,  9558, 12705,   198,   878,   881, 13424,
     882,  7663,   883,   324, 13160, 13424, 13424, 12705,   884, -1449,
   -1449, -1449, -1449,   885, -1449, -1449, -1449,   886, 13424, 12705,
   -1449, -1449,  9440, 12705, 12705, 13180,  9677,  9698, 13424, 12705,
   -1449, 12705, 12705, -1449,   305,   305, -1449,   -86,  9829,   -86,
     888,   -86, -1449, -1449, -1449, 12705, 12705, -1449,   305, -1449,
    9944, 12705,    62,   142,   889, 13200, 13231, 10164,   356, 12705,
   12705, 10216,   907, 10264,   915,   916,   917, 12705,   911,   918,
     920, 10395,   330,   924, 12705,   925, -1449, -1449,   927,   358,
   12705, -1449, -1449,  9440, -1449,   -86, 13253, 10416, 12705, -1449,
   12705, -1449, -1449, -1449, 13424, 12705,   311, -1449, 12705, -1449,
     305, -1449, 13424, -1449,   191, -1449,    62, 13276, 13296, 13329,
     928, 12705, 10554, 10863, 11481,   339, 11790,   930,   932,   933,
     935, -1449, -1449, -1449,   -86, 13352, 12705, 12705, 12705, 12705,
   -1449,   -86,   -86,    19,   936,   937, 12103,   944, 12348,   945,
     947, -1449, -1449, -1449,   949,   -86, 12705, 12705,   305, 12705,
      -9,    -9, -1449,   368,   950, 12399,   952, 13424,   959,   960,
   -1449,   -86, -1449, 12705, -1449, 12705, 12705,   962, 12464, 12497,
   12520, -1449, 12705,   -86,   -86, 13376,   963,   964, -1449,    14,
      14,   965,   966,    19,    19,   968,   969, -1449, -1449
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1449, -1449, -1449,   652,     0,  3338,  -203,  2067,   -50, -1449,
   -1449,  1870,  2461,    39,  -582, -1449, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449, -1449,    20,    42,  -419, -1449, -1449,    47,
   -1449, -1449, -1449, -1449, -1449,   524, -1449, -1449, -1449, -1449,
   -1449, -1449, -1449,   212,   809, -1449,  -181, -1449, -1449,  1163,
   -1449,   -74, -1449, -1449,  -401, -1449,   697,  1729, -1449,  -152,
   -1449, -1449, -1061, -1449, -1449,  -591,  -654, -1449, -1449, -1449,
    -819, -1448,  -747,  -775, -1327, -1449, -1449, -1269,  -592, -1449,
   -1449,   -51,    17,    -4,    56,   287,  -228, -1449, -1449, -1449,
   -1449, -1449, -1449,    18,   200,   217, -1449, -1449
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -904
static const yytype_int16 yytable[] =
{
     170,  1039,   843,   696,  1033,   380,   701,  1183,   705,   706,
    1051,   709,   637,   219,  1866,   219,  1656,  1447,   449,   407,
     183,   534,    18,    19,  1989,    21,  1070,   308,   309,   310,
     230,  1444,  1994,    18,    19,   629,  1624,  1841,   230,   173,
    1540,   630,   184,  1320,   316,   205,   629,   187,   374,    29,
     509,   263,   630,  1454,  1571,   304,  1699,   207,  1887,   466,
    1701,   778,    55,    56,  1530,   896,   853,   480,   760,   373,
     404,   497,   506,  1072,   591,   230,   219,   527,   219,   779,
    2056,  1477,  1478,   231,   230,   921,   330,   408,  1321,  1128,
    1712,   331,   219,   897,   306,  2121,   469,  1066,  1468,   715,
     531,   421,   330,  1623,    45,   208,   785,   331,   375,  1468,
    1990,   467,   592,   721,   209,   783,   417,   469,   631,  1417,
     206,   567,   495,  1485,    21,  1078,   409,   210,   516,   631,
     424,  1503,  1324,   565,   605,   225,   625,   525,   379,   498,
     412,   265,  1334,   298,   299,   854,  1518,   632,    29,   759,
    1888,  1889,    61,   688,   220,   330,   518,   533,   632,   422,
     331,  1995,   538,   540,   543,   545,   682,   760,   219,   661,
     418,   633,   413,  1753,   481,    72,   801,  2122,   499,   507,
     260,   715,   633,   588,  1842,   603,   451,   780,   298,   299,
     683,   781,  1124,   330,  1101,  1102,   528,  1067,   331,   230,
     300,  1991,   211,    45,   626,  1479,   694,   698,   300,   700,
     703,   663,   193,   707,   425,   710,   711,   712,   713,   532,
     679,   689,  1625,   330,   330,   266,  1890,  1882,   331,   331,
     330,  1883,   222,  1520,   330,   331,   222,   470,   219,   331,
     330,   606,  2057,   627,    85,   331,  1891,   222,  1504,   786,
     664,    61,   261,   393,   300,  1079,  1713,   722,   470,   680,
     690,  1531,   333,   414,   723,  1532,  1469,   387,  1338,  1339,
    1129,  1996,  1486,   692,    72,   715,   863,  1469,   684,  1470,
    1718,   389,   405,  1073,   740,   741,   742,   212,   724,  2123,
    1470,  1159,   222,  1487,   870,   872,   230,   874,  1445,   772,
     685,  1992,  1068,  1480,   686,   634,  1843,  1541,   116,   213,
     222,   879,   298,   299,   787,  1258,   634,   715,  1259,   715,
    1341,  1572,   790,  1700,   222,   307,   222,  1702,   330,   635,
    1080,   222,   222,   331,  1567,   593,   452,  1892,   661,   376,
     635,   880,  1756,    85,    55,    56,  1505,  1472,   519,   230,
     222,  1036,    55,    56,  1884,   379,  1481,   410,  1893,   934,
    1714,   851,   146,   993,   795,  1648,  1649,  1384,  1081,   935,
    1844,  1422,   852,   146,   453,   442,   454,   715,  1774,   535,
     549,   802,   715,  1521,   806,  1845,  1677,   814,  1650,  1651,
     219,    55,    56,   156,  1423,   590,   594,   821,   214,    55,
      56,  1885,   828,   829,   156,   482,  1507,   116,   813,   500,
     508,  1508,   565,   549,   823,   215,   853,   566,  1522,   838,
     715,   715,  1357,  1359,   796,   636,   824,   715,  1131,   849,
    1933,   311,  1385,   565,   454,   859,   717,   216,   566,  1199,
    -185,   772,  1226,  1251,   881,   549,   882,   815,  1652,  1653,
     875,   878,  1132,   890,  1526,   678,  1365,  1468,    55,    56,
    1369,   328,   806,   299,   298,   299,   381,   937,   368,   883,
    1260,  1719,   217,   900,   628,  1786,   218,   903,   904,   224,
    1686,   665,   440,   388,   450,   226,   910,   907,   549,  1266,
     681,   691,   230,    55,    56,   854,   295,   230,  1787,   315,
     109,   110,  1165,   919,   920,   318,   330,   222,   109,   110,
     377,   331,   922,   923,   924,   925,   661,  1751,  1752,   329,
    1760,   929,   930,   931,   932,   715,   330,   222,   701,  1766,
    1289,   331,  1291,    55,    56,   948,   949,   950,   219,   687,
     296,   884,   382,   885,   369,   230,   911,   109,   110,   230,
     963,   964,   966,   968,   970,   972,   974,   976,   978,   980,
     982,   984,   986,   988,   990,   938,   939,   886,   183,   995,
     997,   999,  1001,  1003,  1005,  1007,  1009,  1011,  1013,  1015,
    1017,  1019,  1021,  1023,  1179,  1027,  1031,   173,  1122,   222,
     184,  1043,   549,  1040,   222,   187,   940,   222,   222,   393,
    1761,  1762,   370,   297,   230,   298,   299,  1054,  1062,   661,
     298,   299,  1042,  1813,   109,   110,  1196,   227,   549,  1223,
     715,   330,  1075,   222,  1917,  1469,   331,   383,   222,   887,
     384,   888,   385,   661,  1527,   222,  1770,  1771,  1470,   386,
     941,   715,   411,  1144,  1152,  2021,   475,   416,   228,  1161,
     476,  1044,   330,  1175,   419,  1166,   423,   331,   441,   299,
    1180,   444,   298,   299,  1143,   459,   222,   300,  1063,  1203,
    1160,   222,   222,   460,  1174,   222,   462,   806,   816,  1810,
    1811,   549,   463,  1186,   536,  1896,  1897,  1265,   517,   332,
     529,   561,   562,   563,   530,  1123,   564,   580,   581,   582,
    1133,   477,   583,  1145,  1153,   753,   754,   755,   537,  1162,
     756,  2161,  2162,  1176,   547,  1282,   548,   298,   299,   300,
     585,   230,  1187,  1197,   586,  1286,  1224,  1249,   584,   222,
    1927,  1928,  1288,   675,  1290,   676,  1292,  1293,  1294,  1295,
     549,   222,   222,  1296,  1297,  1298,  1299,  1300,  1301,  1302,
    1303,  1304,  1305,  1306,  1307,  1308,  1309,  1310,   371,   330,
     961,  1183,  2013,  2014,   331,   677,   230,  1315,  1316,   549,
    2027,  2028,   478,   718,   301,  1317,  2079,  2080,  1323,   717,
     637,   550,   715,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   729,   302,   756,    55,
      56,  1037,  2064,  2065,  2085,  2086,   730,  1343,   206,   194,
     731,   230,   732,  1041,  2140,  2141,   733,  1345,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   223,
    1347,   564,   451,   229,   298,   299,  2165,  2166,   734,   469,
      21,   735,  1668,   736,   294,   737,   550,   738,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,  2138,  2139,   756,    29,  1371,  1372,  1344,   830,   739,
    1228,  1253,   219,   757,   636,   661,   330,   765,   390,   298,
     299,   331,  1045,   760,   767,   775,   776,   222,   222,   420,
     789,   549,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   793,   810,   564,   461,  1391,   817,
    1414,   319,   484,   833,   834,   846,  1392,   840,   666,    45,
    1137,   468,   847,   472,   298,   299,  1407,   848,   483,   485,
     222,  1134,   905,  1409,  1146,   908,   300,   568,   756,  1630,
    1163,   564,   454,   583,  1177,   520,   992,   526,   994,  1046,
    1061,  1076,  1077,  1188,  1198,   109,   110,  1225,  1250,  1254,
     330,  1261,  1267,  1268,  1327,   331,   330,    61,  1269,  1329,
     320,   331,  1273,  1274,  1277,  1285,  1314,   222,  1328,   663,
     470,   300,   452,   321,  1332,  1333,  1334,  1138,  1335,  1336,
      72,  1340,  1348,   550,  1418,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,  1351,  1352,
     756,  1353,  1355,  1368,  1360,   916,  1366,  1139,   664,   550,
     453,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,  1370,  1425,   756,  1428,  1140,  1373,
     322,   926,  1380,  1379,  1424,  1349,  1430,  1381,   667,   205,
     668,  1451,   222,  1431,   549,  1383,  1434,  1435,  1436,    85,
    1408,  1438,  1412,  1413,  1554,  1421,  1433,  1440,  1453,  1502,
    1584,  1466,  1141,  1442,  1591,   230,  1516,  1446,  1542,  1448,
    1573,  1450,   550,  1181,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1429,  1555,   564,
     330,   669,  1575,   951,   766,   331,    21,  1182,  1576,  1597,
     323,  1616,  1598,   324,  1600,  1455,  1627,   222,  1494,  1607,
    1646,  1667,   811,   116,   782,     5,  1697,  1726,   568,  1463,
      29,  1682,  1465,  1688,   325,  1690,   326,  1467,  1698,  1706,
    1476,   550,  1710,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,  1474,   549,   756,  1725,
    1733,  1111,  1738,   933,  1748,  1750,  1496,  1758,  1749,  1754,
     550,  1498,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,    45,   800,   756,   298,   299,
    1764,   804,  1035,  1512,   808,   809,   670,   671,  1768,  1773,
     959,   568,   312,  1785,  1776,  1780,   672,  1517,  1788,  1783,
    1525,  1784,    55,    56,  1660,  1789,  1812,  1537,  1539,  1814,
     831,  1826,  1827,  1851,  1879,   835,  1497,   568,  1873,   946,
     330,  1913,   845,    61,  1548,   331,  1915,  1559,  1565,  1566,
    1914,  1922,  1568,  1916,  1918,   300,  1926,  1100,  1919,   665,
    1920,  1551,  1924,   549,  1562,  1929,    72,  1930,  1578,  1579,
    1932,  1581,  -903,   891,  -902,  2099,  1934,  1935,   892,   893,
    1939,  1941,   895,  1950,  1585,  1587,  1589,  1943,  1592,  1593,
    1594,  1595,  1944,  1951,  1952,  1960,  2059,  1975,   143,   144,
    1552,  1987,   550,  1563,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,  1999,  2009,   756,
    2010,  2100,  2011,  2015,  1053,  2016,   149,   150,   151,   152,
     153,   154,  1965,  2017,  2022,    85,   927,  2023,  2024,  1972,
    2026,  2031,  2032,  2033,  2049,   806,  2060,   806,   943,   944,
     806,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,  2069,  1629,   583,   549,   962,  2075,  1621,
     700,  2071,  2072,  2073,  1308,  2076,  2077,  1308,   109,   110,
    2081,  2083,   143,   144,  2084,  2104,  2110,  1636,  1637,  2111,
    2112,   806,  2113,  2125,  2126,  1101,  1102,  1642,  1643,   116,
    1644,  2128,  2130,  1645,  2131,  2132,  2142,  1742,  2144,   549,
     149,   150,   151,   152,   153,   154,  2145,  2146,  2151,  1509,
    2159,  2160,  2163,  2164,  2167,  2168,  1659,     0,     0,  1661,
    1663,     0,     0,     0,     0,     0,  1475,  1670,   568,     0,
       0,     0,  1671,     0,     0,  1103,  1104,     0,  1105,  1106,
       0,     0,     0,  1676,     0,     0,     0,   549,  1107,  1108,
    1109,  1110,     0,  1680,     0,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,     0,     0,     0,   549,  1275,     0,     0,
       0,     0,     0,     0,  1255,  1256,     0,     0,     0,     0,
       0,  1689,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1691,  1692,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1694,     0,     0,  1695,     0,     0,     0,
       0,  1553,     0,     0,  1564,     0,   222,  1284,     0,   569,
       0,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   222,   583,  1705,     0,     0,
     952,   222,     0,     0,     0,     0,     0,  1708,     0,     0,
     222,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,  1716,  1313,   756,     0,     0,     0,     0,
       0,     0,  1724,   549,     0,     0,     0,   219,  1189,     0,
     219,     0,     0,     0,   230,   222,     0,   230,  1740,  1741,
       0,  1743,  1744,  1745,  1746,  1747,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,     0,   583,
       0,     0,     0,  1763,   222,   222,     0,     0,   569,     0,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,     0,   583,     0,  1779,   393,  1356,
    1276,   393,     0,     0,   550,  1781,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,  1790,
       0,   756,     0,  1792,  1793,  1794,  1278,     0,  1796,  1797,
       0,  1798,     0,  1800,  1801,     0,  1802,     0,     0,     0,
       0,     0,     0,  1806,     0,   501,  1807,     0,  1190,   502,
       0,     0,     0,  1191,     0,     0,  1808,     0,   299,     0,
    1809,   299,     0,     0,  1389,     0,     0,     0,     0,     0,
       0,     0,     0,  1815,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1818,  1820,  1822,  1823,  1824,  1825,     0,
       0,     0,     0,     0,     0,     0,     0,  1988,     0,     0,
     503,     0,     0,     0,     0,     0,     0,     0,     0,  1192,
     806,  -904,  -904,  -904,  -904,  -904,  -904,   559,   560,   561,
     562,   563,  1857,  1193,   564,     0,     0,  1865,     0,   334,
       0,   372,     0,     0,  1871,     0,     0,     0,     0,     0,
       0,  1875,   549,     0,     0,  1877,     0,     0,     0,   406,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,  1895,   756,     0,     0,
       0,   504,  1279,     0,     0,     0,     0,  1907,  1908,  1909,
    1910,  1911,  1912,  -904,  -904,  -904,  -904,  -904,  -904,   578,
     579,   580,   581,   582,     0,     0,   583,     0,     0,  1923,
       0,   496,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,  1938,     0,  1940,
     171,     0,     0,     0,  1945,   568,     0,   550,  1948,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,   549,  1280,
       0,     0,  1955,  1957,  1958,  1959,     0,     0,     0,     0,
       0,     0,     0,     0,   604,     0,   624,  1968,     0,     0,
       0,     0,   638,   662,  1974,   674,     0,     0,     0,     0,
       0,  1979,     0,     0,   693,     0,  1981,     0,     0,     0,
       0,     0,  1984,     0,     0,     0,  1985,  1986,     0,   714,
       0,     0,     0,  1998,   720,     0,     0,     0,     0,     0,
       0,  2005,  2006,  2007,  2008,     0,     0,     0,     0,     0,
       0,     0,     0,  2018,   222,  1394,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  2030,  -904,  -904,
    -904,  -904,  -904,  -904,   751,   752,   753,   754,   755,     0,
       0,   756,  2035,  2037,  2038,     0,     0,     0,     0,  2041,
       0,     0,  2043,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   222,     0,  2051,     0,     0,     0,     0,
       0,     0,     0,   541,   541,   541,     0,     0,     0,  2066,
    2067,     0,     0,     0,     0,     0,     0,  2074,     0,     0,
       0,     0,     0,   792,  2082,     0,     0,     0,     0,     0,
    2087,     0,     0,  2088,     0,     0,     0,     0,  2092,     0,
    2093,     0,     0,     0,     0,  2094,     0,     0,  2096,   541,
     541,     0,     0,   541,     0,     0,     0,     0,     0,     0,
       0,  2105,     0,     0,     0,     0,     0,     0,   797,     0,
     289,   293,     0,     0,     0,     0,     0,  2116,     0,  2118,
       0,   549,   805,     0,     0,     0,     0,     0,     0,     0,
     812,     0,     0,  1606,   819,     0,     0,  2135,     0,  2137,
       0,     0,     0,     0,     0,     0,     0,  1612,     0,     0,
       0,   832,  1613,  2148,  1615,  2149,  2150,     0,  1618,  1620,
       0,   438,  2155,     0,     0,     0,     0,  1622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1633,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   474,   549,     0,     0,     0,     0,   486,     0,
       0,     0,  1641,   550,   511,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1281,     0,     0,     0,     0,
     912,  1657,  1658,     0,     0,     0,   222,   222,     0,   549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     589,     0,     0,     0,   541,     0,   936,     0,     0,     0,
     945,     0,     0,   947,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   699,   569,     0,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   719,   222,   583,     0,     0,   222,   727,  1337,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
    1038,  1354,     0,     0,     0,     0,     0,  1048,     0,     0,
       0,     0,   541,     0,     0,     0,     0,     0,     0,     0,
     222,     0,  1064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   549,     0,     0,     0,     0,     0,     0,
    1082,  1083,  1084,  1085,     0,   771,   674,   773,  1121,  1125,
       0,     0,     0,     0,     0,  1136,  1142,     0,  1154,     0,
    1157,     0,     0,  1164,     0,  1721,     0,     0,     0,     0,
     549,     0,     0,   794,     0,  1185,     0,     0,     0,  1222,
    1247,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1262,     0,     0,     0,     0,   960,     0,
       0,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   541,   541,     0,     0,   798,   799,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   541,     0,   541,   541,     0,     0,     0,
       0,   818,     0,   820,     0,   822,     0,   826,   827,   549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   836,   837,   839,     0,   842,     0,
       0,     0,     0,     0,     0,   549,   850,     0,     0,     0,
     858,     0,     0,   862,     0,     0,     0,     0,  1325,     0,
       0,   867,   550,     0,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,     0,     0,   756,
       0,     0,     0,     0,  1377,     0,     0,   549,     0,   899,
    1342,     0,   901,   902,     0,     0,     0,   541,     0,     0,
       0,   906,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,     0,     0,   549,     0,     0,     0,   917,   918,
       0,  1848,     0,     0,     0,     0,     0,  1363,     0,     0,
       0,     0,     0,     0,   550,   928,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  1378,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1881,     0,     0,     0,   542,   544,   546,     0,     0,     0,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,  1026,  1387,   549,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1047,     0,  1049,  1050,     0,  1052,
     702,   704,     0,     0,   708,  1055,  1060,   549,     0,     0,
       0,  1065,     0,  1069,     0,     0,  1071,     0,  1074,     0,
     638,   662,     0,     0,     0,     0,     0,     0,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1127,     0,
       0,     0,  1135,     0,     0,  1151,     0,  1155,     0,  1158,
       0,     0,     0,  1167,  1173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1202,     0,  1220,  1245,     0,
       0,     0,     0,     0,     0,     0,     0,   549,     0,     0,
       0,     0,  1263,  1264,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  1388,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   550,  1287,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,     0,     0,  1390,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2044,  2045,     0,     0,  1311,  1312,     0,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,     0,
       0,     0,     0,  1319,     0,   807,     0,     0,     0,   549,
       0,     0,     0,     0,     0,     0,  1330,     0,     0,     0,
    1464,     0,     0,     0,     0,     0,     0,     0,  1473,     0,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,  2097,
       0,     0,  1393,  2098,     0,     0,   550,  1492,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   549,     0,   756,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,   894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   549,     0,  2136,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,  1543,     0,
    1432,     0,  1545,  1550,     0,   550,  1561,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,  1574,     0,     0,     0,  1443,     0,     0,
       0,     0,     0,     0,     0,   549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   965,   967,   969,   971,   973,   975,   977,   979,
     981,   983,   985,   987,   989,   991,     0,     0,     0,     0,
     996,   998,  1000,  1002,  1004,  1006,  1008,  1010,  1012,  1014,
    1016,  1018,  1020,  1022,  1024,     0,  1028,  1032,     0,     0,
       0,     0,     0,  1609,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  1491,     0,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,     0,   550,
    1501,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  1513,     0,     0,     0,     0,  1437,     0,     0,     0,
       0,     0,     0,     0,     0,  1441,     0,     0,  1257,   232,
     233,   234,   549,     0,   541,   541,   541,  1449,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,   549,     0,     0,     0,
    1582,     0,     0,     0,     0,     0,   232,   233,   234,     0,
       0,     0,     0,  1456,     0,  1458,  1459,  1460,     0,     0,
       0,  1461,     0,     0,     0,  1462,     0,     0,     0,     0,
       0,  1687,     0,     0,   549,   541,     0,   541,     0,     0,
     541,     0,     0,     0,     0,  1483,  1484,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1489,     0,     0,     0,
     541,     0,     0,     0,     0,     0,  1493,  1495,     0,  1499,
       0,     0,     0,     0,     0,  1500,     0,     0,     0,     0,
     550,   541,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,   549,     0,
       0,  1514,  1599,     0,     0,  1704,     0,     0,     0,  1528,
       0,     0,  1534,  1535,     0,  1707,     0,     0,     0,   541,
     541,     0,   549,     0,     0,     0,  1711,     0,  1544,     0,
       0,  1549,     0,     0,  1560,     0,     0,     0,     0,     0,
    1570,     0,   550,     0,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,  1580,     0,   756,
       0,     0,     0,   -94,  1583,     0,   550,     0,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,  1596,   756,     0,   221,     0,     0,  1601,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   254,     0,
     267,     0,     0,     0,     0,     0,     0,     0,   313,   314,
       0,     0,   317,     0,     0,     0,   235,     0,     0,     0,
       0,     0,   378,     0,  1610,  1611,   550,     0,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,   415,   756,     0,     0,     0,     0,  1602,     0,
       0,     0,     0,   235,     0,     0,     0,  1631,   443,     0,
     448,     0,     0,  1634,     0,     0,     0,  1635,     0,     0,
       0,     0,     0,     0,   464,   465,     0,  1638,     0,     0,
       0,     0,     0,     0,     0,     0,   479,     0,     0,     0,
       0,   505,     0,     0,   510,   236,     0,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,     0,
     249,   250,   251,   252,  1839,  1840,     0,     0,  1665,  1666,
       0,   549,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,   236,  1858,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,     0,   249,  1178,   251,
     252,     0,     0,     0,     0,   623,     0,     0,     0,     0,
       0,     0,     0,  1685,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   550,   695,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,   716,
     756,     0,   549,     0,     0,  1603,     0,   550,   726,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,     0,  1604,
       0,   728,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   541,   541,   550,   549,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,  1709,     0,  1605,     0,     0,
     541,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,     0,  1717,  1720,     0,     0,     0,  1969,  1970,  1971,
     777,     0,     0,     0,     0,     0,     0,   784,  1978,     0,
       0,   791,     0,     0,  1739,     0,     0,     0,     0,   550,
    1983,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  1647,     0,   550,  1765,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1655,     0,     0,     0,   803,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   549,
       0,     0,     0,     0,     0,  1586,  1588,  1590,     0,     0,
       0,     0,     0,     0,     0,     0,  2046,     0,  2048,  1799,
    2050,     0,     0,     0,     0,  1803,     0,  1805,     0,   841,
     844,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   857,   541,     0,   861,     0,     0,     0,   864,     0,
       0,     0,     0,   868,   869,   871,  1086,   873,   876,     0,
       0,     0,  1817,     0,  2090,     0,  1614,     0,  1617,     0,
       0,  1619,     0,     0,     0,  1087,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1833,  1834,  1835,     0,  1836,
    1837,  1632,   549,     0,     0,     0,     0,   909,     0,     0,
       0,  1850,     0,  2114,  1853,     0,  1854,     0,  1856,     0,
    2119,  2120,  1640,  1863,     0,   549,     0,  1868,     0,     0,
    1870,     0,     0,  1872,  2133,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,     0,     0,     0,     0,
    2147,  1880,   541,   549,     0,     0,     0,     0,     0,     0,
    1662,  1664,  2156,  2157,     0,     0,     0,     0,     0,  1089,
       0,     0,   550,  1906,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,     0,     0,   756,
       0,     0,     0,     0,  1669,     0,     0,     0,  1925,     0,
       0,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,   541,     0,  1090,  1091,  1092,     0,     0,
       0,     0,     0,     0,     0,     0,  1949,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   550,  1954,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,  1126,
     756,  1130,  1966,  1967,     0,  1673,     0,  1093,     0,  1156,
       0,  1094,     0,     0,     0,     0,  1977,     0,     0,     0,
       0,  1980,     0,     0,     0,  1194,  1982,   550,     0,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,     0,  1674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2020,  1095,     0,     0,     0,     0,     0,     0,
       0,  1096,  1097,  1283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2052,     0,     0,     0,     0,  2055,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,     0,     0,     0,     0,     0,  1326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     550,  1331,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,     0,  1675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1346,     0,     0,     0,     0,     0,
       0,     0,  1350,  2115,     0,  2117,     0,     0,     0,     0,
    1358,     0,     0,     0,  1361,  1362,     0,     0,     0,     0,
       0,     0,     0,  2134,  1819,  1821,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1374,     0,
    1375,     0,  1376,     0,     0,     0,     0,     0,     0,     0,
       0,  1847,     0,   550,     0,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1678,   550,     0,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,     0,   756,     0,     0,     0,     0,  1679,     0,
       0,     0,  1410,  1411,   550,   549,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,    -7,     1,     0,  1681,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     5,     6,     0,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,     0,     0,
      17,     0,     0,    18,    19,     0,     0,     0,     0,    20,
      21,    22,     0,     0,     0,    23,    24,    25,     0,    26,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,     0,  1956,    29,     0,     0,     0,    30,     0,
       0,     0,     0,    31,  1426,     0,    32,     0,     0,     0,
      33,     0,     0,    34,     0,     0,     0,    35,    36,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,    38,
      39,     0,     0,     0,  1439,     0,     0,     0,     0,    40,
      41,    42,    43,     0,     0,     0,     0,     0,    44,    45,
       0,     0,    46,     0,    47,     0,     0,    48,     0,     0,
      49,    50,     0,     0,     0,    51,     0,     0,    52,     0,
       0,     0,     0,     0,    53,    54,    55,    56,     0,     0,
    1452,     0,     0,     0,    57,  1457,    58,     0,     0,    59,
       0,     0,     0,  2036,     0,    60,     0,    61,    62,    63,
       0,     0,     0,     0,    64,    65,    66,    67,     0,    68,
       0,    69,     0,     0,     0,     0,     0,    70,     0,    71,
      72,     0,     0,     0,    73,    74,     0,    75,     0,     0,
       0,     0,     0,  1490,     0,     0,     0,    76,    77,    78,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2089,    80,     0,    81,     0,    82,
       0,     0,     0,     0,   549,     0,     0,     0,     0,     0,
       0,     0,    83,  1515,     0,    84,  1519,     0,     0,     0,
       0,  1529,     0,     0,     0,     0,     0,     0,     0,    85,
       0,    86,     0,     0,     0,     0,     0,    87,    88,    89,
      90,    91,    92,     0,     0,    93,    94,    95,    96,     0,
       0,    97,     0,    98,     0,     0,     0,     0,    99,     0,
     100,   101,   102,   103,   104,   105,   106,     0,     0,   107,
       0,   108,   109,   110,     0,     0,     0,     0,   111,     0,
     112,   113,     0,     0,   114,   115,     0,     0,     0,     0,
       0,     0,     0,   116,   117,   118,   119,     0,     0,   120,
       0,     0,     0,   121,   122,   123,     0,     0,     0,     0,
     124,     0,   125,   126,     0,   127,     0,     0,     0,     0,
     128,     0,   129,   130,   131,   132,   133,   134,   135,     0,
    1608,   136,   137,     0,   138,   139,   140,   141,   142,   143,
     144,     0,   145,   146,   147,     0,   550,  1416,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,  1628,   148,   756,     0,     0,     0,   149,   150,   151,
     152,   153,   154,   155,   156,     0,     0,     0,     0,     0,
       0,   157,     0,   158,   159,   160,   161,     0,     0,     0,
       0,     0,    -7,     1,     0,     0,     0,     0,   162,   163,
       0,     0,     0,   164,     0,     0,     0,    -7,   165,     0,
       0,   953,   954,     4,     5,   166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    17,
       0,     0,    18,    19,     0,     0,     0,     0,    20,    21,
      22,     0,     0,     0,    23,    24,    25,     0,     0,    27,
     549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,    29,     0,     0,     0,    30,     0,     0,
       0,     0,    31,     0,   549,    32,     0,     0,     0,    33,
       0,     0,    34,     0,     0,     0,    35,    36,     0,     0,
       0,     0,     0,     0,     0,   549,    37,     0,    38,    39,
       0,     0,     0,     0,     0,     0,     0,     0,    40,    41,
      42,    43,     0,     0,     0,     0,   549,    44,    45,     0,
       0,    46,     0,    47,     0,     0,    48,     0,     0,    49,
      50,     0,     0,     0,    51,     0,     0,    52,     0,     0,
       0,     0,     0,    53,    54,    55,    56,     0,     0,     0,
    1703,     0,     0,    57,     0,    58,     0,     0,    59,     0,
       0,     0,     0,     0,    60,     0,    61,     0,     0,     0,
       0,     0,     0,     0,    65,    66,    67,     0,    68,     0,
      69,     0,     0,     0,     0,     0,    70,     0,    71,    72,
     549,     0,     0,    73,    74,     0,    75,     0,     0,     0,
       0,     0,     0,     0,     0,   550,    76,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     549,     0,   756,     0,    80,     0,    81,  1683,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,   549,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1778,     0,     0,     0,    85,     0,
      86,     0,     0,     0,  1782,     0,    87,    88,    89,    90,
       0,    92,     0,     0,    93,    94,   955,    96,     0,     0,
      97,     0,    98,     0,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,     0,     0,   107,     0,
       0,   109,   110,     0,     0,     0,     0,   111,     0,   112,
     113,     0,     0,   114,   115,     0,     0,     0,     0,     0,
       0,     0,   116,     0,   118,   119,     0,   549,   120,     0,
       0,     0,   121,   122,   123,     0,     0,     0,     0,   124,
       0,   125,   126,     0,   127,     0,     0,     0,     0,   128,
       0,     0,     0,     0,     0,     0,     0,   135,     0,     0,
     136,   137,  1838,   138,     0,     0,     0,     0,   143,   144,
       0,   145,   146,   147,  1852,   549,     0,     0,     0,     0,
       0,     0,     0,     0,  1862,     0,     0,     0,     0,     0,
       0,   148,     0,     0,     0,     0,   149,   150,   151,   152,
     153,   154,   155,   156,     0,     0,     0,     0,     0,     0,
     157,     0,   956,   957,   958,   268,   269,   270,     0,     6,
       0,   271,   272,     9,   273,   274,   275,   276,   277,   278,
     279,     0,     0,     0,     0,     0,    -7,     0,     0,     0,
       0,     0,     0,     0,   166,   568,     0,     0,     0,     0,
       0,   550,    26,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   568,     0,   756,     0,
       0,     0,     0,  1684,  1937,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,   550,  1693,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,     0,   756,     0,     0,     0,   550,  1696,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,  1976,     0,     0,   -91,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    55,
      56,     0,     0,   268,   269,   270,     0,     6,     0,   271,
     272,     9,   273,   274,   275,   276,   277,   278,   279,     0,
       0,    62,    63,     0,     0,     0,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      26,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,    77,     0,  1723,    79,     0,     0,     0,     0,     0,
       0,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,     0,     0,  1734,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  1735,     0,     0,     0,
       0,     0,   549,     0,   280,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2095,     0,     0,    55,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   108,   109,   110,     0,     0,    62,
      63,     0,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,     0,   568,     0,     0,   117,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,   549,     0,    77,
    1736,     0,    79,     0,     0,   129,   130,   131,   132,   133,
     134,     0,     0,     0,     0,     0,     0,     0,   139,   140,
     141,   142,   143,   144,   549,     0,   550,     0,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,     0,   756,     0,     0,     0,     0,  1737,     0,
     149,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,   280,     0,     0,     0,   281,   282,   283,   161,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   162,   284,     0,     0,     0,   285,     0,     0,     0,
       0,   286,   108,   109,   110,  1025,   569,     0,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,     0,   583,     0,   117,     0,   569,  1755,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,     0,   583,     0,     0,     0,     0,  1759,
       0,     0,     0,   129,   130,   131,   132,   133,   134,     0,
       0,     0,     0,     0,     0,     0,   139,   140,   141,   142,
     143,   144,   268,   269,   270,     0,     6,     0,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   149,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,    26,
       0,     0,     0,     0,   281,   282,   283,   161,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   162,
     284,     0,     0,     0,   285,     0,     0,     0,     0,   286,
       0,     0,     0,  1318,   335,     0,     0,     0,     0,     0,
       0,   336,   337,   338,   339,   340,   341,     0,     0,     0,
     549,     0,   342,   343,   344,   345,   346,   347,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     348,     0,     0,   349,   549,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   350,     0,     0,    55,    56,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     351,     0,     0,     0,     0,     0,     0,     0,    62,    63,
       0,     0,     0,   550,    64,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1767,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,     0,
       0,    79,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   569,     0,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,     0,   583,     0,     0,     0,     0,  1769,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,   363,   756,     0,     0,     0,     0,
    1772,   280,     0,     0,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,     0,  1777,   364,     0,
       0,   108,   109,   110,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   268,   269,   270,   117,     6,     0,   271,   272,     9,
     273,   274,   275,   276,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,     0,  1204,     0,     0,  1205,     0,
       0,     0,   129,   130,   131,   132,   133,   134,    26,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,     0,     0,     0,     0,     0,     0,  1206,
       0,     0,     0,     0,     0,     0,     0,     0,   230,     0,
       0,  1112,     0,     0,     0,     0,   549,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,   365,   366,
       0,     0,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,  1113,     0,     0,     0,     0,     0,   162,   284,
       0,   230,     0,   285,     0,     0,   568,     0,   286,     0,
       0,     0,   393,     0,  1207,  1208,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,    56,     0,     0,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,    62,    63,     0,
       0,  1791,     0,    64,     0,   393,     0,  1114,     0,     0,
       0,     0,     0,     0,  1209,     0,     0,     0,     0,     0,
       0,   550,   299,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,    77,   756,     0,
      79,     0,     0,  1795,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,   330,  1210,     0,     0,  1804,   331,   550,
    1192,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,  1211,     0,   756,     0,     0,     0,
       0,  1816,     0,     0,  1212,  1213,     0,     0,     0,     0,
     280,     0,     0,     0,     0,     0,   330,  1115,     0,     0,
       0,   331,     0,   268,   269,   270,     0,     6,     0,   271,
     272,     9,   273,   274,   275,   276,   277,   278,   279,     0,
     108,   109,   110,  1229,  1214,     0,  1215,  1116,  1117,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1216,  1217,
      26,  1218,     0,   117,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,  1230,     0,     0,     0,     0,     0,  1219,
       0,     0,   549,     0,     0,     0,     0,     0,     0,  1119,
     230,   129,   130,   131,   132,   133,   134,     0,     0,     0,
       0,     0,     0,     0,   139,   140,   141,   142,   143,   144,
    1231,     0,   549,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1120,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   149,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   281,   282,   283,   161,     0,    55,    56,     0,
       0,     0,     0,     0,     0,     0,     0,   162,   284,     0,
       0,     0,   285,     0,     0,     0,     0,   286,     0,    62,
      63,  1232,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   299,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,  1234,     0,  1235,
       0,     0,  1236,     0,  1237,     0,     0,   550,     0,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,   330,     0,  1238,  1239,  1828,
     331,     0,  1192,     0,     0,  1240,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1241,   569,     0,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   280,     0,   583,   268,   269,   270,  1270,     6,
       0,   271,   272,     9,   273,   274,   275,   276,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   108,   109,   110,     0,     0,  1242,     0,     0,
       0,     0,    26,  1243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,   391,     0,     0,
       0,     0,     0,   392,   549,     0,     0,     0,     0,     0,
       0,  1244,   230,     0,     0,     0,   255,   256,   257,     0,
       0,     0,     0,   129,   130,   131,   132,   133,   134,     0,
       0,     0,     0,     0,   258,     0,   139,   140,   141,   142,
     143,   144,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   393,    29,   149,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,    55,
      56,     0,     0,     0,   281,   282,   283,   161,     0,     0,
     394,     0,     0,     0,     0,     0,     0,     0,   549,   162,
     284,    62,    63,     0,   285,     0,     0,    64,     0,   286,
       0,   395,   259,     0,     0,     0,     0,   396,   397,   549,
       0,   398,    45,     0,     0,   298,   299,     0,     0,   399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,     0,   550,    79,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1829,     0,   330,     0,   260,
      61,     0,   331,   550,     0,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,    72,     0,  1830,     0,     0,     0,     0,
       0,     0,     0,     0,   280,     0,     0,   268,   269,   270,
       0,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     487,     0,     0,     0,   108,   109,   110,     0,     0,   549,
       0,   261,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   400,   117,     0,     0,
       0,     0,    85,     0,     0,   488,     0,     0,     0,     0,
       0,     0,   549,     0,   230,     0,     0,     0,     0,     0,
       0,     0,   401,     0,     0,   129,   130,   131,   132,   133,
     134,     0,     0,   489,     0,     0,     0,     0,   139,   140,
     141,   142,   143,   144,   402,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   262,     0,
       0,   490,     0,     0,     0,     0,   116,     0,   393,     0,
     149,   150,   403,   152,   153,   154,     0,     0,     0,     0,
       0,    55,    56,     0,     0,     0,   281,   282,   283,   161,
       0,     0,     0,   491,     0,     0,     0,     0,     0,     0,
       0,   162,   284,    62,    63,     0,   285,     0,     0,    64,
       0,   286,     0,     0,     0,   492,     0,     0,     0,   493,
       0,     0,     0,     0,     0,     0,     0,   298,   299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,   550,    79,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,     0,  1831,     0,   330,
       0,     0,     0,     0,   331,     0,     0,     0,     0,     0,
       0,     0,   268,   269,   270,     0,     6,     0,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,     0,   280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
     426,   494,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   108,   109,   110,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,   117,
     550,  1832,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,     0,  1849,     0,   427,     0,     0,   129,   130,   131,
     132,   133,   134,     0,   549,     0,     0,     0,     0,     0,
     139,   140,   141,   142,   143,   144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    56,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   149,   150,   151,   152,   153,   154,    62,    63,
     428,     0,   429,     0,    64,     0,     0,     0,   281,   282,
     283,   161,     0,     0,     0,   430,   431,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,     0,
       0,     0,     0,   286,     0,     0,     0,     0,    77,     0,
     550,    79,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,     0,  1867,     0,     0,     0,   549,     0,     0,     0,
       0,     0,     0,   550,   432,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1869,     0,     0,     0,     0,
       0,   280,     0,     0,     0,     0,     0,     0,     0,     0,
     433,     0,     0,     0,   434,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     435,   108,   109,   110,     0,     0,   436,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   268,   269,   270,   117,     6,     0,   271,   272,     9,
     273,   274,   275,   276,   277,   278,   279,     0,     0,     0,
       0,   437,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,   131,   132,   133,   134,    26,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,   595,     0,     0,     0,     0,     0,   596,
       0,     0,     0,     0,     0,     0,     0,     0,   230,     0,
       0,     0,     0,     0,     0,     0,     0,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   284,
       0,     0,     0,   285,     0,     0,     0,     0,   286,   268,
     269,   270,   393,     6,     0,   271,   272,     9,   273,   274,
     275,   276,   277,   278,   279,    55,    56,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   597,    21,     0,     0,
     549,     0,     0,     0,     0,     0,    26,    62,    63,     0,
       0,     0,     0,    64,     0,     0,     0,   598,     0,     0,
       0,    29,     0,   599,     0,     0,     0,   600,     0,   219,
       0,     0,     0,     0,     0,   601,     0,     0,     0,     0,
     760,     0,   549,     0,     0,     0,     0,    77,     0,     0,
      79,     0,     0,     0,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,   330,     0,     0,    45,  1874,   331,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   549,     0,   756,     0,     0,     0,
       0,  1878,     0,    55,    56,     0,     0,     0,     0,     0,
     280,     0,     0,     0,     0,     0,     0,   549,     0,     0,
       0,     0,     0,     0,    61,    62,    63,     0,     0,     0,
       0,    64,     0,     0,     0,     0,     0,     0,     0,     0,
     108,   109,   110,     0,     0,     0,     0,    72,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,    77,     0,   550,    79,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,   602,  1902,
       0,   129,   130,   131,   132,   133,   134,     0,     0,     0,
       0,     0,     0,     0,   139,   140,   141,   142,   143,   144,
       0,     0,     0,     0,     0,     0,    85,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   280,     0,
       0,     0,     0,     0,     0,     0,   149,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,   549,     0,     0,
       0,     0,   281,   282,   283,   161,     0,     0,   108,   109,
     110,     0,     0,     0,     0,     0,     0,   162,   284,     0,
       0,     0,   285,     0,     0,     0,     0,   286,     0,     0,
     116,   117,   268,   269,   270,     0,     6,     0,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   129,
     130,   131,   132,   133,   134,     0,     0,     0,     0,    26,
       0,     0,   139,   140,   141,   142,   143,   144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1168,
    1169,     0,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,   149,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     281,   282,   283,   161,     0,     0,     0,     0,     0,     0,
       0,     0,   568,     0,     0,   162,   284,     0,     0,     0,
     285,     0,     0,     0,     0,   286,  1170,     0,     0,     0,
       0,   550,  1419,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,    55,    56,   564,     0,
       0,     0,   268,   269,   270,     0,     6,     0,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,    62,    63,
       0,     0,     0,   550,    64,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,    26,
     756,     0,   298,   299,     0,  1903,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,     0,
       0,    79,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,     0,  1904,   550,   300,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,     0,     0,
    1905,   280,     0,     0,     0,   549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    56,  1556,     0,
       0,  2025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   108,   109,   110,     0,     0,  1171,  1172,    62,    63,
       0,     0,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,     0,
       0,     0,   298,   299,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,     0,
       0,    79,   129,   130,   131,   132,   133,   134,     0,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,     0,   330,     0,     0,     0,   550,   331,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,   549,     0,     0,
       0,   280,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   284,
       0,     0,     0,   285,     0,     0,     0,     0,   286,     0,
       0,   108,   109,   110,     0,     0,  1557,   268,   269,   270,
       0,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,     0,   117,     0,     0,     0,     0,     0,
       0,     0,  1558,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,   129,   130,   131,   132,   133,   134,     0,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,   569,   230,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,     0,
     583,     0,     0,     0,     0,  1921,     0,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   284,
       0,     0,     0,   285,     0,     0,     0,     0,   286,     0,
       0,    55,    56,  1546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    62,    63,     0,     0,     0,     0,    64,
     268,   269,   270,     0,     6,     0,   271,   272,     9,   273,
     274,   275,   276,   277,   278,   279,     0,   298,   299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,     0,    79,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   330,
       0,     0,     0,     0,   331,     0,   550,   230,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,     0,   756,     0,     0,     0,     0,  1931,     0,
       0,     0,     0,     0,     0,     0,   280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   268,   269,
     270,     0,     6,     0,   271,   272,     9,   273,   274,   275,
     276,   277,   278,   279,     0,     0,   108,   109,   110,     0,
       0,  1547,     0,     0,    55,    56,     0,     0,     0,     0,
       0,  1510,     0,     0,     0,    26,     0,     0,     0,   117,
       0,     0,     0,     0,     0,     0,    62,    63,  1468,     0,
       0,     0,    64,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   129,   130,   131,
     132,   133,   134,     0,   549,     0,     0,     0,     0,     0,
     139,   140,   141,   142,   143,   144,    77,     0,   550,    79,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,     0,     0,
    1936,     0,   149,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,   568,   300,   281,   282,
     283,   161,    55,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,   280,
       0,     0,     0,   286,    62,    63,     0,     0,     0,     0,
      64,     0,   268,   269,   270,     0,     6,  1148,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,     0,   108,
     109,   110,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,     0,     0,    79,     0,    26,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1469,     0,  1149,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1470,
     129,   130,   131,   132,   133,   134,   549,     0,     0,  1150,
       0,     0,     0,   139,   140,   141,   142,   143,   144,     0,
       0,     0,     0,     0,     0,     0,     0,   280,     0,   549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   149,   150,   151,   152,   153,
     154,     0,   549,     0,     0,     0,     0,   108,   109,   110,
       0,   281,   282,   283,   161,     0,    55,    56,  1511,     0,
       0,     0,     0,     0,     0,     0,   162,   284,     0,     0,
     117,   285,     0,     0,     0,     0,   286,     0,    62,    63,
       0,     0,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   129,   130,
     131,   132,   133,   134,     0,     0,     0,     0,     0,     0,
       0,   139,   140,   141,   142,   143,   144,     0,    77,     0,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   150,   151,   152,   153,   154,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   281,
     282,   283,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,   284,     0,     0,     0,   285,
       0,   280,     0,     0,   286,   268,   269,   270,     0,     6,
       0,   271,   272,     9,   273,   274,   275,   276,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   108,   109,   110,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,     0,  1942,     0,     0,
       0,     0,   129,   130,   131,   132,   133,   134,   549,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,     0,     0,   512,   513,   569,  1420,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,     0,   583,     0,     0,   149,   150,   151,
     152,   153,   154,   549,     0,     0,   514,   515,     0,    55,
      56,     0,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   284,
       0,    62,    63,   285,     0,     0,     0,    64,   286,     0,
       0,     0,     0,     0,   268,   269,   270,     5,     6,     0,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,     0,     0,    79,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     0,     0,     0,   550,     0,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,     0,  1946,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,     0,  1947,   550,   280,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  1953,     0,     0,     0,     0,
       0,     0,     0,     0,   108,   109,   110,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    55,    56,
       0,     0,     0,     0,   268,   269,   270,   117,     6,     0,
     271,   272,     9,   273,   274,   275,   276,   277,   278,   279,
      62,    63,     0,     0,     0,     0,    64,     0,     0,     0,
       0,     0,     0,     0,   549,   129,   130,   131,   132,   133,
     134,    26,     0,     0,     0,     0,     0,     0,   139,   140,
     141,   142,   143,   144,     0,     0,     0,     0,   521,   522,
      77,    78,     0,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   549,
     149,   150,   151,   152,   153,   154,     0,     0,     0,   523,
     524,     0,     0,     0,     0,     0,   281,   282,   283,   161,
     549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   162,   284,     0,     0,     0,   285,     0,     0,     0,
       0,   286,     0,    91,   549,     0,     0,     0,     0,   539,
       0,     0,     0,     0,     0,     0,     0,     0,    55,    56,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   108,   109,   110,     0,     0,     0,     0,
      62,    63,     0,     0,     0,     0,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,  1056,     0,   550,
    1057,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
      77,  1961,     0,    79,   129,   130,   131,   132,   133,   134,
       0,     0,     0,     0,     0,     0,     0,   139,   140,   141,
     142,   143,   144,     0,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  1962,     0,     0,   149,
     150,   151,   152,   153,   154,     0,     0,     0,     0,   549,
       0,     0,     0,   280,     0,   281,   282,   283,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     162,   163,     0,     0,     0,   164,     0,     0,     0,     0,
     165,     0,     0,   108,   109,   110,     0,     0,  1058,   268,
     269,   270,     0,     6,     0,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,   129,   130,   131,   132,   133,   134,
       0,     0,     0,   549,     0,     0,     0,   139,   140,   141,
     142,   143,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   549,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   149,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   281,   282,   283,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     162,   284,   549,     0,     0,   285,     0,     0,     0,     0,
     286,     0,     0,    55,    56,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,    62,    63,  1963,     0,     0,
       0,    64,   268,   269,   270,     0,     6,     0,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,     0,     0,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,    77,    78,   756,    79,    26,
       0,   550,  1964,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,     0,     0,  1973,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,   549,   756,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91,     0,
       0,     0,   549,     0,   539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
     110,     0,     0,     0,     0,     0,    55,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,     0,     0,    62,    63,
       0,     0,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   129,
     130,   131,   132,   133,   134,     0,     0,     0,     0,     0,
       0,     0,   139,   140,   141,   142,   143,   144,    77,    78,
     550,    79,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,     0,  2003,     0,   149,   150,   151,   152,   153,   154,
       0,     0,     0,   549,     0,     0,     0,     0,     0,     0,
     281,   282,   283,   161,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,   163,     0,     0,     0,
     164,    91,     0,     0,     0,   165,     0,  1639,     0,     0,
       0,     0,     0,   268,   269,   270,     0,     6,    99,   271,
     272,     9,   273,   274,   275,   276,   277,   278,   279,     0,
       0,   108,   109,   110,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
      26,   756,     0,     0,   117,   550,  2004,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,   219,     0,     0,     0,  2012,     0,     0,
       0,     0,   129,   130,   131,   132,   133,   134,   549,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,   550,     0,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  2019,     0,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,   549,     0,   281,   282,   283,   161,    55,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   163,
       0,     0,     0,   164,     0,     0,     0,     0,   165,    62,
      63,     0,     0,     0,     0,    64,   268,   269,   270,     0,
       6,     0,   271,   272,     9,   273,   274,   275,   276,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    77,
       0,     0,    79,    26,     0,     0,     0,     0,     0,     0,
       0,   865,   550,     0,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,     0,     0,   756,
       0,     0,     0,   550,  2039,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,     0,     0,
     756,     0,     0,     0,     0,  2040,     0,     0,     0,     0,
       0,     0,   280,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   268,   269,   270,     0,     6,     0,
     271,   272,     9,   273,   274,   275,   276,   277,   278,   279,
       0,     0,   108,   109,   110,     0,     0,     0,   549,     0,
      55,    56,   768,     0,     0,     0,     0,  1523,     0,     0,
       0,    26,     0,     0,     0,   117,     0,     0,     0,     0,
       0,     0,    62,    63,     0,   866,     0,     0,    64,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   129,   130,   131,   132,   133,   134,     0,
     549,     0,     0,     0,     0,     0,   139,   140,   141,   142,
     143,   144,    77,     0,   550,    79,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,     0,
       0,   756,     0,     0,     0,     0,  2047,     0,   149,   150,
     151,   152,   153,   154,     0,     0,     0,     0,   549,     0,
       0,     0,     0,     0,   281,   282,   283,   161,    55,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   162,
     284,     0,     0,     0,   285,   280,     0,     0,     0,   286,
      62,    63,     0,     0,     0,     0,    64,   268,   269,   270,
       0,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,     0,     0,   108,   109,   110,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,     0,     0,    79,    26,     0,     0,     0,   117,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  2054,     0,   549,   230,     0,   129,   130,   131,   132,
     133,   134,     0,     0,     0,     0,     0,     0,     0,   139,
     140,   141,   142,   143,   144,     0,     0,     0,     0,   549,
       0,     0,   550,   280,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     549,   149,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,     0,   108,   109,   110,     0,   281,   282,   283,
     161,    55,    56,     0,  1524,     0,     0,     0,     0,     0,
       0,     0,   162,   284,     0,     0,   117,   285,     0,     0,
       0,     0,   286,    62,    63,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   129,   130,   131,   132,   133,   134,
       0,     0,     0,     0,     0,     0,     0,   139,   140,   141,
     142,   143,   144,    77,     0,     0,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   149,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   300,   281,   282,   283,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   549,     0,
     162,   284,     0,     0,     0,   285,   280,     0,     0,   550,
     286,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  2063,     0,     0,     0,     0,   108,   109,   110,     0,
     268,   269,   270,     0,     6,     0,   271,   272,     9,   273,
     274,   275,   276,   277,   278,   279,     0,     0,     0,   117,
       0,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,    26,   756,     0,
       0,     0,     0,  2068,     0,     0,     0,   129,   130,   131,
     132,   133,   134,     0,     0,     0,     0,     0,     0,     0,
     139,   140,   141,   142,   143,   144,     0,     0,     0,   550,
    1718,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  2070,   149,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   281,   282,
     283,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,     0,
       0,     0,     0,   286,    55,    56,     0,     0,   268,   269,
     270,     0,     6,     0,   271,   272,     9,   273,   274,   275,
     276,   277,   278,   279,     0,     0,    62,    63,     0,     0,
       0,     0,    64,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   550,    26,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,     0,     0,     0,  1271,    77,     0,   219,    79,
     550,     0,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,     0,     0,   756,     0,     0,
       0,   550,  2078,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,     0,     0,  2091,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   280,
       0,  1719,     0,     0,     0,     0,     0,   549,     0,     0,
       0,     0,    55,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   108,
     109,   110,     0,     0,    62,    63,     0,     0,     0,     0,
      64,     0,     0,     0,     0,     0,     0,     0,     0,   268,
     269,   270,   117,     6,     0,   271,   272,     9,   273,   274,
     275,   276,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1859,     0,     0,  1860,  1861,     0,
     129,   130,   131,   132,   133,   134,    26,     0,     0,     0,
       0,     0,     0,   139,   140,   141,   142,   143,   144,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,     0,
       0,  2106,     0,     0,     0,   149,   150,   151,   152,   153,
     154,     0,     0,     0,     0,     0,     0,   280,     0,     0,
       0,   281,   282,   283,   161,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   162,   284,     0,     0,
       0,   285,     0,     0,     0,     0,   286,   108,   109,   110,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    55,    56,     0,     0,   268,   269,   270,
     117,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,     0,     0,    62,    63,     0,     0,     0,
       0,    64,     0,     0,     0,     0,     0,     0,   129,   130,
     131,   132,   133,   134,    26,     0,     0,     0,     0,     0,
       0,   139,   140,   141,   142,   143,   144,     0,     0,     0,
       0,     0,     0,     0,     0,    77,     0,   219,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   150,   151,   152,   153,   154,     0,
       0,   330,     0,     0,     0,     0,   331,     0,     0,   281,
     282,   283,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,   284,     0,     0,     0,   285,
       0,     0,     0,     0,   286,     0,     0,     0,   280,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    55,    56,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
     110,     0,     0,    62,    63,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,     0,     0,   268,   269,
     270,   117,     6,     0,   271,   272,     9,   273,   274,   275,
     276,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,     0,    79,     0,     0,   129,
     130,   131,   132,   133,   134,    26,     0,     0,     0,     0,
       0,     0,   139,   140,   141,   142,   143,   144,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,     0,     0,
    2107,     0,     0,     0,   149,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,   280,     0,     0,     0,
     281,   282,   283,   161,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,   284,     0,     0,     0,
     285,     0,     0,     0,     0,   286,   108,   109,   110,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    55,    56,     0,     0,   268,   269,   270,   117,
       6,     0,   271,   272,     9,   273,   274,   275,   276,   277,
     278,   279,     0,     0,    62,    63,     0,     0,     0,     0,
      64,     0,     0,     0,     0,     0,     0,   129,   130,   131,
     132,   133,   134,    26,     0,     0,     0,     0,     0,     0,
     139,   140,   141,   142,   143,   144,     0,     0,     0,     0,
       0,     0,     0,     0,    77,     0,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   149,   150,   151,   152,   153,   154,     0,     0,
       0,     0,   587,     0,     0,     0,     0,     0,   281,   282,
     283,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,     0,
       0,     0,     0,   286,     0,     0,     0,   280,     0,     0,
       0,     0,     0,     0,     0,   549,     0,     0,     0,     0,
      55,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   108,   109,   110,
       0,     0,    62,    63,     0,     0,     0,     0,    64,     0,
       0,     0,     0,     0,     0,     0,     0,   268,   269,   270,
     117,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    77,     0,     0,    79,     0,     0,   129,   130,
     131,   132,   133,   134,    26,     0,     0,     0,   473,     0,
       0,   139,   140,   141,   142,   143,   144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   150,   151,   152,   153,   154,     0,
       0,     0,     0,     0,     0,   280,     0,     0,     0,   281,
     282,   283,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,   284,     0,     0,     0,   285,
       0,     0,     0,     0,   286,   108,   109,   110,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    55,    56,     0,     0,   268,   269,   270,   117,     6,
       0,   271,   272,     9,   273,   274,   275,   276,   277,   278,
     279,     0,     0,    62,    63,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,   129,   130,   131,   132,
     133,   134,    26,     0,     0,     0,     0,     0,     0,   139,
     140,   141,   142,   143,   144,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,   219,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   149,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   281,   282,   283,
     161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,   284,     0,     0,     0,   285,     0,     0,
       0,     0,   286,     0,     0,     0,   280,     0,     0,     0,
       0,     0,     0,     0,   549,     0,     0,     0,     0,    55,
      56,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   108,   109,   110,     0,
       0,    62,    63,     0,     0,     0,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,   268,   269,   270,   117,
       6,     0,   271,   272,     9,   273,   274,   275,   276,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,     0,     0,    79,     0,     0,   129,   130,   131,
     132,   133,   134,    26,     0,     0,     0,     0,     0,     0,
     139,   140,   141,   142,   143,   144,   550,     0,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,     0,     0,   756,     0,     0,     0,     0,  2108,     0,
       0,     0,   149,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,   280,     0,     0,     0,   281,   282,
     283,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,     0,
       0,     0,     0,   725,   108,   109,   110,   393,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,    56,     0,     0,   268,   269,   270,   117,     6,     0,
     271,   272,     9,   273,   274,   275,   276,   277,   278,   279,
       0,     0,    62,    63,     0,     0,     0,     0,    64,     0,
       0,     0,     0,     0,     0,   129,   130,   131,   132,   133,
     134,    26,     0,     0,     0,     0,     0,     0,   139,   140,
     141,   142,   143,   144,     0,     0,     0,     0,     0,     0,
       0,     0,    77,     0,     0,    79,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     149,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   281,   282,   283,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   162,   284,     0,     0,     0,   285,     0,     0,     0,
       0,   286,     0,     0,     0,   280,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   549,    55,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   108,   109,   110,     0,     0,
      62,    63,     0,     0,     0,     0,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,   268,
     269,   270,     0,     6,     0,   271,   272,     9,   273,   274,
     275,   276,   277,   278,   279,     0,     0,     0,     0,     0,
      77,     0,     0,    79,     0,     0,   129,   130,   131,   132,
     133,   134,     0,     0,     0,     0,    26,     0,     0,   139,
     140,   141,   142,   143,   144,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,     0,     0,  2109,     0,     0,
       0,   149,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,     0,   280,     0,     0,     0,   281,   282,   283,
     161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,   284,     0,     0,     0,   285,     0,     0,
       0,     0,   286,   108,   109,   110,     0,   268,   269,   270,
       0,     6,     0,   271,   272,     9,   273,   274,   275,   276,
     277,   278,   279,    55,    56,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1536,     0,    26,    62,    63,     0,     0,     0,
       0,    64,     0,     0,   129,   130,   131,   132,   133,   134,
       0,     0,     0,     0,     0,     0,     0,   139,   140,   141,
     142,   143,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    77,     0,     0,    79,     0,
       0,     0,   549,     0,     0,     0,     0,     0,     0,   149,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   281,   282,   283,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     162,   284,     0,     0,     0,   285,     0,     0,     0,     0,
     286,    55,    56,   549,     0,     0,     0,     0,   280,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    62,    63,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
     110,     0,   268,   269,   270,     0,     6,     0,   271,   272,
       9,   273,   274,   275,   276,   277,   278,   279,     0,     0,
       0,   117,     0,    77,     0,     0,    79,     0,   549,     0,
       0,     0,     0,     0,     0,     0,     0,  1538,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   129,
     130,   131,   132,   133,   134,     0,     0,     0,     0,     0,
       0,   549,   139,   140,   141,   142,   143,   144,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,   549,   756,   280,     0,     0,     0,
    2127,     0,     0,     0,   149,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,   568,     0,     0,
     281,   282,   283,   161,     0,     0,   108,   109,   110,     0,
       0,     0,     0,     0,     0,   162,   284,   549,     0,     0,
     285,     0,     0,     0,     0,   286,    55,    56,     0,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1569,   568,     0,    62,    63,
       0,     0,     0,     0,    64,     0,     0,   129,   130,   131,
     132,   133,   134,     0,     0,     0,   568,     0,     0,     0,
     139,   140,   141,   142,   143,   144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,     0,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   149,   150,   151,   152,   153,   154,     0,     0,
       0,     0,   549,     0,     0,     0,     0,     0,   281,   282,
     283,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,   284,     0,     0,     0,   285,     0,
       0,     0,     0,   286,     0,     0,     0,     0,     0,     0,
       0,   280,     0,     0,   268,   269,   270,  1855,     6,     0,
     271,   272,     9,   273,   274,   275,   276,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,     0,   549,     0,
       0,   108,   109,   110,     0,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     0,     0,     0,     0,   568,     0,
       0,     0,     0,   550,   117,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   549,     0,
     756,     0,     0,     0,     0,  2129,     0,     0,     0,     0,
       0,     0,   129,   130,   131,   132,   133,   134,   568,     0,
       0,     0,     0,     0,     0,   139,   140,   141,   142,   143,
     144,     0,     0,     0,   550,     0,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   549,
       0,   756,     0,     0,     0,     0,  2143,   149,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,    55,    56,
       0,   568,     0,   281,   282,   283,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,   284,
      62,    63,     0,   285,   568,     0,    64,     0,   286,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   568,     0,   756,     0,     0,     0,
       0,  2152,     0,     0,     0,     0,     0,     0,     0,     0,
      77,     0,   550,    79,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   549,     0,   756,
       0,     0,     0,     0,  2153,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     549,     0,   756,     0,     0,     0,     0,  2154,   569,     0,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   280,   549,   583,     0,     0,   550,  1272,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,   549,   756,     0,     0,     0,   951,
       0,     0,     0,   108,   109,   110,     0,   569,     0,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   568,     0,   583,     0,   117,   569,  1382,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   549,     0,   583,     0,     0,     0,  1577,     0,
       0,     0,     0,     0,   129,   130,   131,   132,   133,   134,
       0,     0,   568,     0,     0,     0,     0,   139,   140,   141,
     142,   143,   144,   550,     0,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   549,     0,
     756,     0,     0,     0,  1271,     0,     0,     0,     0,   149,
     150,   151,   152,   153,   154,     0,     0,     0,   549,     0,
       0,     0,     0,     0,     0,   281,   282,   283,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   549,     0,
     162,   284,     0,     0,     0,   285,     0,     0,     0,   550,
     286,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   568,     0,   564,     0,     0,   569,
    1727,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   549,     0,   583,     0,     0,   550,
    1728,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   549,     0,   564,     0,     0,   569,
    1729,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   549,     0,   583,     0,     0,     0,
    1730,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   568,     0,   564,     0,     0,
       0,  1731,   569,     0,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   549,     0,   583,
       0,     0,     0,  1732,     0,   569,     0,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     549,     0,   583,     0,     0,   569,  1757,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     549,     0,   583,     0,     0,     0,  1775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   568,     0,   756,     0,     0,     0,  1727,
       0,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   549,     0,   756,     0,
       0,     0,  1729,     0,     0,   550,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     549,     0,   756,     0,     0,   550,  1876,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     568,     0,   564,     0,     0,     0,  1898,     0,     0,     0,
       0,     0,     0,   569,     0,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   549,     0,
     583,     0,     0,   550,  1899,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   549,     0,
     564,     0,     0,   569,  1900,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   549,     0,
     583,     0,     0,     0,  1901,     0,     0,     0,     0,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   549,     0,   756,     0,     0,   550,
    1898,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   549,     0,   756,     0,     0,   550,
    1900,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   568,     0,   564,     0,     0,     0,
    2000,     0,     0,     0,     0,   569,     0,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,     0,   583,     0,     0,   550,  2001,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,   550,  2029,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,   550,  2000,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,     0,     0,     0,  2061,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   569,     0,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,     0,   583,     0,     0,     0,  2062,   550,     0,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,     0,     0,   756,     0,     0,     0,  2061,
       0,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,   550,  2101,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,     0,
       0,     0,  2102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   569,     0,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
       0,   583,     0,     0,     0,  2103,     0,   550,     0,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,     0,     0,   756,     0,     0,     0,  2102,     0,
       0,   550,     0,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,     0,     0,   756,     0,
       0,   569,  2158,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,     0,   583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,     0,     0,   756,     0,     0,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,  1364,     0,     0,   756,     0,     0,   550,
       0,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,  1367,     0,     0,   756,     0,     0,     0,
       0,     0,     0,     0,     0,  -904,     0,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
       0,     0,   756,     0,     0,  -904,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,     0,     0,  -904,     0,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     639,     0,   583,     0,     0,     0,     0,   640,     0,     0,
       0,     0,   639,     0,     0,     0,     0,     0,   607,   640,
     608,     0,     0,     0,     0,   609,     0,     0,     0,   641,
       0,   230,   642,   643,     0,     0,     0,     0,   644,     0,
       0,   641,     0,   230,   642,   643,     0,     0,     0,     0,
     644,     0,     0,   610,     0,   219,     0,     0,     0,   611,
       0,     0,   230,     0,     0,     0,     0,     0,   645,   646,
       0,     0,     0,   647,     0,   232,   233,   234,   648,   445,
     645,   646,     0,     0,   446,   647,     0,     0,     0,     0,
     648,     0,     0,     0,     0,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   612,
     649,     0,     0,     0,     0,     0,   393,     0,     0,     0,
       0,     0,   649,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   650,     0,     0,   651,
     652,   613,   653,     0,   298,   299,   654,     0,   650,     0,
       0,   651,   652,     0,   653,     0,   298,   299,   654,     0,
       0,     0,     0,   614,     0,   615,     0,   616,     0,     0,
       0,     0,     0,     0,     0,   298,   299,     0,     0,   617,
       0,     0,     0,     0,     0,     0,   330,     0,     0,     0,
       0,   331,     0,     0,     0,     0,     0,     0,   330,     0,
       0,     0,     0,   331,     0,     0,     0,     0,   655,     0,
       0,     0,     0,     0,     0,     0,     0,   330,     0,     0,
     655,     0,   331,     0,     0,   618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,     0,     0,   336,
     337,   338,   339,   340,   341,   447,     0,     0,     0,   656,
     342,   343,   344,   345,   346,   347,     0,     0,     0,   619,
       0,   656,     0,     0,     0,     0,     0,     0,   348,   657,
       0,   349,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   657,   658,     0,     0,     0,   620,     0,     0,     0,
       0,   350,     0,   659,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   659,     0,     0,   351,     0,
       0,     0,   235,   621,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   660,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     660,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,     0,     0,     0,     0,     0,   661,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1415,   236,   622,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,     0,   249,   250,   251,   252,
       0,     0,   363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   364,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   365,   366
};

static const yytype_int16 yycheck[] =
{
       0,   592,   421,   206,   586,    55,   209,   661,   211,   212,
     601,   214,   193,    79,    37,    79,   142,  1078,    92,    70,
       0,    92,    40,    41,    58,    47,   617,    20,    21,    22,
      86,    52,    18,    40,    41,    53,   149,    51,    86,     0,
      52,    59,     0,   211,    44,   370,    53,     0,    52,    71,
     124,    31,    59,  1114,    52,    38,    52,   450,    67,   109,
      52,   122,   153,   154,    36,   376,   190,   118,    90,    52,
      70,   122,   123,   235,   165,    86,    79,   185,    79,   140,
      18,    69,    70,    27,    86,   347,   241,    70,   256,   238,
      69,   246,    79,   404,    38,    76,   120,   142,    69,   443,
     185,    90,   241,   447,   126,   195,   143,   246,    52,    69,
     144,   111,   203,   235,   445,   318,    86,   120,   136,   426,
     445,   171,   122,    86,    47,   142,    70,   445,   128,   136,
     205,    76,    45,   443,   185,   282,   187,   137,   448,   122,
     252,   205,   449,   199,   200,   269,  1207,   165,    71,    72,
     159,   160,   174,   204,   141,   241,   136,   157,   165,   148,
     246,   147,   162,   163,   164,   165,    53,    90,    79,   443,
     140,   189,   284,   447,   118,   197,   379,   158,   122,   123,
     173,   443,   189,   183,   198,   185,   197,   248,   199,   200,
      77,   252,   347,   241,   309,   310,   304,   242,   246,    86,
     256,   235,   445,   126,   187,   193,   206,   207,   256,   209,
     210,   194,     0,   213,   289,   215,   216,   217,   218,   304,
     203,   204,   335,   241,   241,   289,   235,    85,   246,   246,
     241,    89,    20,   169,   241,   246,    24,   261,    79,   246,
     241,   185,   180,   187,   266,   246,   255,    35,   193,   286,
     194,   174,   245,   140,   256,   272,   235,   379,   261,   203,
     204,   233,    50,   174,   386,   237,   237,    68,   446,   447,
     419,   257,   235,   412,   197,   443,   117,   237,   165,   250,
      89,    69,    70,   445,   284,   285,   286,   445,   410,   270,
     250,   347,    80,   256,   446,   447,    86,   449,   319,   299,
     187,   335,   347,   291,   191,   323,   320,   319,   330,   445,
      98,    35,   199,   200,   351,   192,   323,   443,   195,   443,
     368,   319,   322,   319,   112,    38,   114,   319,   241,   347,
     347,   119,   120,   246,   294,   426,   347,   346,   443,    52,
     347,    65,   447,   266,   153,   154,   291,    82,   136,    86,
     138,   105,   153,   154,   212,   448,   344,    70,   367,   132,
     339,   135,   380,   566,   368,    73,    74,    50,   385,   142,
     384,   426,   146,   380,   385,    88,   445,   443,   447,   450,
      24,   381,   443,   319,   384,   399,  1447,   391,    96,    97,
      79,   153,   154,   411,   449,   183,   184,   397,   445,   153,
     154,   259,   402,   403,   411,   118,   253,   330,   391,   122,
     123,   258,   443,    24,   357,   445,   190,   448,   354,   419,
     443,   443,   841,   842,   368,   443,   369,   443,   165,   429,
     446,   424,   115,   443,   445,   435,   443,   445,   448,   667,
     450,   441,   670,   671,   168,    24,   170,   391,   156,   157,
     450,   451,   189,   453,    66,    49,   857,    69,   153,   154,
     861,    81,   462,   200,   199,   200,   117,   108,    57,   193,
     347,   280,   445,   473,   187,   426,   445,   477,   478,   445,
     195,   194,   343,   284,    19,   247,   490,   487,    24,   692,
     203,   204,    86,   153,   154,   269,   445,    86,   449,   445,
     309,   310,   654,   503,   504,   445,   241,   295,   309,   310,
     445,   246,   512,   513,   514,   515,   443,   446,   447,   139,
     447,   521,   522,   523,   524,   443,   241,   315,   731,   447,
     733,   246,   735,   153,   154,   535,   536,   537,    79,   426,
      77,   265,   445,   267,   133,    86,   490,   309,   310,    86,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   206,   207,   291,   548,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   658,   585,   586,   548,   639,   377,
     548,   595,    24,   593,   382,   548,   237,   385,   386,   140,
     446,   447,   191,   140,    86,   199,   200,   607,   612,   443,
     199,   200,   595,   447,   309,   310,   667,   379,    24,   670,
     443,   241,   622,   411,   447,   237,   246,   445,   416,   353,
     445,   355,   445,   443,   246,   423,   446,   447,   250,   445,
     281,   443,   445,   647,   648,   447,   187,   445,   410,   653,
     191,   595,   241,   657,   445,   655,   445,   246,   200,   200,
     660,   445,   199,   200,   647,   445,   454,   256,   612,   669,
     653,   459,   460,   445,   657,   463,   445,   677,   391,   446,
     447,    24,   445,   666,   450,   446,   447,   687,   445,   309,
     445,   437,   438,   439,   445,   639,   442,   437,   438,   439,
     644,   242,   442,   647,   648,   437,   438,   439,   450,   653,
     442,  2159,  2160,   657,     0,   715,   444,   199,   200,   256,
     450,    86,   666,   667,   450,   725,   670,   671,   448,   517,
     446,   447,   732,   445,   734,   445,   736,   737,   738,   739,
      24,   529,   530,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   756,   757,   347,   241,
     548,  1415,   446,   447,   246,   445,    86,   767,   768,    24,
     446,   447,   313,   343,   311,   775,   446,   447,   778,   443,
     961,   425,   443,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   132,   334,   442,   153,
     154,   589,   446,   447,   446,   447,   132,   811,   445,     0,
     445,    86,   445,   133,   446,   447,   445,   817,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    20,
     830,   442,   197,    24,   199,   200,  2163,  2164,   445,   120,
      47,   445,  1424,   445,    35,   445,   425,   445,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  2130,  2131,   442,    71,   865,   866,   811,   447,   445,
     670,   671,    79,   426,   443,   443,   241,   343,    69,   199,
     200,   246,   595,    90,   313,   313,   448,   675,   676,    80,
     328,    24,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   143,   303,   442,    98,   908,   313,
     960,   143,   266,   343,   132,   132,   916,   343,    59,   126,
     195,   112,   132,   114,   199,   200,   926,   133,   119,   120,
     718,   644,   428,   933,   647,   313,   256,    24,   442,  1358,
     653,   442,   445,   442,   657,   136,   195,   138,   450,   313,
     313,   347,   164,   666,   667,   309,   310,   670,   671,   417,
     241,   313,   447,   446,   313,   246,   241,   174,   446,   446,
     202,   246,   447,   447,   447,   447,   447,   765,   447,   962,
     261,   256,   347,   215,   254,   447,   449,   262,   447,   446,
     197,   447,   447,   425,   994,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   447,   343,
     442,   343,   446,   423,   447,   447,   447,   292,   962,   425,
     385,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   447,  1035,   442,  1041,   313,   446,
     272,   447,   447,   446,   435,   833,  1046,   447,   189,   370,
     191,  1101,   840,  1053,    24,   447,  1056,  1057,  1058,   266,
     447,  1061,   447,   447,   423,   448,   447,  1067,   313,   313,
    1273,   447,   347,  1073,  1277,    86,   313,  1077,   447,  1079,
     447,  1081,   425,   171,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1041,   423,   442,
     241,   242,   447,   446,   295,   246,    47,   195,   447,   447,
     342,   451,   447,   345,   447,  1115,   445,   905,  1169,   449,
     148,   448,   133,   330,   315,    22,   339,   446,    24,  1129,
      71,   447,  1132,   447,   366,   447,   368,  1137,   339,   447,
    1140,   425,   447,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,  1139,    24,   442,   447,
     447,   637,   447,   447,   447,   447,  1170,   446,   448,   447,
     425,  1171,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   126,   377,   442,   199,   200,
     447,   382,   447,  1193,   385,   386,   337,   338,   446,   446,
     548,    24,    39,   449,   447,   447,   347,  1207,   449,   447,
    1210,   447,   153,   154,  1417,   449,   446,  1217,  1218,   447,
     411,   447,   447,   447,   447,   416,  1170,    24,   448,   532,
     241,   447,   423,   174,  1234,   246,   447,  1237,  1238,  1239,
     449,   446,  1242,   447,   447,   256,   446,   171,   447,   962,
     447,  1234,   447,    24,  1237,   447,   197,   446,  1258,  1259,
     446,  1261,   446,   454,   446,  2084,   447,   446,   459,   460,
     447,   447,   463,   447,  1274,  1275,  1276,   449,  1278,  1279,
    1280,  1281,   449,   447,   447,   446,  2033,   447,   376,   377,
    1234,   447,   425,  1237,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   447,   447,   442,
     446,  2086,   447,   447,   447,   446,   404,   405,   406,   407,
     408,   409,  1913,   447,   446,   266,   517,   446,   446,  1921,
     447,   447,   447,   447,   446,  1335,   447,  1337,   529,   530,
    1340,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   446,  1354,   442,    24,   548,   447,  1341,
    1360,   446,   446,   446,  1364,   447,   446,  1367,   309,   310,
     446,   446,   376,   377,   447,   447,   446,  1377,  1378,   447,
     447,  1381,   447,   447,   447,   309,   310,  1387,  1388,   330,
    1390,   447,   447,  1393,   447,   446,   446,  1600,   446,    24,
     404,   405,   406,   407,   408,   409,   447,   447,   446,  1192,
     447,   447,   447,   447,   446,   446,  1416,    -1,    -1,  1419,
    1420,    -1,    -1,    -1,    -1,    -1,  1139,  1427,    24,    -1,
      -1,    -1,  1432,    -1,    -1,   359,   360,    -1,   362,   363,
      -1,    -1,    -1,  1443,    -1,    -1,    -1,    24,   372,   373,
     374,   375,    -1,  1453,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    24,   447,    -1,    -1,
      -1,    -1,    -1,    -1,   675,   676,    -1,    -1,    -1,    -1,
      -1,  1491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1501,  1502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1513,    -1,    -1,  1516,    -1,    -1,    -1,
      -1,  1234,    -1,    -1,  1237,    -1,  1314,   718,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,  1333,   442,  1547,    -1,    -1,
     446,  1339,    -1,    -1,    -1,    -1,    -1,  1557,    -1,    -1,
    1348,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1573,   765,   442,    -1,    -1,    -1,    -1,
      -1,    -1,  1582,    24,    -1,    -1,    -1,    79,    77,    -1,
      79,    -1,    -1,    -1,    86,  1383,    -1,    86,  1598,  1599,
      -1,  1601,  1602,  1603,  1604,  1605,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,    -1,   442,
      -1,    -1,    -1,  1623,  1412,  1413,    -1,    -1,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,  1647,   140,   840,
     447,   140,    -1,    -1,   425,  1655,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1669,
      -1,   442,    -1,  1673,  1674,  1675,   447,    -1,  1678,  1679,
      -1,  1681,    -1,  1683,  1684,    -1,  1686,    -1,    -1,    -1,
      -1,    -1,    -1,  1693,    -1,   187,  1696,    -1,   187,   191,
      -1,    -1,    -1,   192,    -1,    -1,  1706,    -1,   200,    -1,
    1710,   200,    -1,    -1,   905,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1723,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1733,  1734,  1735,  1736,  1737,  1738,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1950,    -1,    -1,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,
    1760,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,  1772,   262,   442,    -1,    -1,  1777,    -1,    50,
      -1,    52,    -1,    -1,  1784,    -1,    -1,    -1,    -1,    -1,
      -1,  1791,    24,    -1,    -1,  1795,    -1,    -1,    -1,    70,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,  1816,   442,    -1,    -1,
      -1,   313,   447,    -1,    -1,    -1,    -1,  1827,  1828,  1829,
    1830,  1831,  1832,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,  1849,
      -1,   122,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,  1867,    -1,  1869,
       0,    -1,    -1,    -1,  1874,    24,    -1,   425,  1878,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,    24,   447,
      -1,    -1,  1902,  1903,  1904,  1905,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   185,    -1,   187,  1917,    -1,    -1,
      -1,    -1,   193,   194,  1924,   196,    -1,    -1,    -1,    -1,
      -1,  1931,    -1,    -1,   205,    -1,  1936,    -1,    -1,    -1,
      -1,    -1,  1942,    -1,    -1,    -1,  1946,  1947,    -1,   220,
      -1,    -1,    -1,  1953,   225,    -1,    -1,    -1,    -1,    -1,
      -1,  1961,  1962,  1963,  1964,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1973,  1762,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,  1987,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,  2002,  2003,  2004,    -1,    -1,    -1,    -1,  2009,
      -1,    -1,  2012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1811,    -1,  2025,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   163,   164,   165,    -1,    -1,    -1,  2039,
    2040,    -1,    -1,    -1,    -1,    -1,    -1,  2047,    -1,    -1,
      -1,    -1,    -1,   324,  2054,    -1,    -1,    -1,    -1,    -1,
    2060,    -1,    -1,  2063,    -1,    -1,    -1,    -1,  2068,    -1,
    2070,    -1,    -1,    -1,    -1,  2075,    -1,    -1,  2078,   209,
     210,    -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2091,    -1,    -1,    -1,    -1,    -1,    -1,   369,    -1,
      33,    34,    -1,    -1,    -1,    -1,    -1,  2107,    -1,  2109,
      -1,    24,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     391,    -1,    -1,  1314,   395,    -1,    -1,  2127,    -1,  2129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1328,    -1,    -1,
      -1,   412,  1333,  2143,  1335,  2145,  2146,    -1,  1339,  1340,
      -1,    84,  2152,    -1,    -1,    -1,    -1,  1348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1360,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    24,    -1,    -1,    -1,    -1,   121,    -1,
      -1,    -1,  1383,   425,   127,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
     491,  1412,  1413,    -1,    -1,    -1,  2014,  2015,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2028,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     183,    -1,    -1,    -1,   384,    -1,   527,    -1,    -1,    -1,
     531,    -1,    -1,   534,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   208,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   224,  2080,   442,    -1,    -1,  2084,   230,   447,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
     591,   447,    -1,    -1,    -1,    -1,    -1,   598,    -1,    -1,
      -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2128,    -1,   613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
     631,   632,   633,   634,    -1,   298,   637,   300,   639,   640,
      -1,    -1,    -1,    -1,    -1,   646,   647,    -1,   649,    -1,
     651,    -1,    -1,   654,    -1,  1576,    -1,    -1,    -1,    -1,
      24,    -1,    -1,   326,    -1,   666,    -1,    -1,    -1,   670,
     671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,   548,    -1,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,    -1,    -1,   370,   371,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,    -1,   585,   586,    -1,    -1,    -1,
      -1,   394,    -1,   396,    -1,   398,    -1,   400,   401,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,    -1,   421,    -1,
      -1,    -1,    -1,    -1,    -1,    24,   429,    -1,    -1,    -1,
     433,    -1,    -1,   436,    -1,    -1,    -1,    -1,   779,    -1,
      -1,   444,   425,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,    -1,   442,
      -1,    -1,    -1,    -1,   447,    -1,    -1,    24,    -1,   472,
     811,    -1,   475,   476,    -1,    -1,    -1,   677,    -1,    -1,
      -1,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,
     493,   494,    -1,    -1,    24,    -1,    -1,    -1,   501,   502,
      -1,  1762,    -1,    -1,    -1,    -1,    -1,   848,    -1,    -1,
      -1,    -1,    -1,    -1,   425,   518,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1811,    -1,    -1,    -1,   163,   164,   165,    -1,    -1,    -1,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,   584,   447,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   597,    -1,   599,   600,    -1,   602,
     209,   210,    -1,    -1,   213,   608,   609,    24,    -1,    -1,
      -1,   614,    -1,   616,    -1,    -1,   619,    -1,   621,    -1,
     961,   962,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   641,    -1,
      -1,    -1,   645,    -1,    -1,   648,    -1,   650,    -1,   652,
      -1,    -1,    -1,   656,   657,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   668,    -1,   670,   671,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,   685,   686,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   425,   725,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2014,  2015,    -1,    -1,   760,   761,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2028,    -1,    -1,
      -1,    -1,    -1,   776,    -1,   384,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,   789,    -1,    -1,    -1,
    1131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1139,    -1,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,  2080,
      -1,    -1,   447,  2084,    -1,    -1,   425,  1168,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    24,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,  2128,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,  1229,    -1,
     447,    -1,  1233,  1234,    -1,   425,  1237,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,  1254,    -1,    -1,    -1,   447,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,    -1,    -1,    -1,    -1,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,    -1,   585,   586,    -1,    -1,
      -1,    -1,    -1,  1324,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,   425,
     447,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,    -1,  1059,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1068,    -1,    -1,   677,    59,
      60,    61,    24,    -1,  1274,  1275,  1276,  1080,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    24,    -1,    -1,    -1,
     447,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    -1,  1116,    -1,  1118,  1119,  1120,    -1,    -1,
      -1,  1124,    -1,    -1,    -1,  1128,    -1,    -1,    -1,    -1,
      -1,  1472,    -1,    -1,    24,  1335,    -1,  1337,    -1,    -1,
    1340,    -1,    -1,    -1,    -1,  1148,  1149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1159,    -1,    -1,    -1,
    1360,    -1,    -1,    -1,    -1,    -1,  1169,  1170,    -1,  1172,
      -1,    -1,    -1,    -1,    -1,  1178,    -1,    -1,    -1,    -1,
     425,  1381,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    24,    -1,
      -1,  1204,   447,    -1,    -1,  1546,    -1,    -1,    -1,  1212,
      -1,    -1,  1215,  1216,    -1,  1556,    -1,    -1,    -1,  1419,
    1420,    -1,    24,    -1,    -1,    -1,  1567,    -1,  1231,    -1,
      -1,  1234,    -1,    -1,  1237,    -1,    -1,    -1,    -1,    -1,
    1243,    -1,   425,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1260,    -1,   442,
      -1,    -1,    -1,   446,  1267,    -1,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,  1285,   442,    -1,    17,    -1,    -1,   447,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,   306,    -1,    -1,    -1,
      -1,    -1,    54,    -1,  1327,  1328,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    74,   442,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,    -1,   306,    -1,    -1,    -1,  1360,    90,    -1,
      92,    -1,    -1,  1366,    -1,    -1,    -1,  1370,    -1,    -1,
      -1,    -1,    -1,    -1,   106,   107,    -1,  1380,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,  1755,  1756,    -1,    -1,  1421,  1422,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1433,    -1,   385,  1774,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1466,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,   206,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,   221,
     442,    -1,    24,    -1,    -1,   447,    -1,   425,   230,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,
      -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1733,  1734,   425,    24,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,  1558,    -1,   447,    -1,    -1,
    1760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,  1575,  1576,    -1,    -1,    -1,  1918,  1919,  1920,
     312,    -1,    -1,    -1,    -1,    -1,    -1,   319,  1929,    -1,
      -1,   323,    -1,    -1,  1597,    -1,    -1,    -1,    -1,   425,
    1941,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,   425,  1627,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,  1274,  1275,  1276,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2017,    -1,  2019,  1682,
    2021,    -1,    -1,    -1,    -1,  1688,    -1,  1690,    -1,   421,
     422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,  1902,    -1,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,   446,   447,    59,   449,   450,    -1,
      -1,    -1,  1725,    -1,  2065,    -1,  1335,    -1,  1337,    -1,
      -1,  1340,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1748,  1749,  1750,    -1,  1752,
    1753,  1360,    24,    -1,    -1,    -1,    -1,   489,    -1,    -1,
      -1,  1764,    -1,  2104,  1767,    -1,  1769,    -1,  1771,    -1,
    2111,  2112,  1381,  1776,    -1,    24,    -1,  1780,    -1,    -1,
    1783,    -1,    -1,  1786,  2125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2141,  1804,  2002,    24,    -1,    -1,    -1,    -1,    -1,    -1,
    1419,  1420,  2153,  2154,    -1,    -1,    -1,    -1,    -1,   162,
      -1,    -1,   425,  1826,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,    -1,   442,
      -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,  1851,    -1,
      -1,    -1,    -1,    -1,    -1,   587,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2063,    -1,   208,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1879,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,  1897,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,   641,
     442,   643,  1915,  1916,    -1,   447,    -1,   260,    -1,   651,
      -1,   264,    -1,    -1,    -1,    -1,  1929,    -1,    -1,    -1,
      -1,  1934,    -1,    -1,    -1,   667,  1939,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1975,   316,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   324,   325,   715,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1999,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2026,    -1,    -1,    -1,    -1,  2031,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,   780,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     425,   793,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   826,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   834,  2106,    -1,  2108,    -1,    -1,    -1,    -1,
     842,    -1,    -1,    -1,   846,   847,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2126,  1733,  1734,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   870,    -1,
     872,    -1,   874,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1760,    -1,   425,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,   934,   935,   425,    24,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,     0,     1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      37,    -1,    -1,    40,    41,    -1,    -1,    -1,    -1,    46,
      47,    48,    -1,    -1,    -1,    52,    53,    54,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,  1902,    71,    -1,    -1,    -1,    75,    -1,
      -1,    -1,    -1,    80,  1036,    -1,    83,    -1,    -1,    -1,
      87,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,   106,
     107,    -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,   116,
     117,   118,   119,    -1,    -1,    -1,    -1,    -1,   125,   126,
      -1,    -1,   129,    -1,   131,    -1,    -1,   134,    -1,    -1,
     137,   138,    -1,    -1,    -1,   142,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    -1,   151,   152,   153,   154,    -1,    -1,
    1112,    -1,    -1,    -1,   161,  1117,   163,    -1,    -1,   166,
      -1,    -1,    -1,  2002,    -1,   172,    -1,   174,   175,   176,
      -1,    -1,    -1,    -1,   181,   182,   183,   184,    -1,   186,
      -1,   188,    -1,    -1,    -1,    -1,    -1,   194,    -1,   196,
     197,    -1,    -1,    -1,   201,   202,    -1,   204,    -1,    -1,
      -1,    -1,    -1,  1165,    -1,    -1,    -1,   214,   215,   216,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2063,   232,    -1,   234,    -1,   236,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   249,  1205,    -1,   252,  1208,    -1,    -1,    -1,
      -1,  1213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      -1,   268,    -1,    -1,    -1,    -1,    -1,   274,   275,   276,
     277,   278,   279,    -1,    -1,   282,   283,   284,   285,    -1,
      -1,   288,    -1,   290,    -1,    -1,    -1,    -1,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,    -1,    -1,   306,
      -1,   308,   309,   310,    -1,    -1,    -1,    -1,   315,    -1,
     317,   318,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,   331,   332,   333,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,   342,    -1,    -1,    -1,    -1,
     347,    -1,   349,   350,    -1,   352,    -1,    -1,    -1,    -1,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
    1322,   368,   369,    -1,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,    -1,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1353,   399,   442,    -1,    -1,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,    -1,    -1,    -1,    -1,
      -1,   418,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,     0,     1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    -1,    -1,   440,    -1,    -1,    -1,   444,   445,    -1,
      -1,    19,    20,    21,    22,   452,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    -1,    -1,    -1,    -1,    46,    47,
      48,    -1,    -1,    -1,    52,    53,    54,    -1,    -1,    57,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    80,    -1,    24,    83,    -1,    -1,    -1,    87,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,   104,    -1,   106,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,
     118,   119,    -1,    -1,    -1,    -1,    24,   125,   126,    -1,
      -1,   129,    -1,   131,    -1,    -1,   134,    -1,    -1,   137,
     138,    -1,    -1,    -1,   142,    -1,    -1,   145,    -1,    -1,
      -1,    -1,    -1,   151,   152,   153,   154,    -1,    -1,    -1,
    1542,    -1,    -1,   161,    -1,   163,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,   172,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   182,   183,   184,    -1,   186,    -1,
     188,    -1,    -1,    -1,    -1,    -1,   194,    -1,   196,   197,
      24,    -1,    -1,   201,   202,    -1,   204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,   214,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,   232,    -1,   234,   447,   236,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    24,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1646,    -1,    -1,    -1,   266,    -1,
     268,    -1,    -1,    -1,  1656,    -1,   274,   275,   276,   277,
      -1,   279,    -1,    -1,   282,   283,   284,   285,    -1,    -1,
     288,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,
     298,   299,   300,   301,   302,   303,    -1,    -1,   306,    -1,
      -1,   309,   310,    -1,    -1,    -1,    -1,   315,    -1,   317,
     318,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   330,    -1,   332,   333,    -1,    24,   336,    -1,
      -1,    -1,   340,   341,   342,    -1,    -1,    -1,    -1,   347,
      -1,   349,   350,    -1,   352,    -1,    -1,    -1,    -1,   357,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,    -1,    -1,
     368,   369,  1754,   371,    -1,    -1,    -1,    -1,   376,   377,
      -1,   379,   380,   381,  1766,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1776,    -1,    -1,    -1,    -1,    -1,
      -1,   399,    -1,    -1,    -1,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,    -1,    -1,    -1,    -1,    -1,
     418,    -1,   420,   421,   422,    19,    20,    21,    -1,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,   444,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   452,    24,    -1,    -1,    -1,    -1,
      -1,   425,    56,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    24,    -1,   442,    -1,
      -1,    -1,    -1,   447,  1866,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,   425,   447,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,   425,   447,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,  1928,    -1,    -1,   447,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
     154,    -1,    -1,    19,    20,    21,    -1,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      -1,   175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      56,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,   215,    -1,   447,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,   447,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    24,    -1,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2076,    -1,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,   309,   310,    -1,    -1,   175,
     176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,   331,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    24,    -1,   215,
     447,    -1,   218,    -1,    -1,   359,   360,   361,   362,   363,
     364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,
     374,   375,   376,   377,    24,    -1,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,   278,    -1,    -1,    -1,   420,   421,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,
      -1,   445,   308,   309,   310,   449,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,   331,    -1,   425,   447,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,
      -1,    -1,    -1,   359,   360,   361,   362,   363,   364,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,
     376,   377,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,   420,   421,   422,   423,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,
     436,    -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,   445,
      -1,    -1,    -1,   449,    91,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    99,   100,   101,   102,   103,    -1,    -1,    -1,
      24,    -1,   109,   110,   111,   112,   113,   114,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     127,    -1,    -1,   130,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   150,    -1,    -1,   153,   154,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,
      -1,    -1,    -1,   425,   181,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,    -1,    -1,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,   271,   442,    -1,    -1,    -1,    -1,
     447,   278,    -1,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,   331,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    46,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    56,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    24,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,   415,   416,
      -1,    -1,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    86,    -1,   440,    -1,    -1,    24,    -1,   445,    -1,
      -1,    -1,   140,    -1,   142,   143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   175,   176,    -1,
      -1,   447,    -1,   181,    -1,   140,    -1,   142,    -1,    -1,
      -1,    -1,    -1,    -1,   192,    -1,    -1,    -1,    -1,    -1,
      -1,   425,   200,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,   215,   442,    -1,
     218,    -1,    -1,   447,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   241,   242,    -1,    -1,   447,   246,   425,
     248,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   262,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,   272,   273,    -1,    -1,    -1,    -1,
     278,    -1,    -1,    -1,    -1,    -1,   241,   242,    -1,    -1,
      -1,   246,    -1,    19,    20,    21,    -1,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
     308,   309,   310,    39,   312,    -1,   314,   272,   273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,   327,
      56,   329,    -1,   331,    -1,    -1,    -1,    -1,   293,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,   314,
      86,   359,   360,   361,   362,   363,   364,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,   377,
     106,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,   421,   422,   423,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,    -1,
      -1,    -1,   440,    -1,    -1,    -1,    -1,   445,    -1,   175,
     176,   177,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,   215,
      -1,    -1,   218,    -1,   220,    -1,    -1,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   241,    -1,   243,   244,   447,
     246,    -1,   248,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   278,    -1,   442,    19,    20,    21,   446,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,    -1,    -1,
      -1,    -1,    56,   319,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   331,    -1,    71,    -1,    -1,
      -1,    -1,    -1,    77,    24,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    86,    -1,    -1,    -1,    20,    21,    22,    -1,
      -1,    -1,    -1,   359,   360,   361,   362,   363,   364,    -1,
      -1,    -1,    -1,    -1,    38,    -1,   372,   373,   374,   375,
     376,   377,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   140,    71,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,   153,
     154,    -1,    -1,    -1,   420,   421,   422,   423,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,   435,
     436,   175,   176,    -1,   440,    -1,    -1,   181,    -1,   445,
      -1,   185,   116,    -1,    -1,    -1,    -1,   191,   192,    24,
      -1,   195,   126,    -1,    -1,   199,   200,    -1,    -1,   203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   215,    -1,   425,   218,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,   241,    -1,   173,
     174,    -1,   246,   425,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,   197,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   278,    -1,    -1,    19,    20,    21,
      -1,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,   308,   309,   310,    -1,    -1,    24,
      -1,   245,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   330,   331,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,    -1,    -1,   105,    -1,    -1,    -1,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,
      -1,   133,    -1,    -1,    -1,    -1,   330,    -1,   140,    -1,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,   153,   154,    -1,    -1,    -1,   420,   421,   422,   423,
      -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,   175,   176,    -1,   440,    -1,    -1,   181,
      -1,   445,    -1,    -1,    -1,   187,    -1,    -1,    -1,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,   200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   215,    -1,   425,   218,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,   241,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      57,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,   309,   310,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,   331,
     425,   447,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,    -1,   447,    -1,   121,    -1,    -1,   359,   360,   361,
     362,   363,   364,    -1,    24,    -1,    -1,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,   154,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,   405,   406,   407,   408,   409,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,    -1,   420,   421,
     422,   423,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,   215,    -1,
     425,   218,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,    -1,   447,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    -1,   425,   251,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,    -1,    -1,    -1,   291,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,    -1,    -1,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,   331,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    56,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,   445,    19,
      20,    21,   140,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,   153,   154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    47,    -1,    -1,
      24,    -1,    -1,    -1,    -1,    -1,    56,   175,   176,    -1,
      -1,    -1,    -1,   181,    -1,    -1,    -1,   185,    -1,    -1,
      -1,    71,    -1,   191,    -1,    -1,    -1,   195,    -1,    79,
      -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,
      90,    -1,    24,    -1,    -1,    -1,    -1,   215,    -1,    -1,
     218,    -1,    -1,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   241,    -1,    -1,   126,   447,   246,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   175,   176,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,   309,   310,    -1,    -1,    -1,    -1,   197,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   331,    -1,   215,    -1,   425,   218,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,   356,   447,
      -1,   359,   360,   361,   362,   363,   364,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,   377,
      -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,   420,   421,   422,   423,    -1,    -1,   308,   309,
     310,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,    -1,
      -1,    -1,   440,    -1,    -1,    -1,    -1,   445,    -1,    -1,
     330,   331,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
     360,   361,   362,   363,   364,    -1,    -1,    -1,    -1,    56,
      -1,    -1,   372,   373,   374,   375,   376,   377,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,   421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,   435,   436,    -1,    -1,    -1,
     440,    -1,    -1,    -1,    -1,   445,   133,    -1,    -1,    -1,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   153,   154,   442,    -1,
      -1,    -1,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,   175,   176,
      -1,    -1,    -1,   425,   181,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    56,
     442,    -1,   199,   200,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,   425,   256,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,
     447,   278,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,   154,   155,    -1,
      -1,   338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   175,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   199,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,   359,   360,   361,   362,   363,   364,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,    -1,   241,    -1,    -1,    -1,   425,   246,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,   278,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,   445,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,    19,    20,    21,
      -1,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,   331,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,   425,    86,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,   445,    -1,
      -1,   153,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,
      19,    20,    21,    -1,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,   199,   200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   215,    -1,    -1,   218,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   246,    -1,   425,    86,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    56,    -1,    -1,    -1,   331,
      -1,    -1,    -1,    -1,    -1,    -1,   175,   176,    69,    -1,
      -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,   360,   361,
     362,   363,   364,    -1,    24,    -1,    -1,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,   215,    -1,   425,   218,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,
     447,    -1,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,   256,   420,   421,
     422,   423,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,   278,
      -1,    -1,    -1,   445,   175,   176,    -1,    -1,    -1,    -1,
     181,    -1,    19,    20,    21,    -1,    23,   296,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,   308,
     309,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,    -1,   218,    -1,    56,
      -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,   347,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   250,
     359,   360,   361,   362,   363,   364,    24,    -1,    -1,   368,
      -1,    -1,    -1,   372,   373,   374,   375,   376,   377,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,   408,
     409,    -1,    24,    -1,    -1,    -1,    -1,   308,   309,   310,
      -1,   420,   421,   422,   423,    -1,   153,   154,   319,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   435,   436,    -1,    -1,
     331,   440,    -1,    -1,    -1,    -1,   445,    -1,   175,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,   360,
     361,   362,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,   374,   375,   376,   377,    -1,   215,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,
     421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,
      -1,   278,    -1,    -1,   445,    19,    20,    21,    -1,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,   309,   310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   331,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    24,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,    -1,    -1,   382,   383,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,   404,   405,   406,
     407,   408,   409,    24,    -1,    -1,   413,   414,    -1,   153,
     154,    -1,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,   175,   176,   440,    -1,    -1,    -1,   181,   445,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   215,    -1,    -1,   218,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,    -1,   447,   425,   278,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,   309,   310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,   154,
      -1,    -1,    -1,    -1,    19,    20,    21,   331,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
     175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,   359,   360,   361,   362,   363,
     364,    56,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,
     374,   375,   376,   377,    -1,    -1,    -1,    -1,   382,   383,
     215,   216,    -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,   413,
     414,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,
      -1,   445,    -1,   278,    24,    -1,    -1,    -1,    -1,   284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,   154,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,   309,   310,    -1,    -1,    -1,    -1,
     175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   331,   192,    -1,   425,
     195,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
     215,   447,    -1,   218,   359,   360,   361,   362,   363,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,
     375,   376,   377,    -1,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    -1,   278,    -1,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,
     445,    -1,    -1,   308,   309,   310,    -1,    -1,   313,    19,
      20,    21,    -1,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,   331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   359,   360,   361,   362,   363,   364,
      -1,    -1,    -1,    24,    -1,    -1,    -1,   372,   373,   374,
     375,   376,   377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,    24,    -1,    -1,   440,    -1,    -1,    -1,    -1,
     445,    -1,    -1,   153,   154,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   175,   176,   447,    -1,    -1,
      -1,   181,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   215,   216,   442,   218,    56,
      -1,   425,   447,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,   447,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    24,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,
      -1,    -1,    24,    -1,   284,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   309,
     310,    -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   331,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
     360,   361,   362,   363,   364,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   373,   374,   375,   376,   377,   215,   216,
     425,   218,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,    -1,   447,    -1,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
     420,   421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,
     440,   278,    -1,    -1,    -1,   445,    -1,   284,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,    23,   295,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      -1,   308,   309,   310,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      56,   442,    -1,    -1,   331,   425,   447,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    79,    -1,    -1,    -1,   447,    -1,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    24,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,   425,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    -1,   420,   421,   422,   423,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
      -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,   445,   175,
     176,    -1,    -1,    -1,    -1,   181,    19,    20,    21,    -1,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,
      -1,    -1,   218,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,   425,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,    -1,   442,
      -1,    -1,    -1,   425,   447,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    -1,   308,   309,   310,    -1,    -1,    -1,    24,    -1,
     153,   154,   318,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    56,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,    -1,   175,   176,    -1,   178,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   359,   360,   361,   362,   363,   364,    -1,
      24,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,
     376,   377,   215,    -1,   425,   218,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,    -1,   447,    -1,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,   420,   421,   422,   423,   153,   154,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,
     436,    -1,    -1,    -1,   440,   278,    -1,    -1,    -1,   445,
     175,   176,    -1,    -1,    -1,    -1,   181,    19,    20,    21,
      -1,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,   308,   309,   310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     215,    -1,    -1,   218,    56,    -1,    -1,    -1,   331,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    24,    86,    -1,   359,   360,   361,   362,
     363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,   374,   375,   376,   377,    -1,    -1,    -1,    -1,    24,
      -1,    -1,   425,   278,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,    -1,   442,
      24,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,   308,   309,   310,    -1,   420,   421,   422,
     423,   153,   154,    -1,   319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   435,   436,    -1,    -1,   331,   440,    -1,    -1,
      -1,    -1,   445,   175,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   359,   360,   361,   362,   363,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,
     375,   376,   377,   215,    -1,    -1,   218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   256,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
     435,   436,    -1,    -1,    -1,   440,   278,    -1,    -1,   425,
     445,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,    -1,   308,   309,   310,    -1,
      19,    20,    21,    -1,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    -1,    -1,   331,
      -1,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    56,   442,    -1,
      -1,    -1,    -1,   447,    -1,    -1,    -1,   359,   360,   361,
     362,   363,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,    -1,    -1,    -1,   425,
      89,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,   153,   154,    -1,    -1,    19,    20,
      21,    -1,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    -1,   175,   176,    -1,    -1,
      -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   425,    56,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,   446,   215,    -1,    79,   218,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,
      -1,   425,   447,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
     309,   310,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,   331,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,    -1,   218,   219,    -1,
     359,   360,   361,   362,   363,   364,    56,    -1,    -1,    -1,
      -1,    -1,    -1,   372,   373,   374,   375,   376,   377,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,
      -1,   420,   421,   422,   423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   435,   436,    -1,    -1,
      -1,   440,    -1,    -1,    -1,    -1,   445,   308,   309,   310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   153,   154,    -1,    -1,    19,    20,    21,
     331,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,   175,   176,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,   359,   360,
     361,   362,   363,   364,    56,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,   374,   375,   376,   377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,    -1,    79,   218,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
      -1,   241,    -1,    -1,    -1,    -1,   246,    -1,    -1,   420,
     421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   309,
     310,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,   331,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   215,    -1,    -1,   218,    -1,    -1,   359,
     360,   361,   362,   363,   364,    56,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   373,   374,   375,   376,   377,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,    -1,
     447,    -1,    -1,    -1,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,
     420,   421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,
     440,    -1,    -1,    -1,    -1,   445,   308,   309,   310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   153,   154,    -1,    -1,    19,    20,    21,   331,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,   359,   360,   361,
     362,   363,   364,    56,    -1,    -1,    -1,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,    -1,   218,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,   420,   421,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,    -1,    -1,    -1,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   309,   310,
      -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
     331,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   215,    -1,    -1,   218,    -1,    -1,   359,   360,
     361,   362,   363,   364,    56,    -1,    -1,    -1,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,   420,
     421,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,
      -1,    -1,    -1,    -1,   445,   308,   309,   310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,   154,    -1,    -1,    19,    20,    21,   331,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,    -1,   359,   360,   361,   362,
     363,   364,    56,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,   374,   375,   376,   377,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   215,    -1,    79,   218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,    -1,
      -1,    -1,   445,    -1,    -1,    -1,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,   153,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,   309,   310,    -1,
      -1,   175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,   331,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   215,    -1,    -1,   218,    -1,    -1,   359,   360,   361,
     362,   363,   364,    56,    -1,    -1,    -1,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,   420,   421,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,   308,   309,   310,   140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,   154,    -1,    -1,    19,    20,    21,   331,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,   359,   360,   361,   362,   363,
     364,    56,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,
     374,   375,   376,   377,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   215,    -1,    -1,   218,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,
      -1,   445,    -1,    -1,    -1,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,   153,   154,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,   309,   310,    -1,    -1,
     175,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   331,    19,
      20,    21,    -1,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
     215,    -1,    -1,   218,    -1,    -1,   359,   360,   361,   362,
     363,   364,    -1,    -1,    -1,    -1,    56,    -1,    -1,   372,
     373,   374,   375,   376,   377,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,    -1,   447,    -1,    -1,
      -1,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   420,   421,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,    -1,
      -1,    -1,   445,   308,   309,   310,    -1,    19,    20,    21,
      -1,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,   153,   154,    -1,   331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    56,   175,   176,    -1,    -1,    -1,
      -1,   181,    -1,    -1,   359,   360,   361,   362,   363,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,
     375,   376,   377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,    -1,    -1,   218,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,
     445,   153,   154,    24,    -1,    -1,    -1,    -1,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   309,
     310,    -1,    19,    20,    21,    -1,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,   331,    -1,   215,    -1,    -1,   218,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
     360,   361,   362,   363,   364,    -1,    -1,    -1,    -1,    -1,
      -1,    24,   372,   373,   374,   375,   376,   377,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    24,   442,   278,    -1,    -1,    -1,
     447,    -1,    -1,    -1,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
     420,   421,   422,   423,    -1,    -1,   308,   309,   310,    -1,
      -1,    -1,    -1,    -1,    -1,   435,   436,    24,    -1,    -1,
     440,    -1,    -1,    -1,    -1,   445,   153,   154,    -1,   331,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,    24,    -1,   175,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,   359,   360,   361,
     362,   363,   364,    -1,    -1,    -1,    24,    -1,    -1,    -1,
     372,   373,   374,   375,   376,   377,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,   420,   421,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    19,    20,    21,   284,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,   308,   309,   310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,   425,   331,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    24,    -1,
     442,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,   359,   360,   361,   362,   363,   364,    24,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,   375,   376,
     377,    -1,    -1,    -1,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    24,
      -1,   442,    -1,    -1,    -1,    -1,   447,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,   153,   154,
      -1,    24,    -1,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
     175,   176,    -1,   440,    24,    -1,   181,    -1,   445,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     215,    -1,   425,   218,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    24,    -1,   442,
      -1,    -1,    -1,    -1,   447,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,    -1,    -1,    -1,   447,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   278,    24,   442,    -1,    -1,   425,   446,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    24,   442,    -1,    -1,    -1,   446,
      -1,    -1,    -1,   308,   309,   310,    -1,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    24,    -1,   442,    -1,   331,   425,   446,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    24,    -1,   442,    -1,    -1,    -1,   446,    -1,
      -1,    -1,    -1,    -1,   359,   360,   361,   362,   363,   364,
      -1,    -1,    24,    -1,    -1,    -1,    -1,   372,   373,   374,
     375,   376,   377,   425,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    24,    -1,
     442,    -1,    -1,    -1,   446,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
     435,   436,    -1,    -1,    -1,   440,    -1,    -1,    -1,   425,
     445,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,   425,
     446,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,   425,
     446,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,   425,
     446,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,    -1,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     425,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    24,    -1,   442,    -1,    -1,
      -1,   446,   425,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    24,    -1,   442,
      -1,    -1,    -1,   446,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,    -1,   425,   446,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    24,    -1,   442,    -1,    -1,    -1,   446,
      -1,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    24,    -1,   442,    -1,
      -1,    -1,   446,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,    -1,   425,   446,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      24,    -1,   442,    -1,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    -1,   425,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    24,    -1,
     442,    -1,    -1,   425,   446,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    24,    -1,
     442,    -1,    -1,   425,   446,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    24,    -1,
     442,    -1,    -1,    -1,   446,    -1,    -1,    -1,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,   425,
     446,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,   425,
     446,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    24,    -1,   442,    -1,    -1,    -1,
     446,    -1,    -1,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   425,   446,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   425,   446,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   425,   446,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,    -1,    -1,    -1,   446,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,   446,
      -1,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,   425,   446,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,    -1,    -1,    -1,   446,    -1,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,    -1,    -1,    -1,   446,    -1,
      -1,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,   425,   446,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,    -1,    -1,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
      55,    -1,   442,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    42,    62,
      44,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    84,
      -1,    86,    87,    88,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    84,    -1,    86,    87,    88,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    77,    -1,    79,    -1,    -1,    -1,    83,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,   123,   124,
      -1,    -1,    -1,   128,    -1,    59,    60,    61,   133,    63,
     123,   124,    -1,    -1,    68,   128,    -1,    -1,    -1,    -1,
     133,    -1,    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
     165,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,   194,
     195,   165,   197,    -1,   199,   200,   201,    -1,   191,    -1,
      -1,   194,   195,    -1,   197,    -1,   199,   200,   201,    -1,
      -1,    -1,    -1,   187,    -1,   189,    -1,   191,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   199,   200,    -1,    -1,   203,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
     263,    -1,   246,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      99,   100,   101,   102,   103,   239,    -1,    -1,    -1,   314,
     109,   110,   111,   112,   113,   114,    -1,    -1,    -1,   293,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,   127,   334,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   334,   347,    -1,    -1,    -1,   320,    -1,    -1,    -1,
      -1,   150,    -1,   358,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,   167,    -1,
      -1,    -1,   306,   347,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,    -1,    -1,    -1,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     443,   385,   426,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   415,   416
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    19,    20,    21,    22,    23,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    37,    40,    41,
      46,    47,    48,    52,    53,    54,    56,    57,    68,    71,
      75,    80,    83,    87,    90,    94,    95,   104,   106,   107,
     116,   117,   118,   119,   125,   126,   129,   131,   134,   137,
     138,   142,   145,   151,   152,   153,   154,   161,   163,   166,
     172,   174,   175,   176,   181,   182,   183,   184,   186,   188,
     194,   196,   197,   201,   202,   204,   214,   215,   216,   218,
     232,   234,   236,   249,   252,   266,   268,   274,   275,   276,
     277,   278,   279,   282,   283,   284,   285,   288,   290,   295,
     297,   298,   299,   300,   301,   302,   303,   306,   308,   309,
     310,   315,   317,   318,   321,   322,   330,   331,   332,   333,
     336,   340,   341,   342,   347,   349,   350,   352,   357,   359,
     360,   361,   362,   363,   364,   365,   368,   369,   371,   372,
     373,   374,   375,   376,   377,   379,   380,   381,   399,   404,
     405,   406,   407,   408,   409,   410,   411,   418,   420,   421,
     422,   423,   435,   436,   440,   445,   452,   454,   455,   456,
     457,   464,   465,   466,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   480,   481,   482,   483,   484,
     485,   486,   487,   496,   497,   498,   499,   511,   519,   522,
     532,   541,   543,   549,   550,   370,   445,   450,   195,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,    79,
     141,   458,   496,   497,   445,   282,   247,   379,   410,   497,
      86,   537,    59,    60,    61,   306,   385,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   400,
     401,   402,   403,   504,   458,    20,    21,    22,    38,   116,
     173,   245,   322,   477,   502,   205,   289,   458,    19,    20,
      21,    25,    26,    28,    29,    30,    31,    32,    33,    34,
     278,   420,   421,   422,   436,   440,   445,   457,   459,   460,
     464,   496,   497,   460,   497,   445,    77,   140,   199,   200,
     256,   311,   334,   534,   535,   536,   537,   538,    20,    21,
      22,   424,   502,   458,   458,   445,   457,   458,   445,   143,
     202,   215,   272,   342,   345,   366,   368,   493,    81,   139,
     241,   246,   309,   496,   510,    91,    98,    99,   100,   101,
     102,   103,   109,   110,   111,   112,   113,   114,   127,   130,
     150,   167,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   271,   305,   415,   416,   515,    57,   133,
     191,   347,   510,   535,   536,   537,   538,   445,   458,   448,
     461,   117,   445,   445,   445,   445,   445,    68,   284,   496,
     497,    71,    77,   140,   164,   185,   191,   192,   195,   203,
     330,   356,   378,   406,   457,   496,   510,   534,   535,   537,
     538,   445,   252,   284,   174,   458,   445,    86,   140,   445,
     497,    90,   148,   445,   205,   289,    57,   121,   177,   179,
     192,   193,   251,   287,   291,   307,   313,   348,   460,   517,
     343,   200,   538,   458,   445,    63,    68,   239,   458,   504,
      19,   197,   347,   385,   445,   510,   535,   537,   538,   445,
     445,   497,   445,   445,   458,   458,   461,   457,   497,   120,
     261,   512,   497,   369,   460,   187,   191,   242,   313,   458,
     534,   537,   538,   497,   266,   497,   460,    42,    77,   105,
     133,   165,   187,   191,   293,   457,   510,   534,   535,   537,
     538,   187,   191,   242,   313,   458,   534,   537,   538,   504,
     458,   460,   382,   383,   413,   414,   457,   445,   477,   496,
     497,   382,   383,   413,   414,   457,   497,   185,   304,   445,
     445,   185,   304,   457,    92,   450,   450,   450,   457,   284,
     457,   464,   465,   457,   465,   457,   465,     0,   444,    24,
     425,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   442,   443,   448,   461,    24,   425,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   442,   448,   450,   450,   105,   457,   460,
     496,   165,   203,   426,   496,    71,    77,   164,   185,   191,
     195,   203,   356,   457,   510,   534,   537,    42,    44,    49,
      77,    83,   133,   165,   187,   189,   191,   203,   249,   293,
     320,   347,   426,   458,   510,   534,   535,   537,   538,    53,
      59,   136,   165,   189,   323,   347,   443,   499,   510,    55,
      62,    84,    87,    88,    93,   123,   124,   128,   133,   165,
     191,   194,   195,   197,   201,   263,   314,   334,   347,   358,
     403,   443,   510,   535,   537,   538,    59,   189,   191,   242,
     337,   338,   347,   488,   510,   445,   445,   445,    49,   535,
     537,   538,    53,    77,   165,   187,   191,   426,   534,   535,
     537,   538,   412,   510,   457,   458,   459,   462,   457,   460,
     457,   459,   465,   457,   465,   459,   459,   457,   465,   459,
     457,   457,   457,   457,   510,   443,   458,   443,   343,   460,
     510,   235,   379,   386,   410,   445,   458,   460,   458,   132,
     132,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     457,   457,   457,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   442,   426,   461,    72,
      90,   477,   478,   479,   482,   343,   497,   313,   318,   458,
     460,   460,   457,   460,   458,   313,   448,   458,   122,   140,
     248,   252,   497,   459,   458,   143,   286,   351,   495,   328,
     457,   458,   510,   143,   460,   536,   537,   510,   460,   460,
     497,   459,   457,   458,   497,   510,   457,   465,   497,   497,
     303,   133,   510,   535,   536,   537,   538,   313,   460,   510,
     460,   457,   460,   357,   369,   518,   460,   460,   457,   457,
     447,   497,   510,   343,   132,   497,   460,   460,   457,   460,
     343,   458,   460,   479,   458,   497,   132,   132,   133,   457,
     460,   135,   146,   190,   269,   506,   507,   458,   460,   457,
     423,   458,   460,   117,   458,    64,   178,   460,   458,   458,
     512,   458,   512,   458,   512,   457,   458,   463,   457,    35,
      65,   168,   170,   193,   265,   267,   291,   353,   355,   508,
     457,   497,   497,   497,   465,   497,   376,   404,   521,   460,
     457,   460,   460,   457,   457,   428,   460,   457,   313,   458,
     536,   537,   510,   460,   460,   460,   447,   460,   460,   457,
     457,   347,   457,   457,   457,   457,   447,   497,   460,   457,
     457,   457,   457,   447,   132,   142,   510,   108,   206,   207,
     237,   281,   509,   497,   497,   510,   509,   510,   457,   457,
     457,   446,   446,    19,    20,   284,   420,   421,   422,   456,
     464,   496,   497,   457,   457,   465,   457,   465,   457,   465,
     457,   465,   457,   465,   457,   465,   457,   465,   457,   465,
     457,   465,   457,   465,   457,   465,   457,   465,   457,   465,
     457,   465,   195,   459,   450,   457,   465,   457,   465,   457,
     465,   457,   465,   457,   465,   457,   465,   457,   465,   457,
     465,   457,   465,   457,   465,   457,   465,   457,   465,   457,
     465,   457,   465,   457,   465,   449,   460,   457,   465,   466,
     467,   457,   465,   467,   458,   447,   105,   496,   510,   518,
     457,   133,   535,   536,   537,   538,   313,   460,   510,   460,
     460,   518,   460,   447,   457,   460,   192,   195,   313,   347,
     460,   313,   536,   537,   510,   460,   142,   242,   347,   460,
     518,   460,   235,   445,   460,   457,   347,   164,   142,   272,
     347,   385,   510,   510,   510,   510,    59,    78,   135,   162,
     208,   209,   210,   260,   264,   316,   324,   325,   385,   505,
     171,   309,   310,   359,   360,   362,   363,   372,   373,   374,
     375,   488,    46,    77,   142,   242,   272,   273,   293,   314,
     347,   510,   534,   537,   347,   510,   458,   460,   238,   419,
     458,   165,   189,   537,   538,   460,   510,   195,   262,   292,
     313,   347,   510,   535,   536,   537,   538,   539,   296,   347,
     368,   460,   536,   537,   510,   460,   458,   510,   460,   347,
     535,   536,   537,   538,   510,   512,   457,   460,    76,    77,
     133,   313,   314,   460,   535,   536,   537,   538,   401,   504,
     457,   171,   195,   519,   492,   510,   535,   537,   538,    77,
     187,   192,   248,   262,   458,   491,   534,   537,   538,   539,
     542,   547,   460,   457,    43,    46,    77,   142,   143,   192,
     242,   262,   272,   273,   312,   314,   326,   327,   329,   347,
     460,   490,   510,   534,   537,   538,   539,   545,   547,    39,
      69,   106,   177,   205,   213,   215,   218,   220,   243,   244,
     251,   262,   313,   319,   347,   460,   489,   510,   514,   537,
     538,   539,   544,   547,   417,   497,   497,   465,   192,   195,
     347,   313,   510,   460,   460,   457,   459,   447,   446,   446,
     446,   446,   446,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   457,   458,   497,   447,   457,   460,   457,   459,
     457,   459,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   460,   460,   497,   447,   457,   457,   457,   449,   460,
     211,   256,   503,   457,    45,   510,   458,   313,   447,   446,
     460,   458,   254,   447,   449,   447,   446,   447,   446,   447,
     447,   368,   510,   536,   537,   457,   458,   457,   447,   496,
     458,   447,   343,   343,   447,   446,   497,   479,   458,   479,
     447,   458,   458,   510,   439,   507,   447,   439,   423,   507,
     447,   457,   457,   446,   458,   458,   458,   447,   447,   446,
     447,   447,   446,   447,    50,   115,   520,   447,   447,   497,
     447,   457,   457,   447,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,   500,   457,   447,   457,
     458,   458,   447,   447,   461,   443,   426,   426,   457,   426,
     426,   448,   426,   449,   435,   457,   458,   447,   536,   537,
     457,   457,   447,   447,   457,   457,   457,   460,   457,   458,
     457,   460,   457,   447,    52,   319,   457,   515,   457,   460,
     457,   461,   458,   313,   515,   457,   460,   458,   460,   460,
     460,   460,   460,   457,   510,   457,   447,   457,    69,   237,
     250,   540,    82,   510,   535,   538,   457,    69,    70,   193,
     291,   344,   548,   460,   460,    86,   235,   256,   546,   460,
     458,   447,   510,   460,   534,   460,   536,   537,   457,   460,
     460,   447,   313,    76,   193,   291,   513,   253,   258,   548,
      52,   319,   457,   447,   460,   458,   313,   457,   515,   458,
     169,   319,   354,    52,   319,   457,    66,   246,   460,   458,
      36,   233,   237,   516,   460,   460,   347,   457,   347,   457,
      52,   319,   447,   510,   460,   510,   155,   313,   457,   460,
     510,   535,   537,   538,   423,   423,   155,   313,   339,   457,
     460,   510,   535,   537,   538,   457,   457,   294,   457,   347,
     460,    52,   319,   447,   510,   447,   447,   446,   457,   457,
     460,   457,   447,   460,   459,   457,   465,   457,   465,   457,
     465,   459,   457,   457,   457,   457,   460,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   497,   449,   458,   510,
     460,   460,   497,   497,   465,   497,   451,   465,   497,   465,
     497,   546,   497,   447,   149,   335,   494,   445,   458,   457,
     479,   460,   465,   497,   460,   460,   457,   457,   460,   284,
     465,   497,   457,   457,   457,   457,   148,   447,    73,    74,
      96,    97,   156,   157,   529,   447,   142,   497,   497,   457,
     459,   457,   465,   457,   465,   460,   460,   448,   467,   447,
     457,   457,   460,   447,   447,   447,   457,   515,   447,   447,
     457,   447,   447,   447,   447,   460,   195,   510,   447,   457,
     447,   457,   457,   447,   457,   457,   447,   339,   339,    52,
     319,    52,   319,   458,   510,   457,   447,   510,   457,   460,
     447,   510,    69,   235,   339,   501,   457,   460,    89,   280,
     460,   497,   523,   447,   457,   447,   446,   446,   446,   446,
     446,   446,   446,   447,   447,   447,   447,   447,   447,   460,
     457,   457,   459,   457,   457,   457,   457,   457,   447,   448,
     447,   446,   447,   447,   447,   447,   447,   446,   446,   447,
     447,   446,   447,   457,   447,   460,   447,   447,   446,   447,
     446,   447,   447,   446,   447,   446,   447,   447,   458,   457,
     447,   457,   458,   447,   447,   449,   426,   449,   449,   449,
     457,   447,   457,   457,   457,   447,   457,   457,   457,   460,
     457,   457,   457,   460,   447,   460,   457,   457,   457,   457,
     446,   447,   446,   447,   447,   457,   447,   460,   457,   465,
     457,   465,   457,   457,   457,   457,   447,   447,   447,   447,
     447,   447,   447,   460,   460,   460,   460,   460,   458,   510,
     510,    51,   198,   320,   384,   399,   531,   465,   497,   447,
     460,   447,   458,   460,   460,   284,   460,   457,   510,   215,
     218,   219,   458,   460,   533,   457,    37,   447,   460,   447,
     460,   457,   460,   448,   447,   457,   446,   457,   447,   447,
     460,   497,    85,    89,   212,   259,   525,    67,   159,   160,
     235,   255,   346,   367,   530,   457,   446,   447,   446,   446,
     446,   446,   447,   447,   447,   447,   460,   457,   457,   457,
     457,   457,   457,   447,   449,   447,   447,   447,   447,   447,
     447,   447,   446,   457,   447,   460,   446,   446,   447,   447,
     446,   447,   446,   446,   447,   446,   447,   458,   457,   447,
     457,   447,   447,   449,   449,   457,   447,   447,   457,   460,
     447,   447,   447,   447,   460,   457,   465,   457,   457,   457,
     446,   447,   447,   447,   447,   518,   460,   460,   457,   510,
     510,   510,   531,   447,   457,   447,   458,   460,   510,   457,
     460,   457,   460,   510,   457,   457,   457,   447,   459,    58,
     144,   235,   335,   528,    18,   147,   257,   524,   457,   447,
     446,   446,   447,   447,   447,   457,   457,   457,   457,   447,
     446,   447,   447,   446,   447,   447,   446,   447,   457,   447,
     460,   447,   446,   446,   446,   338,   447,   446,   447,   446,
     457,   447,   447,   447,   460,   457,   465,   457,   457,   447,
     447,   457,   460,   457,   497,   497,   510,   447,   510,   446,
     510,   457,   460,   497,   447,   460,    18,   180,   526,   525,
     447,   446,   446,   447,   446,   447,   457,   457,   447,   446,
     447,   446,   446,   446,   457,   447,   447,   446,   447,   446,
     447,   446,   457,   446,   447,   446,   447,   457,   457,   465,
     510,   447,   457,   457,   457,   458,   457,   497,   497,   523,
     526,   446,   446,   446,   447,   457,   447,   447,   447,   447,
     446,   447,   447,   447,   510,   460,   457,   460,   457,   510,
     510,    76,   158,   270,   527,   447,   447,   447,   447,   447,
     447,   447,   446,   510,   460,   457,   497,   457,   530,   530,
     446,   447,   446,   447,   446,   447,   447,   510,   457,   457,
     457,   446,   447,   447,   447,   457,   510,   510,   446,   447,
     447,   524,   524,   447,   447,   527,   527,   446,   446
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 754 "pars.yacc"
    {
            expr_parsed = TRUE;
            s_result = (yyvsp[(1) - (1)].dval);
        }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 758 "pars.yacc"
    {
            vexpr_parsed = TRUE;
            v_result = (yyvsp[(1) - (1)].vrbl);
        }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 771 "pars.yacc"
    {}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 772 "pars.yacc"
    {}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 773 "pars.yacc"
    {}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 774 "pars.yacc"
    {}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 775 "pars.yacc"
    {}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 776 "pars.yacc"
    {}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 777 "pars.yacc"
    {}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 778 "pars.yacc"
    {}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 779 "pars.yacc"
    {}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 780 "pars.yacc"
    {}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 781 "pars.yacc"
    {}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 782 "pars.yacc"
    {}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 783 "pars.yacc"
    {}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 784 "pars.yacc"
    {}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 785 "pars.yacc"
    {
	    return 1;
	}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 792 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (1)].dval); }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 793 "pars.yacc"
    { (yyval.dval) = *((yyvsp[(1) - (1)].dptr)); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 794 "pars.yacc"
    { (yyval.dval) = nonl_parms[(yyvsp[(1) - (1)].ival)].value;	}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 795 "pars.yacc"
    { (yyval.dval) = nonl_parms[(yyvsp[(1) - (1)].ival)].max; }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 796 "pars.yacc"
    { (yyval.dval) = nonl_parms[(yyvsp[(1) - (1)].ival)].min; }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 797 "pars.yacc"
    {
            if ((yyvsp[(2) - (2)].ival) >= (yyvsp[(1) - (2)].vrbl)->length) {
                errmsg("Access beyond array bounds");
                return 1;
            }
            (yyval.dval) = (yyvsp[(1) - (2)].vrbl)->data[(yyvsp[(2) - (2)].ival)];
	}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 804 "pars.yacc"
    {
	    double dummy, dummy2;
            int idummy, ind, length = (yyvsp[(3) - (4)].vrbl)->length;
	    if ((yyvsp[(3) - (4)].vrbl)->data == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch ((yyvsp[(1) - (4)].ival)) {
	    case MINP: (yyval.dval) = vmin((yyvsp[(3) - (4)].vrbl)->data, length);		break;
	    case MAXP: (yyval.dval) = vmax((yyvsp[(3) - (4)].vrbl)->data, length);		break;
            case AVG:  stasum((yyvsp[(3) - (4)].vrbl)->data, length, &(yyval.dval), &dummy);   break;
            case SD:   stasum((yyvsp[(3) - (4)].vrbl)->data, length, &dummy, &(yyval.dval));   break;
            case SUM:  stasum((yyvsp[(3) - (4)].vrbl)->data, length, &(yyval.dval), &dummy); (yyval.dval) *= length; break;
            case IMIN: minmax((yyvsp[(3) - (4)].vrbl)->data, length, &dummy, &dummy2, &ind, &idummy); (yyval.dval) = (double) ind; break;
            case IMAX: minmax((yyvsp[(3) - (4)].vrbl)->data, length, &dummy, &dummy2, &idummy, &ind); (yyval.dval) = (double) ind; break;
	    }
	}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 821 "pars.yacc"
    {
	    if ((yyvsp[(3) - (6)].vrbl)->length != (yyvsp[(5) - (6)].vrbl)->length) {
		yyerror("X and Y are of different length");
		return 1;
            } else {
                (yyval.dval) = trapint((yyvsp[(3) - (6)].vrbl)->data, (yyvsp[(5) - (6)].vrbl)->data, NULL, NULL, (yyvsp[(3) - (6)].vrbl)->length);
            }
        }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 829 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].vrbl)->length; }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 830 "pars.yacc"
    { (yyval.dval) = getsetlength((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno); }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 831 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].trgt)->setno; }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 832 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].ival); }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 833 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (1)].ival)].data)) (); }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 834 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (2)].dval) * ((ParserFnc) (key[(yyvsp[(2) - (2)].ival)].data)) (); }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 835 "pars.yacc"
    { (yyval.dval) = drand48(); }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 836 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (4)].ival)].data)) ((yyvsp[(3) - (4)].ival));     }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 837 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (4)].ival)].data)) ((yyvsp[(3) - (4)].dval));     }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 838 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].ival), (yyvsp[(5) - (6)].dval)); }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 839 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].ival), (yyvsp[(5) - (6)].ival));	}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 840 "pars.yacc"
    { (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].dval), (yyvsp[(5) - (6)].dval));	}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 842 "pars.yacc"
    {
	    (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (8)].ival)].data)) ((yyvsp[(3) - (8)].ival), (yyvsp[(5) - (8)].ival), (yyvsp[(7) - (8)].dval));
	}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 846 "pars.yacc"
    {
	    (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (8)].ival)].data)) ((yyvsp[(3) - (8)].dval), (yyvsp[(5) - (8)].dval), (yyvsp[(7) - (8)].dval));
	}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 850 "pars.yacc"
    {
	    (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (10)].ival)].data)) ((yyvsp[(3) - (10)].dval), (yyvsp[(5) - (10)].dval), (yyvsp[(7) - (10)].dval), (yyvsp[(9) - (10)].dval));
	}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 854 "pars.yacc"
    {
	    (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (12)].ival)].data)) ((yyvsp[(3) - (12)].dval), (yyvsp[(5) - (12)].dval), (yyvsp[(7) - (12)].dval), (yyvsp[(9) - (12)].dval), (yyvsp[(11) - (12)].dval));
	}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 858 "pars.yacc"
    {
	    (yyval.dval) = ((ParserFnc) (key[(yyvsp[(1) - (14)].ival)].data)) ((yyvsp[(3) - (14)].dval), (yyvsp[(5) - (14)].dval), (yyvsp[(7) - (14)].dval), (yyvsp[(9) - (14)].dval), (yyvsp[(11) - (14)].dval), (yyvsp[(13) - (14)].dval));
	}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 861 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].v.xv1; }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 862 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].v.xv2; }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 863 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].v.yv1; }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 864 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].v.yv2; }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 865 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].w.xg1; }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 866 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].w.xg2; }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 867 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].w.yg1; }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 868 "pars.yacc"
    { (yyval.dval) = g[(yyvsp[(1) - (3)].ival)].w.yg2; }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 869 "pars.yacc"
    {            (yyval.dval) = (yyvsp[(3) - (4)].dval);      }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 870 "pars.yacc"
    { /* yr, mo, day */
	    (yyval.dval) = cal_and_time_to_jul((yyvsp[(3) - (8)].ival), (yyvsp[(5) - (8)].ival), (yyvsp[(7) - (8)].ival), 12, 0, 0.0);
	}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 874 "pars.yacc"
    { /* yr, mo, day, hr, min, sec */
	    (yyval.dval) = cal_and_time_to_jul((yyvsp[(3) - (14)].ival), (yyvsp[(5) - (14)].ival), (yyvsp[(7) - (14)].ival), (yyvsp[(9) - (14)].ival), (yyvsp[(11) - (14)].ival), (yyvsp[(13) - (14)].dval));
	}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 877 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].v.xv1; }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 878 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].v.xv2; }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 879 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].v.yv1; }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 880 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].v.yv2; }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 881 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].w.xg1; }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 882 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].w.xg2; }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 883 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].w.yg1; }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 884 "pars.yacc"
    { if (bad_gno ()) return 1; (yyval.dval) = g[gn].w.yg2; }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 885 "pars.yacc"
    {
	    double vx, vy;
            get_page_viewport(&vx, &vy);
            (yyval.dval) = vx;
	}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 890 "pars.yacc"
    {
	    double vx, vy;
            get_page_viewport(&vx, &vy);
            (yyval.dval) = vy;
	}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 895 "pars.yacc"
    { (yyval.dval) = (yyvsp[(2) - (3)].dval); }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 896 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].dval) + (yyvsp[(3) - (3)].dval); }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 897 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].dval) - (yyvsp[(3) - (3)].dval); }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 898 "pars.yacc"
    { (yyval.dval) = -(yyvsp[(2) - (2)].dval); }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 899 "pars.yacc"
    { (yyval.dval) = (yyvsp[(2) - (2)].dval); }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 900 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].dval) * (yyvsp[(3) - (3)].dval); }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 901 "pars.yacc"
    { if (div_null ((yyvsp[(3) - (3)].dval))) return 1; (yyval.dval) = (yyvsp[(1) - (3)].dval) / (yyvsp[(3) - (3)].dval); }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 902 "pars.yacc"
    { if (div_null ((yyvsp[(3) - (3)].dval))) return 1; (yyval.dval) = fmod((yyvsp[(1) - (3)].dval), (yyvsp[(3) - (3)].dval)); }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 903 "pars.yacc"
    {
	    if ((yyvsp[(1) - (3)].dval) < 0 && rint((yyvsp[(3) - (3)].dval)) != (yyvsp[(3) - (3)].dval)) {
		yyerror("Negative value raised to non-integer power");
		return 1;
            } else if ((yyvsp[(1) - (3)].dval) == 0.0 && (yyvsp[(3) - (3)].dval) <= 0.0) {
		yyerror("Zero raised to non-positive power");
		return 1;
            } else {
                (yyval.dval) = pow((yyvsp[(1) - (3)].dval), (yyvsp[(3) - (3)].dval));
            }
	}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 914 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (5)].dval) ? (yyvsp[(3) - (5)].dval) : (yyvsp[(5) - (5)].dval);  }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 915 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) > (yyvsp[(3) - (3)].dval)); }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 916 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) < (yyvsp[(3) - (3)].dval)); }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 917 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) <= (yyvsp[(3) - (3)].dval)); }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 918 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) >= (yyvsp[(3) - (3)].dval)); }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 919 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) == (yyvsp[(3) - (3)].dval)); }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 920 "pars.yacc"
    { (yyval.dval) = ((yyvsp[(1) - (3)].dval) != (yyvsp[(3) - (3)].dval)); }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 921 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].dval) && (yyvsp[(3) - (3)].dval);   }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 922 "pars.yacc"
    { (yyval.dval) = (yyvsp[(1) - (3)].dval) || (yyvsp[(3) - (3)].dval);   }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 923 "pars.yacc"
    { (yyval.dval) = !((yyvsp[(2) - (2)].dval));      }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 926 "pars.yacc"
    {
            (yyval.sval) = (yyvsp[(1) - (1)].sval);
	}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 929 "pars.yacc"
    {
            (yyval.sval) = concat_strings((yyvsp[(1) - (3)].sval), (yyvsp[(3) - (3)].sval));
            xfree((yyvsp[(3) - (3)].sval));
        }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 933 "pars.yacc"
    {
            char buf[32];
            set_locale_num(TRUE);
            sprintf(buf, "%g", (yyvsp[(3) - (3)].dval));
            set_locale_num(FALSE);
            (yyval.sval) = concat_strings((yyvsp[(1) - (3)].sval), buf);
        }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 942 "pars.yacc"
    {
	    int itmp = rint((yyvsp[(1) - (1)].dval));
            if (fabs(itmp - (yyvsp[(1) - (1)].dval)) > 1.e-6) {
		yyerror("Non-integer value supplied for integer");
		return 1;
            }
            (yyval.ival) = itmp;
        }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 952 "pars.yacc"
    {
            if ((yyvsp[(1) - (1)].ival) < 0) {
		yyerror("Negative value supplied for non-negative");
		return 1;
            }
            (yyval.ival) = (yyvsp[(1) - (1)].ival);
	}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 961 "pars.yacc"
    {
	    int itmp = (yyvsp[(2) - (3)].ival) - index_shift;
            if (itmp < 0) {
		yyerror("Negative index");
		return 1;
            }
            (yyval.ival) = itmp;
	}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 971 "pars.yacc"
    {
            (yyval.dval) = (yyvsp[(1) - (1)].dval);
        }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 974 "pars.yacc"
    {
            double jul;
            Dates_format dummy;
            if (parse_date((yyvsp[(1) - (1)].sval), get_date_hint(), FALSE, &jul, &dummy)
                == RETURN_SUCCESS) {
                xfree((yyvsp[(1) - (1)].sval));
                (yyval.dval) = jul;
            } else {
                xfree((yyvsp[(1) - (1)].sval));
		yyerror("Invalid date");
		return 1;
            }
        }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 989 "pars.yacc"
    {
            (yyval.dval) = (yyvsp[(1) - (1)].dval);
        }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 992 "pars.yacc"
    {
            double jul;
            Dates_format dummy;
            if (parse_date((yyvsp[(1) - (1)].sval), get_date_hint(), TRUE, &jul, &dummy)
                == RETURN_SUCCESS) {
                xfree((yyvsp[(1) - (1)].sval));
                (yyval.dval) = jul;
            } else {
                xfree((yyvsp[(1) - (1)].sval));
		yyerror("Invalid date");
		return 1;
            }
        }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1007 "pars.yacc"
    { (yyval.vrbl) = (yyvsp[(1) - (1)].vrbl); }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1009 "pars.yacc"
    {
	    double *ptr = getcol(vasgn_gno, vasgn_setno, (yyvsp[(1) - (1)].ival));
            (yyval.vrbl) = &freelist[fcnt++];
            (yyval.vrbl)->type = GRARR_SET;
            (yyval.vrbl)->data = ptr;
            if (ptr == NULL) {
                errmsg("NULL variable - check set type");
                return 1;
            } else {
                (yyval.vrbl)->length = getsetlength(vasgn_gno, vasgn_setno);
            }
	}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1022 "pars.yacc"
    {
	    double *ptr = getcol((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival));
            (yyval.vrbl) = &freelist[fcnt++];
            (yyval.vrbl)->type = GRARR_SET;
            (yyval.vrbl)->data = ptr;
            if (ptr == NULL) {
                errmsg("NULL variable - check set type");
                return 1;
            } else {
                (yyval.vrbl)->length = getsetlength((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno);
            }
	}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1038 "pars.yacc"
    {
            (yyval.vrbl) = (yyvsp[(1) - (1)].vrbl);
	}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1042 "pars.yacc"
    {
            int start = (yyvsp[(3) - (6)].ival) - index_shift, stop = (yyvsp[(5) - (6)].ival) - index_shift;
            if (start < 0 || stop < start || stop >= (yyvsp[(1) - (6)].vrbl)->length) {
		yyerror("Invalid index range");
            } else {
                int len = stop - start + 1;
	        double *ptr = xmalloc(len*SIZEOF_DOUBLE);
                if ((yyval.vrbl)->data == NULL) {
                    yyerror("Not enough memory");
                } else {
                    int i;
                    (yyval.vrbl) = &freelist[fcnt++];
	            (yyval.vrbl)->data = ptr;
                    (yyval.vrbl)->length = len;
                    (yyval.vrbl)->type = GRARR_TMP;
                    for (i = 0; i < len; i++) {
                        (yyval.vrbl)->data[i] = (yyvsp[(1) - (6)].vrbl)->data[i + (yyvsp[(3) - (6)].ival)];
                    }
                }
            }
	}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1064 "pars.yacc"
    {
            int len = (yyvsp[(3) - (4)].ival);
            if (len < 1) {
                yyerror("npoints must be > 0");
            } else {
                double *ptr = allocate_index_data(len);
                if (ptr == NULL) {
                    errmsg("Malloc failed");
                    return 1;
                } else {
                    (yyval.vrbl) = &freelist[fcnt++];
                    (yyval.vrbl)->type = GRARR_TMP;
                    (yyval.vrbl)->data = ptr;
                    (yyval.vrbl)->length = len;
                }
            }
	}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1082 "pars.yacc"
    {
            int len = (yyvsp[(7) - (8)].ival);
            if (len < 2) {
                yyerror("npoints must be > 1");
            } else {
                double *ptr = allocate_mesh((yyvsp[(3) - (8)].dval), (yyvsp[(5) - (8)].dval), len);
                if (ptr == NULL) {
                    errmsg("Malloc failed");
                    return 1;
                } else {
                    (yyval.vrbl) = &freelist[fcnt++];
                    (yyval.vrbl)->type = GRARR_TMP;
                    (yyval.vrbl)->data = ptr;
                    (yyval.vrbl)->length = len;
                }
            }
	}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1100 "pars.yacc"
    {
	    int i;
            int len = (yyvsp[(3) - (4)].ival);
            (yyval.vrbl) = &freelist[fcnt++];
	    (yyval.vrbl)->data = xmalloc((yyvsp[(3) - (4)].ival)*SIZEOF_DOUBLE);
            if ((yyval.vrbl)->data == NULL) {
                errmsg("Not enough memory");
                return 1;
            } else {
                (yyval.vrbl)->length = len;
                (yyval.vrbl)->type = GRARR_TMP;
            }
            for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = drand48();
	    }
	}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1117 "pars.yacc"
    {
	    int rtype, i, len;
            char *rarray;

            rtype = RESTRICT_REG0 + (yyvsp[(1) - (4)].ival);

	    if (get_restriction_array((yyvsp[(3) - (4)].trgt)->gno, (yyvsp[(3) - (4)].trgt)->setno,
                rtype, FALSE, &rarray) != RETURN_SUCCESS) {
                errmsg("Error in region evaluation");
                return 1;
	    }

            len = getsetlength((yyvsp[(3) - (4)].trgt)->gno, (yyvsp[(3) - (4)].trgt)->setno);
            (yyval.vrbl) = &freelist[fcnt++];
	    (yyval.vrbl)->data = xmalloc(len*SIZEOF_DOUBLE);
            if ((yyval.vrbl)->data == NULL) {
                errmsg("Not enough memory");
                return 1;
            } else {
                (yyval.vrbl)->length = len;
                (yyval.vrbl)->type = GRARR_TMP;
            }
            for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = rarray[i];
	    }

            xfree(rarray);
	}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1145 "pars.yacc"
    {
            int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (4)].vrbl));
            for (i = 1; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] += (yyval.vrbl)->data[i - 1];
            }
	}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1152 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (4)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (4)].ival)].data)) ((int) ((yyvsp[(3) - (4)].vrbl)->data[i]));
	    }
	}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1160 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (4)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (4)].ival)].data)) (((yyvsp[(3) - (4)].vrbl)->data[i]));
	    }
	}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1167 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(3) - (6)].vrbl)->length != (yyvsp[(5) - (6)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (6)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].vrbl)->data[i], (yyvsp[(5) - (6)].vrbl)->data[i]);
	    }
	}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1178 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(5) - (6)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].dval), (yyvsp[(5) - (6)].vrbl)->data[i]);
	    }
	}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1185 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (6)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].vrbl)->data[i], (yyvsp[(5) - (6)].dval));
	    }
	}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1192 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(5) - (6)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (6)].ival)].data)) ((yyvsp[(3) - (6)].ival), (yyvsp[(5) - (6)].vrbl)->data[i]);
	    }
	}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1199 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(7) - (8)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (8)].ival)].data)) ((yyvsp[(3) - (8)].ival), (yyvsp[(5) - (8)].ival), (yyvsp[(7) - (8)].vrbl)->data[i]);
	    }
	}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1206 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(7) - (8)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (8)].ival)].data)) ((yyvsp[(3) - (8)].dval), (yyvsp[(5) - (8)].dval), (yyvsp[(7) - (8)].vrbl)->data[i]);
	    }
	}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1213 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(9) - (10)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (10)].ival)].data)) ((yyvsp[(3) - (10)].dval), (yyvsp[(5) - (10)].dval), (yyvsp[(7) - (10)].dval), (yyvsp[(9) - (10)].vrbl)->data[i]);
	    }
	}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1220 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(11) - (12)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (12)].ival)].data)) ((yyvsp[(3) - (12)].dval), (yyvsp[(5) - (12)].dval), (yyvsp[(7) - (12)].dval), (yyvsp[(9) - (12)].dval), (yyvsp[(11) - (12)].vrbl)->data[i]);
	    }
	}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1227 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(13) - (14)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((ParserFnc) (key[(yyvsp[(1) - (14)].ival)].data)) ((yyvsp[(3) - (14)].dval), (yyvsp[(5) - (14)].dval), (yyvsp[(7) - (14)].dval), (yyvsp[(9) - (14)].dval), (yyvsp[(11) - (14)].dval), (yyvsp[(13) - (14)].vrbl)->data[i]);
	    }
	}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1234 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] + (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1245 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] + (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1252 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) + (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1259 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] - (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1270 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] - (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1277 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) - (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1284 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] * (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1295 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] * (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1303 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = &freelist[fcnt++];
	    copy_grarr ((yyval.vrbl), (yyvsp[(3) - (3)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;

	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) * (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1313 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	      if (div_null ((yyvsp[(3) - (3)].vrbl)->data[i])) return 1;
              (yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] / (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1325 "pars.yacc"
    {
	    int i;
	    if (div_null ((yyvsp[(3) - (3)].dval))) return 1;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] / (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1333 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	      if (div_null ((yyvsp[(3) - (3)].vrbl)->data[i])) return 1;
	      (yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) / (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1341 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	      if (div_null ((yyvsp[(3) - (3)].vrbl)->data[i])) return 1;
	      (yyval.vrbl)->data[i] = fmod((yyvsp[(1) - (3)].vrbl)->data[i], (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1353 "pars.yacc"
    {
	    int i;
	    if (div_null ((yyvsp[(3) - (3)].dval))) return 1;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = fmod((yyvsp[(1) - (3)].vrbl)->data[i], (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1361 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	      if (div_null ((yyvsp[(3) - (3)].vrbl)->data[i])) return 1;
	      (yyval.vrbl)->data[i] = fmod((yyvsp[(1) - (3)].dval), (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1369 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	        if ((yyvsp[(1) - (3)].vrbl)->data[i] < 0 && rint((yyvsp[(3) - (3)].vrbl)->data[i]) != (yyvsp[(3) - (3)].vrbl)->data[i]) {
	            yyerror("Negative value raised to non-integer power");
	            return 1;
                } else if ((yyvsp[(1) - (3)].vrbl)->data[i] == 0.0 && (yyvsp[(3) - (3)].vrbl)->data[i] <= 0.0) {
	            yyerror("Zero raised to non-positive power");
	            return 1;
                } else {
                    (yyval.vrbl)->data[i] = pow((yyvsp[(1) - (3)].vrbl)->data[i], (yyvsp[(3) - (3)].vrbl)->data[i]);
                }
	    }
	}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1388 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	        if ((yyvsp[(1) - (3)].vrbl)->data[i] < 0 && rint((yyvsp[(3) - (3)].dval)) != (yyvsp[(3) - (3)].dval)) {
	            yyerror("Negative value raised to non-integer power");
	            return 1;
                } else if ((yyvsp[(1) - (3)].vrbl)->data[i] == 0.0 && (yyvsp[(3) - (3)].dval) <= 0.0) {
	            yyerror("Zero raised to non-positive power");
	            return 1;
                } else {
                    (yyval.vrbl)->data[i] = pow((yyvsp[(1) - (3)].vrbl)->data[i], (yyvsp[(3) - (3)].dval));
                }
	    }
	}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1403 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
	        if ((yyvsp[(1) - (3)].dval) < 0 && rint((yyvsp[(3) - (3)].vrbl)->data[i]) != (yyvsp[(3) - (3)].vrbl)->data[i]) {
	            yyerror("Negative value raised to non-integer power");
	            return 1;
                } else if ((yyvsp[(1) - (3)].dval) == 0.0 && (yyvsp[(3) - (3)].vrbl)->data[i] <= 0.0) {
	            yyerror("Zero raised to non-positive power");
	            return 1;
                } else {
                    (yyval.vrbl)->data[i] = pow((yyvsp[(1) - (3)].dval), (yyvsp[(3) - (3)].vrbl)->data[i]);
                }
	    }
	}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1418 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (2)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (2)].vrbl)->data[i] * ((ParserFnc) (key[(yyvsp[(2) - (2)].ival)].data)) ();
	    }
	}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1425 "pars.yacc"
    {
            int i;
            (yyval.vrbl) = &freelist[fcnt++];
	    copy_grarr ((yyval.vrbl), (yyvsp[(1) - (5)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = CAST_DBL_TO_BOOL((yyvsp[(1) - (5)].vrbl)->data[i]) ? (yyvsp[(3) - (5)].dval) : (yyvsp[(5) - (5)].dval);
            }
	}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1434 "pars.yacc"
    {
            int i;
	    if ((yyvsp[(1) - (5)].vrbl)->length != (yyvsp[(5) - (5)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = &freelist[fcnt++];
	    copy_grarr ((yyval.vrbl), (yyvsp[(1) - (5)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = CAST_DBL_TO_BOOL((yyvsp[(1) - (5)].vrbl)->data[i]) ? (yyvsp[(3) - (5)].dval) : (yyvsp[(5) - (5)].vrbl)->data[i];
            }
	}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1447 "pars.yacc"
    {
            int i;
	    if ((yyvsp[(1) - (5)].vrbl)->length != (yyvsp[(3) - (5)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = &freelist[fcnt++];
	    copy_grarr ((yyval.vrbl), (yyvsp[(1) - (5)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = CAST_DBL_TO_BOOL((yyvsp[(1) - (5)].vrbl)->data[i]) ? (yyvsp[(3) - (5)].vrbl)->data[i] : (yyvsp[(5) - (5)].dval);
            }
	}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1460 "pars.yacc"
    {
            int i;
	    if ((yyvsp[(1) - (5)].vrbl)->length != (yyvsp[(5) - (5)].vrbl)->length || (yyvsp[(1) - (5)].vrbl)->length != (yyvsp[(3) - (5)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = &freelist[fcnt++];
	    copy_grarr ((yyval.vrbl), (yyvsp[(1) - (5)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = CAST_DBL_TO_BOOL((yyvsp[(1) - (5)].vrbl)->data[i]) ? (yyvsp[(3) - (5)].vrbl)->data[i] : (yyvsp[(5) - (5)].vrbl)->data[i];
            }
	}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1473 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] || (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1484 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] || (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1491 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) || (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1498 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
	    copy_grarr ((yyval.vrbl), (yyvsp[(1) - (3)].vrbl));
            (yyval.vrbl)->type = GRARR_TMP;

	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] && (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1511 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].vrbl)->data[i] && (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1518 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = (yyvsp[(1) - (3)].dval) && (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1525 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] > (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1536 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] > (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1543 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) > (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1550 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] < (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1561 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] < (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1568 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) < (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1575 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] >= (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1586 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] >= (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1593 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) >= (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1600 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] <= (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1611 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] <= (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1618 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) <= (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1625 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] == (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1636 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] == (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1643 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) == (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1650 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Can't operate on vectors of different lengths");
                return 1;
            }
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] != (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1661 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(1) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].vrbl)->data[i] != (yyvsp[(3) - (3)].dval));
	    }
	}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1668 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(3) - (3)].vrbl));
	    for (i = 0; i < (yyval.vrbl)->length; i++) {
		(yyval.vrbl)->data[i] = ((yyvsp[(1) - (3)].dval) != (yyvsp[(3) - (3)].vrbl)->data[i]);
	    }
	}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1675 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(2) - (2)].vrbl));
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = !(yyvsp[(2) - (2)].vrbl)->data[i];
            }
	}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1682 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(2) - (3)].vrbl));
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = (yyvsp[(2) - (3)].vrbl)->data[i];
            }
	}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1689 "pars.yacc"
    {
	    int i;
            (yyval.vrbl) = tmp_vec ((yyvsp[(2) - (2)].vrbl));
            for (i = 0; i < (yyval.vrbl)->length; i++) {
                (yyval.vrbl)->data[i] = - (yyvsp[(2) - (2)].vrbl)->data[i];
            }
	}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1705 "pars.yacc"
    { (yyval.matp) = (yyvsp[(1) - (1)].matp); }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1708 "pars.yacc"
    { (yyval.matp) = (yyvsp[(1) - (1)].matp); }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1709 "pars.yacc"
    {
	   int i ,j;
	   if ((yyvsp[(1) - (3)].matp)->nrows != (yyvsp[(3) - (3)].matp)->nrows || (yyvsp[(1) - (3)].matp)->ncols != (yyvsp[(3) - (3)].matp)->ncols) {
	     errmsg ("mexpr + mexpr: Left and right matrices are of different size");
	   }
	   (yyval.matp) = tmp_mat ((yyvsp[(1) - (3)].matp));
	   for (i = 0; i < (yyvsp[(1) - (3)].matp)->nrows; i++) {
	     for (j = 0; j < (yyvsp[(1) - (3)].matp)->ncols; j++) {
	       (yyval.matp)->matrix[i][j] = (yyvsp[(1) - (3)].matp)->matrix[i][j] + (yyvsp[(3) - (3)].matp)->matrix[i][j];
	     }
	   }
	}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1723 "pars.yacc"
    {
  	       switch ((yyvsp[(1) - (1)].matp)->type) {
  	       case GRARR_MAT:
  	         vasgn_gno   = -1;
  	         vasgn_setno = -1;
		 masgn_row1  = -1;
		 masgn_row2  = -1;
		 masgn_col1  = -1;
		 masgn_col2  = -1;
  	         break;
  	         // TODO add assignation to a set */
  	       default:
  	         errmsg("lside_matrix: Internal error");
  	         return 1;
  	       }
  	       (yyval.matp) = (yyvsp[(1) - (1)].matp);
              }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1740 "pars.yacc"
    {
  	       switch ((yyvsp[(1) - (6)].matp)->type) {
  	       case GRARR_MAT:
  	         vasgn_gno   = -1;
  	         vasgn_setno = -1;
		 masgn_row1  = -1;
		 masgn_row2  = -1;
		 masgn_col1 = (yyvsp[(5) - (6)].ival);
		 masgn_col2 = (yyvsp[(5) - (6)].ival);
  	         break;
  	         // TODO add assignation to a set */
  	       default:
  	         errmsg("lside_matrix: Internal error");
  	         return 1;
  	       }
  	       (yyval.matp) = (yyvsp[(1) - (6)].matp);
          }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1757 "pars.yacc"
    {
  	       switch ((yyvsp[(1) - (6)].matp)->type) {
  	       case GRARR_MAT:
  	         vasgn_gno   = -1;
  	         vasgn_setno = -1;
		 masgn_row1  = (yyvsp[(3) - (6)].ival);
		 masgn_row2  = (yyvsp[(3) - (6)].ival);
		 masgn_col1  = -1;
		 masgn_col2  = -1;
  	         break;
  	         // TODO add assignation to a set */
  	       default:
  	         errmsg("lside_matrix: Internal error");
  	         return 1;
  	       }
  	       (yyval.matp) = (yyvsp[(1) - (6)].matp);
          }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1774 "pars.yacc"
    {
  	       switch ((yyvsp[(1) - (8)].matp)->type) {
  	       case GRARR_MAT:
  	         vasgn_gno   = -1;
  	         vasgn_setno = -1;
		 masgn_row1  = (yyvsp[(3) - (8)].ival);
		 masgn_row2  = (yyvsp[(5) - (8)].ival);
		 masgn_col1  = -1;
		 masgn_col2  = -1;
  	         break;
  	         // TODO add assignation to a set */
  	       default:
  	         errmsg("lside_matrix: Internal error");
  	         return 1;
  	       }
  	       (yyval.matp) = (yyvsp[(1) - (8)].matp);
          }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1791 "pars.yacc"
    {
  	       switch ((yyvsp[(1) - (8)].matp)->type) {
  	       case GRARR_MAT:
  	         vasgn_gno   = -1;
  	         vasgn_setno = -1;
		 masgn_row1  = -1;
		 masgn_row2  = -1;
		 masgn_col1  = (yyvsp[(5) - (8)].ival);
		 masgn_col2  = (yyvsp[(7) - (8)].ival);
  	         break;
  	         // TODO add assignation to a set */
  	       default:
  	         errmsg("lside_matrix: Internal error");
  	         return 1;
  	       }
  	       (yyval.matp) = (yyvsp[(1) - (8)].matp);
          }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1810 "pars.yacc"
    {                   /* matrix = matrix */
	   int i ,j;
	   if ((yyvsp[(1) - (3)].matp)->nrows != (yyvsp[(3) - (3)].matp)->nrows || (yyvsp[(1) - (3)].matp)->ncols != (yyvsp[(3) - (3)].matp)->ncols) {
	     errmsg ("Left and right matrices are of different size");
	   }
	   for (i = 0; i < (yyvsp[(1) - (3)].matp)->nrows; i++) {
	     for (j = 0; j < (yyvsp[(1) - (3)].matp)->ncols; j++) {
	       (yyvsp[(1) - (3)].matp)->matrix[i][j] = (yyvsp[(3) - (3)].matp)->matrix[i][j];
	     }
	   }
	 }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1821 "pars.yacc"
    {                /* matrix = scalar */
	   int i ,j;
	   for (i = 0; i < (yyvsp[(1) - (3)].matp)->nrows; i++) {
	     for (j = 0; j < (yyvsp[(1) - (3)].matp)->ncols; j++) {
	       (yyvsp[(1) - (3)].matp)->matrix[i][j] = (yyvsp[(3) - (3)].dval);
	     }
	   }
	 }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1829 "pars.yacc"
    {
	   int i ,j ,k;
	   if (masgn_row1 < 0 && masgn_col1 < 0) {
	     /* matrix = vector : casting of the vector into a matrix */
	     if ((yyvsp[(1) - (3)].matp)->nrows * (yyvsp[(1) - (3)].matp)->ncols != (yyvsp[(3) - (3)].vrbl)->length) {
	       errmsg ("Left matrice size incompatible with right vector length ");
	     }
	     k = 0;
	     for (i = 0; i < (yyvsp[(1) - (3)].matp)->nrows; i++) {
	       for (j = 0; j < (yyvsp[(1) - (3)].matp)->ncols; j++) {
		 (yyvsp[(1) - (3)].matp)->matrix[i][j] = (yyvsp[(3) - (3)].vrbl)->data[k];
		 k++;
	       }
	     }
	   } else if (masgn_row1 < 0 && masgn_col1 >= 0) {
	     /* matrix[][n]     = vector :  vector is copied into column n of the matrix */
	     /* matrix[][n1:n2] = vector :  vector is duplicated into columns n1 to n2 of the matrix */
	     if ((yyvsp[(1) - (3)].matp)->nrows != (yyvsp[(3) - (3)].vrbl)->length) {
	       errmsg ("Left matrice number of rows not equal to vector length ");
	     }
	     for (j = masgn_col1; j <= masgn_col2; j++) {
	       for (i = 0; i < (yyvsp[(1) - (3)].matp)->nrows; i++) {
		 (yyvsp[(1) - (3)].matp)->matrix[i][j] = (yyvsp[(3) - (3)].vrbl)->data[i];
	       }
	     }
	   } else if (masgn_row1 >= 0  && masgn_col1 < 0) {
	     /* matrix[n1:n2][] = vector : vector is duplicated into rows of the matrix */
	     if ((yyvsp[(1) - (3)].matp)->ncols != (yyvsp[(3) - (3)].vrbl)->length) {
	       errmsg ("Left matrice number of columns not equal to vector length ");
	     }
	     for (j = masgn_row1; j <= masgn_row2; j++) {
	       for (i = 0; i < (yyvsp[(1) - (3)].matp)->ncols; i++) {
		 (yyvsp[(1) - (3)].matp)->matrix[j][i] = (yyvsp[(3) - (3)].vrbl)->data[i];
	       }
             }
           }
         }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1870 "pars.yacc"
    { *((yyvsp[(1) - (3)].dptr)) = (yyvsp[(3) - (3)].dval); }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1871 "pars.yacc"
    { nonl_parms[(yyvsp[(1) - (3)].ival)].value = (yyvsp[(3) - (3)].dval); }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1872 "pars.yacc"
    { nonl_parms[(yyvsp[(1) - (3)].ival)].max = (yyvsp[(3) - (3)].dval); }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1873 "pars.yacc"
    { nonl_parms[(yyvsp[(1) - (3)].ival)].min = (yyvsp[(3) - (3)].dval); }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1874 "pars.yacc"
    {
        		          if ((yyvsp[(2) - (4)].ival) >= (yyvsp[(1) - (4)].vrbl)->length) {
        		              yyerror("Access beyond  bounds");
        		              return 1;
        		          }
        		          (yyvsp[(1) - (4)].vrbl)->data[(yyvsp[(2) - (4)].ival)] = (yyvsp[(4) - (4)].dval);
        		      }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1883 "pars.yacc"
    {
            target tgt;
            switch ((yyvsp[(1) - (1)].vrbl)->type) {
            case GRARR_SET:
                if (find_set_bydata((yyvsp[(1) - (1)].vrbl)->data, &tgt) == RETURN_SUCCESS) {
                    vasgn_gno   = tgt.gno;
                    vasgn_setno = tgt.setno;
                } else {
                    errmsg("Internal error");
		    return 1;
                }
                break;
            case GRARR_VEC:
                vasgn_gno   = -1;
                vasgn_setno = -1;
                break;
            default:
                /* It can NOT be a tmp array on the left side! */
                errmsg("Internal error");
	        return 1;
            }
            (yyval.vrbl) = (yyvsp[(1) - (1)].vrbl);
        }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1910 "pars.yacc"
    {
	    int i;
	    if ((yyvsp[(1) - (3)].vrbl)->length != (yyvsp[(3) - (3)].vrbl)->length) {
                errmsg("Left and right vectors are of different lengths");
                return 1;
            }
	    for (i = 0; i < (yyvsp[(1) - (3)].vrbl)->length; i++) {
	        (yyvsp[(1) - (3)].vrbl)->data[i] = (yyvsp[(3) - (3)].vrbl)->data[i];
	    }
	}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1921 "pars.yacc"
    {
	    int i;
	    for (i = 0; i < (yyvsp[(1) - (3)].vrbl)->length; i++) {
	        (yyvsp[(1) - (3)].vrbl)->data[i] = (yyvsp[(3) - (3)].dval);
	    }
	}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1928 "pars.yacc"
    {
	   int i ,j ,k;
	   if ((yyvsp[(3) - (3)].matp)->nrows * (yyvsp[(3) - (3)].matp)->ncols != (yyvsp[(1) - (3)].vrbl)->length) {
	     errmsg ("Right matrice size incompatible with left vector length ");
	   }
	   k = 0;
	   for (i = 0; i < (yyvsp[(3) - (3)].matp)->nrows; i++) {
	     for (j = 0; j < (yyvsp[(3) - (3)].matp)->ncols; j++) {
	       (yyvsp[(1) - (3)].vrbl)->data[k] = (yyvsp[(3) - (3)].matp)->matrix[i][j];
	     k++;
	     }
	   }
	}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1944 "pars.yacc"
    {
  	 printf ("flowcontrol: IF detected \n");
	 ptree = ptree_if_begin (ptree);
         }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1948 "pars.yacc"
    {
  	 printf ("flowcontrol: } detected \n");
         }
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1954 "pars.yacc"
    {
	    symtab_entry tmpkey;
            double *var;
            var		  = xmalloc(SIZEOF_DOUBLE);
            *var	  = 0.0;
	    tmpkey.s	  = (yyvsp[(2) - (2)].sval);
	    tmpkey.type	  = KEY_VAR;
	    tmpkey.status = VAR_USER;
	    tmpkey.data	  = (void *) var;
	    if (addto_symtab (tmpkey) != RETURN_SUCCESS) {
	        yyerror("Adding new symbol failed");
	    }

            xfree((yyvsp[(2) - (2)].sval));
        }
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1970 "pars.yacc"
    {
	    if (define_parser_arr ((yyvsp[(2) - (4)].sval) ,VAR_USER) == NULL) {
	        yyerror("Adding new symbol failed");
	    }

            xfree((yyvsp[(2) - (4)].sval));
        }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1978 "pars.yacc"
    {
	    grarr *var;
            if ((var = define_parser_arr ((yyvsp[(2) - (5)].sval) ,VAR_USER)) == NULL) {
	        yyerror("Adding new symbol failed");
	    } else {
                realloc_vrbl(var, (yyvsp[(4) - (5)].ival));
            }

            xfree((yyvsp[(2) - (5)].sval));
        }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1989 "pars.yacc"
    {
	    grarr *var;
            if ((var = define_parser_arr2 ((yyvsp[(2) - (8)].sval) ,VAR_USER ,(yyvsp[(4) - (8)].ival) ,(yyvsp[(7) - (8)].ival))) == NULL) {
	        yyerror("Adding new 2D symbol failed");
            }
            xfree((yyvsp[(2) - (8)].sval));
        }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1996 "pars.yacc"
    { yyerror("Keyword already exists"); }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1997 "pars.yacc"
    { yyerror("Keyword already exists"); }
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1998 "pars.yacc"
    { yyerror("Keyword already exists"); }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1999 "pars.yacc"
    { undefine_parser_var((void *) (yyvsp[(2) - (2)].dptr)); xfree((yyvsp[(2) - (2)].dptr)); }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2000 "pars.yacc"
    {
            realloc_vrbl((yyvsp[(2) - (2)].vrbl), 0);
            undefine_parser_var((void *) (yyvsp[(2) - (2)].vrbl));
            xfree((yyvsp[(2) - (2)].vrbl));
        }
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 2005 "pars.yacc"
    {
	   int i;
	   for (i = 0; i < (yyvsp[(2) - (2)].matp)->nrows; i++) xfree ((yyvsp[(2) - (2)].matp)->matrix[i]);
	   xfree ((yyvsp[(2) - (2)].matp)->matrix);
	   (yyvsp[(2) - (2)].matp)->length = 0;
	   (yyvsp[(2) - (2)].matp)->nrows = 0;
	   (yyvsp[(2) - (2)].matp)->ncols = 0;
            undefine_parser_var((void *) (yyvsp[(2) - (2)].matp));
            xfree((yyvsp[(2) - (2)].matp));
          }
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 2015 "pars.yacc"
    { undefine_all_users_var (); }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 2016 "pars.yacc"
    {
	    int position;

	    lowtoupper((yyvsp[(3) - (3)].sval));
	    if ((position = findf(key, (yyvsp[(3) - (3)].sval))) >= 0) {
	        symtab_entry tmpkey;
		tmpkey.s = (yyvsp[(2) - (3)].sval);
		tmpkey.type   = key[position].type;
		tmpkey.data   = key[position].data;
		if (addto_symtab(tmpkey) != RETURN_SUCCESS) {
		    yyerror("Keyword already exists");
		}
	    } else {
	        yyerror("Aliased keyword not found");
	    }
	    xfree((yyvsp[(2) - (3)].sval));
	    xfree((yyvsp[(3) - (3)].sval));
	}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 2034 "pars.yacc"
    {
	    alias_force = (yyvsp[(3) - (3)].ival);
	}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2037 "pars.yacc"
    {
	    if (load_module((yyvsp[(6) - (6)].sval), (yyvsp[(2) - (6)].sval), (yyvsp[(2) - (6)].sval), (yyvsp[(4) - (6)].ival)) != 0) {
	        yyerror("DL module load failed");
	    }
	    xfree((yyvsp[(2) - (6)].sval));
	    xfree((yyvsp[(6) - (6)].sval));
	}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 2044 "pars.yacc"
    {
	    if (load_module((yyvsp[(6) - (8)].sval), (yyvsp[(2) - (8)].sval), (yyvsp[(8) - (8)].sval), (yyvsp[(4) - (8)].ival)) != 0) {
	        yyerror("DL module load failed");
	    }
	    xfree((yyvsp[(2) - (8)].sval));
	    xfree((yyvsp[(6) - (8)].sval));
	    xfree((yyvsp[(8) - (8)].sval));
	}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 2055 "pars.yacc"
    { rg[(yyvsp[(1) - (2)].ival)].active = (yyvsp[(2) - (2)].ival); }
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2056 "pars.yacc"
    { rg[(yyvsp[(1) - (3)].ival)].type   = (yyvsp[(3) - (3)].ival);   }
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2057 "pars.yacc"
    { rg[(yyvsp[(1) - (2)].ival)].color  = (yyvsp[(2) - (2)].ival);  }
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2058 "pars.yacc"
    { rg[(yyvsp[(1) - (2)].ival)].lines  = (yyvsp[(2) - (2)].ival);  }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2059 "pars.yacc"
    { rg[(yyvsp[(1) - (2)].ival)].linew  = (yyvsp[(2) - (2)].dval);  }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2061 "pars.yacc"
    {
	    rg[(yyvsp[(1) - (9)].ival)].x1 = (yyvsp[(3) - (9)].dval);
	    rg[(yyvsp[(1) - (9)].ival)].y1 = (yyvsp[(5) - (9)].dval);
	    rg[(yyvsp[(1) - (9)].ival)].x2 = (yyvsp[(7) - (9)].dval);
	    rg[(yyvsp[(1) - (9)].ival)].y2 = (yyvsp[(9) - (9)].dval);
	}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2068 "pars.yacc"
    {
	    rg[(yyvsp[(1) - (5)].ival)].x = xrealloc(rg[(yyvsp[(1) - (5)].ival)].x, (rg[(yyvsp[(1) - (5)].ival)].n + 1) * SIZEOF_DOUBLE);
	    rg[(yyvsp[(1) - (5)].ival)].y = xrealloc(rg[(yyvsp[(1) - (5)].ival)].y, (rg[(yyvsp[(1) - (5)].ival)].n + 1) * SIZEOF_DOUBLE);
	    rg[(yyvsp[(1) - (5)].ival)].x[rg[(yyvsp[(1) - (5)].ival)].n] = (yyvsp[(3) - (5)].dval);
	    rg[(yyvsp[(1) - (5)].ival)].y[rg[(yyvsp[(1) - (5)].ival)].n] = (yyvsp[(5) - (5)].dval);
	    rg[(yyvsp[(1) - (5)].ival)].n++;
	}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 2075 "pars.yacc"
    { rg[(yyvsp[(2) - (4)].ival)].linkto = (yyvsp[(4) - (4)].ival); }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2079 "pars.yacc"
    {
	  file_project_version = (yyvsp[(2) - (2)].ival);
            if (set_project_version((yyvsp[(2) - (2)].ival)) != RETURN_SUCCESS) {
                errmsg("Project version is newer than software!");
            }
            if (get_project_version() < 50001) {
                map_fonts(FONT_MAP_ACEGR);
            } else {
                map_fonts(FONT_MAP_DEFAULT);
            }
        }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2090 "pars.yacc"
    { set_page_dimensions 	  ((yyvsp[(3) - (5)].ival) ,(yyvsp[(5) - (5)].ival) ,TRUE);  }
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 2091 "pars.yacc"
    { set_page_dimensions 	  ((yyvsp[(3) - (5)].ival) ,(yyvsp[(5) - (5)].ival) ,FALSE); }
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2092 "pars.yacc"
    { set_page_dimensions_std ((yyvsp[(3) - (4)].sval) ,(yyvsp[(4) - (4)].ival) ,FALSE); }
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 2093 "pars.yacc"
    { set_page_dimensions_std ((yyvsp[(3) - (4)].sval) ,(yyvsp[(4) - (4)].ival) ,TRUE); }
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 2094 "pars.yacc"
    {
            int device_id;
            Device_entry dev;

            device_id = get_device_by_name((yyvsp[(2) - (7)].sval));
            xfree((yyvsp[(2) - (7)].sval));
            if (device_id < 0) {
                yyerror("Unknown device");
            } else {
                dev = get_device_props(device_id);
                dev.pg.width =  (long) ((yyvsp[(5) - (7)].ival)*dev.pg.dpi/72);
                dev.pg.height = (long) ((yyvsp[(7) - (7)].ival)*dev.pg.dpi/72);
                set_device_props(device_id, dev);
            }
        }
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2109 "pars.yacc"
    {
            int device_id;
            Device_entry dev;

            device_id = get_device_by_name((yyvsp[(2) - (4)].sval));
            if (device_id < 0) {
                yyerror("Unknown device");
            } else {
                dev = get_device_props(device_id);
                dev.pg.dpi = (yyvsp[(4) - (4)].dval);
                set_device_props(device_id, dev);
            }
            xfree((yyvsp[(2) - (4)].sval));
        }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2123 "pars.yacc"
    {
            int device_id;
            Device_entry dev;

            device_id = get_device_by_name((yyvsp[(2) - (5)].sval));
            if (device_id < 0) {
                yyerror("Unknown device");
            } else {
                dev = get_device_props(device_id);
                dev.fontaa = (yyvsp[(5) - (5)].ival);
                set_device_props(device_id, dev);
            }
            xfree((yyvsp[(2) - (5)].sval));
        }
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 2137 "pars.yacc"
    {
            int device_id;
            Device_entry dev;

            device_id = get_device_by_name((yyvsp[(2) - (4)].sval));
            if (device_id < 0) {
                yyerror("Unknown device");
            } else {
                dev = get_device_props(device_id);
                dev.devfonts = (yyvsp[(4) - (4)].ival);
                set_device_props(device_id, dev);
            }
            xfree((yyvsp[(2) - (4)].sval));
        }
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 2151 "pars.yacc"
    {
            int device_id;

            device_id = get_device_by_name((yyvsp[(2) - (4)].sval));
            if (device_id < 0) {
                yyerror("Unknown device");
            } else {
                if (parse_device_options(device_id, (yyvsp[(4) - (4)].sval)) !=
                                                        RETURN_SUCCESS) {
                    yyerror("Incorrect device option string");
                }
            }
            xfree((yyvsp[(2) - (4)].sval));
            xfree((yyvsp[(4) - (4)].sval));
        }
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 2166 "pars.yacc"
    { set_printer_by_name    ((yyvsp[(3) - (3)].sval)); xfree((yyvsp[(3) - (3)].sval)); }
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 2167 "pars.yacc"
    { set_ref_date 	  ((yyvsp[(3) - (3)].dval)); }
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 2168 "pars.yacc"
    { allow_two_digits_years ((yyvsp[(3) - (3)].ival)); }
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 2169 "pars.yacc"
    { set_wrap_year 	  ((yyvsp[(4) - (4)].ival)); }
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 2170 "pars.yacc"
    { setbgcolor             ((yyvsp[(2) - (2)].ival)); }
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 2171 "pars.yacc"
    { }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 2172 "pars.yacc"
    { scroll_proc((int) (yyvsp[(3) - (4)].dval));	}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 2173 "pars.yacc"
    { scrollinout_proc((int) (yyvsp[(3) - (4)].dval));	}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 2174 "pars.yacc"
    { scrolling_islinked = (yyvsp[(3) - (3)].ival);	}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 2175 "pars.yacc"
    { add_world(gn, (yyvsp[(3) - (9)].dval), (yyvsp[(5) - (9)].dval), (yyvsp[(7) - (9)].dval), (yyvsp[(9) - (9)].dval)); }
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 2176 "pars.yacc"
    { timer_delay = (yyvsp[(2) - (2)].ival); }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 2178 "pars.yacc"
    {
	    target_set = *((yyvsp[(2) - (2)].trgt));
	    cur_obj_typ = Q_Set;
	    set_parser_setno(target_set.gno, target_set.setno);
	}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 2183 "pars.yacc"
    {
	  curtype = SET_XY; /* we use this although it is not a set */
	  cur_obj_typ = Q_Polyline;
        }
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 2187 "pars.yacc"
    { set_parser_gno((yyvsp[(2) - (2)].ival)); }
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 2188 "pars.yacc"
    { set_parser_setno((yyvsp[(2) - (2)].trgt)->gno, (yyvsp[(2) - (2)].trgt)->setno); }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 2191 "pars.yacc"
    {
	    set_hotlink((yyvsp[(1) - (4)].trgt)->gno, (yyvsp[(1) - (4)].trgt)->setno, 1, (yyvsp[(4) - (4)].sval), (yyvsp[(3) - (4)].ival));
	    xfree((yyvsp[(4) - (4)].sval));
	}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 2195 "pars.yacc"
    {
	    set_hotlink((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival), NULL, 0);
	}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 2199 "pars.yacc"
    { g[gn].l.active  = (yyvsp[(2) - (2)].ival); }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 2200 "pars.yacc"
    { set_legend_layer (gn ,(yyvsp[(3) - (3)].ival)); }
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 2201 "pars.yacc"
    { g[gn].l.loctype = (yyvsp[(3) - (3)].ival); }
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 2202 "pars.yacc"
    { g[gn].l.vgap    = (yyvsp[(3) - (3)].ival); }
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 2203 "pars.yacc"
    { g[gn].l.hgap    = (yyvsp[(3) - (3)].ival); }
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 2204 "pars.yacc"
    { g[gn].l.len     = (yyvsp[(3) - (3)].ival); }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 2205 "pars.yacc"
    { g[gn].l.invert  = (yyvsp[(3) - (3)].ival); }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 2206 "pars.yacc"
    { g[gn].l.boxfillpen.color   = (yyvsp[(4) - (4)].ival); }
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 2207 "pars.yacc"
    { g[gn].l.boxfillpen.pattern = (yyvsp[(4) - (4)].ival); }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 2208 "pars.yacc"
    { g[gn].l.boxpen.color   = (yyvsp[(3) - (3)].ival); }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 2209 "pars.yacc"
    { g[gn].l.boxpen.pattern = (yyvsp[(3) - (3)].ival); }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 2210 "pars.yacc"
    { g[gn].l.boxlines       = (yyvsp[(3) - (3)].ival); }
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 2211 "pars.yacc"
    { g[gn].l.boxlinew       = (yyvsp[(3) - (3)].dval); }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 2212 "pars.yacc"
    { g[gn].l.legx = (yyvsp[(2) - (4)].dval);
                                               g[gn].l.legy = (yyvsp[(4) - (4)].dval);
	}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 2215 "pars.yacc"
    { g[gn].l.charsize    = (yyvsp[(4) - (4)].dval); }
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 2216 "pars.yacc"
    { g[gn].l.font        = (yyvsp[(2) - (2)].ival); }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 2217 "pars.yacc"
    { g[gn].l.color       = (yyvsp[(2) - (2)].ival); }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 2222 "pars.yacc"
    { objs[iTS].hidden   = (yyvsp[(3) - (3)].ival); }
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 2223 "pars.yacc"
    { objs[iTS].x1 = (yyvsp[(3) - (5)].dval);
	    		        	    objs[iTS].y1 = (yyvsp[(5) - (5)].dval);      }
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 2225 "pars.yacc"
    { objs[iTS].hidden   	= ((yyvsp[(2) - (2)].ival) == TRUE) ? 0 : 1; }
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 2226 "pars.yacc"
    { objs[iTS].layer     	= (yyvsp[(3) - (3)].ival); }
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 2227 "pars.yacc"
    { objs[iTS].font     	= (yyvsp[(2) - (2)].ival); }
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 2228 "pars.yacc"
    { objs[iTS].just     	= (yyvsp[(3) - (3)].ival); }
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 2229 "pars.yacc"
    { objs[iTS].charsize 	= (yyvsp[(4) - (4)].dval); }
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 2230 "pars.yacc"
    { objs[iTS].rot      	= (yyvsp[(3) - (3)].ival); }
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 2231 "pars.yacc"
    { objs[iTS].color    	= (yyvsp[(2) - (2)].ival); }
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 2232 "pars.yacc"
    { objs[iTS].lines    	= (yyvsp[(2) - (2)].ival); }
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 2233 "pars.yacc"
    { objs[iTS].fillpattern = (yyvsp[(3) - (3)].ival); }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 2234 "pars.yacc"
    { objs[iTS].fillcolor   = (yyvsp[(3) - (3)].ival); }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 2235 "pars.yacc"
    { objs[iTS].x1 = (yyvsp[(2) - (4)].dval);
	    		   	    	  objs[iTS].y1 = (yyvsp[(4) - (4)].dval); }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 2237 "pars.yacc"
    { set_plotstr_string (&objs[iTS], (yyvsp[(3) - (3)].sval)); xfree((yyvsp[(3) - (3)].sval)); }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 2240 "pars.yacc"
    { grdefaults.lines    	= (yyvsp[(2) - (2)].ival); }
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 2241 "pars.yacc"
    { grdefaults.linew    	= (yyvsp[(2) - (2)].dval); }
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 2242 "pars.yacc"
    { grdefaults.color    	= (yyvsp[(2) - (2)].ival); }
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 2243 "pars.yacc"
    { grdefaults.pattern  	= (yyvsp[(2) - (2)].ival); }
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 2244 "pars.yacc"
    { grdefaults.charsize 	= (yyvsp[(4) - (4)].dval); string_size = (yyvsp[(4) - (4)].dval); }
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 2245 "pars.yacc"
    { grdefaults.font     	= (yyvsp[(2) - (2)].ival); string_font = (yyvsp[(2) - (2)].ival); }
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 2246 "pars.yacc"
    { grdefaults.symsize = (yyvsp[(4) - (4)].dval); }
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 2247 "pars.yacc"
    { strcpy(sformat, (yyvsp[(3) - (3)].sval)); xfree((yyvsp[(3) - (3)].sval));  }
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 2248 "pars.yacc"
    {
            			   if ((map_font_by_name((yyvsp[(5) - (7)].sval), (yyvsp[(3) - (7)].ival)) != RETURN_SUCCESS) && 
            			       (map_font_by_name((yyvsp[(7) - (7)].sval), (yyvsp[(3) - (7)].ival)) != RETURN_SUCCESS)) {
            			       errmsg("Failed mapping a font");
            			   }
            			   xfree((yyvsp[(5) - (7)].sval));
            			   xfree((yyvsp[(7) - (7)].sval));
        }
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 2256 "pars.yacc"
    {
	    CMap_entry cmap;
            cmap.rgb.red   = (yyvsp[(6) - (13)].ival);
            cmap.rgb.green = (yyvsp[(8) - (13)].ival);
            cmap.rgb.blue  = (yyvsp[(10) - (13)].ival);
            cmap.ctype = COLOR_MAIN;
            cmap.cname = (yyvsp[(13) - (13)].sval);
            if (store_color((yyvsp[(3) - (13)].ival), cmap) == RETURN_FAILURE) {
                errmsg("Failed mapping a color");
            }
	    xfree((yyvsp[(13) - (13)].sval));
        }
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 2269 "pars.yacc"
    {
			   if (bad_gno ()) return 1;
	    g[gn].w.xg1 = (yyvsp[(2) - (8)].dval);
	    g[gn].w.yg1 = (yyvsp[(4) - (8)].dval);
	    g[gn].w.xg2 = (yyvsp[(6) - (8)].dval);
	    g[gn].w.yg2 = (yyvsp[(8) - (8)].dval);
	}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 2276 "pars.yacc"
    {
	    set_graph_znorm(gn, (yyvsp[(2) - (2)].dval));
	}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 2279 "pars.yacc"
    {
			   if (bad_gno ()) return 1;
	    g[gn].v.xv1 = (yyvsp[(2) - (8)].dval);
	    g[gn].v.yv1 = (yyvsp[(4) - (8)].dval);
	    g[gn].v.xv2 = (yyvsp[(6) - (8)].dval);
	    g[gn].v.yv2 = (yyvsp[(8) - (8)].dval);
        }
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 2287 "pars.yacc"
    { if (bad_gno ()) return 1; set_plotstr_string (&g[gn].labs.title, (yyvsp[(2) - (2)].sval)); xfree((yyvsp[(2) - (2)].sval)); }
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 2288 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.title.layer     = (yyvsp[(3) - (3)].ival); }
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 2289 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.title.font      = (yyvsp[(2) - (2)].ival); }
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 2290 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.title.charsize  = (yyvsp[(3) - (3)].dval); }
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 2291 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.title.color     = (yyvsp[(2) - (2)].ival); }
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 2292 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.title.just   = (yyvsp[(3) - (3)].ival); }
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 2293 "pars.yacc"
    {
  	                        if (bad_gno ()) return 1; g[gn].labs.title.x1     = (yyvsp[(3) - (5)].dval);
                                                    g[gn].labs.title.y1     = (yyvsp[(5) - (5)].dval); }
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 2296 "pars.yacc"
    { if (bad_gno ()) return 1; set_plotstr_string (&g[gn].labs.stitle, (yyvsp[(2) - (2)].sval)); xfree((yyvsp[(2) - (2)].sval)); }
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 2297 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.stitle.layer    = (yyvsp[(3) - (3)].ival); }
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 2298 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.stitle.font     = (yyvsp[(2) - (2)].ival); }
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 2299 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.stitle.charsize = (yyvsp[(3) - (3)].dval); }
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2300 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.stitle.color    = (yyvsp[(2) - (2)].ival); }
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2301 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].labs.stitle.just   = (yyvsp[(3) - (3)].ival); }
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2302 "pars.yacc"
    {
  	                          if (bad_gno ()) return 1; g[gn].labs.stitle.x1     = (yyvsp[(3) - (5)].dval);
                            	  if (bad_gno ()) return 1; g[gn].labs.stitle.y1     = (yyvsp[(5) - (5)].dval); }
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2305 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].xscale  	       	= (yyvsp[(3) - (3)].ival); }
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2306 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].yscale  	       	= (yyvsp[(3) - (3)].ival); }
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2307 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].xinvert 	       	= (yyvsp[(3) - (3)].ival); }
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2308 "pars.yacc"
    { if (bad_gno ()) return 1; g[gn].yinvert 	       	= (yyvsp[(3) - (3)].ival); }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2309 "pars.yacc"
    { autoscale_onread = AUTOSCALE_NONE; }
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2310 "pars.yacc"
    { autoscale_onread = AUTOSCALE_X;    }
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2311 "pars.yacc"
    { autoscale_onread = AUTOSCALE_Y;    }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2312 "pars.yacc"
    { autoscale_onread = AUTOSCALE_XY;   }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2313 "pars.yacc"
    {
            char *s;
            s = copy_string(NULL, get_project_description());
            s = concat_strings(s, (yyvsp[(2) - (2)].sval));
	    xfree((yyvsp[(2) - (2)].sval));
            s = concat_strings(s, "\n");
            set_project_description(s);
            xfree(s);
	}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2322 "pars.yacc"
    { set_project_description(NULL); }
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2324 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.active      	   = (yyvsp[(2) - (2)].ival); }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2325 "pars.yacc"
    { if (bad_gno ())  return 1;        set_legend_layer (gn ,(yyvsp[(3) - (3)].ival)); }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2326 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.loctype     	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2327 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.vgap        	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2328 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.hgap        	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2329 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.len         	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2330 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.invert      	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2331 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxfillpen.color   = (yyvsp[(4) - (4)].ival); }
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2332 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxfillpen.pattern = (yyvsp[(4) - (4)].ival); }
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2333 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxpen.color       = (yyvsp[(3) - (3)].ival); }
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2334 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxpen.pattern     = (yyvsp[(3) - (3)].ival); }
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2335 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxlines           = (yyvsp[(3) - (3)].ival); }
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2336 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.boxlinew           = (yyvsp[(3) - (3)].dval); }
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2337 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.legx               = (yyvsp[(2) - (4)].dval);
                                                                g[gn].l.legy               = (yyvsp[(4) - (4)].dval); }
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2339 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.charsize           = (yyvsp[(4) - (4)].dval); }
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2340 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.font               = (yyvsp[(2) - (2)].ival); }
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2341 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].l.color              = (yyvsp[(2) - (2)].ival); }
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2343 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.pen.pattern        = (yyvsp[(2) - (2)].ival); }
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2344 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.layer        	   = (yyvsp[(3) - (3)].ival); }
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2345 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.type               = (yyvsp[(3) - (3)].ival); }
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2346 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.lines              = (yyvsp[(2) - (2)].ival); }
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2347 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.linew              = (yyvsp[(2) - (2)].dval); }
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2348 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.pen.color          = (yyvsp[(2) - (2)].ival); }
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2349 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.pen.pattern        = (yyvsp[(2) - (2)].ival); }
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2350 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.fillpen.color      = (yyvsp[(3) - (3)].ival); }
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2351 "pars.yacc"
    { if (bad_gno ())  return 1; g[gn].f.fillpen.pattern  = (yyvsp[(3) - (3)].ival); }
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2355 "pars.yacc"
    { set_graph_hidden  ((yyvsp[(1) - (2)].ival), !(yyvsp[(2) - (2)].ival)); }
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2356 "pars.yacc"
    { set_graph_hidden  ((yyvsp[(1) - (3)].ival), (yyvsp[(3) - (3)].ival)); }
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2357 "pars.yacc"
    { set_graph_type    ((yyvsp[(1) - (3)].ival), (yyvsp[(3) - (3)].ival)); }
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2358 "pars.yacc"
    { set_graph_stacked ((yyvsp[(1) - (3)].ival), (yyvsp[(3) - (3)].ival)); }
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2359 "pars.yacc"
    { set_graph_bargap  ((yyvsp[(1) - (4)].ival), (yyvsp[(4) - (4)].dval)); }
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2360 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].locator.pointset = (yyvsp[(3) - (3)].ival); }
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2361 "pars.yacc"
    { g[(yyvsp[(1) - (4)].ival)].locator.pt_type = (yyvsp[(4) - (4)].ival); }
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2362 "pars.yacc"
    {
                                        g[(yyvsp[(1) - (5)].ival)].locator.fx = (yyvsp[(4) - (5)].ival);
                                        g[(yyvsp[(1) - (5)].ival)].locator.fy = (yyvsp[(5) - (5)].ival); }
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2365 "pars.yacc"
    {
                                        g[(yyvsp[(1) - (6)].ival)].locator.px = (yyvsp[(4) - (6)].dval);
                                        g[(yyvsp[(1) - (6)].ival)].locator.py = (yyvsp[(6) - (6)].dval); }
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2368 "pars.yacc"
    {
                                        g[(yyvsp[(1) - (6)].ival)].locator.dsx = (yyvsp[(4) - (6)].dval);
                                        g[(yyvsp[(1) - (6)].ival)].locator.dsy = (yyvsp[(6) - (6)].dval); }
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2372 "pars.yacc"
    { curtype = (yyvsp[(2) - (2)].ival);}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2375 "pars.yacc"
    {
      		     		    if (add_io_filter ((yyvsp[(2) - (5)].ival), (yyvsp[(4) - (5)].ival), (yyvsp[(5) - (5)].sval), (yyvsp[(3) - (5)].sval)) != 0) {
      		     		      yyerror("Failed adding i/o filter");
      		     		    }
      		     		    xfree ((yyvsp[(3) - (5)].sval));
      		     		    xfree ((yyvsp[(5) - (5)].sval));
      		     		    }
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2382 "pars.yacc"
    { clear_io_filters((yyvsp[(2) - (2)].ival)); }
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2383 "pars.yacc"
    { cursource = (yyvsp[(2) - (2)].ival); }
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2384 "pars.yacc"
    { readxformat = (yyvsp[(2) - (2)].ival); }
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2385 "pars.yacc"
    { }
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2386 "pars.yacc"
    { nonl_prefs.load = (yyvsp[(3) - (3)].ival);}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2387 "pars.yacc"
    { nonl_parms[(yyvsp[(2) - (3)].ival)].constr = (yyvsp[(3) - (3)].ival); }
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2394 "pars.yacc"
    { curobjtyp = Q_Line; curpmask = MA_2_HANDLES; (yyval.ival) = Q_Line;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2395 "pars.yacc"
    { curobjtyp = Q_Box; 	curpmask = 0;            (yyval.ival) = Q_Box;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2396 "pars.yacc"
    { curobjtyp = Q_Arc; 	curpmask = MARC_Ellipse; (yyval.ival) = Q_Arc;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2397 "pars.yacc"
    { curobjtyp = Q_Arc;                           (yyval.ival) = Q_Arc;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2398 "pars.yacc"
    { curobjtyp = Q_String;                        (yyval.ival) = Q_String;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2399 "pars.yacc"
    { curobjtyp = Q_Polyline;                      (yyval.ival) = Q_Polyline;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2400 "pars.yacc"
    { curobjtyp = Q_Image;                      	 (yyval.ival) = Q_Image;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2404 "pars.yacc"
    {
        curid = (yyvsp[(2) - (2)].ival);
        if (obj_tid_is_valid (Q_Compound ,curid)) {
          jo = cur_obj_num = obj_geom_get_num (Q_Compound ,curid);
	  (yyval.qobj) = &objs[jo];
        } else {
	  char buf[32];
	  sprintf (buf ,"Compound %d not active" ,curid);
          yyerror(buf);
        }
      }
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2423 "pars.yacc"
    {
    if (!is_valid_gno ((yyvsp[(2) - (2)].ival))) {
      yyerror("No valid graph selected");
      return 1;
    }
    gn = (yyvsp[(2) - (2)].ival);
  }
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2432 "pars.yacc"
    { curid = -2; jo = cur_obj_num = obj_t_next ((yyvsp[(2) - (2)].ival) ,&curid ,(yyvsp[(2) - (2)].ival) ,-1); }
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2433 "pars.yacc"
    { if (obj_tid_is_valid (curobjtyp ,(yyvsp[(3) - (3)].ival)))  {
			      jo = cur_obj_num = obj_geom_get_num ((yyvsp[(2) - (3)].ival) ,(yyvsp[(3) - (3)].ival));
			      curid 	  = (yyvsp[(3) - (3)].ival);
             		     } else {
			       int id 	  = (yyvsp[(3) - (3)].ival);
                               jo = obj_t_next ((yyvsp[(2) - (3)].ival) ,&id ,(yyvsp[(2) - (3)].ival) ,-1);
			       if (jo < 0) {
				 yyerror ("error in  WITH objtyp nexpr");
				 jo = cur_obj_num;
			       } else {
				 cur_obj_num = jo;
				 curid       = (yyvsp[(3) - (3)].ival);
			       }
                             }
        }
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2450 "pars.yacc"
    { (yyval.qobj) = &objs[jo]; }
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2451 "pars.yacc"
    { if (obj_tid_is_valid (curobjtyp ,(yyvsp[(2) - (2)].ival)))  {
	    		  jo = cur_obj_num = obj_geom_get_num ((yyvsp[(1) - (2)].ival) ,(yyvsp[(2) - (2)].ival));
		       	  (yyval.qobj) = &objs[jo];
		       } else {
		       	  yyerror ("Object not active");
      	  	       }
	}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2464 "pars.yacc"
    { objs[jo].active = TRUE;  }
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2465 "pars.yacc"
    { if (obj_tid_is_valid (curobjtyp ,(yyvsp[(2) - (3)].ival)))  {
	    		    jo = cur_obj_num = obj_geom_get_num ((yyvsp[(1) - (3)].ival) ,(yyvsp[(2) - (3)].ival));
		       	    } else {
		       	    	  yyerror ("Object not active");
      	  	       	    }
       }
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2471 "pars.yacc"
    { char *fname;
	 		    objs[jo].active = TRUE;
			    objs[jo].s      = copy_string (objs[jo].s ,(yyvsp[(3) - (3)].sval));
			    switch (curobjtyp) {
			    case Q_Polyline:  curpmask = MA_N_HANDLES; break;
			    case Q_Line:      curpmask = MA_2_HANDLES; break;
			    case Q_Image:
			      fname = grace_path ((yyvsp[(3) - (3)].sval));
			      printf ("\npars.yacc: %s\n" ,fname);
			      set_image_filename (fname);
			      obj_image_read_file (jo);
			    }
			    xfree ((yyvsp[(3) - (3)].sval));
       }
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2485 "pars.yacc"
    { if (obj_tid_is_valid (curobjtyp ,(yyvsp[(2) - (4)].ival)))  {
      				     objs[jo].s      = copy_string (objs[jo].s ,(yyvsp[(4) - (4)].sval));
			             if (curobjtyp == Q_Polyline) curpmask = MA_N_HANDLES;
			             if (curobjtyp == Q_Line)	  curpmask = MA_2_HANDLES;
		       	   	   } else {
		       	   	     yyerror ("Object not active");
      	  	       	   	   }
			           xfree ((yyvsp[(4) - (4)].sval));
      }
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2494 "pars.yacc"
    { obj_geom_attach_to_graph (curobjtyp ,curid ,(yyvsp[(2) - (2)].ival) ,TRUE);  }
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2496 "pars.yacc"
    { if (obj_tid_is_valid (curobjtyp ,(yyvsp[(2) - (3)].ival)))  {
			      	       jo = cur_obj_num = obj_geom_get_num (curobjtyp ,(yyvsp[(2) - (3)].ival));
				       obj_geom_attach_to_graph (curobjtyp ,(yyvsp[(2) - (3)].ival) ,(yyvsp[(3) - (3)].ival) ,TRUE);
	                             } else {
		       	    	       yyerror ("Object not active");
      	  	       	             }
      }
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2504 "pars.yacc"
    {
 	     		    	        objs[jo].x1 = (yyvsp[(2) - (8)].dval);
 	     		    	        objs[jo].y1 = (yyvsp[(4) - (8)].dval);
 	     		    	        objs[jo].x2 = (yyvsp[(6) - (8)].dval);
 	     		    	        objs[jo].y2 = (yyvsp[(8) - (8)].dval);

       }
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2511 "pars.yacc"
    {
 	     		    	        objs[jo].x1 = (yyvsp[(2) - (4)].dval);
 	     		    	        objs[jo].y1 = (yyvsp[(4) - (4)].dval);
       }
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2515 "pars.yacc"
    {
 	     		    	        objs[jo].x1 = (yyvsp[(3) - (9)].dval);
 	     		    	        objs[jo].y1 = (yyvsp[(5) - (9)].dval);
 	     		    	        objs[jo].x2 = (yyvsp[(7) - (9)].dval);
 	     		    	        objs[jo].y2 = (yyvsp[(9) - (9)].dval);
       }
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2521 "pars.yacc"
    {	objs[jo].x1 = (yyvsp[(3) - (5)].dval);
 	     		    	        objs[jo].y1 = (yyvsp[(5) - (5)].dval);
       }
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2524 "pars.yacc"
    { if (cur_obj_typ == Q_String) {
 					   objs[jo].active     = (yyvsp[(2) - (2)].ival);
 					   objs[jo].hidden     = !(yyvsp[(2) - (2)].ival);
					} else {
					   objs[jo].hidden     = !(yyvsp[(2) - (2)].ival);
					}
       }
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2531 "pars.yacc"
    { objs[jo].layer        = (yyvsp[(3) - (3)].ival); }
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2532 "pars.yacc"
    { objs[jo].hidden       = (yyvsp[(3) - (3)].ival); }
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2533 "pars.yacc"
    { objs[jo].loctyp       = (yyvsp[(3) - (3)].ival); }
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2534 "pars.yacc"
    { objs[jo].lines        = (yyvsp[(2) - (2)].ival); }
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2535 "pars.yacc"
    { objs[jo].linew        = (yyvsp[(2) - (2)].dval); }
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2536 "pars.yacc"
    { objs[jo].color        = (yyvsp[(2) - (2)].ival); }
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2537 "pars.yacc"
    { objs[jo].fillcolor    = (yyvsp[(3) - (3)].ival); }
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2538 "pars.yacc"
    { objs[jo].fillpattern  = (yyvsp[(3) - (3)].ival); }
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2539 "pars.yacc"
    { objs[jo].arrow_end    = (yyvsp[(3) - (3)].ival); }
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2540 "pars.yacc"
    { objs[jo].arrow.length = (yyvsp[(4) - (4)].dval); }
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2541 "pars.yacc"
    { objs[jo].arrow.type   = (yyvsp[(4) - (4)].ival); }
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2542 "pars.yacc"
    { objs[jo].arrow.dL_ff  = (yyvsp[(4) - (6)].dval);
				    	     objs[jo].arrow.lL_ff  = (yyvsp[(6) - (6)].dval); }
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2544 "pars.yacc"
    { objs[jo].arrow.length  = 2.0*(yyvsp[(4) - (4)].dval); }
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2545 "pars.yacc"
    { if (curobjtyp == Q_Arc) {
 	  			   	       objs[jo].pmask = arc_pmask ((yyvsp[(3) - (3)].ival));
 	  			   	     } else {
 	  			   	       yyerror("selobj TYPE is valid only for ARCs");
 	  			   	     }
 	}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2551 "pars.yacc"
    { objs[jo].astart   = (yyvsp[(3) - (5)].ival); objs[jo].aend = (yyvsp[(5) - (5)].ival); }
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2552 "pars.yacc"
    { objs[jo].rot      = (yyvsp[(3) - (3)].ival); }
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2553 "pars.yacc"
    { objs[jo].font     = (yyvsp[(2) - (2)].ival); }
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2554 "pars.yacc"
    { objs[jo].just     = (yyvsp[(3) - (3)].ival); }
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2555 "pars.yacc"
    { objs[jo].charsize = (yyvsp[(4) - (4)].dval); }
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2556 "pars.yacc"
    { objs[jo].s        = copy_string (objs[jo].s , (yyvsp[(2) - (2)].sval)); }
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2558 "pars.yacc"
    { if (curobjtyp == Q_Polyline)  {
			       			   objs[jo].pmask = objs[jo].pmask | MA_SMOOTH;
			       			   objs[jo].xspline_s = (yyvsp[(4) - (7)].dval);
			       			   objs[jo].xspline_p = (yyvsp[(6) - (7)].dval);
                                                } else {
		       	       	       	           yyerror ("Only polylines use SPLINE");
                                                }
        }
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2566 "pars.yacc"
    { objs[jo].pmask     = objs[jo].pmask & ~MA_SMOOTH; }
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2567 "pars.yacc"
    { objs[jo].pmask     = objs[jo].pmask | MA_IS_CLOSED; printf ("\n pmask = %d \n" ,objs[jo].pmask); }
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2568 "pars.yacc"
    { objs[jo].pmask     = objs[jo].pmask & ~MA_IS_CLOSED; }
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2569 "pars.yacc"
    { objs[jo].label_opt = (yyvsp[(4) - (4)].ival); }
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2570 "pars.yacc"
    { objs[jo].frmt      = copy_string (objs[jo].frmt ,(yyvsp[(4) - (4)].sval)); xfree ((yyvsp[(4) - (4)].sval)); }
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2571 "pars.yacc"
    { objs[jo].perp	 = (yyvsp[(4) - (6)].dval); objs[jo].para = (yyvsp[(6) - (6)].dval); }
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2575 "pars.yacc"
    { int compound_id = -2;
	  		  	  	   int compound_num = obj_tid_next_compound (&compound_id ,objs[jo].father_typ ,objs[jo].father_id ,jo);
	  		  	  	   if (compound_num > 0) obj_make_current (compound_num);
	}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2579 "pars.yacc"
    { int compound_id = -2;
	    /*	  		  	  	   int compound_num    = obj_t_next_compound_orphaned (&compound_id ,cur_obj_num);*/
	  		  	  	   int compound_num = obj_tid_next_compound (&compound_id ,objs[jo].father_typ ,objs[jo].father_id ,jo);
	  		  	  	   if (compound_num > 0) {
					     obj_make_current (compound_num);
					     objs[compound_num].s = copy_string (objs[compound_num].s ,(yyvsp[(3) - (4)].sval));
					   }
	}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2587 "pars.yacc"
    { int compound_id = (yyvsp[(3) - (4)].ival);
	  		  	  	   int compound_num = obj_tid_next_compound (&compound_id ,objs[jo].father_typ ,objs[jo].father_id ,jo);
	  		  	  	   if (compound_num > 0) obj_make_current (compound_num);
	}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2591 "pars.yacc"
    { int compound_id = (yyvsp[(3) - (5)].ival);
	  		  	  	   int compound_num = obj_tid_next_compound (&compound_id ,objs[jo].father_typ ,objs[jo].father_id ,jo);
	  		  	  	   if (compound_num > 0) {
					     obj_make_current (compound_num);
					     objs[compound_num].s = copy_string (objs[compound_num].s ,(yyvsp[(4) - (5)].sval));
					   }
	}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2598 "pars.yacc"
    { obj_glue_add ((yyvsp[(2) - (3)].ival) ,cur_obj_num); }
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2599 "pars.yacc"
    { objs[cur_obj_num].hidden = (yyvsp[(3) - (3)].ival); }
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2600 "pars.yacc"
    { objs[cur_obj_num].loctyp = (yyvsp[(3) - (3)].ival); }
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2601 "pars.yacc"
    { printf("thiscompound selectgraph A FAIRE\n"); }
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2602 "pars.yacc"
    {
	  			    	   objs[cur_obj_num].x1 = (yyvsp[(3) - (9)].dval);
	  			    	   objs[cur_obj_num].y1 = (yyvsp[(5) - (9)].dval);
	  			    	   objs[cur_obj_num].x2 = (yyvsp[(7) - (9)].dval);
	  			    	   objs[cur_obj_num].y2 = (yyvsp[(9) - (9)].dval);
	}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2608 "pars.yacc"
    { obj_break_compound (cur_obj_num); }
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2610 "pars.yacc"
    {
                                         int i ,id = -1;
					 set_image_filename ((yyvsp[(4) - (10)].sval));
					 i = obj_t_next (Q_Image ,&id ,Q_Image ,-1);
					 if  ((yyvsp[(6) - (10)].dval) == 1.0) {
					   objs[i].scaling_type = SCALE_ORIGINAL_SIZE;
					   objs[i].pmask = MA_NONE;
					   objs[i].x1 = objs[i].x2 = (yyvsp[(8) - (10)].dval);
					   objs[i].y1 = objs[i].y2 = (yyvsp[(10) - (10)].dval);
					 } else {
					   objs[i].scaling_type = SCALE_KEEP_ASPECT_RATIO;
					   objs[i].pmask = MA_ASPECT_RATIO;
					   objs[i].scale_factor = (yyvsp[(6) - (10)].dval);
					   objs[i].x1 = (yyvsp[(8) - (10)].dval);
					   objs[i].y1 = (yyvsp[(10) - (10)].dval);
					 }
					 if (obj_image_read_file (i) == RETURN_FAILURE) {
					   obj_geom_kill (Q_Image ,cur_obj_num);
					   yyerror("Failed");
					 }
					 gg_pixbuf_scale (i);
					 obj_make_current (i);
					 clear_image_filename ();
        }
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2634 "pars.yacc"
    {
                                         int i ,id = -1;
					 set_image_filename ((yyvsp[(4) - (12)].sval));
					 i = obj_t_next (Q_Image ,&id ,Q_Image ,-1);
					 objs[i].scaling_type = SCALE_FREE;
					 objs[i].pmask = MA_NONE;
					 objs[i].x1 = (yyvsp[(6) - (12)].dval);
					 objs[i].y1 = (yyvsp[(8) - (12)].dval);
					 objs[i].x2 = (yyvsp[(10) - (12)].dval);
					 objs[i].y2 = (yyvsp[(12) - (12)].dval);
					 if (obj_image_read_file (i) == RETURN_FAILURE) {
					   obj_geom_kill (Q_Image ,cur_obj_num);
					   yyerror("Failed");
					 }
					 obj_make_current (i);
					 clear_image_filename ();
        }
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2660 "pars.yacc"
    { drawgraph (); }
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2661 "pars.yacc"
    {
	 if (inwin) gg_update_all();
	 }
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2664 "pars.yacc"
    { set_workingdir ((yyvsp[(2) - (2)].sval)); xfree ((yyvsp[(2) - (2)].sval)); }
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2665 "pars.yacc"
    { echomsg ((yyvsp[(2) - (2)].sval)); 	    xfree ((yyvsp[(2) - (2)].sval)); }
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2666 "pars.yacc"
    {
	              char buf[32];
	              set_locale_num(TRUE);
	              sprintf (buf, "%g", (yyvsp[(2) - (2)].dval));
	              set_locale_num (FALSE);
	              echomsg (buf);
	}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2673 "pars.yacc"
    { close_input = copy_string (close_input, ""); }
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2674 "pars.yacc"
    { close_input = copy_string (close_input, (yyvsp[(2) - (2)].sval)); }
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2675 "pars.yacc"
    { if (fplog != NULL) fclose (fplog); fplog = NULL;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2676 "pars.yacc"
    { if (resfp != NULL) fclose (resfp); resfp = NULL; }
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2677 "pars.yacc"
    { exit(0); }
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2678 "pars.yacc"
    { exit((yyvsp[(3) - (4)].ival)); }
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2679 "pars.yacc"
    { if ( (fplog = fopen ((yyvsp[(4) - (4)].sval) ,"w")) != NULL) {
       				    printf ("LOG FILE %s  opened\n" ,(yyvsp[(4) - (4)].sval));
       				  } else {
	 			    printf ("Fails to open LOG FILE  %s\n" ,(yyvsp[(4) - (4)].sval));
       				  }
        }
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2685 "pars.yacc"
    {if ((resfp = grace_openw((yyvsp[(4) - (4)].sval))) == NULL) return 1;
        }
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2687 "pars.yacc"
    {
	                         if (!safe_mode) {
	                           do_hardcopy();
	                         } else {
	                           yyerror("File modifications are disabled in safe mode");
	                         }
	}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2694 "pars.yacc"
    { set_ptofile (FALSE); }
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2695 "pars.yacc"
    { set_ptofile (TRUE);
	                   strcpy (print_file, (yyvsp[(3) - (3)].sval));
	                   xfree ((yyvsp[(3) - (3)].sval));
	}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2699 "pars.yacc"
    {
	                  switch ((yyvsp[(2) - (2)].ival)) {
	                  case UP:    graph_scroll (GSCROLL_UP);    break;
	                  case DOWN:  graph_scroll (GSCROLL_DOWN);  break;
	                  case RIGHT: graph_scroll (GSCROLL_RIGHT); break;
	                  case LEFT:  graph_scroll (GSCROLL_LEFT);  break;
	                  case IN:    graph_zoom   (GZOOM_SHRINK);  break;
	                  case OUT:   graph_zoom   (GZOOM_EXPAND);  break;
	                  }
	}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2709 "pars.yacc"
    { if ((yyvsp[(2) - (2)].dval) > 0) msleep_wrap((unsigned int) (1000 * (yyvsp[(2) - (2)].dval))); }
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2711 "pars.yacc"
    {
#ifndef NONE_GUI
            if (inwin) {
                gg_HelpCB("doc/UsersGuide.html");
            }
#endif
	}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2718 "pars.yacc"
    {	    gotparams = TRUE;	    strcpy(paramfile, (yyvsp[(2) - (2)].sval));	    xfree((yyvsp[(2) - (2)].sval));	}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2719 "pars.yacc"
    {
	    if (!safe_mode) {
                FILE *pp = grace_openw((yyvsp[(2) - (2)].sval));
	        if (pp != NULL) {
	            putparms(gn, pp, 0);
	            grace_close(pp);
	        }
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
            xfree((yyvsp[(2) - (2)].sval));
        }
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2733 "pars.yacc"
    { set_set_hidden ((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival)); }
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2734 "pars.yacc"
    { setlength 	  ((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival)); }
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2735 "pars.yacc"
    { realloc_vrbl   ((yyvsp[(1) - (3)].vrbl), (yyvsp[(3) - (3)].ival)); }
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2736 "pars.yacc"
    { add_point 	  ((yyvsp[(1) - (5)].trgt)->gno, (yyvsp[(1) - (5)].trgt)->setno, (yyvsp[(3) - (5)].dval), (yyvsp[(5) - (5)].dval)); }
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2737 "pars.yacc"
    {
	  Datapoint dpoint;
	  int typ = dataset_type ((yyvsp[(1) - (7)].trgt)->gno ,(yyvsp[(1) - (7)].trgt)->setno);
	  if (typ >= 0) {
	    if (settype_cols (typ) != 2) {
	      yyerror("Try to insert a point in a set with more than 2 columns");
	    }
	    dpoint.ex[0] = (yyvsp[(3) - (7)].dval);
	    dpoint.ex[1] = (yyvsp[(5) - (7)].dval);
	    dpoint.s 	 = NULL;
	    if (add_point_at ((yyvsp[(1) - (7)].trgt)->gno ,(yyvsp[(1) - (7)].trgt)->setno ,(yyvsp[(7) - (7)].ival) ,&dpoint) == RETURN_FAILURE) {
	      yyerror("When inserting  a point to a set");
	    }
	  } else {
	    yyerror("Unknown dataset type");
	  }
        }
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2754 "pars.yacc"
    { int start = (yyvsp[(3) - (5)].ival) - index_shift;
            				   int stop = (yyvsp[(5) - (5)].ival) - index_shift;
            				   droppoints 	  ((yyvsp[(1) - (5)].trgt)->gno, (yyvsp[(1) - (5)].trgt)->setno, start, stop); }
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2757 "pars.yacc"
    { if (is_set_active ((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno)) {
                			   sortset 	  ((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, (yyvsp[(3) - (4)].ival), (yyvsp[(4) - (4)].ival) == ASCENDING ? 0 : 1);
                                           }
        }
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2761 "pars.yacc"
    { do_copyset ((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, (yyvsp[(4) - (4)].trgt)->gno, (yyvsp[(4) - (4)].trgt)->setno); }
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2762 "pars.yacc"
    {
            if ((yyvsp[(2) - (4)].trgt)->gno != (yyvsp[(4) - (4)].trgt)->gno) {
                errmsg ("Can't append sets from different graphs");
            } else {
                int sets[2];
                sets[0] = (yyvsp[(4) - (4)].trgt)->setno;
                sets[1] = (yyvsp[(2) - (4)].trgt)->setno;
                join_sets ((yyvsp[(2) - (4)].trgt)->gno, sets, 2);
            }
        }
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2772 "pars.yacc"
    { reverse_set  ((yyvsp[(2) - (2)].trgt)->gno, (yyvsp[(2) - (2)].trgt)->setno); }
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2773 "pars.yacc"
    { do_splitsets ((yyvsp[(2) - (3)].trgt)->gno, (yyvsp[(2) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival)); }
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2774 "pars.yacc"
    { do_moveset   ((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, (yyvsp[(4) - (4)].trgt)->gno, (yyvsp[(4) - (4)].trgt)->setno); }
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2775 "pars.yacc"
    { do_swapset   ((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, (yyvsp[(4) - (4)].trgt)->gno, (yyvsp[(4) - (4)].trgt)->setno); }
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2776 "pars.yacc"
    { killset      ((yyvsp[(2) - (2)].trgt)->gno, (yyvsp[(2) - (2)].trgt)->setno); }
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2777 "pars.yacc"
    { killsetdata  ((yyvsp[(2) - (3)].trgt)->gno, (yyvsp[(2) - (3)].trgt)->setno); }
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2778 "pars.yacc"
    { kill_graph   ((yyvsp[(2) - (2)].ival)); }
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2779 "pars.yacc"
    { kill_region  ((yyvsp[(2) - (2)].ival)); }
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2780 "pars.yacc"
    { wipeout      (); }
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2781 "pars.yacc"
    {
            arrange_graphs_simple((yyvsp[(3) - (12)].ival), (yyvsp[(5) - (12)].ival), 0, FALSE, (yyvsp[(7) - (12)].dval), (yyvsp[(9) - (12)].dval), (yyvsp[(11) - (12)].dval));
        }
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2784 "pars.yacc"
    {
            int order = ((yyvsp[(13) - (18)].ival) * GA_ORDER_HV_INV) |
                        ((yyvsp[(15) - (18)].ival) * GA_ORDER_H_INV ) |
                        ((yyvsp[(17) - (18)].ival) * GA_ORDER_V_INV );
            arrange_graphs_simple((yyvsp[(3) - (18)].ival), (yyvsp[(5) - (18)].ival), order, FALSE, (yyvsp[(7) - (18)].dval), (yyvsp[(9) - (18)].dval), (yyvsp[(11) - (18)].dval));
        }
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2790 "pars.yacc"
    {
            int order = ((yyvsp[(13) - (20)].ival) * GA_ORDER_HV_INV) |
                        ((yyvsp[(15) - (20)].ival) * GA_ORDER_H_INV ) |
                        ((yyvsp[(17) - (20)].ival) * GA_ORDER_V_INV );
            arrange_graphs_simple((yyvsp[(3) - (20)].ival), (yyvsp[(5) - (20)].ival), order, (yyvsp[(19) - (20)].ival), (yyvsp[(7) - (20)].dval), (yyvsp[(9) - (20)].dval), (yyvsp[(11) - (20)].dval));
        }
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2796 "pars.yacc"
    {
	  do_prune ((yyvsp[(3) - (18)].trgt)->gno, (yyvsp[(3) - (18)].trgt)->setno ,(yyvsp[(5) - (18)].trgt)->gno, (yyvsp[(5) - (18)].trgt)->setno ,(yyvsp[(7) - (18)].ival) ,(yyvsp[(9) - (18)].ival) ,(yyvsp[(11) - (18)].dval) ,(yyvsp[(13) - (18)].dval) ,(yyvsp[(15) - (18)].ival) ,(yyvsp[(17) - (18)].ival));
	}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2799 "pars.yacc"
    {
	  int bar_setno;
	  double *warray;
	  if ((yyvsp[(17) - (18)].trgt)->gno != (yyvsp[(3) - (18)].trgt)->gno) {
	    errmsg("LOESS: source and destination graph must be the same");
	    return 1;
	  }
	  /* compute weigh array warray */
	  /* TODO add non uniform weights */
	  if (compute_weights ((yyvsp[(3) - (18)].trgt)->gno ,(yyvsp[(3) - (18)].trgt)->setno ,NL_WEIGHT_NONE ,NULL ,&warray) != RETURN_SUCCESS) {
	    return 1;
	  }
	  /*                                        fam deg span w      resid  conf  lev  len  dest      dest        bar */
	  nonlfit_loess_comand ((yyvsp[(3) - (18)].trgt)->gno ,(yyvsp[(3) - (18)].trgt)->setno ,(yyvsp[(5) - (18)].ival) ,(yyvsp[(7) - (18)].ival) ,(yyvsp[(9) - (18)].dval) ,warray ,FALSE ,(yyvsp[(11) - (18)].ival) ,(yyvsp[(13) - (18)].dval) ,(yyvsp[(15) - (18)].ival) ,(yyvsp[(17) - (18)].trgt)->gno ,(yyvsp[(17) - (18)].trgt)->setno ,&bar_setno);
        }
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2814 "pars.yacc"
    {
  	  nonl_opts.nsteps = (yyvsp[(5) - (6)].ival);
	  do_nonlfit ((yyvsp[(3) - (6)].trgt)->gno,(yyvsp[(3) - (6)].trgt)->setno ,NULL ,NULL ,(yyvsp[(3) - (6)].trgt)->gno);
        }
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2818 "pars.yacc"
    {
            if (getsetlength((yyvsp[(3) - (8)].trgt)->gno, (yyvsp[(3) - (8)].trgt)->setno) != (yyvsp[(5) - (8)].vrbl)->length) {
                errmsg("Data and weight arrays are of different lengths");
                return 1;
            } else {
	      nonl_opts.nsteps = (yyvsp[(7) - (8)].ival);
	      nlfit_warray = copy_data_column ((yyvsp[(5) - (8)].vrbl)->data, (yyvsp[(5) - (8)].vrbl)->length);

	      do_nonlfit ((yyvsp[(3) - (8)].trgt)->gno,(yyvsp[(3) - (8)].trgt)->setno ,nlfit_warray ,NULL ,(yyvsp[(3) - (8)].trgt)->gno);
            }
        }
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2829 "pars.yacc"
    {
	  int i;
  	  nonl_opts.parnum  = (yyvsp[(5) - (12)].vrbl)->length;
	  for (i = 0; i < nonl_opts.parnum; i++) nonl_parms[i].value = (yyvsp[(5) - (12)].vrbl)->data[i];
  	  nonl_opts.formula  = copy_string (nonl_opts.formula ,(yyvsp[(9) - (12)].sval));
	  nonl_opts.nsteps   = (yyvsp[(7) - (12)].ival);
	  nonl_opts.trace_on = (yyvsp[(11) - (12)].ival);
	  gg_nonl_update ();
	  do_nonlfit ((yyvsp[(3) - (12)].trgt)->gno,(yyvsp[(3) - (12)].trgt)->setno ,NULL ,NULL ,(yyvsp[(3) - (12)].trgt)->gno);
        }
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2839 "pars.yacc"
    {
	  do_nonlfit ((yyvsp[(3) - (6)].trgt)->gno,(yyvsp[(3) - (6)].trgt)->setno ,NULL ,NULL ,(yyvsp[(5) - (6)].trgt)->gno);
	  nonlfit_compute_and_load ((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno ,(yyvsp[(5) - (6)].trgt)->gno, (yyvsp[(5) - (6)].trgt)->setno ,FALSE);
	  gg_nonl_update ();
        }
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2844 "pars.yacc"
    {
	  char *rarray;
	  if (get_restriction_array ((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(7) - (10)].ival) ,(yyvsp[(9) - (10)].ival) ,&rarray) == RETURN_SUCCESS) {
	    do_nonlfit ((yyvsp[(3) - (10)].trgt)->gno,(yyvsp[(3) - (10)].trgt)->setno ,NULL ,rarray ,(yyvsp[(5) - (10)].trgt)->gno);
	    nonlfit_compute_and_load ((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(5) - (10)].trgt)->gno, (yyvsp[(5) - (10)].trgt)->setno ,FALSE);
	  }
	  
        }
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2852 "pars.yacc"
    {
	  double *warray;
	  nonl_opts.wmethod = (yyvsp[(7) - (8)].ival);
	  if (compute_weights ((yyvsp[(3) - (8)].trgt)->gno ,(yyvsp[(3) - (8)].trgt)->setno ,nonl_opts.wmethod ,nonl_opts.wfunc ,&warray) != RETURN_SUCCESS) {
	    xfree (warray);
	    return 1;
	  } else {
	    do_nonlfit ((yyvsp[(3) - (8)].trgt)->gno,(yyvsp[(3) - (8)].trgt)->setno ,warray ,NULL ,(yyvsp[(5) - (8)].trgt)->gno);
	    nonlfit_compute_and_load ((yyvsp[(3) - (8)].trgt)->gno, (yyvsp[(3) - (8)].trgt)->setno ,(yyvsp[(5) - (8)].trgt)->gno, (yyvsp[(5) - (8)].trgt)->setno ,FALSE);
	    gg_nonl_update ();
	    xfree (warray);
	  }
        }
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2865 "pars.yacc"
    {
	  char *rarray;
	  double *warray;
	  if (get_restriction_array ((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(7) - (10)].ival) ,(yyvsp[(9) - (10)].ival) ,&rarray) == RETURN_SUCCESS) {
	    nonl_opts.wmethod = (yyvsp[(9) - (10)].ival);
	    if (compute_weights ((yyvsp[(3) - (10)].trgt)->gno ,(yyvsp[(3) - (10)].trgt)->setno ,nonl_opts.wmethod ,nonl_opts.wfunc ,&warray) != RETURN_SUCCESS) {
	      xfree (warray);
	      return 1;
	    } else {
	      do_nonlfit ((yyvsp[(3) - (10)].trgt)->gno,(yyvsp[(3) - (10)].trgt)->setno ,warray ,rarray ,(yyvsp[(5) - (10)].trgt)->gno);
	      nonlfit_compute_and_load ((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(5) - (10)].trgt)->gno, (yyvsp[(5) - (10)].trgt)->setno ,FALSE);
	      gg_nonl_update ();
	      xfree (warray);
	    }
	  }
        }
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2881 "pars.yacc"
    {
            do_regress((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno, (yyvsp[(5) - (6)].ival), 0, -1, 0, -1);
        }
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2884 "pars.yacc"
    {
            do_runavg((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno, (yyvsp[(5) - (6)].ival), (yyvsp[(1) - (6)].ival), -1, 0);
        }
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2887 "pars.yacc"
    {
          do_runavg12 ((yyvsp[(3) - (12)].trgt)->gno ,(yyvsp[(3) - (12)].trgt)->setno ,(yyvsp[(7) - (12)].trgt)->gno ,(yyvsp[(7) - (12)].trgt)->setno ,(yyvsp[(5) - (12)].ival) ,(yyvsp[(1) - (12)].ival) ,(yyvsp[(9) - (12)].ival) ,(yyvsp[(11) - (12)].ival));
        }
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2891 "pars.yacc"
    {
          do_fourier_command ((yyvsp[(3) - (6)].trgt)->gno ,(yyvsp[(3) - (6)].trgt)->setno ,(yyvsp[(1) - (6)].ival) ,(yyvsp[(5) - (6)].ival));
        }
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2895 "pars.yacc"
    {
          do_fourier_command_1 ((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno
                                ,(yyvsp[(1) - (12)].ival) ,(yyvsp[(9) - (12)].ival) ,(yyvsp[(5) - (12)].ival)
                                ,(yyvsp[(7) - (12)].ival)
                                ,(yyvsp[(11) - (12)].ival) ,-1 ,-1);
          }
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2902 "pars.yacc"
    {
          do_fourier_command_1 ((yyvsp[(3) - (16)].trgt)->gno, (yyvsp[(3) - (16)].trgt)->setno
                                ,(yyvsp[(1) - (16)].ival) ,(yyvsp[(9) - (16)].ival) ,(yyvsp[(5) - (16)].ival)
                                ,(yyvsp[(7) - (16)].ival)
                                ,(yyvsp[(11) - (16)].ival) ,(yyvsp[(13) - (16)].ival) ,(yyvsp[(15) - (16)].ival));
	  }
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2911 "pars.yacc"
    {
	  /*                13             15        17            19        21             23             25  */
	  FFTParams fou;
	  fou.invflag  	= (yyvsp[(1) - (26)].ival);
	  fou.output    = (yyvsp[(7) - (26)].ival);
	  fou.norm     	= (yyvsp[(9) - (26)].ival);
	  if ((yyvsp[(11) - (26)].ival)  >= 0) fou.insegmt  = (yyvsp[(11) - (26)].ival);
	  fou.complexin = ((yyvsp[(13) - (26)].ival) == 1) ? FFT_COMPLEX_IN_COL3 :FFT_COMPLEX_IN_NONE;
	  fou.set1_im   = -1;
	  fou.dcdump    = (yyvsp[(15) - (26)].ival);
	  fou.filter    = (yyvsp[(17) - (26)].ival);
	  fou.padding   = (yyvsp[(19) - (26)].dval);
	  fou.round2n   = (yyvsp[(21) - (26)].ival);
	  fou.xscale    = (yyvsp[(23) - (26)].ival);
	  if ((yyvsp[(25) - (26)].ival) >= 0) fou.outsegmt = (yyvsp[(25) - (26)].ival);
	  fourier_params_set (&fou);
	  do_fourier_command_2 ((yyvsp[(3) - (26)].trgt)->gno, (yyvsp[(3) - (26)].trgt)->setno ,(yyvsp[(5) - (26)].trgt)->gno, (yyvsp[(5) - (26)].trgt)->setno);
        }
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2932 "pars.yacc"
    {
	  /*                13             15        17            19        21             23             25  */
	  FFTParams fou;
	  fou.invflag  	= (yyvsp[(1) - (26)].ival);
	  fou.output    = (yyvsp[(7) - (26)].ival);
	  fou.norm     	= (yyvsp[(9) - (26)].ival);
	  if ((yyvsp[(11) - (26)].ival)  >= 0) fou.insegmt  = (yyvsp[(11) - (26)].ival);
	  fou.complexin = FFT_COMPLEX_IN_SET;
	  fou.set1_im   = (yyvsp[(13) - (26)].trgt)->setno;
	  fou.dcdump    = (yyvsp[(15) - (26)].ival);
	  fou.filter    = (yyvsp[(17) - (26)].ival);
	  fou.padding   = (yyvsp[(19) - (26)].dval);
	  fou.round2n   = (yyvsp[(21) - (26)].ival);
	  fou.xscale    = (yyvsp[(23) - (26)].ival);
	  if ((yyvsp[(25) - (26)].ival) >= 0) fou.outsegmt = (yyvsp[(25) - (26)].ival);
	  fourier_params_set (&fou);
	  do_fourier_command_2 ((yyvsp[(3) - (26)].trgt)->gno, (yyvsp[(3) - (26)].trgt)->setno ,(yyvsp[(5) - (26)].trgt)->gno, (yyvsp[(5) - (26)].trgt)->setno);
        }
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 2952 "pars.yacc"
    { 
	  do_wavelet_command ((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno ,(yyvsp[(5) - (12)].ival) ,(yyvsp[(7) - (12)].ival) ,(yyvsp[(9) - (12)].ival) ,(yyvsp[(11) - (12)].ival));
        }
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 2955 "pars.yacc"
    { 
	  do_wavelet_command_1 ((yyvsp[(3) - (14)].trgt)->gno, (yyvsp[(3) - (14)].trgt)->setno ,(yyvsp[(5) - (14)].ival) ,(yyvsp[(7) - (14)].ival) ,(yyvsp[(9) - (14)].ival) ,(yyvsp[(11) - (14)].ival) ,(yyvsp[(13) - (14)].trgt)->gno ,(yyvsp[(13) - (14)].trgt)->setno);
        }
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 2959 "pars.yacc"
    {
            	       do_interp((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno, get_cg(), SET_SELECT_NEXT,
				 (yyvsp[(5) - (10)].vrbl)->data, (yyvsp[(5) - (10)].vrbl)->length, (yyvsp[(7) - (10)].ival), (yyvsp[(9) - (10)].ival)
				 ,  /* Default for INTERP_XSPLINE xspline_s = */ -0.5);
        }
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 2964 "pars.yacc"
    {
            	       do_interp((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno, (yyvsp[(5) - (12)].trgt)->gno, (yyvsp[(5) - (12)].trgt)->setno, 
				 (yyvsp[(7) - (12)].vrbl)->data, (yyvsp[(7) - (12)].vrbl)->length, (yyvsp[(9) - (12)].ival), (yyvsp[(11) - (12)].ival)
				 ,  /* Default for INTERP_XSPLINE xspline_s = */ -0.5);
        }
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 2969 "pars.yacc"
    {
	               do_xyspline ((yyvsp[(3) - (10)].trgt)->gno ,(yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(5) - (10)].trgt)->gno ,(yyvsp[(5) - (10)].trgt)->setno ,(yyvsp[(7) - (10)].dval) ,(yyvsp[(9) - (10)].dval));
	}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 2972 "pars.yacc"
    {
            		do_histo((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno, get_cg(), SET_SELECT_NEXT,
				 (yyvsp[(5) - (10)].vrbl)->data, (yyvsp[(5) - (10)].vrbl)->length - 1, (yyvsp[(7) - (10)].ival), (yyvsp[(9) - (10)].ival));
	}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 2976 "pars.yacc"
    {
            		do_histo((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno, (yyvsp[(11) - (12)].trgt)->gno, (yyvsp[(11) - (12)].trgt)->setno,
				 (yyvsp[(5) - (12)].vrbl)->data, (yyvsp[(5) - (12)].vrbl)->length - 1, (yyvsp[(7) - (12)].ival), (yyvsp[(9) - (12)].ival));
	}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 2980 "pars.yacc"
    {
			int    nbins = getsetlength ((yyvsp[(5) - (12)].trgt)->gno ,(yyvsp[(5) - (12)].trgt)->setno) - 1;
	                double *bins = getcol ((yyvsp[(5) - (12)].trgt)->gno ,(yyvsp[(5) - (12)].trgt)->setno ,DATA_X);
            		do_histo((yyvsp[(3) - (12)].trgt)->gno ,(yyvsp[(3) - (12)].trgt)->setno ,(yyvsp[(11) - (12)].trgt)->gno ,(yyvsp[(11) - (12)].trgt)->setno ,bins ,nbins  ,(yyvsp[(7) - (12)].ival) ,(yyvsp[(9) - (12)].ival));
	}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 2985 "pars.yacc"
    {
	    		do_diff_command ((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno, (yyvsp[(5) - (6)].ival));
	}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 2988 "pars.yacc"
    {
	    		do_diff_command_1 ((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno, (yyvsp[(5) - (10)].ival) ,(yyvsp[(7) - (10)].ival) ,(yyvsp[(9) - (10)].ival));
	}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 2991 "pars.yacc"
    {
	    		do_diff_command_2 ((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno, (yyvsp[(5) - (12)].trgt)->gno, (yyvsp[(5) - (12)].trgt)->setno, (yyvsp[(7) - (12)].ival) ,(yyvsp[(9) - (12)].ival) ,(yyvsp[(11) - (12)].ival));
	}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 2994 "pars.yacc"
    {
	    		do_int((yyvsp[(3) - (4)].trgt)->gno, (yyvsp[(3) - (4)].trgt)->setno, 0);
	}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 2997 "pars.yacc"
    {
	  		do_integrate ((yyvsp[(3) - (6)].trgt)->gno ,(yyvsp[(3) - (6)].trgt)->setno ,(yyvsp[(5) - (6)].trgt)->gno ,(yyvsp[(5) - (6)].trgt)->setno);
	  }
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3000 "pars.yacc"
    {
	    		do_xcor((yyvsp[(3) - (10)].trgt)->gno, (yyvsp[(3) - (10)].trgt)->setno, (yyvsp[(5) - (10)].trgt)->gno, (yyvsp[(5) - (10)].trgt)->setno, (yyvsp[(7) - (10)].ival), (yyvsp[(9) - (10)].ival) ,-2 ,-1);
	}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3003 "pars.yacc"
    {
	    		do_xcor((yyvsp[(3) - (12)].trgt)->gno, (yyvsp[(3) - (12)].trgt)->setno, (yyvsp[(5) - (12)].trgt)->gno, (yyvsp[(5) - (12)].trgt)->setno, (yyvsp[(7) - (12)].ival), (yyvsp[(9) - (12)].ival) ,(yyvsp[(11) - (12)].trgt)->gno, (yyvsp[(11) - (12)].trgt)->setno);
	}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3006 "pars.yacc"
    {
	    		do_linearc((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno, (yyvsp[(5) - (6)].trgt)->gno, (yyvsp[(5) - (6)].trgt)->setno ,-1 ,-1);
	}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3009 "pars.yacc"
    {
	    		do_linearc ((yyvsp[(3) - (8)].trgt)->gno ,(yyvsp[(3) - (8)].trgt)->setno ,(yyvsp[(5) - (8)].trgt)->gno ,(yyvsp[(5) - (8)].trgt)->setno ,(yyvsp[(7) - (8)].trgt)->gno ,(yyvsp[(7) - (8)].trgt)->setno);
	}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3012 "pars.yacc"
    {
	  		GeomTransform geomtr;
			strncpy (geomtr.sorder ,(yyvsp[(7) - (22)].sval) ,4);
			geomtr.degrees = (yyvsp[(9) - (22)].dval); 
			geomtr.rotx    = (yyvsp[(11) - (22)].dval);
			geomtr.roty    = (yyvsp[(13) - (22)].dval);
			geomtr.transx  = (yyvsp[(15) - (22)].dval);
			geomtr.transy  = (yyvsp[(17) - (22)].dval);
			geomtr.scalex  = (yyvsp[(19) - (22)].dval);
			geomtr.scaley  = (yyvsp[(21) - (22)].dval);
	    		do_geom_transfo ((yyvsp[(3) - (22)].trgt)->gno ,(yyvsp[(3) - (22)].trgt)->setno ,(yyvsp[(5) - (22)].trgt)->gno ,(yyvsp[(5) - (22)].trgt)->setno ,&geomtr);
	}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3024 "pars.yacc"
    {
            int len = getsetlength((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno);
            if (len != (yyvsp[(5) - (6)].vrbl)->length) {
		errmsg("Filter expression is of a wrong length");
            } else {
                char *rarray;
                rarray = xmalloc(len*SIZEOF_CHAR);
                if (rarray) {
                    int i;
                    for (i = 0; i < len; i++) {
                        rarray[i] = CAST_DBL_TO_BOOL((yyvsp[(5) - (6)].vrbl)->data[i]);
                    }
                    filter_set((yyvsp[(3) - (6)].trgt)->gno, (yyvsp[(3) - (6)].trgt)->setno, rarray);
                    xfree(rarray);
                }
            }
	}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3041 "pars.yacc"
    {
            int rtype;
            char *rarray;

            rtype = RESTRICT_REG0 + (yyvsp[(5) - (8)].ival);

	    if (get_restriction_array((yyvsp[(3) - (8)].trgt)->gno, (yyvsp[(3) - (8)].trgt)->setno,
                rtype, (yyvsp[(7) - (8)].ival), &rarray) != RETURN_SUCCESS) {
                errmsg("Error in region evaluation");
                return 1;
	    } else {
                filter_set((yyvsp[(3) - (8)].trgt)->gno, (yyvsp[(3) - (8)].trgt)->setno, rarray);
                xfree(rarray);
            }
	}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3057 "pars.yacc"
    {
	do_sample ((yyvsp[(3) - (10)].trgt)->gno ,(yyvsp[(3) - (10)].trgt)->setno ,(yyvsp[(5) - (10)].trgt)->gno ,(yyvsp[(5) - (10)].trgt)->setno ,0 ,NULL ,(yyvsp[(7) - (10)].ival) ,(yyvsp[(9) - (10)].ival));
	}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3061 "pars.yacc"
    {
	do_sample ((yyvsp[(3) - (8)].trgt)->gno ,(yyvsp[(3) - (8)].trgt)->setno ,(yyvsp[(5) - (8)].trgt)->gno ,(yyvsp[(5) - (8)].trgt)->setno ,1 ,(yyvsp[(7) - (8)].sval) ,1 ,1);
	xfree ((yyvsp[(7) - (8)].sval));
	}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3066 "pars.yacc"
    {
	do_sample ((yyvsp[(3) - (8)].trgt)->gno ,(yyvsp[(3) - (8)].trgt)->setno ,(yyvsp[(5) - (8)].trgt)->gno ,(yyvsp[(5) - (8)].trgt)->setno ,(yyvsp[(7) - (8)].ival) ,NULL ,1 ,1);
	}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3069 "pars.yacc"
    {
	    if (autoscale_graph (gn, AUTOSCALE_XY) != RETURN_SUCCESS) {
		errmsg ("Can't autoscale (no active sets?)");
	    }
	}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3074 "pars.yacc"
    {
	    if (autoscale_graph (gn, AUTOSCALE_X) != RETURN_SUCCESS) {
		errmsg ("Can't autoscale (no active sets?)");
	    }
	}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3079 "pars.yacc"
    {
	    if (autoscale_graph (gn, AUTOSCALE_Y) != RETURN_SUCCESS) {
		errmsg ("Can't autoscale (no active sets?)");
	    }
	}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3084 "pars.yacc"
    { autoscale_byset ((yyvsp[(2) - (2)].trgt)->gno, (yyvsp[(2) - (2)].trgt)->setno, AUTOSCALE_XY); }
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3085 "pars.yacc"
    { autotick_axis (gn, ALL_AXES); }
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3086 "pars.yacc"
    {
	    int gno = (yyvsp[(2) - (2)].ival);
            if (is_graph_hidden (gno) == FALSE) {
                select_graph (gno);
            } else {
		errmsg ("Graph is not active");
            }
	}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3094 "pars.yacc"
    { gotread = TRUE; strcpy (readfile, (yyvsp[(2) - (2)].sval)); xfree ((yyvsp[(2) - (2)].sval)); }
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3095 "pars.yacc"
    { strcpy  (batchfile, (yyvsp[(3) - (3)].sval)); xfree ((yyvsp[(3) - (3)].sval)); }
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3096 "pars.yacc"
    { getdata (gn, (yyvsp[(3) - (3)].sval), SOURCE_DISK, LOAD_BLOCK); xfree ((yyvsp[(3) - (3)].sval)); }
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3097 "pars.yacc"
    { getdata (gn, (yyvsp[(4) - (4)].sval), (yyvsp[(3) - (4)].ival), LOAD_BLOCK); xfree ((yyvsp[(4) - (4)].sval)); 	}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3098 "pars.yacc"
    {
            int nc, *cols, scol;
            if (field_string_to_cols((yyvsp[(3) - (3)].sval), &nc, &cols, &scol) != RETURN_SUCCESS) {
                errmsg("Erroneous field specifications");
	        xfree((yyvsp[(3) - (3)].sval));
                return 1;
            } else {
	        xfree((yyvsp[(3) - (3)].sval));
	        create_set_fromblock(gn, NEW_SET,
                    (yyvsp[(2) - (3)].ival), nc, cols, scol, autoscale_onread);
                xfree(cols);
            }
	}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3111 "pars.yacc"
    {
	    set_blockdata(NULL);
	}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3114 "pars.yacc"
    { selxy_set ((yyvsp[(2) - (2)].sval));	}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3115 "pars.yacc"
    {
	  if ((yyvsp[(2) - (3)].ival) == SELXY) {
	    getdata (gn, (yyvsp[(3) - (3)].sval), SOURCE_DISK, LOAD_SELXY);
	  } else {
	    gotread = TRUE;
	    curtype = (yyvsp[(2) - (3)].ival);
	    strcpy(readfile, (yyvsp[(3) - (3)].sval));
	  }
	    xfree((yyvsp[(3) - (3)].sval));
	}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3125 "pars.yacc"
    {
	    gotread = TRUE;
	    strcpy(readfile, (yyvsp[(4) - (4)].sval));
	    curtype = (yyvsp[(2) - (4)].ival);
	    cursource = (yyvsp[(3) - (4)].ival);
	    xfree((yyvsp[(4) - (4)].sval));
	}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3132 "pars.yacc"
    {
	    getdata(gn, (yyvsp[(3) - (3)].sval), SOURCE_DISK, LOAD_NXY);
	    xfree((yyvsp[(3) - (3)].sval));
	}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3136 "pars.yacc"
    {
	    getdata(gn, (yyvsp[(4) - (4)].sval), (yyvsp[(3) - (4)].ival), LOAD_NXY);
	    xfree((yyvsp[(4) - (4)].sval));
	}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3140 "pars.yacc"
    {
	    if (!safe_mode) {
                outputset((yyvsp[(2) - (2)].trgt)->gno, (yyvsp[(2) - (2)].trgt)->setno, "stdout", NULL);
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
	}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3147 "pars.yacc"
    {
	    if (!safe_mode) {
	        outputset((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, "stdout", (yyvsp[(4) - (4)].sval));
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
	    xfree((yyvsp[(4) - (4)].sval));
	}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3155 "pars.yacc"
    {
	    if (!safe_mode) {
	        outputset((yyvsp[(2) - (4)].trgt)->gno, (yyvsp[(2) - (4)].trgt)->setno, (yyvsp[(4) - (4)].sval), NULL);
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
	    xfree((yyvsp[(4) - (4)].sval));
	}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3163 "pars.yacc"
    {
	    if (!safe_mode) {
	        outputset((yyvsp[(2) - (6)].trgt)->gno, (yyvsp[(2) - (6)].trgt)->setno, (yyvsp[(4) - (6)].sval), (yyvsp[(6) - (6)].sval));
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
	    xfree((yyvsp[(4) - (6)].sval));
	    xfree((yyvsp[(6) - (6)].sval));
	}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3172 "pars.yacc"
    {
            if (!safe_mode) {
                save_project((yyvsp[(2) - (2)].sval));
            } else {
                yyerror("File modifications are disabled in safe mode");
            }
            xfree((yyvsp[(2) - (2)].sval));
        }
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3180 "pars.yacc"
    { load_project      ((yyvsp[(2) - (2)].sval)); xfree ((yyvsp[(2) - (2)].sval)); }
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3181 "pars.yacc"
    { new_project 	     (NULL); }
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3182 "pars.yacc"
    { new_project 	     ((yyvsp[(3) - (3)].sval)); xfree ((yyvsp[(3) - (3)].sval)); }
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3183 "pars.yacc"
    { push_world 	     (); }
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3184 "pars.yacc"
    { pop_world 	     (); }
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3185 "pars.yacc"
    { cycle_world_stack (); }
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3186 "pars.yacc"
    { if ((yyvsp[(2) - (2)].ival) > 0) show_world_stack ((yyvsp[(2) - (2)].ival) - 1); }
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3187 "pars.yacc"
    { clear_world_stack (); }
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3188 "pars.yacc"
    { objs_t_clear      (curobjtyp); }
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3194 "pars.yacc"
    {
#ifndef NONE_GUI
            set_pagelayout((yyvsp[(3) - (3)].ival));
#endif
        }
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3199 "pars.yacc"
    { auto_redraw = (yyvsp[(3) - (3)].ival); }
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3200 "pars.yacc"
    { draw_focus_flag = (yyvsp[(2) - (2)].ival); }
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3201 "pars.yacc"
    { focus_policy = FOCUS_SET; }
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3202 "pars.yacc"
    { focus_policy = FOCUS_FOLLOWS; }
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3203 "pars.yacc"
    { focus_policy = FOCUS_CLICK; }
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3208 "pars.yacc"
    {}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3209 "pars.yacc"
    {}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3213 "pars.yacc"
    { set_set_hidden ((yyvsp[(1) - (2)].trgt)->gno, (yyvsp[(1) - (2)].trgt)->setno, !(yyvsp[(2) - (2)].ival)); }
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3214 "pars.yacc"
    { curtype = (yyvsp[(3) - (3)].ival);
					   	 set_dataset_type ((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno, (yyvsp[(3) - (3)].ival)); }
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3216 "pars.yacc"
    { curtype = SET_XYCMAP;
						  set_dataset_type ((yyvsp[(1) - (6)].trgt)->gno, (yyvsp[(1) - (6)].trgt)->setno, SET_XYCMAP);
	                                          set_xymap_nxy    ((yyvsp[(1) - (6)].trgt)->gno, (yyvsp[(1) - (6)].trgt)->setno, (yyvsp[(4) - (6)].ival) ,(yyvsp[(6) - (6)].ival));
	}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3220 "pars.yacc"
    { int num = obj_tid_get_set_num ((yyvsp[(1) - (3)].trgt)->gno, (yyvsp[(1) - (3)].trgt)->setno);
	                                                       objs[num].layer              = (yyvsp[(3) - (3)].ival); }
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3222 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].sym 	      	    = (yyvsp[(3) - (3)].ival); }
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3223 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].sympen.color 	    = (yyvsp[(3) - (3)].ival); }
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3224 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].sympen.pattern     = (yyvsp[(3) - (3)].ival); }
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3225 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].symlinew 	    = (yyvsp[(3) - (3)].dval); }
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3226 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].symlines 	    = (yyvsp[(3) - (3)].ival); }
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3227 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.color   = (yyvsp[(4) - (4)].ival); }
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3228 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.pattern = (yyvsp[(4) - (4)].ival); }
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3229 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symsize  	    = (yyvsp[(4) - (4)].dval); }
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3230 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symchar  	    = (yyvsp[(4) - (4)].ival); }
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3231 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].charfont 	    = (yyvsp[(4) - (4)].ival); }
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3232 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symskip  	    = (yyvsp[(4) - (4)].ival);
					     	 if (get_project_version () < 70000) {
					     	   g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.skip = (yyvsp[(4) - (4)].ival);
					     	   g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.start= 0;
					     	   }
	}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3238 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].linet    	    = (yyvsp[(4) - (4)].ival); }
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3239 "pars.yacc"
    {
	    				       	 g[(yyvsp[(1) - (8)].trgt)->gno].p[(yyvsp[(1) - (8)].trgt)->setno].linet   = (yyvsp[(4) - (8)].ival);
            				       	 g[(yyvsp[(1) - (8)].trgt)->gno].p[(yyvsp[(1) - (8)].trgt)->setno].method  = (yyvsp[(6) - (8)].ival);
            				       	 g[(yyvsp[(1) - (8)].trgt)->gno].p[(yyvsp[(1) - (8)].trgt)->setno].meshlen = (yyvsp[(8) - (8)].ival);
        }
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3244 "pars.yacc"
    {
	    				       	 g[(yyvsp[(1) - (10)].trgt)->gno].p[(yyvsp[(1) - (10)].trgt)->setno].linet   = (yyvsp[(4) - (10)].ival);
            				       	 g[(yyvsp[(1) - (10)].trgt)->gno].p[(yyvsp[(1) - (10)].trgt)->setno].method  = (yyvsp[(6) - (10)].ival);
            				       	 g[(yyvsp[(1) - (10)].trgt)->gno].p[(yyvsp[(1) - (10)].trgt)->setno].meshlen = (yyvsp[(8) - (10)].ival);
						 if ((yyvsp[(6) - (10)].ival) == INTERP_XYSPLINE || (yyvsp[(6) - (10)].ival) == INTERP_XSPLINE) {
						   QDobject *po = obj_tid_get_pointer (Q_Set ,(yyvsp[(1) - (10)].trgt)->setno ,(yyvsp[(1) - (10)].trgt)->gno);
						   if (po != NULL) po->xspline_s = (yyvsp[(10) - (10)].dval);
                                                 }
        }
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3253 "pars.yacc"
    {
	    				       	 g[(yyvsp[(1) - (12)].trgt)->gno].p[(yyvsp[(1) - (12)].trgt)->setno].linet   = (yyvsp[(4) - (12)].ival);
            				       	 g[(yyvsp[(1) - (12)].trgt)->gno].p[(yyvsp[(1) - (12)].trgt)->setno].method  = (yyvsp[(6) - (12)].ival);
            				       	 g[(yyvsp[(1) - (12)].trgt)->gno].p[(yyvsp[(1) - (12)].trgt)->setno].meshlen = (yyvsp[(8) - (12)].ival);
						 if ((yyvsp[(6) - (12)].ival) == INTERP_XYSPLINE || (yyvsp[(6) - (12)].ival) == INTERP_XSPLINE) {
						   QDobject *po = obj_tid_get_pointer (Q_Set ,(yyvsp[(1) - (12)].trgt)->setno ,(yyvsp[(1) - (12)].trgt)->gno);
						   if (po != NULL) {
						     po->xspline_s = (yyvsp[(10) - (12)].dval);
						     if ((yyvsp[(6) - (12)].ival) == INTERP_XYSPLINE) po->xspline_p = (yyvsp[(12) - (12)].dval);
                                                   }
                                                 }
        }
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3265 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].lines 	       = (yyvsp[(3) - (3)].ival); }
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3266 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].linew 	       = (yyvsp[(3) - (3)].dval); }
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3267 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].linepen.color   = (yyvsp[(3) - (3)].ival); }
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3268 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].linepen.pattern = (yyvsp[(3) - (3)].ival); }
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3270 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].filltype = (yyvsp[(4) - (4)].ival); }
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3271 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].fillrule = (yyvsp[(4) - (4)].ival); }
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3272 "pars.yacc"
    {
            int prop = (yyvsp[(3) - (3)].ival);

	    if (get_project_version() <= 40102 && get_project_version() >= 30000) {
                switch (filltype_obs) {
                case COLOR:
                    break;
                case PATTERN:
                    prop = 1;
                    break;
                default: /* NONE */
	            prop = 0;
                    break;
                }
	    }
	    g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].setfillpen.color = prop;
	}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3290 "pars.yacc"
    {
	    int prop = (yyvsp[(3) - (3)].ival);

	    if (get_project_version() <= 40102) {
                switch (filltype_obs) {
                case COLOR:
                    prop = 1;
                    break;
                case PATTERN:
                    break;
                default: /* NONE */
	            prop = 0;
                    break;
                }
	    }
	    g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].setfillpen.pattern = prop;
	}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3309 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].baseline = (yyvsp[(3) - (3)].ival);     }
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3310 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].baseline_type = (yyvsp[(4) - (4)].ival);   }
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3312 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].dropline 	    	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3313 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].avalue.active 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3314 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.type 	 = (yyvsp[(4) - (4)].ival); }
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3315 "pars.yacc"
    { g[(yyvsp[(1) - (5)].trgt)->gno].p[(yyvsp[(1) - (5)].trgt)->setno].avalue.size 	 = (yyvsp[(5) - (5)].dval); }
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3316 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].avalue.font 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3317 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].avalue.color 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3318 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.angle 	 = (yyvsp[(4) - (4)].ival); }
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3319 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.format 	 = (yyvsp[(4) - (4)].ival); }
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3320 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.prec 	 = (yyvsp[(4) - (4)].ival); }
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3321 "pars.yacc"
    { g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].avalue.offset.x 	 = (yyvsp[(4) - (6)].dval);
           				       	      g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].avalue.offset.y 	 = (yyvsp[(6) - (6)].dval); }
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3323 "pars.yacc"
    { strcpy(g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.prestr, (yyvsp[(4) - (4)].sval)); xfree((yyvsp[(4) - (4)].sval)); }
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3324 "pars.yacc"
    { strcpy(g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.appstr, (yyvsp[(4) - (4)].sval)); xfree((yyvsp[(4) - (4)].sval)); }
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3325 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.skip      	 = (yyvsp[(4) - (4)].ival);
	 				       	      g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].avalue.start       = 0; }
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3327 "pars.yacc"
    { g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].avalue.skip      	 = (yyvsp[(4) - (6)].ival);
	 				       	      g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].avalue.start       = (yyvsp[(6) - (6)].ival); }
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3329 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.active 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3330 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.ptype 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3331 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.pen.color	 = (yyvsp[(3) - (3)].ival);
	                                             errbar_to_obj ((yyvsp[(1) - (3)].trgt)->gno ,(yyvsp[(1) - (3)].trgt)->setno ,&(g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar) ,file_project_version); }
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3333 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.pen.pattern = (yyvsp[(3) - (3)].ival); }
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3334 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].errbar.barsize 	 = (yyvsp[(4) - (4)].dval); }
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3335 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.linew 	 = (yyvsp[(3) - (3)].dval);
	                                             errbar_to_obj ((yyvsp[(1) - (3)].trgt)->gno ,(yyvsp[(1) - (3)].trgt)->setno ,&(g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar) ,file_project_version); }
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3337 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar.lines 	 = (yyvsp[(3) - (3)].ival);
	                                             errbar_to_obj ((yyvsp[(1) - (3)].trgt)->gno ,(yyvsp[(1) - (3)].trgt)->setno ,&(g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].errbar) ,file_project_version); }
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3339 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].errbar.riser_linew = (yyvsp[(4) - (4)].dval); }
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3340 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].errbar.riser_lines = (yyvsp[(4) - (4)].ival); }
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3341 "pars.yacc"
    { g[(yyvsp[(1) - (5)].trgt)->gno].p[(yyvsp[(1) - (5)].trgt)->setno].errbar.arrow_clip  = (yyvsp[(5) - (5)].ival); }
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3342 "pars.yacc"
    { g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].errbar.cliplen 	 = (yyvsp[(6) - (6)].dval); }
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3344 "pars.yacc"
    { objs[(yyvsp[(1) - (2)].ival)].color = (yyvsp[(2) - (2)].ival); }
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3345 "pars.yacc"
    { objs[(yyvsp[(1) - (2)].ival)].linew = (yyvsp[(2) - (2)].dval); }
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3346 "pars.yacc"
    { objs[(yyvsp[(1) - (2)].ival)].lines = (yyvsp[(2) - (2)].ival); }
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3347 "pars.yacc"
    { objs[(yyvsp[(1) - (4)].ival)].arrow.type = (yyvsp[(4) - (4)].ival); }
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3348 "pars.yacc"
    { objs[(yyvsp[(1) - (4)].ival)].arrow.length = (yyvsp[(4) - (4)].dval); }
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3349 "pars.yacc"
    { objs[(yyvsp[(1) - (6)].ival)].arrow.dL_ff  = (yyvsp[(4) - (6)].dval);
         			     		      objs[(yyvsp[(1) - (6)].ival)].arrow.lL_ff  = (yyvsp[(6) - (6)].dval); }
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3352 "pars.yacc"
    {
	 				  	     g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].contour.z_scaled = TRUE;
	 				  	     g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].contour.z1 = (yyvsp[(4) - (6)].dval);
	 				  	     g[(yyvsp[(1) - (6)].trgt)->gno].p[(yyvsp[(1) - (6)].trgt)->setno].contour.z2 = (yyvsp[(6) - (6)].dval);
         				  	    }
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3357 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].contour.nticks = (yyvsp[(4) - (4)].ival); }
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3358 "pars.yacc"
    {
 	     		    	        	      objs[jo].x1 = (yyvsp[(3) - (9)].dval);
 	     		    	        	      objs[jo].y1 = (yyvsp[(5) - (9)].dval);
 	     		    	        	      objs[jo].x2 = (yyvsp[(7) - (9)].dval);
 	     		    	        	      objs[jo].y2 = (yyvsp[(9) - (9)].dval);
                                                    }
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3364 "pars.yacc"
    {
						    if (obj_tid_is_valid (Q_Colorbar ,(yyvsp[(2) - (10)].ival)))  {
	    					       jo = cur_obj_num = obj_geom_get_num (Q_Colorbar ,(yyvsp[(2) - (10)].ival));
						       objs[jo].x1 = (yyvsp[(4) - (10)].dval);
						       objs[jo].y1 = (yyvsp[(6) - (10)].dval);
						       objs[jo].x2 = (yyvsp[(8) - (10)].dval);
						       objs[jo].y2 = (yyvsp[(10) - (10)].dval);
                                                       }
                                                    }
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3373 "pars.yacc"
    { zc_autoscale (jo); }
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3374 "pars.yacc"
    { objs[jo].layer        = (yyvsp[(3) - (3)].ival); }
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3375 "pars.yacc"
    { objs[jo].hidden       = (yyvsp[(3) - (3)].ival); }
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3376 "pars.yacc"
    { objs[jo].lines        = (yyvsp[(2) - (2)].ival); }
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3377 "pars.yacc"
    { objs[jo].linew        = (yyvsp[(2) - (2)].dval); }
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3378 "pars.yacc"
    { objs[jo].color        = (yyvsp[(2) - (2)].ival); }
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3379 "pars.yacc"
    { objs[jo].just         = (yyvsp[(3) - (3)].ival); }
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3380 "pars.yacc"
    { objs[jo].font         = (yyvsp[(2) - (2)].ival); }
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3381 "pars.yacc"
    { objs[jo].charsize     = (yyvsp[(4) - (4)].dval); }
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3383 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].contour.nmap = (yyvsp[(3) - (3)].ival); }
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3384 "pars.yacc"
    { int nmap = zc_cmap_get_by_name ((yyvsp[(3) - (3)].sval));
                                                      if (nmap >= 0) {
                                                        g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].contour.nmap = nmap;
						      }
						      xfree ((yyvsp[(3) - (3)].sval));
	                                            }
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3391 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].contour.hidden 	 = (yyvsp[(4) - (4)].ival); }
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3392 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].contour.line_color = (yyvsp[(3) - (3)].ival); }
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3393 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].linew              = (yyvsp[(3) - (3)].dval); }
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3394 "pars.yacc"
    { zc_label_new ((yyvsp[(1) - (8)].trgt)->gno ,(yyvsp[(1) - (8)].trgt)->setno ,(yyvsp[(4) - (8)].dval) ,(yyvsp[(6) - (8)].dval) ,(yyvsp[(8) - (8)].dval) ,0.0); }
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3397 "pars.yacc"
    { strncpy(g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].comments ,(yyvsp[(3) - (3)].sval), MAX_STRING_LENGTH - 1); xfree((yyvsp[(3) - (3)].sval)); }
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3398 "pars.yacc"
    { strncpy(g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].lstr     ,(yyvsp[(3) - (3)].sval), MAX_STRING_LENGTH - 1); xfree((yyvsp[(3) - (3)].sval)); }
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3399 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].legend_on = (yyvsp[(3) - (3)].ival); }
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3403 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->active = (yyvsp[(1) - (1)].ival);	}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3404 "pars.yacc"
    { if (bad_axis ()) return 1; int num = obj_tid_get_num (Q_Axis ,naxis ,Q_Graph ,gn);
                                                                   objs[num].layer        = (yyvsp[(2) - (2)].ival); }
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3406 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->zero   = (yyvsp[(3) - (3)].ival); }
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3407 "pars.yacc"
    {}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3408 "pars.yacc"
    {}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3409 "pars.yacc"
    {}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 3410 "pars.yacc"
    {}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 3411 "pars.yacc"
    {}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 3412 "pars.yacc"
    {}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 3413 "pars.yacc"
    {}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 3414 "pars.yacc"
    { if (bad_axis ()) return 1;
            			 g[gn].t[naxis]->offsx = (yyvsp[(2) - (4)].dval);
	    			 g[gn].t[naxis]->offsy = (yyvsp[(4) - (4)].dval);
        }
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 3421 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_flag 	      = (yyvsp[(1) - (1)].ival); }
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 3422 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tmajor 	      = (yyvsp[(2) - (2)].dval); }
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 3423 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->nminor 	      = (yyvsp[(3) - (3)].ival); }
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 3424 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_round 	      = (yyvsp[(3) - (3)].ival); }
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 3425 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->offsx 	      = (yyvsp[(2) - (2)].dval); }
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 3426 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->offsy 	      = (yyvsp[(2) - (2)].dval); }
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 3427 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_autonum       = (yyvsp[(2) - (2)].ival); }
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 3428 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_inout 	      = (yyvsp[(1) - (1)].ival); }
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 3429 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.size      = (yyvsp[(3) - (3)].dval); }
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 3430 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->mprops.size     = (yyvsp[(3) - (3)].dval); }
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 3431 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.color     = g[gn].t[naxis]->mprops.color = (yyvsp[(1) - (1)].ival); }
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 3432 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.color     = (yyvsp[(2) - (2)].ival); }
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 3433 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->mprops.color    = (yyvsp[(2) - (2)].ival); }
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 3434 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.linew     = g[gn].t[naxis]->mprops.linew = (yyvsp[(1) - (1)].dval); }
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 3435 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.linew     = (yyvsp[(2) - (2)].dval);        }
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 3436 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->mprops.linew    = (yyvsp[(2) - (2)].dval); }
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 3437 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.lines     = (yyvsp[(2) - (2)].ival); }
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 3438 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->mprops.lines    = (yyvsp[(2) - (2)].ival); }
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 3439 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.gridflag  = (yyvsp[(3) - (3)].ival); }
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 3440 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->mprops.gridflag = (yyvsp[(3) - (3)].ival); }
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 3441 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_op   	      = (yyvsp[(1) - (1)].ival); }
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 3442 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_spec 	      = (yyvsp[(3) - (3)].ival); }
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 3443 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->nticks 	      = (yyvsp[(2) - (2)].ival); }
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 3444 "pars.yacc"
    { if (bad_axis ()) return 1;
            						      g[gn].t[naxis]->tloc[(yyvsp[(2) - (4)].ival)].wtpos = (yyvsp[(4) - (4)].dval);
            						      g[gn].t[naxis]->tloc[(yyvsp[(2) - (4)].ival)].type = TICK_TYPE_MAJOR;
        }
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 3448 "pars.yacc"
    { if (bad_axis ()) return 1;
            						      g[gn].t[naxis]->tloc[(yyvsp[(2) - (4)].ival)].wtpos = (yyvsp[(4) - (4)].dval);
            						      g[gn].t[naxis]->tloc[(yyvsp[(2) - (4)].ival)].type = TICK_TYPE_MINOR;
        }
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 3455 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_flag   	= (yyvsp[(1) - (1)].ival); }
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 3456 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_prec   	= (yyvsp[(2) - (2)].ival); }
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 3457 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_format 	= (yyvsp[(2) - (2)].ival); }
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 3458 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_format 	= (yyvsp[(2) - (2)].dval); }
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 3459 "pars.yacc"
    { if (bad_axis ()) return 1; strncpy (g[gn].t[naxis]->tl_appstr, (yyvsp[(2) - (2)].sval) ,63); xfree((yyvsp[(2) - (2)].sval)); }
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 3460 "pars.yacc"
    { if (bad_axis ()) return 1; strncpy (g[gn].t[naxis]->tl_prestr, (yyvsp[(2) - (2)].sval) ,63); xfree((yyvsp[(2) - (2)].sval)); }
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 3461 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_angle  	= (yyvsp[(2) - (2)].ival); }
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 3462 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_skip   	= (yyvsp[(2) - (2)].ival); }
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 3463 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_staggered = (yyvsp[(2) - (2)].ival); }
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 3464 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_op     	= (yyvsp[(1) - (1)].ival); }
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 3465 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_formula =
            		        			     copy_string(g[gn].t[naxis]->tl_formula, (yyvsp[(2) - (2)].sval));
            		        			   xfree((yyvsp[(2) - (2)].sval));
	}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 3469 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_start     = (yyvsp[(2) - (2)].dval); }
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 3470 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_stop 	    = (yyvsp[(2) - (2)].dval); }
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 3471 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_starttype = TYPE_SPEC; }
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 3472 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_starttype = TYPE_AUTO; }
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 3473 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_stoptype  = TYPE_SPEC; }
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 3474 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_stoptype  = TYPE_AUTO; }
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 3475 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_charsize  = (yyvsp[(3) - (3)].dval); }
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 3476 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_font 	    = (yyvsp[(1) - (1)].ival); }
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 3477 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_color     = (yyvsp[(1) - (1)].ival); }
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 3478 "pars.yacc"
    { if (bad_axis ()) { xfree((yyvsp[(3) - (3)].sval)); return 1; }
	    		         if ((yyvsp[(1) - (3)].ival) >= MAX_TICKS) {
	    		              yyerror("Number of ticks exceeds maximum");
	    		              xfree((yyvsp[(3) - (3)].sval));
	    		              return 1;
	    		         }
	    		         g[gn].t[naxis]->tloc[(yyvsp[(1) - (3)].ival)].label =
            		             copy_string(g[gn].t[naxis]->tloc[(yyvsp[(1) - (3)].ival)].label, (yyvsp[(3) - (3)].sval));
	    		         xfree((yyvsp[(3) - (3)].sval));
	}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 3488 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_gaptype = TYPE_AUTO; }
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 3489 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_gaptype = TYPE_SPEC; }
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 3490 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_gap.x = (yyvsp[(2) - (4)].dval);
	    					 	    g[gn].t[naxis]->tl_gap.y = (yyvsp[(4) - (4)].dval); }
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 3495 "pars.yacc"
    { if (bad_axis ()) return 1; set_plotstr_string(&g[gn].t[naxis]->label, (yyvsp[(1) - (1)].sval)); xfree((yyvsp[(1) - (1)].sval)); }
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 3496 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label_layout   = LAYOUT_PERPENDICULAR; }
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 3497 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label_layout   = LAYOUT_PARALLEL; }
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 3498 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label_place    = TYPE_AUTO; }
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 3499 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label_place    = TYPE_SPEC; }
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 3500 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label.x1       = (yyvsp[(2) - (4)].dval);
	                                                   g[gn].t[naxis]->label.y1       = (yyvsp[(4) - (4)].dval); }
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 3502 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label.just     = (yyvsp[(2) - (2)].ival); }
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 3503 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label.charsize = (yyvsp[(3) - (3)].dval); }
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 3504 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label.font     = (yyvsp[(1) - (1)].ival); }
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 3505 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label.color    = (yyvsp[(1) - (1)].ival); }
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 3506 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->label_op       = (yyvsp[(1) - (1)].ival); }
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 3508 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_drawbar      = (yyvsp[(1) - (1)].ival); }
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 3509 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_drawbarcolor = (yyvsp[(1) - (1)].ival); }
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 3510 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_drawbarlines = (yyvsp[(1) - (1)].ival); }
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 3511 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_drawbarlinew = (yyvsp[(1) - (1)].dval); }
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 3514 "pars.yacc"
    { nonl_opts.title     = copy_string (nonl_opts.title   ,(yyvsp[(2) - (2)].sval));  xfree((yyvsp[(2) - (2)].sval));}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 3515 "pars.yacc"
    { nonl_opts.formula   = copy_string (nonl_opts.formula ,(yyvsp[(2) - (2)].sval));  xfree((yyvsp[(2) - (2)].sval));}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 3516 "pars.yacc"
    { nonl_opts.parnum    = (yyvsp[(2) - (3)].ival); }
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 3517 "pars.yacc"
    { nonl_opts.tolerance = (yyvsp[(2) - (2)].dval); }
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 3518 "pars.yacc"
    { nonl_opts.nsteps 	 = (yyvsp[(3) - (3)].ival); }
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 3519 "pars.yacc"
    { nonl_opts.trace_on	 = (yyvsp[(2) - (2)].ival); }
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 3520 "pars.yacc"
    { nonl_opts.wfunc   	 = copy_string (nonl_opts.wfunc ,(yyvsp[(3) - (3)].sval));  xfree((yyvsp[(3) - (3)].sval));}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 3523 "pars.yacc"
    {(yyval.ival) = NL_GAUSSIAN;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 3524 "pars.yacc"
    {(yyval.ival) = NL_SYMMETRIC;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 3527 "pars.yacc"
    {(yyval.ival) = NL_LOAD_VALUES;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 3528 "pars.yacc"
    {(yyval.ival) = NL_LOAD_RESIDUALS;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 3529 "pars.yacc"
    {(yyval.ival) = NL_LOAD_FUNCTION;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 3531 "pars.yacc"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 3532 "pars.yacc"
    { (yyval.ival) = (yyvsp[(2) - (2)].ival); }
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 3537 "pars.yacc"
    {
	    int gno = (yyvsp[(1) - (3)].ival), setno = (yyvsp[(3) - (3)].ival);
            if (allocate_set(gno, setno) == RETURN_SUCCESS) {
                (yyval.trgt) = &trgt_pool[tgtn];
                (yyval.trgt)->gno   = gno;
                (yyval.trgt)->setno = setno;
                tgtn++;
            } else {
                errmsg("Can't allocate referred set");
                return 1;
            }
	}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 3550 "pars.yacc"
    {
	    int gno = (yyvsp[(1) - (4)].ival), setno = (yyvsp[(4) - (4)].ival);
            if (allocate_set(gno, setno) == RETURN_SUCCESS) {
                (yyval.trgt) = &trgt_pool[tgtn];
                (yyval.trgt)->gno   = gno;
                (yyval.trgt)->setno = setno;
                tgtn++;
            } else {
                errmsg("Can't allocate referred set");
                return 1;
            }
	}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 3563 "pars.yacc"
    {
	    int gno = gn, setno = (yyvsp[(1) - (1)].ival);
            if (allocate_set(gno, setno) == RETURN_SUCCESS) {
                (yyval.trgt) = &trgt_pool[tgtn];
                (yyval.trgt)->gno   = gno;
                (yyval.trgt)->setno = setno;
                tgtn++;
            } else {
                errmsg("Can't allocate referred set");
                return 1;
            }
	}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 3576 "pars.yacc"
    {
	    int gno = gn, setno = (yyvsp[(2) - (2)].ival);
            if (allocate_set(gno, setno) == RETURN_SUCCESS) {
                (yyval.trgt) = &trgt_pool[tgtn];
                (yyval.trgt)->gno   = gno;
                (yyval.trgt)->setno = setno;
                tgtn++;
            } else {
                errmsg("Can't allocate referred set");
                return 1;
            }
	}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 3591 "pars.yacc"
    {}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 3592 "pars.yacc"
    {}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 3596 "pars.yacc"
    { naxis = X_AXIS; }
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 3597 "pars.yacc"
    { naxis = Y_AXIS; }
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 3598 "pars.yacc"
    { naxis = ZX_AXIS; }
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 3599 "pars.yacc"
    { naxis = ZY_AXIS; }
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 3603 "pars.yacc"
    { (yyval.ival) = CONSTANT;  }
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 3604 "pars.yacc"
    { (yyval.ival) = UCONSTANT; }
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 3605 "pars.yacc"
    { (yyval.ival) = FUNC_I;    }
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 3606 "pars.yacc"
    { (yyval.ival) = FUNC_D;    }
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 3607 "pars.yacc"
    { (yyval.ival) = FUNC_ND;   }
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 3608 "pars.yacc"
    { (yyval.ival) = FUNC_NN;   }
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 3609 "pars.yacc"
    { (yyval.ival) = FUNC_DD;   }
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 3610 "pars.yacc"
    { (yyval.ival) = FUNC_NND;  }
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 3611 "pars.yacc"
    { (yyval.ival) = FUNC_PPD;  }
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 3612 "pars.yacc"
    { (yyval.ival) = FUNC_PPPD; }
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 3613 "pars.yacc"
    { (yyval.ival) = FUNC_PPPPD; }
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 3614 "pars.yacc"
    { (yyval.ival) = FUNC_PPPPPD; }
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 3618 "pars.yacc"
    { (yyval.ival) = TICKS_SPEC_NONE; }
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 3619 "pars.yacc"
    { (yyval.ival) = TICKS_SPEC_MARKS; }
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 3620 "pars.yacc"
    { (yyval.ival) = TICKS_SPEC_BOTH; }
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 3624 "pars.yacc"
    { (yyval.ival) = FILTER_INPUT; }
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 3625 "pars.yacc"
    { (yyval.ival) = FILTER_OUTPUT; }
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 3629 "pars.yacc"
    { (yyval.ival) = FILTER_MAGIC; }
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 3630 "pars.yacc"
    { (yyval.ival) = FILTER_PATTERN; }
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 3633 "pars.yacc"
    { (yyval.ival) = SET_XY; }
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 3634 "pars.yacc"
    { (yyval.ival) = SELXY; }
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 3635 "pars.yacc"
    { (yyval.ival) = SET_BAR; }
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 3636 "pars.yacc"
    { (yyval.ival) = SET_BARDY; }
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 3637 "pars.yacc"
    { (yyval.ival) = SET_BARDYDY; }
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 3638 "pars.yacc"
    { (yyval.ival) = SET_XYZ; }
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 3639 "pars.yacc"
    { (yyval.ival) = SET_XYDX; }
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 3640 "pars.yacc"
    { (yyval.ival) = SET_XYDY; }
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 3641 "pars.yacc"
    { (yyval.ival) = SET_XYDXDX; }
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 3642 "pars.yacc"
    { (yyval.ival) = SET_XYDYDY; }
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 3643 "pars.yacc"
    { (yyval.ival) = SET_XYDXDY; }
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 3644 "pars.yacc"
    { (yyval.ival) = SET_XYDXDXDYDY; }
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 3645 "pars.yacc"
    { (yyval.ival) = SET_XYHILO; }
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 3646 "pars.yacc"
    { (yyval.ival) = SET_XYR; }
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 3647 "pars.yacc"
    { (yyval.ival) = SET_XYSIZE; }
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 3648 "pars.yacc"
    { (yyval.ival) = SET_XYCOLOR; }
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 3649 "pars.yacc"
    { (yyval.ival) = SET_XYCOLPAT; }
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 3650 "pars.yacc"
    { (yyval.ival) = SET_XYCMAP; }
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 3651 "pars.yacc"
    { (yyval.ival) = SET_XYVMAP; }
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 3652 "pars.yacc"
    { (yyval.ival) = SET_BOXPLOT; }
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 3653 "pars.yacc"
    { (yyval.ival) = SET_XY; }
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 3657 "pars.yacc"
    { (yyval.ival) = GRAPH_XY; }
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 3658 "pars.yacc"
    { (yyval.ival) = GRAPH_CHART; }
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 3659 "pars.yacc"
    { (yyval.ival) = GRAPH_POLAR; }
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 3660 "pars.yacc"
    { (yyval.ival) = GRAPH_SMITH; }
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 3661 "pars.yacc"
    { (yyval.ival) = GRAPH_FIXED; }
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 3662 "pars.yacc"
    { (yyval.ival) = GRAPH_PIE;   }
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 3666 "pars.yacc"
    { (yyval.ival) = PAGE_FREE; }
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 3667 "pars.yacc"
    { (yyval.ival) = PAGE_FIXED; }
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 3671 "pars.yacc"
    { (yyval.ival) = PAGE_ORIENT_LANDSCAPE; }
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 3672 "pars.yacc"
    { (yyval.ival) = PAGE_ORIENT_PORTRAIT;  }
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 3676 "pars.yacc"
    { (yyval.ival) = REGION_ABOVE; }
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 3677 "pars.yacc"
    { (yyval.ival) = REGION_BELOW; }
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 3678 "pars.yacc"
    { (yyval.ival) = REGION_TOLEFT; }
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 3679 "pars.yacc"
    { (yyval.ival) = REGION_TORIGHT; }
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 3680 "pars.yacc"
    { (yyval.ival) = REGION_POLYI; }
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 3681 "pars.yacc"
    { (yyval.ival) = REGION_POLYO; }
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 3682 "pars.yacc"
    { (yyval.ival) = REGION_HORIZI; }
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 3683 "pars.yacc"
    { (yyval.ival) = REGION_VERTI; }
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 3684 "pars.yacc"
    { (yyval.ival) = REGION_HORIZO; }
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 3685 "pars.yacc"
    { (yyval.ival) = REGION_VERTO; }
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 3688 "pars.yacc"
    { (yyval.ival) = SCALE_NORMAL; }
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 3689 "pars.yacc"
    { (yyval.ival) = SCALE_LOG; }
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 3690 "pars.yacc"
    { (yyval.ival) = SCALE_REC; }
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 3691 "pars.yacc"
    { (yyval.ival) = SCALE_LOGIT; }
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 3692 "pars.yacc"
    { (yyval.ival) = SCALE_DEGREES; }
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 3695 "pars.yacc"
    { (yyval.ival) = TRUE; }
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 3696 "pars.yacc"
    { (yyval.ival) = FALSE; }
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 3699 "pars.yacc"
    { (yyval.ival) = RUN_AVG; }
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 3700 "pars.yacc"
    { (yyval.ival) = RUN_STD; }
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 3701 "pars.yacc"
    { (yyval.ival) = RUN_MED; }
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 3702 "pars.yacc"
    { (yyval.ival) = RUN_MAX; }
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 3703 "pars.yacc"
    { (yyval.ival) = RUN_MIN; }
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 3707 "pars.yacc"
    { (yyval.ival) = SOURCE_DISK; }
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 3708 "pars.yacc"
    {
            if (!safe_mode) {
                (yyval.ival) = SOURCE_PIPE;
            } else {
                yyerror("Pipe inputs are disabled in safe mode");
                (yyval.ival) = SOURCE_DISK;
            }
        }
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 3718 "pars.yacc"
    { (yyval.ival) = JUST_RIGHT; }
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 3719 "pars.yacc"
    { (yyval.ival) = JUST_LEFT; }
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 3720 "pars.yacc"
    { (yyval.ival) = JUST_CENTER; }
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 3723 "pars.yacc"
    { (yyval.ival) = TICKS_IN; }
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 3724 "pars.yacc"
    { (yyval.ival) = TICKS_OUT; }
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 3725 "pars.yacc"
    { (yyval.ival) = TICKS_BOTH; }
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 3728 "pars.yacc"
    { (yyval.ival) = FORMAT_DECIMAL; }
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 3729 "pars.yacc"
    { (yyval.ival) = FORMAT_EXPONENTIAL; }
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 3730 "pars.yacc"
    { (yyval.ival) = FORMAT_GENERAL; }
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 3731 "pars.yacc"
    { (yyval.ival) = FORMAT_SCIENTIFIC; }
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 3732 "pars.yacc"
    { (yyval.ival) = FORMAT_ENGINEERING; }
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 3733 "pars.yacc"
    { (yyval.ival) = FORMAT_COMPUTING; }
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 3734 "pars.yacc"
    { (yyval.ival) = FORMAT_POWER; }
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 3735 "pars.yacc"
    { (yyval.ival) = FORMAT_DDMMYY; }
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 3736 "pars.yacc"
    { (yyval.ival) = FORMAT_MMDDYY; }
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 3737 "pars.yacc"
    { (yyval.ival) = FORMAT_YYMMDD; }
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 3738 "pars.yacc"
    { (yyval.ival) = FORMAT_MMYY; }
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 3739 "pars.yacc"
    { (yyval.ival) = FORMAT_MMDD; }
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 3740 "pars.yacc"
    { (yyval.ival) = FORMAT_MONTHDAY; }
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 3741 "pars.yacc"
    { (yyval.ival) = FORMAT_DAYMONTH; }
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 3742 "pars.yacc"
    { (yyval.ival) = FORMAT_MONTHS; }
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 3743 "pars.yacc"
    { (yyval.ival) = FORMAT_MONTHSY; }
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 3744 "pars.yacc"
    { (yyval.ival) = FORMAT_MONTHL; }
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 3745 "pars.yacc"
    { (yyval.ival) = FORMAT_DAYOFWEEKS; }
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 3746 "pars.yacc"
    { (yyval.ival) = FORMAT_DAYOFWEEKL; }
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 3747 "pars.yacc"
    { (yyval.ival) = FORMAT_DAYOFYEAR; }
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 3748 "pars.yacc"
    { (yyval.ival) = FORMAT_HMS; }
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 3749 "pars.yacc"
    { (yyval.ival) = FORMAT_MMDDHMS; }
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 3750 "pars.yacc"
    { (yyval.ival) = FORMAT_MMDDYYHMS; }
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 3751 "pars.yacc"
    { (yyval.ival) = FORMAT_YYMMDDHMS; }
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 3752 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESLON; }
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 3753 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESMMLON; }
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 3754 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESMMSSLON; }
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 3755 "pars.yacc"
    { (yyval.ival) = FORMAT_MMSSLON; }
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 3756 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESLAT; }
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 3757 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESMMLAT; }
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 3758 "pars.yacc"
    { (yyval.ival) = FORMAT_DEGREESMMSSLAT; }
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 3759 "pars.yacc"
    { (yyval.ival) = FORMAT_MMSSLAT; }
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 3762 "pars.yacc"
    { (yyval.ival) = SIGN_NORMAL; }
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 3763 "pars.yacc"
    { (yyval.ival) = SIGN_ABSOLUTE; }
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 3764 "pars.yacc"
    { (yyval.ival) = SIGN_NEGATE; }
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 3767 "pars.yacc"
    { (yyval.ival) = UP; }
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 3768 "pars.yacc"
    { (yyval.ival) = DOWN; }
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 3769 "pars.yacc"
    { (yyval.ival) = RIGHT; }
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 3770 "pars.yacc"
    { (yyval.ival) = LEFT; }
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 3771 "pars.yacc"
    { (yyval.ival) = IN; }
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 3772 "pars.yacc"
    { (yyval.ival) = OUT; }
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 3775 "pars.yacc"
    { (yyval.ival) = COORD_WORLD; }
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 3776 "pars.yacc"
    { (yyval.ival) = COORD_VIEW; }
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 3779 "pars.yacc"
    { (yyval.ival) = DATA_X; }
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 3780 "pars.yacc"
    { (yyval.ival) = DATA_Y; }
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 3781 "pars.yacc"
    { (yyval.ival) = DATA_X; }
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 3782 "pars.yacc"
    { (yyval.ival) = DATA_Y; }
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 3783 "pars.yacc"
    { (yyval.ival) = DATA_Y1; }
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 3784 "pars.yacc"
    { (yyval.ival) = DATA_Y2; }
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 3785 "pars.yacc"
    { (yyval.ival) = DATA_Y3; }
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 3786 "pars.yacc"
    { (yyval.ival) = DATA_Y4; }
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 3789 "pars.yacc"
    { (yyval.ival) = ASCENDING; }
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 3790 "pars.yacc"
    { (yyval.ival) = DESCENDING; }
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 3793 "pars.yacc"
    { (yyval.ival) = DATA_X; }
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 3794 "pars.yacc"
    { (yyval.ival) = DATA_Y; }
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 3798 "pars.yacc"
    { (yyval.ival) = 0; }
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 3799 "pars.yacc"
    { (yyval.ival) = 0; }
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 3800 "pars.yacc"
    { (yyval.ival) = 1; }
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 3801 "pars.yacc"
    { (yyval.ival) = 1; }
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 3806 "pars.yacc"
    {(yyval.ival)=0;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 3807 "pars.yacc"
    {(yyval.ival)=1;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 3811 "pars.yacc"
    {(yyval.ival) = FFT_XSCALE_INDEX;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 3812 "pars.yacc"
    {(yyval.ival) = FFT_XSCALE_NU;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 3813 "pars.yacc"
    {(yyval.ival) = FFT_XSCALE_OMEGA;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 3817 "pars.yacc"
    {(yyval.ival) = FFT_OUTPUT_MAGNITUDE;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 3818 "pars.yacc"
    {(yyval.ival) = FFT_OUTPUT_PHASE;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 3819 "pars.yacc"
    {(yyval.ival) = FFT_OUTPUT_COEFF;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 3820 "pars.yacc"
    {(yyval.ival) = FFT_OUTPUT_REIM;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 3824 "pars.yacc"
    {(yyval.ival) = FFT_INPUT_SEG_INDEX;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 3825 "pars.yacc"
    {(yyval.ival) = FFT_INPUT_SEG_X ;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 3829 "pars.yacc"
    {(yyval.ival) = FFT_OUTSEGMT_POSITIVE;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 3830 "pars.yacc"
    {(yyval.ival) = FFT_OUTSEGMT_HALF_LENGTH;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 3831 "pars.yacc"
    {(yyval.ival) = FFT_OUTSEGMT_CENTERED;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 3835 "pars.yacc"
    {(yyval.ival) = FFT_NORM_NONE;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 3836 "pars.yacc"
    {(yyval.ival) = FFT_NORM_SYMMETRIC;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 3837 "pars.yacc"
    {(yyval.ival) = FFT_NORM_FORWARD;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 3838 "pars.yacc"
    {(yyval.ival) = FFT_NORM_BACKWARD;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 3842 "pars.yacc"
    {(yyval.ival) = WAVELET_DAUBECHIES;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 3843 "pars.yacc"
    {(yyval.ival) = WAVELET_DAUBECHIES_CENTERED;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 3844 "pars.yacc"
    {(yyval.ival) = WAVELET_HARR;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 3845 "pars.yacc"
    {(yyval.ival) = WAVELET_HARR_CENTERED;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 3846 "pars.yacc"
    {(yyval.ival) = WAVELET_BSPLINE;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 3847 "pars.yacc"
    {(yyval.ival) = WAVELET_BSPLINE_CENTERED;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 3851 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_NONE;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 3852 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_TRIANGULAR;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 3853 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_PARZEN;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 3854 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_WELCH;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 3855 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_HANNING;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 3856 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_HAMMING;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 3857 "pars.yacc"
    {(yyval.ival) = FFT_WINDOW_BLACKMAN;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 3860 "pars.yacc"
    { (yyval.ival) = INTERP_LINEAR; }
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 3861 "pars.yacc"
    { (yyval.ival) = INTERP_SPLINE; }
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 3862 "pars.yacc"
    { (yyval.ival) = INTERP_ASPLINE; }
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 3863 "pars.yacc"
    { (yyval.ival) = INTERP_XSPLINE; }
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 3864 "pars.yacc"
    { (yyval.ival) = INTERP_XYSPLINE; }
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 3867 "pars.yacc"
    { (yyval.ival) = MINP; }
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 3868 "pars.yacc"
    { (yyval.ival) = MAXP; }
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 3869 "pars.yacc"
    { (yyval.ival) = AVG; }
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 3870 "pars.yacc"
    { (yyval.ival) = SD; }
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 3871 "pars.yacc"
    { (yyval.ival) = SUM; }
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 3872 "pars.yacc"
    { (yyval.ival) = IMIN; }
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 3873 "pars.yacc"
    { (yyval.ival) = IMAX; }
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 3876 "pars.yacc"
    { (yyval.ival) = 3; }
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 3877 "pars.yacc"
    { (yyval.ival) = 4; }
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 3878 "pars.yacc"
    { (yyval.ival) = 2; }
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 3883 "pars.yacc"
    {
            (yyval.ival) = get_mapped_font((yyvsp[(2) - (2)].ival));
        }
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 3887 "pars.yacc"
    {
            (yyval.ival) = get_font_by_name((yyvsp[(2) - (2)].sval));
            xfree((yyvsp[(2) - (2)].sval));
        }
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 3895 "pars.yacc"
    {
	    int lines = (yyvsp[(2) - (2)].ival);
            if (lines >= 0 && lines < number_of_linestyles()) {
	        (yyval.ival) = lines;
	    } else {
	        errmsg("invalid linestyle");
	        (yyval.ival) = 1;
	    }
        }
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 3908 "pars.yacc"
    {
	    int patno = (yyvsp[(2) - (2)].ival);
            if (patno >= 0 && patno < number_of_patterns()) {
	        (yyval.ival) = patno;
	    } else {
	        errmsg("invalid pattern number");
	        (yyval.ival) = 1;
	    }
        }
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 3921 "pars.yacc"
    {
            int c = (yyvsp[(2) - (2)].ival);
            if (c >= 0 && c < number_of_colors()) {
                (yyval.ival) = c;
            } else {
                errmsg("Invalid color ID");
                (yyval.ival) = 1;
            }
        }
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 3931 "pars.yacc"
    {
            int c = get_color_by_name((yyvsp[(2) - (2)].sval));
            if (c == BAD_COLOR) {
                errmsg("Invalid color name");
                c = 1;
            }
            xfree((yyvsp[(2) - (2)].sval));
            (yyval.ival) = c;
        }
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 3941 "pars.yacc"
    {
            int c;
            CMap_entry cmap;
            cmap.rgb.red = (yyvsp[(3) - (8)].ival);
            cmap.rgb.green = (yyvsp[(5) - (8)].ival);
            cmap.rgb.blue = (yyvsp[(7) - (8)].ival);
            cmap.ctype = COLOR_MAIN;
            cmap.cname = NULL;
            c = add_color(cmap);
            if (c == BAD_COLOR) {
                errmsg("Can't allocate requested color");
                c = 1;
            }
            (yyval.ival) = c;
        }
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 3960 "pars.yacc"
    {
            double linew;
            linew = (yyvsp[(2) - (2)].dval);
            if (linew < 0.0) {
                yyerror("Negative linewidth");
                linew = 0.0;
            } else if (linew > MAX_LINEWIDTH) {
                yyerror("Linewidth too large");
                linew = MAX_LINEWIDTH;
            }
            (yyval.dval) = linew;
        }
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 3975 "pars.yacc"
    {
            (yyval.ival) = (yyvsp[(2) - (2)].ival);
        }
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 3980 "pars.yacc"
    { (yyval.ival) = PLACEMENT_NORMAL; }
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 3981 "pars.yacc"
    { (yyval.ival) = PLACEMENT_OPPOSITE; }
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 3982 "pars.yacc"
    { (yyval.ival) = PLACEMENT_BOTH; }
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 3987 "pars.yacc"
    {
            		 	int wpp, hpp;
            		 	if ((yyvsp[(3) - (3)].ival) == PAGE_ORIENT_LANDSCAPE) {
            		 	    wpp = 792;
            		 	    hpp = 612;
            		 	} else {
            		 	    wpp = 612;
            		 	    hpp = 792;
            		 	}
            		 	set_page_dimensions(wpp, hpp, FALSE);
        }
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 3998 "pars.yacc"
    { set_page_dimensions((int) (yyvsp[(3) - (4)].dval), (int) (yyvsp[(4) - (4)].dval), FALSE); }
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 3999 "pars.yacc"
    { scroll_proc((yyvsp[(2) - (2)].ival)); }
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 4000 "pars.yacc"
    { scrollinout_proc((yyvsp[(3) - (3)].ival)); }
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 4002 "pars.yacc"
    { }
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 4004 "pars.yacc"
    {
	    				  add_world(gn, (yyvsp[(3) - (17)].dval), (yyvsp[(5) - (17)].dval), (yyvsp[(7) - (17)].dval), (yyvsp[(9) - (17)].dval)); 
        }
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 4007 "pars.yacc"
    { }
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 4009 "pars.yacc"
    { }
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 4010 "pars.yacc"
    { }
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 4011 "pars.yacc"
    { if ( bad_gno ()) return 1;
	    		     if ((yyvsp[(3) - (3)].ival) == FALSE && get_project_version() <= 40102) {
            		         g[gn].l.boxpen.pattern = 0;
            		     }
	}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 4016 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].l.legx = (yyvsp[(3) - (3)].dval);	}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 4017 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].l.legy = (yyvsp[(3) - (3)].dval);	}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 4018 "pars.yacc"
    { if (is_valid_setno(gn, (yyvsp[(3) - (4)].ival))) {
             			          strncpy(g[gn].p[(yyvsp[(3) - (4)].ival)].lstr, (yyvsp[(4) - (4)].sval), MAX_STRING_LENGTH - 1);
 	    			      } else {
             			          yyerror("Unallocated set");
             			      }
             			      xfree((yyvsp[(4) - (4)].sval));
 	}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 4025 "pars.yacc"
    { }
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 4026 "pars.yacc"
    {filltype_obs = (yyvsp[(5) - (5)].ival);}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 4027 "pars.yacc"
    { }
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 4028 "pars.yacc"
    { }
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 4030 "pars.yacc"
    { }
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 4031 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_XY;    g[(yyvsp[(1) - (3)].ival)].xscale  = SCALE_LOG; }
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 4032 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_XY;    g[(yyvsp[(1) - (3)].ival)].yscale  = SCALE_LOG; }
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 4033 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_XY;    g[(yyvsp[(1) - (3)].ival)].xscale  = SCALE_LOG; g[(yyvsp[(1) - (3)].ival)].yscale  = SCALE_LOG; }
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 4034 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_CHART; g[(yyvsp[(1) - (3)].ival)].xyflip  = FALSE;     g[(yyvsp[(1) - (3)].ival)].stacked = FALSE; }
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 4035 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_CHART; g[(yyvsp[(1) - (3)].ival)].xyflip  = TRUE; }
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 4036 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_CHART; g[(yyvsp[(1) - (3)].ival)].stacked = TRUE; }
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 4037 "pars.yacc"
    { g[(yyvsp[(1) - (3)].ival)].type = GRAPH_CHART; g[(yyvsp[(1) - (3)].ival)].stacked = TRUE;      g[(yyvsp[(1) - (3)].ival)].xyflip = TRUE; }
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 4039 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].w.xg1 = (yyvsp[(3) - (3)].dval); }
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 4040 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].w.xg2 = (yyvsp[(3) - (3)].dval); }
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 4041 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].w.yg1 = (yyvsp[(3) - (3)].dval); }
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 4042 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].w.yg2 = (yyvsp[(3) - (3)].dval); }
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 4043 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].v.xv1 = (yyvsp[(3) - (3)].dval); }
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 4044 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].v.xv2 = (yyvsp[(3) - (3)].dval); }
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 4045 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].v.yv1 = (yyvsp[(3) - (3)].dval); }
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 4046 "pars.yacc"
    { if ( bad_gno ()) return 1; g[gn].v.yv2 = (yyvsp[(3) - (3)].dval); }
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 4048 "pars.yacc"
    {	}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 4050 "pars.yacc"
    {  if ( bad_gno ()) return 1;            g[gn].f.fillpen.pattern = (yyvsp[(3) - (3)].ival);        }
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 4051 "pars.yacc"
    {        }
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 4052 "pars.yacc"
    {        }
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 4053 "pars.yacc"
    { }
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 4054 "pars.yacc"
    { }
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 4055 "pars.yacc"
    { }
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 4056 "pars.yacc"
    { }
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 4061 "pars.yacc"
    { }
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 4062 "pars.yacc"
    {
	    if (!is_valid_axis(gn, naxis)) {
                yyerror("No valid axis selected");
                return 1;
            }
	    g[gn].t[naxis]->label_op = (yyvsp[(1) - (1)].ival);
	}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 4072 "pars.yacc"
    {
	    switch ((yyvsp[(4) - (4)].ival)){
	    case 0:
	        g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.pattern = 0;
	        break;
	    case 1:
	        g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.pattern = 1;
	        break;
	    case 2:
	        g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.pattern = 1;
	        g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].symfillpen.color = getbgcolor();
	        break;
	    }
	}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 4086 "pars.yacc"
    { g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].symskip = (yyvsp[(3) - (3)].ival); }
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 4087 "pars.yacc"
    {
	    switch ((yyvsp[(3) - (3)].ival)) {
            case 0:
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].filltype = SETFILL_NONE;
                break;
            case 1:
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].filltype = SETFILL_POLYGON;
                break;
            case 2:
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].filltype = SETFILL_BASELINE;
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].baseline_type = BASELINE_TYPE_0;
                break;
            case 6:
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].filltype = SETFILL_BASELINE;
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].baseline_type = BASELINE_TYPE_GMIN;
                break;
            case 7:
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].filltype = SETFILL_BASELINE;
                g[(yyvsp[(1) - (3)].trgt)->gno].p[(yyvsp[(1) - (3)].trgt)->setno].baseline_type = BASELINE_TYPE_GMAX;
                break;
            }
	}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 4109 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].errbar.ptype = (yyvsp[(4) - (4)].ival); }
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 4110 "pars.yacc"
    { }
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 4111 "pars.yacc"
    { g[(yyvsp[(1) - (2)].trgt)->gno].p[(yyvsp[(1) - (2)].trgt)->setno].lines = (yyvsp[(2) - (2)].ival); }
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 4112 "pars.yacc"
    { g[(yyvsp[(1) - (2)].trgt)->gno].p[(yyvsp[(1) - (2)].trgt)->setno].linew = (yyvsp[(2) - (2)].dval); }
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 4113 "pars.yacc"
    { g[(yyvsp[(1) - (2)].trgt)->gno].p[(yyvsp[(1) - (2)].trgt)->setno].linepen.color = (yyvsp[(2) - (2)].ival); }
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 4114 "pars.yacc"
    { filltype_obs = (yyvsp[(4) - (4)].ival); }
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 4115 "pars.yacc"
    { }
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 4116 "pars.yacc"
    { g[(yyvsp[(1) - (4)].trgt)->gno].p[(yyvsp[(1) - (4)].trgt)->setno].errbar.barsize = (yyvsp[(4) - (4)].dval);	}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 4117 "pars.yacc"
    { }
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 4127 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->active = (yyvsp[(2) - (2)].ival); }
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 4128 "pars.yacc"
    { }
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 4129 "pars.yacc"
    { }
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 4130 "pars.yacc"
    { }
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 4131 "pars.yacc"
    { }
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 4132 "pars.yacc"
    { }
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 4133 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_spec = TICKS_SPEC_NONE; }
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 4134 "pars.yacc"
    { if (bad_axis ()) return 1;
	    		if (!is_valid_axis(gn, naxis)) {
	    		   if (g[gn].t[naxis]->t_spec != TICKS_SPEC_BOTH) {
            		       g[gn].t[naxis]->t_spec = TICKS_SPEC_MARKS;
            		   }
	    		}
	}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 4141 "pars.yacc"
    { if (bad_axis ()) return 1;
	    	       if ((yyvsp[(2) - (2)].dval) != 0.0) {
            	           g[gn].t[naxis]->nminor =
            	                       (int) rint(g[gn].t[naxis]->tmajor / (yyvsp[(2) - (2)].dval) - 1);
            	       } else {
            	           g[gn].t[naxis]->nminor = 0;
            	       }
	}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 4149 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->props.size = (yyvsp[(2) - (2)].dval); }
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 4150 "pars.yacc"
    { if (bad_axis ()) return 1;
	    		     g[gn].t[naxis]->tloc[(yyvsp[(1) - (3)].ival)].wtpos = (yyvsp[(3) - (3)].dval);
	    		     g[gn].t[naxis]->tloc[(yyvsp[(1) - (3)].ival)].type = TICK_TYPE_MAJOR; }
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 4153 "pars.yacc"
    { if (bad_axis ()) return 1;g[gn].t[naxis]->t_op = (yyvsp[(1) - (1)].ival); }
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 4157 "pars.yacc"
    { }
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 4158 "pars.yacc"
    { if (bad_axis ()) return 1;
	    	      if (g[gn].t[naxis]->t_spec == TICKS_SPEC_BOTH) {
            	          g[gn].t[naxis]->t_spec = TICKS_SPEC_MARKS;
            	      }
	}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 4163 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->t_spec = TICKS_SPEC_BOTH; }
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 4164 "pars.yacc"
    { }
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 4165 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_angle = 0; }
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 4166 "pars.yacc"
    { if (bad_axis ()) return 1; g[gn].t[naxis]->tl_angle = 90;	}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 4167 "pars.yacc"
    { }
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 4168 "pars.yacc"
    { }
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 4169 "pars.yacc"
    { if (bad_axis ()) return 1;g[gn].t[naxis]->tl_op = (yyvsp[(1) - (1)].ival); }
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 4170 "pars.yacc"
    { if (bad_axis ()) return 1;
	    		      switch((yyvsp[(2) - (2)].ival)) {
            		      case SIGN_NEGATE:
            		          g[gn].t[naxis]->tl_formula =
            		              copy_string(g[gn].t[naxis]->tl_formula, "-$t");
            		          break;
            		      case SIGN_ABSOLUTE:
            		          g[gn].t[naxis]->tl_formula =
            		              copy_string(g[gn].t[naxis]->tl_formula, "abs($t)");
            		          break;
            		      default:
            		          g[gn].t[naxis]->tl_formula =
            		              copy_string(g[gn].t[naxis]->tl_formula, NULL);
            		          break;
            		      }
	}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 4193 "pars.yacc"
    { (yyval.ival) = (yyvsp[(2) - (2)].ival); }
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 4196 "pars.yacc"
    { (yyval.ival) = PLACEMENT_OPPOSITE; }
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 4197 "pars.yacc"
    { (yyval.ival) = PLACEMENT_NORMAL; }
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 4198 "pars.yacc"
    { (yyval.ival) = PLACEMENT_NORMAL; }
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 4199 "pars.yacc"
    { (yyval.ival) = PLACEMENT_OPPOSITE; }
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 4200 "pars.yacc"
    { (yyval.ival) = PLACEMENT_BOTH; }
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 4203 "pars.yacc"
    { (yyval.ival) = obj_tid_get_set_num ((yyvsp[(1) - (2)].trgt)->gno ,(yyvsp[(1) - (2)].trgt)->setno); }
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 4206 "pars.yacc"
    {
	  int numset = obj_tid_get_set_num ((yyvsp[(1) - (2)].trgt)->gno ,(yyvsp[(1) - (2)].trgt)->setno);
	  jo = objs[numset].child;
	  if (jo < 0) {
	    errmsg("No colorbar defined");
	  }
	}
    break;



/* Line 1455 of yacc.c  */
#line 15958 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 4216 "pars.yacc"


/* -----------------------  EPILOGUE  ----------------------- */

/* list of intrinsic functions and keywords */
symtab_entry ikey[] = {
	{"A0"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A0MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A0MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A1"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A1MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A1MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A2"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A2MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A2MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A3"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A3MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A3MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A4"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A4MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A4MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A5"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A5MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A5MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A6"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A6MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A6MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A7"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A7MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A7MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A8"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A8MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A8MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"A9"			, FITPARM	  , VAR_INTRINSIC , NULL}				,
	{"A9MAX"		, FITPMAX	  , VAR_INTRINSIC , NULL}				,
	{"A9MIN"		, FITPMIN	  , VAR_INTRINSIC , NULL}				,
	{"ABOVE"		, ABOVE		  , VAR_INTRINSIC , NULL}				,
	{"ABS"			, FUNC_D	  , VAR_INTRINSIC , (void *) fabs}		,
	{"ABSOLUTE"		, ABSOLUTE	  , VAR_INTRINSIC , NULL}				,
	{"ACOS"			, FUNC_D	  , VAR_INTRINSIC , (void *) acos}		,
	{"ACOSH"		, FUNC_D	  , VAR_INTRINSIC , (void *) acosh}		,
	{"AI"			, FUNC_D	  , VAR_INTRINSIC , (void *) ai_wrap}		,
	{"ALLVARS"		, ALLVARS	  , VAR_INTRINSIC , NULL}				,
	{"ALIAS"		, ALIAS		  , VAR_INTRINSIC , NULL}				,
	{"ALT"			, ALT		  , VAR_INTRINSIC , NULL}				,
	{"ALTXAXIS"		, ALTXAXIS	  , VAR_INTRINSIC , NULL}				,
	{"ALTYAXIS"		, ALTYAXIS	  , VAR_INTRINSIC , NULL}				,
	{"AND"			, AND		  , VAR_INTRINSIC , NULL}				,
	{"ANCHOR"		, ANCHOR	  , VAR_INTRINSIC , NULL}				,
	{"ANGLE"		, ANGLE		  , VAR_INTRINSIC , NULL}				,
	{"ANGLES"		, ANGLES	  , VAR_INTRINSIC , NULL}				,
	{"ANTIALIASING"		, ANTIALIASING	  , VAR_INTRINSIC , NULL}				,
	{"APPEND"		, APPEND	  , VAR_INTRINSIC , NULL}				,
	{"ARC"			, ARC		  , VAR_INTRINSIC , NULL}				,
	{"ARRANGE"		, ARRANGE	  , VAR_INTRINSIC , NULL}				,
	{"ARROW"		, ARROW		  , VAR_INTRINSIC , NULL}				,
	{"ASCENDING"		, ASCENDING	  , VAR_INTRINSIC , NULL}				,
	{"ASIN"			, FUNC_D	  , VAR_INTRINSIC , (void *) asin}		,
	{"ASINH"		, FUNC_D	  , VAR_INTRINSIC , (void *) asinh}		,
	{"ASPLINE"		, ASPLINE	  , VAR_INTRINSIC , NULL}				,
	{"ATAN"			, FUNC_D	  , VAR_INTRINSIC , (void *) atan}		,
	{"ATAN2"		, FUNC_DD	  , VAR_INTRINSIC , (void *) atan2}		,
	{"ATANH"		, FUNC_D	  , VAR_INTRINSIC , (void *) atanh}		,
	{"AUTO"			, AUTO		  , VAR_INTRINSIC , NULL}				,
	{"AUTOSCALE"		, AUTOSCALE	  , VAR_INTRINSIC , NULL}				,
	{"AUTOTICKS"		, AUTOTICKS	  , VAR_INTRINSIC , NULL}				,
	{"AVALUE"		, AVALUE	  , VAR_INTRINSIC , NULL}				,
	{"AVG"			, AVG		  , VAR_INTRINSIC , NULL}				,
	{"BACKGROUND"		, BACKGROUND	  , VAR_INTRINSIC , NULL}				,
	{"BACKWARD"		, BACKWARD	  , VAR_INTRINSIC , NULL}				,
	{"BAR"			, BAR		  , VAR_INTRINSIC , NULL}				,
	{"BARDY"		, BARDY		  , VAR_INTRINSIC , NULL}				,
	{"BARDYDY"		, BARDYDY	  , VAR_INTRINSIC , NULL}				,
	{"BASELINE"		, BASELINE	  , VAR_INTRINSIC , NULL}				,
	{"BATCH"		, BATCH		  , VAR_INTRINSIC , NULL}				,
        {"BEGIN"		, BEGIN		  , VAR_INTRINSIC , NULL}				,
	{"BELOW"		, BELOW		  , VAR_INTRINSIC , NULL}				,
	{"BETA"			, FUNC_DD	  , VAR_INTRINSIC , (void *) beta}		,
	{"BETWEEN"		, BETWEEN	  , VAR_INTRINSIC , NULL}				,
	{"BI"			, FUNC_D	  , VAR_INTRINSIC , (void *) bi_wrap}		,
	{"BLACKMAN"		, BLACKMAN	  , VAR_INTRINSIC , NULL}				,
	{"BLOCK"		, BLOCK		  , VAR_INTRINSIC , NULL}				,
	{"BOTH"			, BOTH		  , VAR_INTRINSIC , NULL}				,
	{"BOTTOM"		, BOTTOM	  , VAR_INTRINSIC , NULL}				,
	{"BOX"			, BOX		  , VAR_INTRINSIC , NULL}				,
	{"BREAK"		, BREAK		  , VAR_INTRINSIC , NULL}				,
	{"BSPLINE"		, BSPLINE	  , VAR_INTRINSIC , NULL}				,
	{"BSPLINE_CENTERED"	, BSPLINE_CENTERED, VAR_INTRINSIC , NULL}				,
	{"CD"			, CD		  , VAR_INTRINSIC , NULL}				,
	{"CEIL"			, FUNC_D	  , VAR_INTRINSIC , (void *) ceil}		,
	{"CENTER"		, CENTER	  , VAR_INTRINSIC , NULL}				,
	{"CHAR"			, CHAR		  , VAR_INTRINSIC , NULL}				,
	{"CHART"		, CHART		  , VAR_INTRINSIC , NULL}				,
	{"CHDTR"		, FUNC_DD	  , VAR_INTRINSIC , (void *) chdtr}		,
	{"CHDTRC"		, FUNC_DD	  , VAR_INTRINSIC , (void *) chdtrc}		,
	{"CHDTRI"		, FUNC_DD	  , VAR_INTRINSIC , (void *) chdtri}		,
	{"CHI"			, FUNC_D	  , VAR_INTRINSIC , (void *) chi_wrap}		,
	{"CI"			, FUNC_D	  , VAR_INTRINSIC , (void *) ci_wrap}		,
	{"CLEAR"		, CLEAR		  , VAR_INTRINSIC , NULL}				,
	{"CLICK"		, CLICK		  , VAR_INTRINSIC , NULL}				,
	{"CLIP"			, CLIP		  , VAR_INTRINSIC , NULL}				,
	{"CLOSE"		, CLOSE		  , VAR_INTRINSIC , NULL}				,
	{"CMAP"		        , CMAP		  , VAR_INTRINSIC , NULL}				,
	{"COEFFICIENTS"		, COEFFICIENTS	  , VAR_INTRINSIC , NULL}				,
	{"COLOR"		, COLOR		  , VAR_INTRINSIC , NULL}				,
	{"COLORBAR"		, COLORBAR	  , VAR_INTRINSIC , NULL}				,
	{"COMMENT"		, COMMENT	  , VAR_INTRINSIC , NULL}				,
	{"COMPLEX"		, COMPLEX	  , VAR_INTRINSIC , NULL}				,
	{"COMPOUND"		, COMPOUND	  , VAR_INTRINSIC , NULL}				,
	{"COMPUTING"		, COMPUTING	  , VAR_INTRINSIC , NULL}				,
	{"CONST"		, KEY_CONST	  , VAR_INTRINSIC , NULL}				,
	{"CONSTRAINTS"		, CONSTRAINTS	  , VAR_INTRINSIC , NULL}				,
	{"CONTOUR"		, CONTOUR	  , VAR_INTRINSIC , NULL}				,
	{"COPY"			, COPY		  , VAR_INTRINSIC , NULL}				,
	{"COS"			, FUNC_D	  , VAR_INTRINSIC , (void *) cos}			,
	{"COSH"			, FUNC_D	  , VAR_INTRINSIC , (void *) cosh}		,
	{"CYCLE"		, CYCLE		  , VAR_INTRINSIC , NULL}				,
	{"DAUBECHIES"		, DAUBECHIES	  , VAR_INTRINSIC , NULL}				,
	{"DAUBECHIES_CENTERED"	, DAUBECHIES_CENTERED , VAR_INTRINSIC , NULL}				,
	{"DATE"			, DATE		  , VAR_INTRINSIC , NULL}				,
	{"DAWSN"		, FUNC_D	  , VAR_INTRINSIC , (void *) dawsn}		,
	{"DAYMONTH"		, DAYMONTH	  , VAR_INTRINSIC , NULL}				,
	{"DAYOFWEEKL"		, DAYOFWEEKL	  , VAR_INTRINSIC , NULL}				,
	{"DAYOFWEEKS"		, DAYOFWEEKS	  , VAR_INTRINSIC , NULL}				,
	{"DAYOFYEAR"		, DAYOFYEAR	  , VAR_INTRINSIC , NULL}				,
	{"DDMMYY"		, DDMMYY	  , VAR_INTRINSIC , NULL}				,
	{"DECIMAL"		, DECIMAL	  , VAR_INTRINSIC , NULL}				,
	{"DECIMATE"		, DECIMATE	  , VAR_INTRINSIC , NULL}				,
	{"DEF"			, DEF		  , VAR_INTRINSIC , NULL}				,
	{"DEFAULT"		, DEFAULT	  , VAR_INTRINSIC , NULL}				,
	{"DEFINE"		, DEFINE	  , VAR_INTRINSIC , NULL}				,
	{"DEG"			, UCONSTANT	  , VAR_INTRINSIC , (void *) deg_uconst}		,
	{"DEGREES"		, DEGREES	  , VAR_INTRINSIC , NULL}				,
	{"DEGREESLAT"		, DEGREESLAT	  , VAR_INTRINSIC , NULL}				,
	{"DEGREESLON"		, DEGREESLON	  , VAR_INTRINSIC , NULL}				,
	{"DEGREESMMLAT"		, DEGREESMMLAT	  , VAR_INTRINSIC , NULL}				,
	{"DEGREESMMLON"		, DEGREESMMLON	  , VAR_INTRINSIC , NULL}				,
	{"DEGREESMMSSLAT"	, DEGREESMMSSLAT  , VAR_INTRINSIC , NULL}				,
	{"DEGREESMMSSLON"	, DEGREESMMSSLON  , VAR_INTRINSIC , NULL}				,
	{"DESCENDING"		, DESCENDING	  , VAR_INTRINSIC , NULL}				,
	{"DESCRIPTION"		, DESCRIPTION	  , VAR_INTRINSIC , NULL}				,
	{"DEVICE"		, DEVICE	  , VAR_INTRINSIC , NULL}				,
	{"DFT"			, DFT		  , VAR_INTRINSIC , NULL}				,
	{"DIFF"			, DIFFERENCE	  , VAR_INTRINSIC , NULL}				,
	{"DIFFERENCE"		, DIFFERENCE	  , VAR_INTRINSIC , NULL}				,
	{"DISK"			, DISK		  , VAR_INTRINSIC , NULL}				,
	{"DOWN"			, DOWN		  , VAR_INTRINSIC , NULL}				,
	{"DPI"			, DPI		  , VAR_INTRINSIC , NULL}				,
	{"DROP"			, DROP		  , VAR_INTRINSIC , NULL}				,
	{"DROPLINE"		, DROPLINE	  , VAR_INTRINSIC , NULL}				,
	{"ECHO"			, ECHO		  , VAR_INTRINSIC , NULL}				,
	{"ELLIE"		, FUNC_DD	  , VAR_INTRINSIC , (void *) ellie}		,
	{"ELLIK"		, FUNC_DD	  , VAR_INTRINSIC , (void *) ellik}		,
	{"ELLIPSE"		, ELLIPSE	  , VAR_INTRINSIC , NULL}				,
	{"ELLPE"		, FUNC_D	  , VAR_INTRINSIC , (void *) ellpe_wrap}		,
	{"ELLPK"		, FUNC_D	  , VAR_INTRINSIC , (void *) ellpk_wrap}		,
	{"ENGINEERING"		, ENGINEERING	  , VAR_INTRINSIC , NULL}				,
	{"EQ"			, EQ		  , VAR_INTRINSIC , NULL}				,
	{"ER"			, ERRORBAR	  , VAR_INTRINSIC , NULL}				,
	{"ERF"			, FUNC_D	  , VAR_INTRINSIC , (void *) erf}			,
	{"ERFC"			, FUNC_D	  , VAR_INTRINSIC , (void *) erfc}		,
	{"ERRORBAR"		, ERRORBAR	  , VAR_INTRINSIC , NULL}				,
	{"EXIT"			, EXIT		  , VAR_INTRINSIC , NULL}				,
	{"EXP"			, FUNC_D	  , VAR_INTRINSIC , (void *) exp}			,
	{"EXPN"			, FUNC_ND	  , VAR_INTRINSIC , (void *) expn}		,
	{"EXPONENTIAL"		, EXPONENTIAL	  , VAR_INTRINSIC , NULL}				,
	{"FAC"			, FUNC_I	  , VAR_INTRINSIC , (void *) fac}			,
	{"FALSE"		, OFF		  , VAR_INTRINSIC , NULL}				,
	{"FDTR"			, FUNC_NND	  , VAR_INTRINSIC , (void *) fdtr}		,
	{"FDTRC"		, FUNC_NND	  , VAR_INTRINSIC , (void *) fdtrc}		,
	{"FDTRI"		, FUNC_NND	  , VAR_INTRINSIC , (void *) fdtri}		,
	{"FFT"			, FFT		  , VAR_INTRINSIC , NULL}				,
	{"FILE"			, FILEP		  , VAR_INTRINSIC , NULL}				,
	{"FILL"			, FILL		  , VAR_INTRINSIC , NULL}				,
	{"FIT"			, FIT		  , VAR_INTRINSIC , NULL}				,
	{"FIXED"		, FIXED		  , VAR_INTRINSIC , NULL}				,
	{"FIXEDPOINT"		, FIXEDPOINT	  , VAR_INTRINSIC , NULL}				,
	{"FLOOR"		, FUNC_D	  , VAR_INTRINSIC , (void *) floor}		,
	{"FLUSH"		, FLUSH		  , VAR_INTRINSIC , NULL}				,
	{"FOCUS"		, FOCUS		  , VAR_INTRINSIC , NULL}				,
	{"FOLLOWS"		, FOLLOWS	  , VAR_INTRINSIC , NULL}				,
	{"FONT"			, FONTP		  , VAR_INTRINSIC , NULL}				,
	{"FORCE"		, FORCE		  , VAR_INTRINSIC , NULL}				,
	{"FORMAT"		, FORMAT	  , VAR_INTRINSIC , NULL}				,
	{"FORMULA"		, FORMULA	  , VAR_INTRINSIC , NULL}				,
	{"FORWARD"		, FORWARD	  , VAR_INTRINSIC , NULL}				,
	{"FRAME"		, FRAMEP	  , VAR_INTRINSIC , NULL}				,
	{"FREE"			, FREE		  , VAR_INTRINSIC , NULL}				,
	{"FREQUENCY"		, FREQUENCY	  , VAR_INTRINSIC , NULL}				,
	{"FRESNLC"		, FUNC_D	  , VAR_INTRINSIC , (void *) fresnlc_wrap}	,
	{"FRESNLS"		, FUNC_D	  , VAR_INTRINSIC , (void *) fresnls_wrap}	,
	{"GAUSSIAN"		, GAUSSIAN	  , VAR_INTRINSIC , NULL}				,
	{"FROM"			, FROM		  , VAR_INTRINSIC , NULL}				,
	{"F_OF_D"		, KEY_FUNC_D	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_DD"		, KEY_FUNC_DD	  , VAR_INTRINSIC , NULL}				,
        {"F_OF_I"		, KEY_FUNC_I	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_ND"		, KEY_FUNC_ND	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_NN"		, KEY_FUNC_NN	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_NND"		, KEY_FUNC_NND	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_PPD"		, KEY_FUNC_PPD	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_PPPD"		, KEY_FUNC_PPPD	  , VAR_INTRINSIC , NULL}				,
	{"F_OF_PPPPD"		, KEY_FUNC_PPPPD  , VAR_INTRINSIC , NULL}				,
	{"F_OF_PPPPPD"		, KEY_FUNC_PPPPPD , VAR_INTRINSIC , NULL}				,
	{"GAMMA"		, FUNC_D	  , VAR_INTRINSIC , (void *) true_gamma}		,
	{"GDTR"			, FUNC_PPD	  , VAR_INTRINSIC , (void *) gdtr}		,
	{"GDTRC"		, FUNC_PPD	  , VAR_INTRINSIC , (void *) gdtrc}		,
	{"GE"			, GE		  , VAR_INTRINSIC , NULL}				,
	{"GENERAL"		, GENERAL	  , VAR_INTRINSIC , NULL}				,
	{"GEOTRANSFORM"		, GEOTRANSFORM	  , VAR_INTRINSIC , NULL}				,
	{"GETP"			, GETP		  , VAR_INTRINSIC , NULL}				,
	{"GRAPH"		, GRAPH		  , VAR_INTRINSIC , NULL}				,
	{"GRID"			, GRID		  , VAR_INTRINSIC , NULL}				,
	{"GT"			, GT		  , VAR_INTRINSIC , NULL}				,
	{"HAAR"			, HAAR		  , VAR_INTRINSIC , NULL}				,
	{"HAAR_CENTERED"	, HAAR_CENTERED	  , VAR_INTRINSIC , NULL}				,
	{"HALF"			, HALF		  , VAR_INTRINSIC , NULL}				,
	{"HAMMING"		, HAMMING	  , VAR_INTRINSIC , NULL}				,
	{"HANNING"		, HANNING	  , VAR_INTRINSIC , NULL}				,
	{"HARDCOPY"		, HARDCOPY	  , VAR_INTRINSIC , NULL}				,
	{"HBAR"			, HBAR		  , VAR_INTRINSIC , NULL}				,
	{"HELP"			, HELP		  , VAR_INTRINSIC , NULL}				,
	{"HGAP"			, HGAP		  , VAR_INTRINSIC , NULL}				,
	{"HIDDEN"		, HIDDEN	  , VAR_INTRINSIC , NULL}				,
	{"HISTOGRAM"		, HISTOGRAM	  , VAR_INTRINSIC , NULL}				,
	{"HMS"			, HMS		  , VAR_INTRINSIC , NULL}				,
	{"HORIZI"		, HORIZI	  , VAR_INTRINSIC , NULL}				,
	{"HORIZO"		, HORIZO	  , VAR_INTRINSIC , NULL}				,
	{"HORIZONTAL"		, HORIZONTAL	  , VAR_INTRINSIC , NULL}				,
	{"HYP2F1"		, FUNC_PPPD	  , VAR_INTRINSIC , (void *) hyp2f1}		,
	{"HYPERG"		, FUNC_PPD	  , VAR_INTRINSIC , (void *) hyperg}		,
	{"HYPOT"		, FUNC_DD	  , VAR_INTRINSIC , (void *) hypot}		,
	{"I0E"			, FUNC_D	  , VAR_INTRINSIC , (void *) i0e}			,
	{"I1E"			, FUNC_D	  , VAR_INTRINSIC , (void *) i1e}			,
	{"ID"			, ID		  , VAR_INTRINSIC , NULL}				,
	{"IF"			, IF		  , VAR_INTRINSIC , NULL}				,
	{"IFILTER"		, IFILTER	  , VAR_INTRINSIC , NULL}				,
	{"IGAM"			, FUNC_DD	  , VAR_INTRINSIC , (void *) igam}		,
	{"IGAMC"		, FUNC_DD	  , VAR_INTRINSIC , (void *) igamc}		,
	{"IGAMI"		, FUNC_DD	  , VAR_INTRINSIC , (void *) igami}		,
	{"IMAGE"		, IMAGE		  , VAR_INTRINSIC , NULL}				,
	{"IMAX"			, IMAX		  , VAR_INTRINSIC , NULL}				,
	{"IMIN"			, IMIN		  , VAR_INTRINSIC , NULL}				,
	{"IN"			, IN		  , VAR_INTRINSIC , NULL}				,
	{"INCBET"		, FUNC_PPD	  , VAR_INTRINSIC , (void *) incbet}		,
	{"INCBI"		, FUNC_PPD	  , VAR_INTRINSIC , (void *) incbi}		,
	{"INCREMENT"		, INCREMENT	  , VAR_INTRINSIC , NULL}				,
	{"INDEX"		, INDEX		  , VAR_INTRINSIC , NULL}				,
	{"INOUT"		, INOUT		  , VAR_INTRINSIC , NULL}				,
	{"INSEGX"		, INSEGX	  , VAR_INTRINSIC , NULL}				,
	{"INT"			, INT		  , VAR_INTRINSIC , NULL}				,
	{"INTEGRATE"		, INTEGRATE	  , VAR_INTRINSIC , NULL}				,
	{"INTERPOLATE"		, INTERPOLATE	  , VAR_INTRINSIC , NULL}				,
	{"INVDFT"		, INVDFT	  , VAR_INTRINSIC , NULL}				,
	{"INVERT"		, INVERT	  , VAR_INTRINSIC , NULL}				,
	{"INVFFT"		, INVFFT	  , VAR_INTRINSIC , NULL}				,
	{"IRAND"		, FUNC_I	  , VAR_INTRINSIC , (void *) irand_wrap}		,
	{"IV"			, FUNC_DD	  , VAR_INTRINSIC , (void *) iv_wrap}		,
	{"JUST"			, JUST		  , VAR_INTRINSIC , NULL}				,
	{"JV"			, FUNC_DD	  , VAR_INTRINSIC , (void *) jv_wrap}		,
	{"K0E"			, FUNC_D	  , VAR_INTRINSIC , (void *) k0e}			,
	{"K1E"			, FUNC_D	  , VAR_INTRINSIC , (void *) k1e}			,
	{"KILL"			, KILL		  , VAR_INTRINSIC , NULL}				,
	{"KN"			, FUNC_ND	  , VAR_INTRINSIC , (void *) kn_wrap}		,
	{"LABEL"		, LABEL		  , VAR_INTRINSIC , NULL}				,
	{"LANDSCAPE"		, LANDSCAPE	  , VAR_INTRINSIC , NULL}				,
	{"LAYER"		 ,LAYER		  , VAR_INTRINSIC  ,NULL}				,
	{"LAYOUT"		, LAYOUT	  , VAR_INTRINSIC , NULL}				,
	{"LBETA"		, FUNC_DD	  , VAR_INTRINSIC , (void *) lbeta}		,
	{"LE"			, LE		  , VAR_INTRINSIC , NULL}				,
	{"LEFT"			, LEFT		  , VAR_INTRINSIC , NULL}				,
	{"LEGEND"		, LEGEND	  , VAR_INTRINSIC , NULL}				,
	{"LENGTH"		, LENGTH	  , VAR_INTRINSIC , NULL}				,
	{"LGAMMA"		, FUNC_D	  , VAR_INTRINSIC , (void *) lgamma}		,
	{"LINCONV"		, LINCONV	  , VAR_INTRINSIC , NULL}				,
	{"LINE"			, LINE		  , VAR_INTRINSIC , NULL}				,
	{"LINEAR"		, LINEAR	  , VAR_INTRINSIC , NULL}				,
	{"LINESTYLE"		, LINESTYLE	  , VAR_INTRINSIC , NULL}				,
	{"LINEWIDTH"		, LINEWIDTH	  , VAR_INTRINSIC , NULL}				,
	{"LINK"			, LINK		  , VAR_INTRINSIC , NULL}				,
	{"LN"			, FUNC_D	  , VAR_INTRINSIC , (void *) log}			,
	{"LOAD"			, LOAD		  , VAR_INTRINSIC , NULL}				,
	{"LOCTYPE"		, LOCTYPE	  , VAR_INTRINSIC , NULL}				,
	{"LOESS"		, LOESS		  , VAR_INTRINSIC , NULL}				,
	{"LOG"			, LOG		  , VAR_INTRINSIC , NULL}				,
	{"LOG10"		, FUNC_D	  , VAR_INTRINSIC , (void *) log10}		,
	{"LOG2"			, FUNC_D	  , VAR_INTRINSIC , (void *) log2}		,
	{"LOGARITHMIC"		 ,LOGARITHMIC	  , VAR_INTRINSIC  ,NULL}				,
	{"LOGX"			, LOGX		  , VAR_INTRINSIC , NULL}				,
	{"LOGXY"		, LOGXY		  , VAR_INTRINSIC , NULL}				,
	{"LOGY"			, LOGY		  , VAR_INTRINSIC , NULL}				,
	{"LOGIT"		, LOGIT		  , VAR_INTRINSIC , NULL}				,
	{"LT"			, LT		  , VAR_INTRINSIC , NULL}				,
	{"MAGIC"		, MAGIC		  , VAR_INTRINSIC , NULL}				,
	{"MAGNITUDE"		, MAGNITUDE	  , VAR_INTRINSIC , NULL}				,
	{"MAJOR"		, MAJOR		  , VAR_INTRINSIC , NULL}				,
	{"MAP"			, MAP		  , VAR_INTRINSIC , NULL}				,
	{"MAX"			, MAXP		  , VAR_INTRINSIC , NULL}				,
	{"MAXOF"		, FUNC_DD	  , VAR_INTRINSIC , (void *) max_wrap}		,
	{"MESH"			, MESH		  , VAR_INTRINSIC , NULL}				,
	{"MESH2D"		, MESH2D	  , VAR_INTRINSIC , NULL}				,
	{"MIN"			, MINP		  , VAR_INTRINSIC , NULL}				,
	{"MINMAX"		, MINMAXP	  , VAR_INTRINSIC , NULL}				,
	{"MINOF"		, FUNC_DD	  , VAR_INTRINSIC , (void *) min_wrap}		,
	{"MINOR"		, MINOR		  , VAR_INTRINSIC , NULL}				,
	{"MMDD"			, MMDD		  , VAR_INTRINSIC , NULL}				,
	{"MMDDHMS"		, MMDDHMS	  , VAR_INTRINSIC , NULL}				,
	{"MMDDYY"		, MMDDYY	  , VAR_INTRINSIC , NULL}				,
	{"MMDDYYHMS"		, MMDDYYHMS	  , VAR_INTRINSIC , NULL}				,
	{"MMSSLAT"		, MMSSLAT	  , VAR_INTRINSIC , NULL}				,
	{"MMSSLON"		, MMSSLON	  , VAR_INTRINSIC , NULL}				,
	{"MMYY"			, MMYY		  , VAR_INTRINSIC , NULL}				,
	{"MOD"			, FUNC_DD	  , VAR_INTRINSIC , (void *) fmod}		,
	{"MONTHDAY"		, MONTHDAY	  , VAR_INTRINSIC , NULL}				,
	{"MONTHL"		, MONTHL	  , VAR_INTRINSIC , NULL}				,
	{"MONTHS"		, MONTHS	  , VAR_INTRINSIC , NULL}				,
	{"MONTHSY"		, MONTHSY	  , VAR_INTRINSIC , NULL}				,
	{"MOVE"			, MOVE		  , VAR_INTRINSIC , NULL}				,
	{"NDTR"			, FUNC_D	  , VAR_INTRINSIC , (void *) ndtr}		,
	{"NDTRI"		, FUNC_D	  , VAR_INTRINSIC , (void *) ndtri}		,
	{"NE"			, NE		  , VAR_INTRINSIC , NULL}				,
	{"NEGATE"		, NEGATE	  , VAR_INTRINSIC , NULL}				,
	{"NEW"			, NEW		  , VAR_INTRINSIC , NULL}				,
	{"NONE"			, NONE		  , VAR_INTRINSIC , NULL}				,
	{"NONLFIT"		, NONLFIT	  , VAR_INTRINSIC , NULL}				,
	{"NORM"			, FUNC_D	  , VAR_INTRINSIC , (void *) fx}			,
	{"NORMAL"		, NORMAL	  , VAR_INTRINSIC , NULL}				,
	{"NOT"			, NOT		  , VAR_INTRINSIC , NULL}				,
	{"NTICKS"		, NTICKS 	  , VAR_INTRINSIC , NULL}				,
	{"NXY"			, NXY		  , VAR_INTRINSIC , NULL}				,
	{"OBJ"			, OBJ		  , VAR_INTRINSIC , NULL}				,
	{"OFF"			, OFF		  , VAR_INTRINSIC , NULL}				,
	{"OFFSET"		, OFFSET	  , VAR_INTRINSIC , NULL}				,
	{"OFFSETX"		, OFFSETX	  , VAR_INTRINSIC , NULL}				,
	{"OFFSETY"		, OFFSETY	  , VAR_INTRINSIC , NULL}				,
	{"OFILTER"		, OFILTER	  , VAR_INTRINSIC , NULL}				,
	{"ON"			, ON		  , VAR_INTRINSIC , NULL}				,
	{"ONREAD"		, ONREAD	  , VAR_INTRINSIC , NULL}				,
	{"OP"			, OP		  , VAR_INTRINSIC , NULL}				,
	{"OPEN"			, OPEN		  , VAR_INTRINSIC , NULL}				,
	{"OPPOSITE"		, OPPOSITE	  , VAR_INTRINSIC , NULL}				,
	{"OR"			, OR		  , VAR_INTRINSIC , NULL}				,
	{"OUT"			, OUT		  , VAR_INTRINSIC , NULL}				,
	{"PAGE"			, PAGE		  , VAR_INTRINSIC , NULL}				,
	{"PARA"			, PARA		  , VAR_INTRINSIC , NULL}				,
	{"PARAMETERS"		, PARAMETERS	  , VAR_INTRINSIC , NULL}				,
	{"PARZEN"		, PARZEN	  , VAR_INTRINSIC , NULL}				,
	{"PATTERN"		, PATTERN	  , VAR_INTRINSIC , NULL}				,
	{"PDTR"			, FUNC_ND	  , VAR_INTRINSIC , (void *) pdtr}		,
	{"PDTRC"		, FUNC_ND	  , VAR_INTRINSIC , (void *) pdtrc}		,
	{"PDTRI"		, FUNC_ND	  , VAR_INTRINSIC , (void *) pdtri}		,
	{"PERIOD"		, PERIOD	  , VAR_INTRINSIC , NULL}				,
	{"PERP"			, PERP		  , VAR_INTRINSIC , NULL}				,
	{"PHASE"		, PHASE		  , VAR_INTRINSIC , NULL}				,
	{"PI"			, CONSTANT	  , VAR_INTRINSIC , (void *) pi_const}		,
	{"PIE"			, PIE		  , VAR_INTRINSIC , NULL}				,
	{"PIPE"			, PIPE		  , VAR_INTRINSIC , NULL}				,
	{"PLACE"		, PLACE		  , VAR_INTRINSIC , NULL}				,
	{"POINT"		, POINT		  , VAR_INTRINSIC , NULL}				,
	{"POLAR"		, POLAR		  , VAR_INTRINSIC , NULL}				,
	{"POLYI"		, POLYI		  , VAR_INTRINSIC , NULL}				,
	{"POLYLINE"		, POLYLINE	  , VAR_INTRINSIC , NULL}				,
	{"POLYO"		, POLYO		  , VAR_INTRINSIC , NULL}				,
	{"POP"			, POP		  , VAR_INTRINSIC , NULL}				,
	{"PORTRAIT"		, PORTRAIT	  , VAR_INTRINSIC , NULL}				,
	{"POSITIVE"		, POSITIVE	  , VAR_INTRINSIC , NULL}				,
	{"POWER"		, POWER		  , VAR_INTRINSIC , NULL}				,
	{"PREC"			, PREC		  , VAR_INTRINSIC , NULL}				,
	{"PREPEND"		, PREPEND	  , VAR_INTRINSIC , NULL}				,
	{"PRINT"		, PRINT		  , VAR_INTRINSIC , NULL}				,
	{"PS"			, PS		  , VAR_INTRINSIC , NULL}				,
	{"PSI"			, FUNC_D	  , VAR_INTRINSIC , (void *) psi}			,
	{"PUSH"			, PUSH		  , VAR_INTRINSIC , NULL}				,
	{"PUTP"			, PUTP		  , VAR_INTRINSIC , NULL}				,
	{"RAD"			, UCONSTANT	  , VAR_INTRINSIC , (void *) rad_uconst}		,
	{"RAND"			, RAND		  , VAR_INTRINSIC , NULL}				,
	{"READ"			, READ		  , VAR_INTRINSIC , NULL}				,
	{"REAL"			, REAL		  , VAR_INTRINSIC , NULL}				,
	{"RECIPROCAL"		, RECIPROCAL	  , VAR_INTRINSIC , NULL}				,
	{"REDRAW"		, REDRAW	  , VAR_INTRINSIC , NULL}				,
	{"REFERENCE"		, REFERENCE	  , VAR_INTRINSIC , NULL}				,
	{"REGRESS"		, REGRESS	  , VAR_INTRINSIC , NULL}				,
	{"RESIDUALS"		, RESIDUALS	  , VAR_INTRINSIC , NULL}				,
	{"RESIZE"		, RESIZE	  , VAR_INTRINSIC , NULL}				,
	{"RESTRICT"		, RESTRICT	  , VAR_INTRINSIC , NULL}				,
	{"RESULTS"		, RESULTS	  , VAR_INTRINSIC , NULL}				,
	{"REVERSE"		, REVERSE	  , VAR_INTRINSIC , NULL}				,
	{"RGAMMA"		, FUNC_D	  , VAR_INTRINSIC , (void *) rgamma}		,
	{"RIGHT"		, RIGHT		  , VAR_INTRINSIC , NULL}				,
	{"RINT"			, FUNC_D	  , VAR_INTRINSIC , (void *) rint}		,
	{"RISER"		, RISER		  , VAR_INTRINSIC , NULL}				,
	{"RNORM"		, FUNC_DD	  , VAR_INTRINSIC , (void *) rnorm}		,
	{"ROT"			, ROT		  , VAR_INTRINSIC , NULL}				,
	{"ROUNDED"		, ROUNDED	  , VAR_INTRINSIC , NULL}				,
	{"RSUM"			, RSUM		  , VAR_INTRINSIC , NULL}				,
	{"RULE"			, RULE		  , VAR_INTRINSIC , NULL}				,
	{"RUNAVG"		, RUNAVG	  , VAR_INTRINSIC , NULL}				,
	{"RUNMAX"		, RUNMAX	  , VAR_INTRINSIC , NULL}				,
	{"RUNMED"		, RUNMED	  , VAR_INTRINSIC , NULL}				,
	{"RUNMIN"		, RUNMIN	  , VAR_INTRINSIC , NULL}				,
	{"RUNSTD"		, RUNSTD	  , VAR_INTRINSIC , NULL}				,
	{"SAMPLE"		, SAMPLE	  , VAR_INTRINSIC , NULL}				,
	{"SAVEALL"		, SAVEALL	  , VAR_INTRINSIC , NULL}				,
	{"SCALE"		, SCALE		  , VAR_INTRINSIC , NULL}				,
	{"SCIENTIFIC"		, SCIENTIFIC	  , VAR_INTRINSIC , NULL}				,
	{"SCROLL"		, SCROLL	  , VAR_INTRINSIC , NULL}				,
	{"SD"			, SD		  , VAR_INTRINSIC , NULL}				,
	{"SET"			, SET		  , VAR_INTRINSIC , NULL}				,
	{"SELXY"		, SELXY		  , VAR_INTRINSIC , NULL}				,
	{"SFORMAT"		, SFORMAT	  , VAR_INTRINSIC , NULL}				,
	{"SGN"			, FUNC_D	  , VAR_INTRINSIC , (void *) sign_wrap}		,
	{"SHI"			, FUNC_D	  , VAR_INTRINSIC , (void *) shi_wrap}		,
	{"SI"			, FUNC_D	  , VAR_INTRINSIC , (void *) si_wrap}		,
	{"SIGN"			, SIGN		  , VAR_INTRINSIC , NULL}				,
	{"SIN"			, FUNC_D	  , VAR_INTRINSIC , (void *) sin}			,
	{"SINH"			, FUNC_D	  , VAR_INTRINSIC , (void *) sinh}		,
	{"SIZE"			, SIZE		  , VAR_INTRINSIC , NULL}				,
	{"SKIP"			, SKIP		  , VAR_INTRINSIC , NULL}				,
	{"SLEEP"		, SLEEP		  , VAR_INTRINSIC , NULL}				,
	{"SMITH"		, SMITH		  , VAR_INTRINSIC , NULL}				,
	{"SORT"			, SORT		  , VAR_INTRINSIC , NULL}				,
	{"SOURCE"		, SOURCE	  , VAR_INTRINSIC , NULL}				,
	{"SPEC"			, SPEC		  , VAR_INTRINSIC , NULL}				,
	{"SPENCE"		, FUNC_D	  , VAR_INTRINSIC , (void *) spence}		,
	{"SPLINE"		, SPLINE	  , VAR_INTRINSIC , NULL}				,
	{"SPLIT"		, SPLIT		  , VAR_INTRINSIC , NULL}				,
	{"SQR"			, FUNC_D	  , VAR_INTRINSIC , (void *) sqr_wrap}		,
	{"SQRT"			, FUNC_D	  , VAR_INTRINSIC , (void *) sqrt}		,
	{"STACK"		, STACK		  , VAR_INTRINSIC , NULL}				,
	{"STACKED"		, STACKED	  , VAR_INTRINSIC , NULL}				,
	{"STACKEDBAR"		, STACKEDBAR	  , VAR_INTRINSIC , NULL}				,
	{"STACKEDHBAR"		, STACKEDHBAR	  , VAR_INTRINSIC , NULL}				,
	{"STAGGER"		, STAGGER	  , VAR_INTRINSIC , NULL}				,
	{"START"		, START		  , VAR_INTRINSIC , NULL}				,
	{"STDTR"		, FUNC_ND	  , VAR_INTRINSIC , (void *) stdtr}		,
	{"STDTRI"		, FUNC_ND	  , VAR_INTRINSIC , (void *) stdtri}		,
	{"STEPS"		, STEPS		  , VAR_INTRINSIC , NULL}				,
	{"STOP"			, STOP		  , VAR_INTRINSIC , NULL}				,
	{"STRING"		, STRING	  , VAR_INTRINSIC , NULL}				,
	{"STRUVE"		, FUNC_DD	  , VAR_INTRINSIC , (void *) struve}		,
	{"SUBTITLE"		, SUBTITLE	  , VAR_INTRINSIC , NULL}				,
	{"SUM"			, SUM		  , VAR_INTRINSIC , NULL}				,
	{"SWAP"			, SWAP		  , VAR_INTRINSIC , NULL}				,
	{"SYMBOL"		, SYMBOL	  , VAR_INTRINSIC , NULL}				,
	{"SYMMETRIC"		, SYMMETRIC	  , VAR_INTRINSIC , NULL}				,
	{"TAN"			, FUNC_D	  , VAR_INTRINSIC , (void *) tan}			,
	{"TANH"			, FUNC_D	  , VAR_INTRINSIC , (void *) tanh}		,
	{"TARGET"		, TARGET	  , VAR_INTRINSIC , NULL}				,
	{"TICK"			, TICKP		  , VAR_INTRINSIC , NULL}				,
	{"TICKLABEL"		, TICKLABEL	  , VAR_INTRINSIC , NULL}				,
	{"TICKS"		, TICKSP	  , VAR_INTRINSIC , NULL}				,
	{"TIMER"		, TIMER		  , VAR_INTRINSIC , NULL}				,
	{"TIMESTAMP"		, TIMESTAMP	  , VAR_INTRINSIC , NULL}				,
	{"TITLE"		, TITLE		  , VAR_INTRINSIC , NULL}				,
	{"TO"			, TO		  , VAR_INTRINSIC , NULL}				,
	{"TOP"			, TOP		  , VAR_INTRINSIC , NULL}				,
	{"TRACE"		, TRACE		  , VAR_INTRINSIC , NULL}				,
	{"TRIANGULAR"		, TRIANGULAR	  , VAR_INTRINSIC , NULL}				,
	{"TRUE"			, ON		  , VAR_INTRINSIC , NULL}				,
	{"TYPE"			, TYPE		  , VAR_INTRINSIC , NULL}				,
	{"UNIT"			, KEY_UNIT	  , VAR_INTRINSIC , NULL}				,
	{"UP"			, UP		  , VAR_INTRINSIC , NULL}				,
	{"UPDATEALL"		, UPDATEALL	  , VAR_INTRINSIC , NULL}				,
	{"USE"			, USE		  , VAR_INTRINSIC , NULL}				,
	{"VALUES"		, VALUES	  , VAR_INTRINSIC , NULL}				,
	{"VERSION"		, VERSION	  , VAR_INTRINSIC , NULL}				,
	{"VERTI"		, VERTI		  , VAR_INTRINSIC , NULL}				,
	{"VERTICAL"		, VERTICAL	  , VAR_INTRINSIC , NULL}				,
	{"VERTO"		, VERTO		  , VAR_INTRINSIC , NULL}				,
	{"VGAP"			, VGAP		  , VAR_INTRINSIC , NULL}				,
	{"VIEW"			, VIEW		  , VAR_INTRINSIC , NULL}				,
	{"VMAP"			, VMAP		  , VAR_INTRINSIC , NULL}				,
	{"VOIGT"		, FUNC_PPD	  , VAR_INTRINSIC , (void *) voigt}		,
	{"VX1"			, VX1		  , VAR_INTRINSIC , NULL}				,
	{"VX2"			, VX2		  , VAR_INTRINSIC , NULL}				,
	{"VXMAX"		, VXMAX		  , VAR_INTRINSIC , NULL}				,
	{"VY1"			, VY1		  , VAR_INTRINSIC , NULL}				,
	{"VY2"			, VY2		  , VAR_INTRINSIC , NULL}				,
	{"VYMAX"		, VYMAX		  , VAR_INTRINSIC , NULL}				,
	{"WAVELET"		, WAVELET	  , VAR_INTRINSIC , NULL}				,
	{"WEIGHT"		, WEIGHT	  , VAR_INTRINSIC , NULL}				,
	{"WELCH"		, WELCH		  , VAR_INTRINSIC , NULL}				,
	{"WITH"			, WITH		  , VAR_INTRINSIC , NULL}				,
	{"WORLD"		, WORLD		  , VAR_INTRINSIC , NULL}				,
	{"WRAP"			, WRAP		  , VAR_INTRINSIC , NULL}				,
	{"WRITE"		, WRITE		  , VAR_INTRINSIC , NULL}				,
	{"WX1"			, WX1		  , VAR_INTRINSIC , NULL}				,
	{"WX2"			, WX2		  , VAR_INTRINSIC , NULL}				,
	{"WY1"			, WY1		  , VAR_INTRINSIC , NULL}				,
	{"WY2"			, WY2		  , VAR_INTRINSIC , NULL}				,
	{"X"			, X_TOK		  , VAR_INTRINSIC , NULL}				,
	{"X0"			, X0		  , VAR_INTRINSIC , NULL}				,
	{"X1"			, X1		  , VAR_INTRINSIC , NULL}				,
	{"XAXES"		, XAXES		  , VAR_INTRINSIC , NULL}				,
	{"XAXIS"		, XAXIS		  , VAR_INTRINSIC , NULL}				,
	{"XCOR"			, XCOR		  , VAR_INTRINSIC , NULL}				,
	{"XMAX"			, XMAX		  , VAR_INTRINSIC , NULL}				,
	{"XMIN"			, XMIN		  , VAR_INTRINSIC , NULL}				,
	{"XSPLINE"		, XSPLINE	  , VAR_INTRINSIC , NULL}				,
	{"XY"			, XY		  , VAR_INTRINSIC , NULL}				,
	{"XYAXES"		, XYAXES	  , VAR_INTRINSIC , NULL}				,
	{"XYBOXPLOT"		, XYBOXPLOT	  , VAR_INTRINSIC , NULL}				,
	{"XYCOLOR"		, XYCOLOR	  , VAR_INTRINSIC , NULL}				,
	{"XYCOLPAT"		, XYCOLPAT	  , VAR_INTRINSIC , NULL}				,
	{"XYDX"			, XYDX		  , VAR_INTRINSIC , NULL}				,
	{"XYDXDX"		, XYDXDX	  , VAR_INTRINSIC , NULL}				,
	{"XYDXDXDYDY"		, XYDXDXDYDY	  , VAR_INTRINSIC , NULL}				,
	{"XYDXDY"		, XYDXDY	  , VAR_INTRINSIC , NULL}				,
	{"XYDY"			, XYDY		  , VAR_INTRINSIC , NULL}				,
	{"XYDYDY"		, XYDYDY	  , VAR_INTRINSIC , NULL}				,
	{"XYHILO"		, XYHILO	  , VAR_INTRINSIC , NULL}				,
	{"XYR"			, XYR		  , VAR_INTRINSIC , NULL}				,
	{"XYSIZE"		, XYSIZE	  , VAR_INTRINSIC , NULL}				,
	{"XYSPLINE"		, XYSPLINE	  , VAR_INTRINSIC , NULL}				,
	{"XYSTRING"		, XYSTRING	  , VAR_INTRINSIC , NULL}				,
	{"XYCMAP"		, XYCMAP	  , VAR_INTRINSIC , NULL}				,
	{"XYVMAP"		, XYVMAP	  , VAR_INTRINSIC , NULL}				,
	{"XYZ"			, XYZ		  , VAR_INTRINSIC , NULL}				,
	{"Y"			, Y_TOK		  , VAR_INTRINSIC , NULL}				,
	{"Y0"			, Y0		  , VAR_INTRINSIC , NULL}				,
	{"Y1"			, Y1		  , VAR_INTRINSIC , NULL}				,
	{"Y2"			, Y2		  , VAR_INTRINSIC , NULL}				,
	{"Y3"			, Y3		  , VAR_INTRINSIC , NULL}				,
	{"Y4"			, Y4		  , VAR_INTRINSIC , NULL}				,
	{"YAXES"		, YAXES		  , VAR_INTRINSIC , NULL}				,
	{"YAXIS"		, YAXIS		  , VAR_INTRINSIC , NULL}				,
	{"YEAR"			, YEAR		  , VAR_INTRINSIC , NULL}				,
	{"YMAX"			, YMAX		  , VAR_INTRINSIC , NULL}				,
	{"YMIN"			, YMIN		  , VAR_INTRINSIC , NULL}				,
	{"YV"			, FUNC_DD	  , VAR_INTRINSIC , (void *) yv_wrap}		,
	{"YYMMDD"		, YYMMDD	  , VAR_INTRINSIC , NULL}				,
	{"YYMMDDHMS"		, YYMMDDHMS	  , VAR_INTRINSIC , NULL}				,
	{"ZERO"			, ZERO		  , VAR_INTRINSIC , NULL}				,
	{"ZEROXAXIS"		, ALTXAXIS	  , VAR_INTRINSIC , NULL}				,
	{"ZEROYAXIS"		, ALTYAXIS	  , VAR_INTRINSIC , NULL}				,
	{"ZETA"			, FUNC_DD	  , VAR_INTRINSIC , (void *) zeta}		,
	{"ZETAC"		, FUNC_D	  , VAR_INTRINSIC , (void *) zetac}		,
	{"ZNORM"		, ZNORM		  , VAR_INTRINSIC , NULL}                       ,
	{"ZSCALE"		, ZSCALE	  , VAR_INTRINSIC , NULL}
};

const  int maxintrinsics = sizeof(ikey) / sizeof(symtab_entry);
static int maxfunc = sizeof(ikey) / sizeof(symtab_entry);

int get_parser_gno(void)
{
    return gn;
}

int set_parser_gno(int gno)
{
    if (is_valid_gno(gno) == TRUE) {
      gn = gno;
      /* For compatibility with Grace */
      lock_dirtystate (TRUE);
      if (gno == 0) set_graph_hidden (0 ,FALSE);
      lock_dirtystate (FALSE);
        return RETURN_SUCCESS;
    } else {
        return RETURN_FAILURE;
    }
}

int get_parser_setno(void)
{
    return sn;
}

int set_parser_setno(int gno, int setno)
{
    if (is_valid_setno(gno, setno) == TRUE) {
        gn = gno;
        sn = setno;
        /* those will usually be overridden except when evaluating
           a _standalone_ vexpr */
        vasgn_gno = gno;
        vasgn_setno = setno;
        return RETURN_SUCCESS;
    } else {
        return RETURN_FAILURE;
    }
}

/* Resize user defined vectors */
void realloc_vrbl(grarr *vrbl, int len)
{
    double *a;
    int i, oldlen;

    if (vrbl->type != GRARR_VEC) {
        errmsg("Internal error");
        return;
    }
    oldlen = vrbl->length;
    if (oldlen == len) {
        return;
    } else {
        a = xrealloc(vrbl->data, len*SIZEOF_DOUBLE);
        if (a != NULL || len == 0) {
            vrbl->data = a;
            vrbl->length = len;
            for (i = oldlen; i < len; i++) {
                vrbl->data[i] = 0.0;
            }
        } else {
            errmsg("Malloc failed in realloc_vrbl()");
        }
    }
}


//flow  static int com_depth = 0;
//flow  static char **com_tree = NULL;  /* command tree */

static int parser (const char *s, int type)
{
    char *seekpos;
    int i;

    if (s == NULL || s[0] == '\0') {
        if (type == PARSER_TYPE_VOID) {
            /* don't consider an empty string as error for generic parser */
            return RETURN_SUCCESS;
        } else {
            return RETURN_FAILURE;
        }
    } else if (fplog != NULL) {
       fprintf (fplog ,"@ %s " ,s);
    }

//flow      if (type == PARSER_TYPE_PUSH) {  /* push lines on the tree */
//flow      }

    strncpy(f_string, s, MAX_PARS_STRING_LENGTH - 2);
    f_string[MAX_PARS_STRING_LENGTH - 2] = '\0';
    strcat(f_string, " ");

    seekpos = f_string;

    while ((seekpos - f_string < MAX_PARS_STRING_LENGTH - 1) && (*seekpos == ' ' || *seekpos == '\t')) {
        seekpos++;
    }
    if (*seekpos == '\n' || *seekpos == '#') {
        if (type == PARSER_TYPE_VOID) {
            /* don't consider an empty string as error for generic parser */
            return RETURN_SUCCESS;
        } else {
            return RETURN_FAILURE;
        }
    }

    lowtoupper(f_string);

    pos = 0;
    interr = 0;
    expr_parsed  = FALSE;
    vexpr_parsed = FALSE;

    yyparse();

    /* free temp. arrays; for a vector expression keep the last one
     * (which is none but v_result), given there have been no errors
     * and it's what we've been asked for
     */
    if (vexpr_parsed && !interr && type == PARSER_TYPE_VEXPR) {
        for (i = 0; i < fcnt - 1; i++) {
            free_grarr (&(freelist[i]));
        }
    } else {
        for (i = 0; i < fcnt; i++) {
            free_grarr (&(freelist[i]));
        }
    }
    fcnt = 0;

    tgtn = 0;

    if ((type == PARSER_TYPE_VEXPR && !vexpr_parsed) ||
        (type == PARSER_TYPE_EXPR  && !expr_parsed)) {
        return RETURN_FAILURE;
    } else {
        return (interr ? RETURN_FAILURE:RETURN_SUCCESS);
    }
}

int s_scanner(char *s, double *res)
{
    int retval = parser(s, PARSER_TYPE_EXPR);
    *res = s_result;
    return retval;
}

int v_scanner (const char *s, int *reslen, double **vres)
{
    int retval = parser(s, PARSER_TYPE_VEXPR);
    if (retval != RETURN_SUCCESS) {
        return RETURN_FAILURE;
    } else {
        *reslen = v_result->length;
        if (v_result->type == GRARR_TMP) {
            *vres = v_result->data;
            v_result->length = 0;
            v_result->data = NULL;
        } else {
            *vres = copy_data_column(v_result->data, v_result->length);
        }
        return RETURN_SUCCESS;
    }
}

int scanner(char *s)
{
    int retval = parser(s, PARSER_TYPE_VOID);
    if (retval != RETURN_SUCCESS) {
        return RETURN_FAILURE;
    }

    if (gotparams) {
	gotparams = FALSE;
        getparms(paramfile);
    }

    if (gotread) {
	gotread = FALSE;
        getdata(gn, readfile, cursource, LOAD_SINGLE);
    }

    return retval;
}

/******** Management of grace arrays grarr *********/

static void free_grarr (grarr *gar)
{
    if (gar->type == GRARR_TMP) {
        XCFREE(gar->data);
	gar->length = 0;
	gar->nrows  = 0;
	gar->ncols  = 0;
    } else if (gar->type == GRARR_MATTMP) {
      int i;
      for (i = 0; i < gar->nrows; i++) XCFREE (gar->matrix[i]);
      XCFREE (gar->matrix);
      gar->length = 0;
      gar->nrows  = 0;
      gar->ncols  = 0;
    }
}

static void copy_grarr (grarr *dest, grarr *src)
{
  int i;
  dest->type = src->type;
  switch (src->type) {
  case GRARR_MAT:
    dest->matrix = xmalloc (src->nrows * sizeof(double *));
    for (i = 0; i < src->nrows; i++) {
      dest->matrix[i] = xmalloc (src->ncols * SIZEOF_DOUBLE);
      memcpy (dest->matrix[i], src->matrix[i], src->ncols*SIZEOF_DOUBLE);
    }
    dest->length = src->length;
    dest->ncols = src->ncols;
    dest->nrows = src->nrows;
    break;
  default:
    dest->data = xmalloc(src->length*SIZEOF_DOUBLE);
    if (dest->data == NULL) {
      errmsg("Malloc failed in copy_grarr ()");
    } else {
      memcpy(dest->data, src->data, src->length*SIZEOF_DOUBLE);
      dest->length = src->length;
    }
    break;
  }
}

grarr *get_parser_arr_by_name(char * const name)
{
     int position;
     char *s;

     s = copy_string(NULL, name);
     lowtoupper(s);

     position = findf(key, s);
     xfree(s);

     if (position >= 0) {
         if (key[position].type == KEY_VEC) {
            return (grarr *) key[position].data;
         } else if (key[position].type == KEY_MAT) {
            return (grarr *) key[position].data;
	 }
     }

     return NULL;
}

grarr *define_parser_arr(char * const name ,VarStatus status)
{
     if (get_parser_arr_by_name(name) == NULL) {
	symtab_entry tmpkey;
        grarr *var;

        var = xmalloc(sizeof(grarr));
        var->type = GRARR_VEC;
        var->length = 0;
        var->data = NULL;

	tmpkey.s      = name;
	tmpkey.type   = KEY_VEC;
	tmpkey.status = status;
	tmpkey.data   = (void *) var;
	if (addto_symtab(tmpkey) == RETURN_SUCCESS) {
	    return var;
	} else {
            return NULL;
        }
     } else {
        return NULL;
     }
}

/**
 * Define an array with two indices (a matrix), allocate memory
 *   and initialise to zero.
 */
grarr *define_parser_arr2 (char * const name ,VarStatus status ,int nrows ,int ncols)
{
  int i ,j;
     if (get_parser_arr_by_name(name) == NULL) {
	symtab_entry tmpkey;
        grarr *var;
        /* first create the entry */
        var = xmalloc(sizeof(grarr));
        var->type   = GRARR_MAT;
        var->length = 0;
        var->data   = NULL;
        var->matrix = NULL;
        /* and add to symbol table */
	tmpkey.s      = name;
	tmpkey.type   = KEY_MAT;
	tmpkey.status = status;
	tmpkey.data   = (void *) var;
	if (addto_symtab(tmpkey) == RETURN_SUCCESS) {
	  /* then allocate memory */
	  var->matrix = malloc (nrows * sizeof(double *));
	  for (i = 0; i < nrows; i++) {
	    var->matrix[i] = malloc (ncols * SIZEOF_DOUBLE);
	    for (j = 0; j < ncols; j++) var->matrix[i][j] = 0.0;
	  }
	  var->length = nrows * ncols;
	  var->nrows  = nrows;
	  var->ncols  = ncols;
	  return var;
	} else {
            return NULL;
        }
     } else {
        return NULL;
     }
}


/******** Management of symbols in key array *********/


int undefine_parser_var(void *ptr)
{
    int i;

    for (i = 0; i < maxfunc; i++) {
	if (key[i].data == ptr) {
            xfree(key[i].s);
            maxfunc--;
            if (i != maxfunc) {
                memmove(&(key[i]), &(key[i + 1]), (maxfunc - i)*sizeof(symtab_entry));
            }
            key = xrealloc(key, maxfunc*sizeof(symtab_entry));
            return RETURN_SUCCESS;
        }
    }
    return RETURN_FAILURE;
}

static void undefine_all_users_var (void)
{
  int i;
  grarr *var;
  /* Free user defined and temporary matrices and vectors */
  for (i = 0; i < matcnt; i++) free_grarr (&mattmp[i]);
  for (i = 0; i < fcnt;   i++) free_grarr (&freelist[i]);
  /* free symbol table entry and data */
  for (i = maxfunc; i > 0; i--) {
    if (key[i].status == VAR_USER) {
      var = (grarr*) (&key[i].data);
      xfree (key[i].s);
      if (key[i].type == GRARR_VEC) {
	realloc_vrbl (var, 0);
      } else if (key[i].type == GRARR_MAT) {
	free_grarr (var);
      }
      maxfunc--;
      if (i != maxfunc) {
	memmove(&(key[i]), &(key[i + 1]), (maxfunc - i)*sizeof(symtab_entry));
      }
      key = xrealloc (key, maxfunc*sizeof(symtab_entry));
    }
  }
}


static int find_set_bydata(double *data, target *tgt)
{
    int gno, setno, ncol;

    if (data == NULL) {
        return RETURN_FAILURE;
    } else {
        for (gno = 0; gno < number_of_graphs(); gno++) {
            for (setno = 0; setno < number_of_sets(gno); setno++) {
                for (ncol = 0; ncol < MAX_SET_COLS; ncol++) {
                    if (getcol(gno, setno, ncol) == data) {
                        tgt->gno   = gno;
                        tgt->setno = setno;
                        return RETURN_SUCCESS;
                    }
                }
            }
        }
    }
    return RETURN_FAILURE;
}

static int findf(symtab_entry *keytable, char *s)
{

    int low, high, mid;

    low = 0;
    high = maxfunc - 1;
    while (low <= high) {
	mid = (low + high) / 2;
	if (strcmp(s, keytable[mid].s) < 0) {
	    high = mid - 1;
	} else {
	    if (strcmp(s, keytable[mid].s) > 0) {
		low = mid + 1;
	    } else {
		return (mid);
	    }
	}
    }
    return (-1);
}

static int compare_keys (const void *a, const void *b)
{
    return (int) strcmp (((const symtab_entry*)a)->s,
                         ((const symtab_entry*)b)->s);
}

/* add new entry to the symbol table */
int addto_symtab(symtab_entry newkey)
{
    int position;
    char *s;

    s = copy_string(NULL, newkey.s);
    lowtoupper(s);
    if ((position = findf(key, s)) < 0) {
        if ((key = (symtab_entry *) xrealloc(key, (maxfunc + 1)*sizeof(symtab_entry))) != NULL) {
	    key[maxfunc].type	= newkey.type;
	    key[maxfunc].status	= newkey.status;
	    key[maxfunc].data	= newkey.data;
	    key[maxfunc].s	= s;
	    maxfunc++;
	    qsort(key, maxfunc, sizeof(symtab_entry), compare_keys);
	    return RETURN_SUCCESS;
	} else {
	    xfree(s);
	    return RETURN_FAILURE;
	}
    } else if (alias_force == TRUE) { /* already exists but alias_force enabled */
        key[position].type   = newkey.type;
	key[position].data   = newkey.data;
	key[position].status = newkey.status;
	return RETURN_SUCCESS;
    } else {
	xfree(s);
        return RETURN_FAILURE;
    }
}

/* initialize symbol table */
void init_symtab(void)
{
    int i;

    if ((key = (symtab_entry *) xmalloc(maxfunc*sizeof(symtab_entry))) != NULL) {
    	memcpy (key, ikey, maxfunc*sizeof(symtab_entry));
	for (i = 0; i < maxfunc; i++) {
	    key[i].s = xmalloc(strlen(ikey[i].s) + 1);
	    strcpy(key[i].s, ikey[i].s);
	}
	qsort(key, maxfunc, sizeof(symtab_entry), compare_keys);
	return;
    } else {
	key = ikey;
	return;
    }
}

static int getcharstr(void)
{
    if (pos >= strlen(f_string))
	 return EOF;
    return (f_string[pos++]);
}

static void ungetchstr(void)
{
    if (pos > 0)
	pos--;
}

static int yylex(void)
{
    int c, i;
    int found;
    char sbuf[MAX_PARS_STRING_LENGTH + 40];

    while ((c = getcharstr()) == ' ' || c == '\t');
    if (c == EOF) {
	return (0);
    }
    if (c == '"') {
	i = 0;
	while ((c = getcharstr()) != '"' && c != EOF) {
	    if (c == '\\') {
		int ctmp;
		ctmp = getcharstr();
		if (ctmp != '"') {
		    ungetchstr();
		}
		else {
		    c = ctmp;
		}
	    }
	    sbuf[i] = c;
	    i++;
	}
	if (c == EOF) {
	    yyerror("Nonterminating string");
	    return 0;
	}
	sbuf[i] = '\0';
	yylval.sval = copy_string(NULL, sbuf);
	return CHRSTR;
    }
    if (c == '.' || isdigit(c)) {
	double d;
	int i, gotdot = 0;

	i = 0;
	while (c == '.' || isdigit(c)) {
	    if (c == '.') {
		if (gotdot) {
		    yyerror("Reading number, too many dots");
	    	    return 0;
		} else {
		    gotdot = 1;
		}
	    }
	    sbuf[i++] = c;
	    c = getcharstr();
	}
	if (c == 'E' || c == 'e') {
	    sbuf[i++] = c;
	    c = getcharstr();
	    if (c == '+' || c == '-') {
		sbuf[i++] = c;
		c = getcharstr();
	    }
	    while (isdigit(c)) {
		sbuf[i++] = c;
		c = getcharstr();
	    }
	}
	if (gotdot && i == 1) {
	    ungetchstr();
	    return '.';
	}
	sbuf[i] = '\0';
	ungetchstr();
	sscanf(sbuf, "%lf", &d);
	yylval.dval = d;
	return NUMBER;
    }
/* graphs, sets, regions resp. */
    if (c == 'G' || c == 'S' || c == 'R') {
	int i = 0, ctmp = c, gna, sna, rn;
	c = getcharstr();
	while (isdigit(c) || c == '$' || c == '_') {
	    sbuf[i++] = c;
	    c = getcharstr();
	}
	if (i == 0) {
	    c = ctmp;
	    ungetchstr();
	} else {
	    ungetchstr();
	    if (ctmp == 'G') {
	        sbuf[i] = '\0';
		if (i == 1 && sbuf[0] == '_') {
                    gna = get_recent_gno();
                } else if (i == 1 && sbuf[0] == '$') {
                    gna = gn;
                } else {
                    gna = atoi(sbuf);
                }
		if (is_valid_gno(gna) || graph_allocate(gna) == RETURN_SUCCESS) {
		    yylval.ival = gna;
		    return GRAPHNO;
		}
	    } else if (ctmp == 'S') {
	        sbuf[i] = '\0';
		if (i == 1 && sbuf[0] == '_') {
                    sna = get_recent_setno();
                } else if (i == 1 && sbuf[0] == '$') {
                    sna = sn;
                } else {
		    sna = atoi(sbuf);
                }
		yylval.ival = sna;
		return SETNUM;
	    } else if (ctmp == 'R') {
	        sbuf[i] = '\0';
		rn = atoi(sbuf);
		if (rn >= 0 && rn < MAXREGION) {
		    yylval.ival = rn;
		    return REGNUM;
		} else {
                    errmsg("Invalid region number");
                }
	    }
	}
    }
    if (isalpha(c) || c == '$') {
	char *p = sbuf;

	do {
	    *p++ = c;
	} while ((c = getcharstr()) != EOF && (isalpha(c) || isdigit(c) ||
                  c == '_' || c == '$'));
	ungetchstr();
	*p = '\0';
#ifdef DEBUG
        if (get_debuglevel() == 2) {
	    printf("->%s<-\n", sbuf);
	}
#endif
	found = -1;
	if ((found = findf(key, sbuf)) >= 0) {
	    if (key[found].type == FITPARM) {
		int index = sbuf[1] - '0';
		yylval.ival = index;
		return FITPARM;
	    }
	    else if (key[found].type == FITPMAX) {
		int index = sbuf[1] - '0';
		yylval.ival = index;
		return FITPMAX;
	    }
	    else if (key[found].type == FITPMIN) {
		int index = sbuf[1] - '0';
		yylval.ival = index;
		return FITPMIN;
	    }

	    else if (key[found].type == KEY_VAR) {
		yylval.dptr = (double *) key[found].data;
		return VAR_D;
	    }
	    else if (key[found].type == KEY_VEC) {
		yylval.vrbl = (grarr *) key[found].data;
		return VEC_D;
	    }
	    else if (key[found].type == KEY_MAT) {
		yylval.matp = (grarr *) key[found].data;
		return MAT_D;
	    }

	    else if (key[found].type == FUNC_I) {
		yylval.ival = found;
		return FUNC_I;
	    }
	    else if (key[found].type == CONSTANT) {
		yylval.ival = found;
		return CONSTANT;
	    }
	    else if (key[found].type == UCONSTANT) {
		yylval.ival = found;
		return UCONSTANT;
	    }
	    else if (key[found].type == FUNC_D) {
		yylval.ival = found;
		return FUNC_D;
	    }
	    else if (key[found].type == FUNC_ND) {
		yylval.ival = found;
		return FUNC_ND;
	    }
	    else if (key[found].type == FUNC_DD) {
		yylval.ival = found;
		return FUNC_DD;
	    }
	    else if (key[found].type == FUNC_NND) {
		yylval.ival = found;
		return FUNC_NND;
	    }
	    else if (key[found].type == FUNC_PPD) {
		yylval.ival = found;
		return FUNC_PPD;
	    }
	    else if (key[found].type == FUNC_PPPD) {
		yylval.ival = found;
		return FUNC_PPPD;
	    }
	    else if (key[found].type == FUNC_PPPPD) {
		yylval.ival = found;
		return FUNC_PPPPD;
	    }
	    else if (key[found].type == FUNC_PPPPPD) {
		yylval.ival = found;
		return FUNC_PPPPPD;
	    }
	    else {
	        yylval.ival = key[found].type;
	        return key[found].type;
	    }
	} else {
	    yylval.sval = copy_string(NULL, sbuf);
	    return NEW_TOKEN;
	}
    }
    switch (c) {
    case '>':
	return follow('=', GE, GT);
    case '<':
	return follow('=', LE, LT);
    case '=':
	return follow('=', EQ, '=');
    case '!':
	return follow('=', NE, NOT);
    case '|':
	return follow('|', OR, '|');
    case '&':
	return follow('&', AND, '&');
    case '\n':
	return '\n';
    default:
	return c;
    }
}

static int follow(int expect, int ifyes, int ifno)
{
    int c = getcharstr();

    if (c == expect) {
	return ifyes;
    }
    ungetchstr();
    return ifno;
}

static void yyerror(char *s)
{
    char *buf;

    buf = copy_string(NULL, s);
    buf = concat_strings(buf, ": ");
    buf = concat_strings(buf, f_string);
    errmsg(buf);
    xfree(buf);
    interr = 1;
}

static int bad_gno (void)
{
  if (!is_valid_gno (gn)) {
    yyerror("No valid graph selected");
    return TRUE;
  }
  return FALSE;
}

static int bad_axis (void)
{
  if (!is_valid_axis (gn, naxis)) {
    yyerror("No valid axis selected");
    return TRUE;
  }
  return FALSE;
}

static int div_null (double div)
{
  if (div == 0.0) {
    yyerror("Divide by zero");
    return TRUE;
  }
  return FALSE;

}

static grarr *tmp_vec (grarr *src)
{
  grarr *retval;
  if (fcnt > MAX_GRARR_TMP-2) {
    yyerror ("Max number of temporary vectors exceeded");
    return NULL;
  }
  retval = &freelist[fcnt++];
  copy_grarr  (retval, src);
  retval->type = GRARR_TMP;
  return retval;
}

static grarr *tmp_mat (grarr *src)
{
  grarr *retval;
  if (matcnt > MAX_GRARR_TMP-2) {
    yyerror ("Max number of temporary matrices  exceeded");
    return NULL;
  }
  retval = &mattmp[fcnt++];
  copy_grarr (retval, src);
  retval->type = GRARR_TMP;
  return retval;
}

